System.register("chunks:///_virtual/linkItem.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './poolManager.ts', './resourceUtil.ts', './constants.ts'], function (exports) {
  'use strict';

  var cclegacy, Enum, _decorator, Component, TweenSystem, tween, UITransform, Vec3, Animation, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, poolManager, resourceUtil, constants;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Enum = module.Enum;
      _decorator = module._decorator;
      Component = module.Component;
      TweenSystem = module.TweenSystem;
      tween = module.tween;
      UITransform = module.UITransform;
      Vec3 = module.Vec3;
      Animation = module.Animation;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      poolManager = module.poolManager;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }, function (module) {
      constants = module.constants;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _temp;

      cclegacy._RF.push({}, "000eahOFsJC4YWx/wV0fJqQ", "linkItem", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      const LINK_ITEM_STATUS = Enum({
        SHOW: "linkItemShow",
        HIDE: "linkItemHide",
        SELECT: "linkItemSelect",
        SHAKE: "linkItemShake",
        SKILL: "linkItemSkill"
      });
      let LinkItem = exports('LinkItem', (_dec = ccclass('LinkItem'), _dec(_class = (_class2 = (_temp = class LinkItem extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spCake", _descriptor, this);

          _initializerDefineProperty(this, "aniCake", _descriptor2, this);

          _defineProperty(this, "index", void 0);

          _defineProperty(this, "cake", void 0);

          _defineProperty(this, "linkParent", void 0);

          _defineProperty(this, "isSpecial", void 0);

          _defineProperty(this, "specialType", void 0);

          _defineProperty(this, "effectType", void 0);

          _defineProperty(this, "currentStatus", void 0);

          _defineProperty(this, "effectNode", void 0);

          _defineProperty(this, "specialEffect", void 0);
        }

        show(index, cake, isShowRightNow, parent) {
          this.index = index;
          this.cake = cake;
          this.linkParent = parent;
          this.isSpecial = false;
          this.specialType = null;
          this.effectType = null;
          this.node.setSiblingIndex(constants.ZORDER.LINK_ITEM_NORMAL);
          this.spCake.node.setScale(0, 0, 0);
          resourceUtil.setCakeIcon(this.cake, this.spCake, () => {});

          if (isShowRightNow) {
            this.playShowAction(0);
          }
        }

        playShowAction(delayTime) {
          TweenSystem.instance.ActionManager.removeAllActionsFromTarget(this.node);
          tween(this.node).delay(delayTime).call(() => {
            this.aniCake.play(LINK_ITEM_STATUS.SHOW);
            this.currentStatus = LINK_ITEM_STATUS.SHOW;
          }).start();
        }

        playHideAction(delayTime, isNeedShowEffect) {
          TweenSystem.instance.ActionManager.removeAllActionsFromTarget(this.node);
          tween(this.node).delay(delayTime).call(() => {
            this.aniCake.play(LINK_ITEM_STATUS.HIDE);
            this.currentStatus = LINK_ITEM_STATUS.HIDE;

            if (isNeedShowEffect) {
              this.linkParent._fightScene.effectGroup.showLinkItemDestroyEffect(this.node.getComponent(UITransform).convertToWorldSpaceAR(new Vec3(0, 0, 0)), this.getScore());
            }

            this.aniCake.once(Animation.EventType.FINISHED, () => {
              poolManager.instance.putNode(this.node);

              if (this.effectNode) {
                this.effectNode.destroy();
                this.effectNode = null;
              }

              if (this.specialEffect) {
                poolManager.instance.putNode(this.specialEffect);
                this.specialEffect = null;
              }
            }, this);
          }).start();
        }

        getScore() {
          let score = 0;

          if (this.isSpecial) {
            if (this.specialType === constants.SPECIAL_EFFECT.HORIZONTAL || this.specialType === constants.SPECIAL_EFFECT.VERTICAL) {
              score += 1000;
            } else if (this.specialType === constants.SPECIAL_EFFECT.PLUS) {
              score += 2000;
            } else if (this.specialType === constants.SPECIAL_EFFECT.CENTER) {
              score += 3000;
            }

            if (!this.effectType) {
              return score;
            }
          }

          if (this.effectType) {
            switch (this.effectType) {
              case constants.SPECIAL_EFFECT.HORIZONTAL:
              case constants.SPECIAL_EFFECT.VERTICAL:
                return score + 500;

              case constants.SPECIAL_EFFECT.PLUS:
                return score + 1000;

              case constants.SPECIAL_EFFECT.CENTER:
                return score + 1500;
            }
          }

          return 50;
        }

        showSelect(isShow) {
          let cakeStr = this.cake;

          if (isShow) {
            this.aniCake.play(LINK_ITEM_STATUS.SELECT);
            this.currentStatus = LINK_ITEM_STATUS.SELECT;
            cakeStr = this.cake + 'Light';
          } else {
            if (this.effectType) {
              this.aniCake.play(LINK_ITEM_STATUS.SKILL);
              this.currentStatus = LINK_ITEM_STATUS.SKILL;
            } else {
              // this.aniCake.setCurrentTime(0);
              this.aniCake.stop();
            }
          }

          resourceUtil.setCakeIcon(cakeStr, this.spCake, () => {});
        }

        showDestory() {
          this.playHideAction(0, true);
        }

        playMove2Index(index) {
          let screenPos = this.linkParent.getScreenPosByIndex(index);
          let distance = screenPos.clone().subtract(this.node.position).length();
          TweenSystem.instance.ActionManager.removeAllActionsFromTarget(this.node);
          tween(this.node).to(distance / 1000, {
            position: screenPos
          }, {
            easing: 'backIn'
          }).call(() => {
            this.aniCake.play(LINK_ITEM_STATUS.SHAKE);
          }).start();
        }

        showSpecial(isShow) {
          this.isSpecial = isShow;

          if (isShow) {
            resourceUtil.getEffectPrefab('fight/linkStar/linkStar', (err, prefab) => {
              if (err) {
                return;
              }

              if (!this.isSpecial) {
                return;
              }

              this.specialEffect = poolManager.instance.getNode(prefab, this.node);
              this.specialEffect.position = new Vec3(0, 0, 0);
              this.specialEffect.getComponent(Animation).play('linkStarShow');
            });
          } else if (this.specialEffect) {
            poolManager.instance.putNode(this.specialEffect);
            this.specialEffect = null;
          }
        }

        setSpecialType(type) {
          this.specialType = type;
        }

        markEffect(type) {
          this.effectType = type;
        }

        showEffect(type) {
          if (this.effectNode) {
            this.effectNode.destroy();
          }

          this.node.setSiblingIndex(constants.ZORDER.LINK_ITEM_SKILL);
          this.effectType = type;
          this.aniCake.play(LINK_ITEM_STATUS.SKILL);
          this.currentStatus = LINK_ITEM_STATUS.SKILL;
          let rotation = 0;
          let effectStr = "fight/effectSkillTips/skillTipsLine";

          switch (type) {
            case constants.SPECIAL_EFFECT.HORIZONTAL:
              break;

            case constants.SPECIAL_EFFECT.VERTICAL:
              rotation = 90;
              break;

            case constants.SPECIAL_EFFECT.PLUS:
              effectStr = "fight/effectSkillTips/skillTipsPlus";
              break;

            case constants.SPECIAL_EFFECT.CENTER:
              effectStr = "fight/effectSkillTips/skillTipsRange";
              break;
          }

          resourceUtil.createEffect(effectStr, (err, effectNode) => {
            if (err) {
              return;
            }

            this.effectNode = effectNode;
            this.effectNode.eulerAngles = new Vec3(0, 0, rotation);
          }, this.node);
        }

        getEffect() {
          return this.effectType;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spCake", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "aniCake", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/fightPropsOperation.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './resourceUtil.ts', './clientEvent.ts', './uiManager.ts', './fightProp.ts', './LanguageData.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, Node, UITransform, Vec3, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, resourceUtil, clientEvent, uiManager, FightProp, t;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      Node = module.Node;
      UITransform = module.UITransform;
      Vec3 = module.Vec3;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }, function (module) {
      clientEvent = module.clientEvent;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      FightProp = module.FightProp;
    }, function (module) {
      t = module.t;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _temp;

      cclegacy._RF.push({}, "01774upBQlPPZbPTE42gyAF", "fightPropsOperation", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let FightPropsOperation = exports('FightPropsOperation', (_dec = ccclass('FightPropsOperation'), _dec(_class = (_class2 = (_temp = class FightPropsOperation extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "nodeMask", _descriptor, this);

          _initializerDefineProperty(this, "nodeTouch", _descriptor2, this);

          _initializerDefineProperty(this, "nodeBg", _descriptor3, this);

          _initializerDefineProperty(this, "nodeProp", _descriptor4, this);

          _initializerDefineProperty(this, "lbTips", _descriptor5, this);

          _initializerDefineProperty(this, "lbName", _descriptor6, this);

          _initializerDefineProperty(this, "spProp", _descriptor7, this);

          _initializerDefineProperty(this, "arrSfTip", _descriptor8, this);

          _defineProperty(this, "propId", void 0);

          _defineProperty(this, "closeCallback", void 0);

          _defineProperty(this, "_fightScene", void 0);
        }

        onEnable() {
          this.nodeTouch.on(Node.EventType.TOUCH_START, this.onTouchStart, this);
          this.nodeTouch.on(Node.EventType.TOUCH_END, this.onTouchEnded, this);
          this.nodeTouch.on(Node.EventType.TOUCH_CANCEL, this.onTouchCancel, this);
        }

        onDisable() {
          this.nodeTouch.off(Node.EventType.TOUCH_START, this.onTouchStart, this);
          this.nodeTouch.off(Node.EventType.TOUCH_END, this.onTouchEnded, this);
          this.nodeTouch.off(Node.EventType.TOUCH_CANCEL, this.onTouchCancel, this);
        }

        show(propInfo, propWorldPos, linkRect, fightScene, closeCallback) {
          this.propId = propInfo.ID;
          resourceUtil.setPropIcon(propInfo.icon, this.spProp, () => {});
          let propPos = this.node.getComponent(UITransform).convertToNodeSpaceAR(propWorldPos);
          this.closeCallback = closeCallback;
          this.nodeProp.position = propPos;
          this.nodeProp.getComponent(FightProp).show(propInfo);
          this.lbTips.string = t('table_prop.' + propInfo.desc);
          this.lbName.string = t('table_prop.' + propInfo.name);
          this._fightScene = fightScene;
          this.nodeMask.position = new Vec3(linkRect.x + linkRect.width / 2, linkRect.y + linkRect.height / 2, 0);
          this.nodeTouch.position = this.nodeMask.position;
          const uiTraMask = this.nodeMask.getComponent(UITransform);
          uiTraMask.width = linkRect.width;
          uiTraMask.height = linkRect.height;
          const uiTraTouch = this.nodeTouch.getComponent(UITransform);
          uiTraTouch.width = linkRect.width;
          uiTraTouch.height = linkRect.height;
          this.scheduleOnce(() => {
            const uiTraSelf = this.node.getComponent(UITransform);
            const uiTraBg = this.nodeBg.getComponent(UITransform);
            uiTraBg.width = uiTraSelf.width;
            uiTraBg.height = uiTraSelf.height;
            this.nodeBg.position = new Vec3(-this.nodeMask.position.x, -this.nodeMask.position.y, 0);
          }, 0.1);
        }

        onTouchStart(touchEvent) {
          this._fightScene.linkContent.onPropTouchStart(touchEvent);
        }

        onTouchEnded(touchEvent) {
          let idxTouch = this._fightScene.linkContent.onPropTouchEnd(touchEvent);

          if (idxTouch !== -1) {
            clientEvent.dispatchEvent('useProp', this.propId, idxTouch);
            this.close();
          }
        }

        onTouchCancel(touchEvent) {
          this._fightScene.linkContent.onPropTouchCancel(touchEvent);
        }

        onBtnCloseClick() {
          this.close();
        }

        close() {
          uiManager.instance.hideDialog('fight/fightPropsOperation');

          if (this.closeCallback) {
            this.closeCallback();
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "nodeMask", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "nodeTouch", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "nodeBg", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "nodeProp", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "lbTips", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "lbName", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "spProp", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "arrSfTip", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/fightTarget.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './resourceUtil.ts', './clientEvent.ts', './playerData.ts', './loadsh.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, Vec3, Animation, UITransform, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, resourceUtil, clientEvent, playerData, loadsh;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      Vec3 = module.Vec3;
      Animation = module.Animation;
      UITransform = module.UITransform;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }, function (module) {
      clientEvent = module.clientEvent;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      loadsh = module.loadsh;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _temp;

      cclegacy._RF.push({}, "01817VhYV5BoLEoEhl13On0", "fightTarget", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let FightTarget = exports('FightTarget', (_dec = ccclass('FightTarget'), _dec(_class = (_class2 = (_temp = class FightTarget extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spCake", _descriptor, this);

          _initializerDefineProperty(this, "lbTargetValue", _descriptor2, this);

          _initializerDefineProperty(this, "nodeCustomer", _descriptor3, this);

          _initializerDefineProperty(this, "nodeNeed", _descriptor4, this);

          _initializerDefineProperty(this, "nodeCake", _descriptor5, this);

          _initializerDefineProperty(this, "nodeYes", _descriptor6, this);

          _initializerDefineProperty(this, "aniCake", _descriptor7, this);

          _defineProperty(this, "cake", void 0);

          _defineProperty(this, "customer", void 0);
        }

        onEnable() {
          clientEvent.on('updateTargets', this.updateTarget, this);
          clientEvent.on('showTargetCake', this.showTargetCake, this);
        }

        onDisable() {
          clientEvent.off('updateTargets', this.updateTarget, this);
          clientEvent.off('showTargetCake', this.showTargetCake, this);
        }

        show(cake, isShowCustomer) {
          this.cake = cake;
          resourceUtil.setCakeIcon(this.cake, this.spCake, () => {});
          this.updateTagetValue();

          if (isShowCustomer) {
            if (this.customer) {
              this.customer.active = true;
            } else {
              let rand = loadsh.random(0, 1);
              let roleStr = 'role/man01/man01';
              let posY = 0;

              if (rand) {
                roleStr = 'role/woman01/woman01';
                posY = 15;
              }

              resourceUtil.createEffect(roleStr, (err, role) => {
                if (!err) {
                  this.customer = role;
                  this.customer.position = new Vec3(0, posY, 0);
                }
              }, this.nodeCustomer);
            }
          } else if (this.customer) {
            this.customer.active = false;
          }

          this.nodeNeed.active = false;
          this.nodeCake.active = false;
        }

        showTargetCake(cake) {
          if (cake === 'all' || cake === this.cake) {
            this.nodeNeed.active = true;
            this.nodeCake.active = true;
            this.node.getComponent(Animation).play('linkItemShowTarget');
          }
        }

        updateTagetValue() {
          let spareValue = playerData.instance.getTargetValue(this.cake);
          this.lbTargetValue.string = spareValue;
          this.nodeYes.active = spareValue <= 0;
        }

        updateTarget(cake) {
          if (this.cake === cake) {
            this.updateTagetValue();
          }
        }

        playIdle() {
          if (this.customer) {
            this.customer.getComponent(Animation).play('idle');
          }
        }

        getCakeWorldPos() {
          return this.spCake.node.getComponent(UITransform).convertToWorldSpaceAR(new Vec3(0, 0, 0));
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spCake", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "lbTargetValue", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "nodeCustomer", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "nodeNeed", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "nodeCake", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "nodeYes", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "aniCake", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/utils.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      cclegacy._RF.push({}, "04ef58UptZE3aEqQ2I+onJb", "utils", undefined);
      /*
       * Copyright (c) 2017 Xiamen Yaji Software Co.Ltd. All rights reserved.
       * 工具类
      **/


      var utils = exports('utils', {
        /**
        * 深度拷贝
        * @param {any} sObj 拷贝的对象
        * @returns 
        */
        clone(sObj) {
          if (sObj === null || typeof sObj !== "object") {
            return sObj;
          }

          let s = {};

          if (sObj.constructor === Array) {
            s = [];
          }

          for (let i in sObj) {
            if (sObj.hasOwnProperty(i)) {
              s[i] = this.clone(sObj[i]);
            }
          }

          return s;
        },

        /**
         * 将object转化为数组
         * @param { any} srcObj  
         * @returns 
         */
        objectToArray(srcObj) {
          let resultArr = []; // to array

          for (let key in srcObj) {
            if (!srcObj.hasOwnProperty(key)) {
              continue;
            }

            resultArr.push(srcObj[key]);
          }

          return resultArr;
        },

        /**
         * !#zh 将数组转化为object。
         */

        /**
         * 将数组转化为object。
         * @param { any} srcObj 
         * @param { string} objectKey 
         * @returns 
         */
        arrayToObject(srcObj, objectKey) {
          let resultObj = {}; // to object

          for (var key in srcObj) {
            if (!srcObj.hasOwnProperty(key) || !srcObj[key][objectKey]) {
              continue;
            }

            resultObj[srcObj[key][objectKey]] = srcObj[key];
          }

          return resultObj;
        },

        /**
         * 根据权重,计算随机内容
         * @param {arrany} weightArr 
         * @param {number} totalWeight 权重
         * @returns 
         */
        getWeightRandIndex(weightArr, totalWeight) {
          let randWeight = Math.floor(Math.random() * totalWeight);
          let sum = 0;

          for (var weightIndex = 0; weightIndex < weightArr.length; weightIndex++) {
            sum += weightArr[weightIndex];

            if (randWeight < sum) {
              break;
            }
          }

          return weightIndex;
        },

        /**
         * 从n个数中获取m个随机数
         * @param {Number} n   总数
         * @param {Number} m    获取数
         * @returns {Array} array   获取数列
         */
        getRandomNFromM(n, m) {
          let array = [];
          let intRd = 0;
          let count = 0;

          while (count < m) {
            if (count >= n + 1) {
              break;
            }

            intRd = this.getRandomInt(0, n);
            var flag = 0;

            for (var i = 0; i < count; i++) {
              if (array[i] === intRd) {
                flag = 1;
                break;
              }
            }

            if (flag === 0) {
              array[count] = intRd;
              count++;
            }
          }

          return array;
        },

        /**
         * 获取随机整数
         * @param {Number} min 最小值
         * @param {Number} max 最大值
         * @returns 
         */
        getRandomInt(min, max) {
          let r = Math.random();
          let rr = r * (max - min + 1) + min;
          return Math.floor(rr);
        },

        /**
         * 获取字符串长度
         * @param {string} render 
         * @returns 
         */
        getStringLength(render) {
          let strArr = render;
          let len = 0;

          for (let i = 0, n = strArr.length; i < n; i++) {
            let val = strArr.charCodeAt(i);

            if (val <= 255) {
              len = len + 1;
            } else {
              len = len + 2;
            }
          }

          return Math.ceil(len / 2);
        },

        /**
         * 判断传入的参数是否为空的Object。数组或undefined会返回false
         * @param obj
         */
        isEmptyObject(obj) {
          let result = true;

          if (obj && obj.constructor === Object) {
            for (var key in obj) {
              if (obj.hasOwnProperty(key)) {
                result = false;
                break;
              }
            }
          } else {
            result = false;
          }

          return result;
        },

        /**
         * 判断是否是新的一天
         * @param {Object|Number} dateValue 时间对象 todo MessageCenter 与 pve 相关的时间存储建议改为 Date 类型
         * @returns {boolean}
         */
        isNewDay(dateValue) {
          // todo：是否需要判断时区？
          var oldDate = new Date(dateValue);
          var curDate = new Date();
          var oldYear = oldDate.getYear();
          var oldMonth = oldDate.getMonth();
          var oldDay = oldDate.getDate();
          var curYear = curDate.getYear();
          var curMonth = curDate.getMonth();
          var curDay = curDate.getDate();

          if (curYear > oldYear) {
            return true;
          } else {
            if (curMonth > oldMonth) {
              return true;
            } else {
              if (curDay > oldDay) {
                return true;
              }
            }
          }

          return false;
        },

        /**
         * 获取对象属性数量
         * @param {object}o 对象
         * @returns 
         */
        getPropertyCount(o) {
          var n,
              count = 0;

          for (n in o) {
            if (o.hasOwnProperty(n)) {
              count++;
            }
          }

          return count;
        },

        /**
         * 返回一个差异化数组（将array中diff里的值去掉）
         * @param array
         * @param diff
         */
        difference(array, diff) {
          let result = [];

          if (array.constructor !== Array || diff.constructor !== Array) {
            return result;
          }

          let length = array.length;

          for (let i = 0; i < length; i++) {
            if (diff.indexOf(array[i]) === -1) {
              result.push(array[i]);
            }
          }

          return result;
        },

        //public method for encoding
        base64encode: function (input) {
          var keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
          var output = "",
              chr1,
              chr2,
              chr3,
              enc1,
              enc2,
              enc3,
              enc4,
              i = 0;
          input = this.utf8Encode(input);

          while (i < input.length) {
            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);
            enc1 = chr1 >> 2;
            enc2 = (chr1 & 3) << 4 | chr2 >> 4;
            enc3 = (chr2 & 15) << 2 | chr3 >> 6;
            enc4 = chr3 & 63;

            if (isNaN(chr2)) {
              enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
              enc4 = 64;
            }

            output = output + keyStr.charAt(enc1) + keyStr.charAt(enc2) + keyStr.charAt(enc3) + keyStr.charAt(enc4);
          }

          return output;
        },
        // private method for UTF-8 encoding
        utf8Encode: function (string) {
          string = string.replace(/\r\n/g, "\n");
          var utftext = "";

          for (var n = 0; n < string.length; n++) {
            var c = string.charCodeAt(n);

            if (c < 128) {
              utftext += String.fromCharCode(c);
            } else if (c > 127 && c < 2048) {
              utftext += String.fromCharCode(c >> 6 | 192);
              utftext += String.fromCharCode(c & 63 | 128);
            } else {
              utftext += String.fromCharCode(c >> 12 | 224);
              utftext += String.fromCharCode(c >> 6 & 63 | 128);
              utftext += String.fromCharCode(c & 63 | 128);
            }
          }

          return utftext;
        },
        base64Decode: function (input) {
          var keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
          var output = "";
          var chr1;
          var chr2;
          var chr3;
          var enc1;
          var enc2;
          var enc3;
          var enc4;
          var i = 0;
          input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

          while (i < input.length) {
            enc1 = keyStr.indexOf(input.charAt(i++));
            enc2 = keyStr.indexOf(input.charAt(i++));
            enc3 = keyStr.indexOf(input.charAt(i++));
            enc4 = keyStr.indexOf(input.charAt(i++));
            chr1 = enc1 << 2 | enc2 >> 4;
            chr2 = (enc2 & 15) << 4 | enc3 >> 2;
            chr3 = (enc3 & 3) << 6 | enc4;
            output = output + String.fromCharCode(chr1);

            if (enc3 != 64) {
              output = output + String.fromCharCode(chr2);
            }

            if (enc4 != 64) {
              output = output + String.fromCharCode(chr3);
            }
          }

          output = this.utf8Decode(output);
          return output;
        },
        utf8Decode: function (utftext) {
          var string = "";
          var i = 0;
          var c = 0;
          var c2 = 0;
          var c3 = 0;

          while (i < utftext.length) {
            c = utftext.charCodeAt(i);

            if (c < 128) {
              string += String.fromCharCode(c);
              i++;
            } else if (c > 191 && c < 224) {
              c2 = utftext.charCodeAt(i + 1);
              string += String.fromCharCode((c & 31) << 6 | c2 & 63);
              i += 2;
            } else {
              c2 = utftext.charCodeAt(i + 1);
              c3 = utftext.charCodeAt(i + 2);
              string += String.fromCharCode((c & 15) << 12 | (c2 & 63) << 6 | c3 & 63);
              i += 3;
            }
          }

          return string;
        },
        stringToArray: function (string) {
          // 用于判断emoji的正则们
          var rsAstralRange = '\\ud800-\\udfff';
          var rsZWJ = '\\u200d';
          var rsVarRange = '\\ufe0e\\ufe0f';
          var rsComboMarksRange = '\\u0300-\\u036f';
          var reComboHalfMarksRange = '\\ufe20-\\ufe2f';
          var rsComboSymbolsRange = '\\u20d0-\\u20ff';
          var rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange;
          var reHasUnicode = RegExp('[' + rsZWJ + rsAstralRange + rsComboRange + rsVarRange + ']');
          var rsFitz = '\\ud83c[\\udffb-\\udfff]';
          var rsOptVar = '[' + rsVarRange + ']?';
          var rsCombo = '[' + rsComboRange + ']';
          var rsModifier = '(?:' + rsCombo + '|' + rsFitz + ')';
          var reOptMod = rsModifier + '?';
          var rsAstral = '[' + rsAstralRange + ']';
          var rsNonAstral = '[^' + rsAstralRange + ']';
          var rsRegional = '(?:\\ud83c[\\udde6-\\uddff]){2}';
          var rsSurrPair = '[\\ud800-\\udbff][\\udc00-\\udfff]';
          var rsOptJoin = '(?:' + rsZWJ + '(?:' + [rsNonAstral, rsRegional, rsSurrPair].join('|') + ')' + rsOptVar + reOptMod + ')*';
          var rsSeq = rsOptVar + reOptMod + rsOptJoin;
          var rsSymbol = '(?:' + [rsNonAstral + rsCombo + '?', rsCombo, rsRegional, rsSurrPair, rsAstral].join('|') + ')';
          var reUnicode = RegExp(rsFitz + '(?=' + rsFitz + ')|' + rsSymbol + rsSeq, 'g');

          var hasUnicode = function (val) {
            return reHasUnicode.test(val);
          };

          var unicodeToArray = function (val) {
            return val.match(reUnicode) || [];
          };

          var asciiToArray = function (val) {
            return val.split('');
          };

          return hasUnicode(string) ? unicodeToArray(string) : asciiToArray(string);
        },
        // 模拟传msg的uuid
        simulationUUID: function () {
          function s4() {
            return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1);
          }

          return s4() + s4() + '-' + s4() + '-' + s4() + '-' + s4() + '-' + s4() + s4() + s4();
        },
        trim: function (str) {
          return str.replace(/(^\s*)|(\s*$)/g, "");
        },

        /**
         * 判断当前时间是否在有效时间内
         * @param {String|Number} start 起始时间。带有时区信息
         * @param {String|Number} end 结束时间。带有时区信息
         */
        isNowValid: function (start, end) {
          var startTime = new Date(start);
          var endTime = new Date(end);
          var result = false;

          if (startTime.getDate() + '' !== 'NaN' && endTime.getDate() + '' !== 'NaN') {
            var curDate = new Date();
            result = curDate < endTime && curDate > startTime;
          }

          return result;
        },
        getDeltaDays: function (start, end) {
          start = new Date(start);
          end = new Date(end);
          var startYear = start.getFullYear();
          var startMonth = start.getMonth() + 1;
          var startDate = start.getDate();
          var endYear = end.getFullYear();
          var endMonth = end.getMonth() + 1;
          var endDate = end.getDate();
          start = new Date(startYear + '/' + startMonth + '/' + startDate + ' GMT+0800').getTime();
          end = new Date(endYear + '/' + endMonth + '/' + endDate + ' GMT+0800').getTime();
          var deltaTime = end - start;
          return Math.floor(deltaTime / (24 * 60 * 60 * 1000));
        },
        getMin: function (array) {
          var result = null;

          if (array.constructor === Array) {
            var length = array.length;

            for (var i = 0; i < length; i++) {
              if (i === 0) {
                result = Number(array[0]);
              } else {
                result = result > Number(array[i]) ? Number(array[i]) : result;
              }
            }
          }

          return result;
        },

        /**
         * 格式化两位小数点
         * @param time 
         * @returns 
         */
        formatTwoDigits(time) {
          //@ts-ignore
          return (Array(2).join(0) + time).slice(-2);
        },

        /**
         * 获取格式化后的日期（不含小时分秒）
         */
        getDay: function () {
          var date = new Date();
          return date.getFullYear() + '-' + (date.getMonth() + 1) + '-' + date.getDate();
        },
        formatName: function (name, limit) {
          limit = limit || 6;
          var nameArray = this.stringToArray(name);
          var str = '';
          var length = nameArray.length;

          if (length > limit) {
            for (var i = 0; i < limit; i++) {
              str += nameArray[i];
            }

            str += '...';
          } else {
            str = name;
          }

          return str;
        },

        /**
         * 格式化钱数，超过10000 转换位 10K   10000K 转换为 10M
         */
        formatMoney: function (money) {
          var arrUnit = ['', 'K', 'M', 'G', 'T', 'P', 'E', 'Z', 'Y', 'B', 'N', 'D'];
          var strValue = '';

          for (var idx = 0; idx < arrUnit.length; idx++) {
            if (money >= 10000) {
              money /= 1000;
            } else {
              strValue = Math.floor(money) + arrUnit[idx];
              break;
            }
          }

          if (strValue === '') {
            strValue = Math.floor(money) + 'U'; //超过最大值就加个U
          }

          return strValue;
        },

        /**
         * 根据剩余秒数格式化剩余时间 返回 HH:MM:SS
         * @param {Number} leftSec 
         */
        formatTimeForSecond(leftSec) {
          var timeStr = '';
          var sec = leftSec % 60;
          var leftMin = Math.floor(leftSec / 60);
          leftMin = leftMin < 0 ? 0 : leftMin;
          var hour = Math.floor(leftMin / 60);
          var min = leftMin % 60;

          if (hour > 0) {
            timeStr += hour > 9 ? hour.toString() : '0' + hour;
            timeStr += ':';
          }

          timeStr += min > 9 ? min.toString() : '0' + min;
          timeStr += ':';
          timeStr += sec > 9 ? sec.toString() : '0' + sec;
          return timeStr;
        },

        /**
        *  根据剩余毫秒数格式化剩余时间 返回 HH:MM:SS
        *
        * @param {Number} ms
        */
        formatTimeForMillisecond(ms) {
          let second = Math.floor(ms / 1000 % 60);
          let minute = Math.floor(ms / 1000 / 60 % 60);
          let hour = Math.floor(ms / 1000 / 60 / 60);
          return `${hour}:${minute}:${second}`;
        },

        // /**
        //  * TODO 需要将pako进行引入，目前已经去除了压缩算法的需要，如需要使用需引入库文件
        //  * 将字符串进行压缩
        //  * @param {String} str 
        //  */
        // zip(str: any) {
        //     var binaryString = pako.gzip(encodeURIComponent(str), { to: 'string' });
        //     return this.base64encode(binaryString);
        // },
        // /**
        //  * todo 目前已经去除了压缩算法的需要，如需要使用需引入库文件
        //  * 将数据进行解压
        //  * @param {String} b64Data 
        //  */
        // unZip(b64Data: any) {
        //     var strData = this.base64Decode(b64Data);
        //     // Convert binary string to character-number array
        //     var charData = strData.split('').map(function (x) { return x.charCodeAt(0); });
        //     // Turn number array into byte-array
        //     var binData = new Uint8Array(charData);
        //     // // unzip
        //     var data = pako.inflate(binData);
        //     // Convert gunzipped byteArray back to ascii string:
        //     strData = String.fromCharCode.apply(null, new Uint16Array(data));
        //     return decodeURIComponent(strData);
        // },

        /**
         * 数据加密
         * @param {String} str 
         */
        encrypt(str) {
          let b64Data = this.base64encode(str);
          let n = 6;

          if (b64Data.length % 2 === 0) {
            n = 7;
          }

          let encodeData = '';

          for (let idx = 0; idx < (b64Data.length - n + 1) / 2; idx++) {
            encodeData += b64Data[2 * idx + 1];
            encodeData += b64Data[2 * idx];
          }

          encodeData += b64Data.slice(b64Data.length - n + 1);
          return encodeData;
        },

        /**
         * 数据解密
         * @param {String} b64Data 
         */
        decrypt(b64Data) {
          let n = 6;

          if (b64Data.length % 2 === 0) {
            n = 7;
          }

          let decodeData = '';

          for (var idx = 0; idx < b64Data.length - n; idx += 2) {
            decodeData += b64Data[idx + 1];
            decodeData += b64Data[idx];
          }

          decodeData += b64Data.slice(b64Data.length - n + 1);
          decodeData = this.base64Decode(decodeData);
          return decodeData;
        }

      });

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/NativeAdIcon.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './PlatformBridge.js', './PlatformBridge.mjs_cjs=&original=.js'], function (exports) {
  'use strict';

  var cclegacy, Node, Sprite, _decorator, Component, _applyDecoratedDescriptor, _initializerDefineProperty, _cjsExports;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Sprite = module.Sprite;
      _decorator = module._decorator;
      Component = module.Component;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
    }, function (module) {
      _cjsExports = module.default;
    }, null],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp;

      cclegacy._RF.push({}, "075e6aKJxNI1IA/fCEtCicq", "NativeAdIcon", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let NewClass = exports('default', (_dec = property(Node), _dec2 = property(Sprite), _dec3 = property(Node), ccclass(_class = (_class2 = (_temp = class NewClass extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "Ad", _descriptor, this);

          _initializerDefineProperty(this, "AdSprite", _descriptor2, this);

          _initializerDefineProperty(this, "adButtonNode", _descriptor3, this);
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {}


        start() {}

        onClickOpen() {
          _cjsExports.onClickNativeAdOpen();

          this.AdSprite.node.active = false;
          this.adButtonNode.active = false;
        }

        setSprite(frame) {
          if (frame != null) {
            // self.node.getComponent(cc.Sprite).spriteFrame=frame;
            console.log("nativeadbig->", frame);
            this.AdSprite.node.active = true;
            this.adButtonNode.active = true;
            this.AdSprite.spriteFrame = frame;
          }
        }

        onClickClose() {
          _cjsExports.onClickNativeAdClose();

          this.AdSprite.node.active = false;
          this.adButtonNode.active = false;
        } // update (dt) {}


      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "Ad", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "AdSprite", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "adButtonNode", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/levelUI.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './resourceUtil.ts', './constants.ts', './sceneManager.ts', './playerData.ts', './uiManager.ts', './LanguageData.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Label, Animation, Sprite, _decorator, Component, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, resourceUtil, constants, SceneManager, playerData, uiManager, t;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Label = module.Label;
      Animation = module.Animation;
      Sprite = module.Sprite;
      _decorator = module._decorator;
      Component = module.Component;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      SceneManager = module.SceneManager;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      t = module.t;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _temp;

      cclegacy._RF.push({}, "09faeI+TthOKbk54kKEeYOU", "levelUI", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let LevelUI = exports('LevelUI', (_dec = ccclass('LevelUI'), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(Node), _dec5 = property(Node), _dec6 = property(Label), _dec7 = property(Animation), _dec8 = property(Sprite), _dec9 = property(Node), _dec(_class = (_class2 = (_temp = class LevelUI extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "nStars", _descriptor, this);

          _initializerDefineProperty(this, "nCurrentLevel", _descriptor2, this);

          _initializerDefineProperty(this, "nLevelNotPassed", _descriptor3, this);

          _initializerDefineProperty(this, "nLevelPassed", _descriptor4, this);

          _initializerDefineProperty(this, "lbLevel", _descriptor5, this);

          _initializerDefineProperty(this, "aniTips", _descriptor6, this);

          _initializerDefineProperty(this, "spAvatar", _descriptor7, this);

          _initializerDefineProperty(this, "arrStarNode", _descriptor8, this);

          _defineProperty(this, "levelInfo", void 0);

          _defineProperty(this, "updateInterval", void 0);

          _defineProperty(this, "lastPositionY", void 0);

          _defineProperty(this, "pool", void 0);

          _defineProperty(this, "pool1", void 0);
        }

        onLoad() {
          this.aniTips.once(Animation.EventType.FINISHED, this.onAniTipsFinished, this);
        }

        onDisable() {
          this.aniTips.once(Animation.EventType.FINISHED, this.onAniTipsFinished, this);
        }

        onAniTipsFinished() {
          this.aniTips.play('pveLevelTipsIdle');
        }

        init(levelInfo) {
          this.levelInfo = levelInfo;
          this.setLevelNum(levelInfo.name);
          this.setLevelStatus(levelInfo.status);
          this.setStars(levelInfo.star);

          if (playerData.instance.playerInfo.avatarUrl) {
            resourceUtil.setAvatar(playerData.instance.playerInfo.avatarUrl, this.spAvatar, () => {});
          }
        }

        setLevelNum(number) {
          this.lbLevel.string = number;
        }

        setLevelStatus(status) {
          if (status === constants.PVE_LEVEL_STATUS.DONE) {
            this.nCurrentLevel.active = false;
            this.nLevelNotPassed.active = false;
            this.nLevelPassed.active = true;
          } else if (status === constants.PVE_LEVEL_STATUS.DOING) {
            this.nCurrentLevel.active = true;
            this.nLevelNotPassed.active = false;
            this.nLevelPassed.active = false;
          } else {
            this.nCurrentLevel.active = false;
            this.nLevelNotPassed.active = true;
            this.nLevelPassed.active = false;
          }
        }

        setStars(stars) {
          if (!stars) {
            this.nStars.active = false;
            return;
          }

          this.nStars.active = true;

          for (let i = 0; i < constants.MAX_GRADE_OF_EACH_PVE_LEVEL; i++) {
            let acheived = false;

            if (i <= stars - 1) {
              acheived = true;
            }

            this.arrStarNode[i].active = acheived;
          }
        }

        onBtnLevelChallenge() {
          if (this.levelInfo.status === constants.PVE_LEVEL_STATUS.UNDONE) {
            uiManager.instance.showTips(t('pve.cannotSkipLastLevel'));
            return;
          }

          uiManager.instance.showDialog('pve/levelPanel', [this.levelInfo, this.levelCallback]);
        }

        levelCallback() {
          // let timeStamp = Date.now();
          try {
            playerData.instance.level = this.levelInfo.ID;
            SceneManager.instance.loadScene('fight', [function (cb) {
              cb();
            }], (err, result) => {
              if (err) {
                console.error(err.message || err);
                return;
              }
            });
          } catch (error) {
            console.log("levelCallback.error", error);
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "nStars", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "nCurrentLevel", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "nLevelNotPassed", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "nLevelPassed", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "lbLevel", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "aniTips", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "spAvatar", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "arrStarNode", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/fightGuide.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './animationUI.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, _defineProperty, AnimationUI;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
    }, function (module) {
      _defineProperty = module.defineProperty;
    }, function (module) {
      AnimationUI = module.AnimationUI;
    }],
    execute: function () {
      var _dec, _class, _temp;

      cclegacy._RF.push({}, "0c335oC9Y9Fc5YWelPxejg7", "fightGuide", undefined);

      const {
        ccclass
      } = _decorator;
      let FightGuide = exports('FightGuide', (_dec = ccclass('FightGuide'), _dec(_class = (_temp = class FightGuide extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "startTime", void 0);

          _defineProperty(this, "closeCb", void 0);
        }

        show(callback) {
          this.startTime = Date.now();
          this.closeCb = callback;
        }

        onBtnCloseClick() {
          let ani = this.node.getComponent(AnimationUI);

          if (ani) {
            ani.close(() => {
              this.node && this.node.destroy();
            });
          } else {
            this.node && this.node.destroy();
          }

          if (this.closeCb) {
            this.closeCb();
          }
        }

      }, _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/fightNum.ts", ['cc', './_rollupPluginModLoBabelHelpers.js'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, Animation, _applyDecoratedDescriptor, _initializerDefineProperty;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      Animation = module.Animation;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _temp;

      cclegacy._RF.push({}, "0e8531febFP+ojrUxtAih7t", "fightNum", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let FightNum = exports('FightNum', (_dec = ccclass('FightNum'), _dec(_class = (_class2 = (_temp = class FightNum extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "lbNum", _descriptor, this);

          _initializerDefineProperty(this, "ani", _descriptor2, this);

          _initializerDefineProperty(this, "font1", _descriptor3, this);

          _initializerDefineProperty(this, "font2", _descriptor4, this);
        }

        show(value, callback) {
          this.lbNum.string = value;
          let scale = 1;

          if (value <= 50) {
            this.lbNum.font = this.font1;
          } else {
            this.lbNum.font = this.font2;
            scale = 1.2;
          }

          this.node.setScale(scale, scale, scale);
          this.ani.once(Animation.EventType.FINISHED, callback);
          this.ani.play('fightNum');
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "lbNum", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "ani", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "font1", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "font2", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/localConfig.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './resourceUtil.ts', './csvManager.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, resources, _defineProperty, resourceUtil, CSVManager;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      resources = module.resources;
    }, function (module) {
      _defineProperty = module.defineProperty;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }, function (module) {
      CSVManager = module.CSVManager;
    }],
    execute: function () {
      var _dec, _class, _class2, _temp;

      cclegacy._RF.push({}, "12facSZhFRGIYa7yxiLVDOp", "localConfig", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let localConfig = exports('localConfig', (_dec = ccclass("localConfig"), _dec(_class = (_temp = _class2 = class localConfig {
        constructor() {
          _defineProperty(this, "_csvManager", new CSVManager());

          _defineProperty(this, "_callback", null);

          _defineProperty(this, "_currentLoad", 0);

          _defineProperty(this, "_cntLoad", 0);
        }

        static get instance() {
          console.log("_loadCSV->01");

          if (this._instance) {
            console.log("_loadCSV->02");
            return this._instance;
          }

          console.log("_loadCSV->03");
          let a = new localConfig();
          console.log("_loadCSV->3.5");
          this._instance = a;
          console.log("_loadCSV->04");
          return this._instance;
        }

        localConfig() {}
        /**
         * 加载配置文件
         * @param {Function}cb 回调函数 
         */


        loadConfig(cb) {
          console.log("_loadCSV->05");
          this._callback = cb;
          console.log("_loadCSV->06");

          this._loadCSV();
        }

        _loadCSV() {
          //新增数据表 请往该数组中添加....
          console.log("_loadCSV->000000!!");
          resources.loadDir("datas", (err, assets) => {
            console.log("_loadCSV->11111!!");

            if (err) {
              console.log("_loadCSV->error!!");
              return;
            }

            let arrCsvFiles = assets.filter(item => {
              console.log("_loadCSV->item._native ", item._native !== ".md");

              this._tryToCallbackOnFinished();

              return item._native !== ".md";
            });
            console.log("_loadCSV->suc!!");
            this._cntLoad = arrCsvFiles.length; //客户端加载

            if (arrCsvFiles.length) {
              arrCsvFiles.forEach((item, index, array) => {
                resourceUtil.getTextData(item.name, (err, content) => {
                  this._csvManager.addTable(item.name, content);

                  this._tryToCallbackOnFinished();
                });
              });
            } else {
              this._tryToCallbackOnFinished();
            }
          });
        }
        /**
         * 查询一条表内容
         * @param {string} tableName 表名
         * @param {string} key 列名
         * @param {any} value 值
         * @returns {Object} 一条表内容
         */


        queryOne(tableName, key, value) {
          return this._csvManager.queryOne(tableName, key, value);
        }
        /**
         * 根据ID查询一条表内容
         * @param {string}tableName 表名
         * @param {string}ID
         * @returns {Object} 一条表内容
         */


        queryByID(tableName, ID) {
          return this._csvManager.queryByID(tableName, ID);
        }
        /**
         * 根据表名获取表的所有内容
         * @param {string} tableName  表名
         * @returns {object} 表内容
         */


        getTable(tableName) {
          return this._csvManager.getTable(tableName);
        }
        /**
         * 根据表名获取表的所有内容
         * @param {string} tableName  表名
         * @returns {object} 表内容
         */


        getTableArr(tableName) {
          return this._csvManager.getTableArr(tableName);
        }
        /**
         * 查询key和value对应的所有行内容
         * @param {string} tableName 表名
         * @param {string} key 列名
         * @param {any} value 值
         * @returns {Object}
         */


        queryAll(tableName, key, value) {
          return this._csvManager.queryAll(tableName, key, value);
        } // 

        /**
         * 选出指定表里所有 key 的值在 values 数组中的数据，返回 Object，key 为 ID
         * @param {string} tableName 表名
         * @param {string} key  列名
         * @param {Array}values 数值
         * @returns 
         */


        queryIn(tableName, key, values) {
          return this._csvManager.queryIn(tableName, key, values);
        }
        /**
         * 选出符合条件的数据。condition key 为表格的key，value 为值的数组。返回的object，key 为数据在表格的ID，value为具体数据
         * @param {string} tableName 表名
         * @param {any} condition 筛选条件
         * @returns 
         */


        queryByCondition(tableName, condition) {
          return this._csvManager.queryByCondition(tableName, condition);
        }

        _tryToCallbackOnFinished() {
          if (this._callback) {
            this._currentLoad++;

            if (this._currentLoad >= this._cntLoad) {
              this._callback();
            }
          }
        }

      }, _defineProperty(_class2, "_instance", void 0), _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/sceneManager.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './resourceUtil.ts', './constants.ts', './clientEvent.ts', './loadingUI.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, director, game, find, instantiate, _defineProperty, resourceUtil, constants, clientEvent, LoadingUI;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      director = module.director;
      game = module.game;
      find = module.find;
      instantiate = module.instantiate;
    }, function (module) {
      _defineProperty = module.defineProperty;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      clientEvent = module.clientEvent;
    }, function (module) {
      LoadingUI = module.LoadingUI;
    }],
    execute: function () {
      var _dec, _class, _class2, _temp;

      cclegacy._RF.push({}, "1c9f2SaApBI24JPUfdbbqk8", "sceneManager", undefined);

      const {
        ccclass
      } = _decorator;
      let SceneManager = exports('SceneManager', (_dec = ccclass('SceneManager'), _dec(_class = (_temp = _class2 = class SceneManager extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "curLoadingScene", null);

          _defineProperty(this, "callback", null);

          _defineProperty(this, "loading", null);

          _defineProperty(this, "tasks", null);

          _defineProperty(this, "isStop", false);
        }

        static get instance() {
          if (this._instance) {
            return this._instance;
          }

          this._instance = new SceneManager();
          return this._instance;
        }

        loadScene(sceneName, tasks, callback) {
          this.curLoadingScene = sceneName;
          this.callback = callback;
          var type = constants.SCENE_MANAGER_TYPE.LOAD_SCENE;

          var _this = this;

          tasks.push(this.preloadScene.bind(this));
          var parent = director.getScene();
          this.initLoadingUI(parent, 'loading', function () {
            _this.loading.getComponent(LoadingUI).startLoading(type, tasks, function (err, result) {
              if (err) {
                console.error(err.message || err);

                _this.callback.apply(null, [err].concat(result));

                return;
              }

              try {
                director.loadScene(_this.curLoadingScene, function () {
                  _this.callback.apply(null, [null].concat(null));

                  game.removePersistRootNode(_this.loading);

                  _this.loading.removeFromParent();

                  clientEvent.dispatchEvent("onSceneChanged");
                });
              } catch (error) {
                console.log("loadScene", sceneName, error);
              }
            });
          });
        }

        preloadScene() {
          var arg = arguments;

          var onSceneLoaded = function () {
            arg[arg.length - 1].apply(null, Array.prototype.slice.call(arg, 1));
          };

          director.preloadScene(this.curLoadingScene, onSceneLoaded);
        }

        load(tasks, callback) {
          this.callback = callback;
          this.tasks = tasks;

          var _this = this;

          var type = constants.SCENE_MANAGER_TYPE.LOAD;
          var canvas = find('Canvas');
          this.initLoadingUI(canvas, 'loading', function () {
            _this.loading.setPosition(0, 0);

            _this.loading.getComponent(LoadingUI).startLoading(type, _this.tasks, function (err, result) {
              if (err) {
                console.error(err.message || err);

                _this.callback.apply(null, [err].concat(result));

                return;
              }

              _this.callback.apply(null, [null].concat(null));
            });
          });
        }

        initLoadingUI(parent, name, cb) {
          var _this = this;

          resourceUtil.getUIPrefabRes('loading/' + name, function (error, prefab) {
            if (!_this.loading || _this.loading.name !== 'loading') {
              delete _this.loading;
              _this.loading = instantiate(prefab);
              _this.loading.active = false;
              parent.addChild(_this.loading, 999);
            }

            cb();
          });
        }

        enterSceneByAnimation(name, sceneName, tasks, callback) {
          this.curLoadingScene = sceneName;
          this.callback = callback;

          var _this = this;

          tasks.push(this.preloadScene.bind(this));
          var parent = director.getScene();
          this.initLoadingUI(parent, name, function () {
            _this.loading.getComponent('loadingCloudUI').startLoading(false, tasks, function (err, result) {
              if (err) {
                console.error(err.message || err);

                _this.callback.apply(null, [err].concat(result));

                return;
              }

              director.preloadScene(_this.curLoadingScene, function () {
                director.loadScene(_this.curLoadingScene, function () {
                  _this.loading.getComponent('loadingCloudUI').endLoading(true);

                  _this.callback.apply(null, [null].concat(null));

                  clientEvent.dispatchEvent("onSceneChanged");
                });
              });
            });
          });
        }

        discontinue() {
          this.loading && this.loading.destroy();
        }

      }, _defineProperty(_class2, "_instance", void 0), _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/buy.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './resourceUtil.ts', './constants.ts', './clientEvent.ts', './utils.ts', './localConfig.ts', './playerData.ts', './uiManager.ts', './LanguageData.ts', './PlatformBridge.js', './PlatformBridge.mjs_cjs=&original=.js', './gameLogic.ts', './ConstValue.js', './ConstValue.mjs_cjs=&original=.js'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, Color, Animation, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, resourceUtil, constants, clientEvent, utils, localConfig, playerData, uiManager, t, _cjsExports, GameLogic, _cjsExports$1;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      Color = module.Color;
      Animation = module.Animation;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      clientEvent = module.clientEvent;
    }, function (module) {
      utils = module.utils;
    }, function (module) {
      localConfig = module.localConfig;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      t = module.t;
    }, function (module) {
      _cjsExports = module.default;
    }, null, function (module) {
      GameLogic = module.GameLogic;
    }, function (module) {
      _cjsExports$1 = module.default;
    }, null],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _temp;

      cclegacy._RF.push({}, "1f6e9kNl7VAkLVmkwCJLBL2", "buy", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let Buy = exports('Buy', (_dec = ccclass('Buy'), _dec(_class = (_class2 = (_temp = class Buy extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "lbTitle", _descriptor, this);

          _initializerDefineProperty(this, "lbNum", _descriptor2, this);

          _initializerDefineProperty(this, "lbDesc", _descriptor3, this);

          _initializerDefineProperty(this, "lbGold", _descriptor4, this);

          _initializerDefineProperty(this, "lbGoldNum", _descriptor5, this);

          _initializerDefineProperty(this, "lbAd", _descriptor6, this);

          _initializerDefineProperty(this, "spProp", _descriptor7, this);

          _initializerDefineProperty(this, "spAdIcon", _descriptor8, this);

          _initializerDefineProperty(this, "btnBuy", _descriptor9, this);

          _initializerDefineProperty(this, "nodeBtnBuy", _descriptor10, this);

          _initializerDefineProperty(this, "nodeBtnAd", _descriptor11, this);

          _initializerDefineProperty(this, "imgShare", _descriptor12, this);

          _initializerDefineProperty(this, "imgAd", _descriptor13, this);

          _defineProperty(this, "propId", void 0);

          _defineProperty(this, "eventType", void 0);

          _defineProperty(this, "countPerBuy", void 0);

          _defineProperty(this, "propNum", void 0);

          _defineProperty(this, "cost", void 0);

          _defineProperty(this, "getPropType", void 0);
        }

        onEnable() {
          clientEvent.on('updateGold', this.updateGold, this);
          clientEvent.on('updateInfiniteShareTimes', this.updateBuyBtn, this);
        }

        onDisable() {
          clientEvent.off('updateGold', this.updateGold, this);
          clientEvent.off('updateInfiniteShareTimes', this.updateBuyBtn, this);
        }

        showBuy(isShow) {
          this.nodeBtnBuy.active = isShow;
          this.nodeBtnAd.active = !isShow;
        }

        show(propId, eventType) {
          Global.buySc = this;
          this.propId = propId;
          this.eventType = eventType;
          let prop = localConfig.instance.queryByID('prop', propId);

          if (!prop) {
            console.error('prop was error!', propId);
            this.close();
            return;
          }

          this.countPerBuy = prop.countPerBuy;
          this.lbTitle.string = t('table_prop.' + prop.name);
          this.propNum = prop.countPerBuy;
          this.lbNum.string = 'X ' + this.propNum;
          this.lbDesc.string = t('table_prop.' + prop.desc);
          this.cost = prop.countPerBuy * prop.price;
          this.lbGold.string = this.cost;

          if (this.cost > playerData.instance.getGold()) {
            this.btnBuy.interactable = false;
            this.lbGold.color = Color.RED;
          } else {
            this.btnBuy.interactable = true;
            this.lbGold.color = Color.WHITE;
          }

          resourceUtil.setPropIcon(prop.icon, this.spProp, () => {});
          let ani = this.node.getComponent(Animation);
          ani.once(Animation.EventType.FINISHED, () => {
            ani.play('buy');
          });
          this.updateGold();
          this.updateBuyBtn();
        }

        updateBuyBtn() {
          if (this.propId === constants.PROP_ID.INFINITE) {
            this.showBuy(false);
            GameLogic.instance.getOpenRewardType(constants.SHARE_FUNCTION.BUY_INFINITE, (err, type) => {
              this.getPropType = type;

              switch (type) {
                case constants.OPEN_REWARD_TYPE.AD:
                  this.spAdIcon.spriteFrame = this.imgAd;
                  break;

                case constants.OPEN_REWARD_TYPE.SHARE:
                  this.spAdIcon.spriteFrame = this.imgShare;
                  break;

                case constants.OPEN_REWARD_TYPE.NULL:
                  this.showBuy(true);
                  break;
              } // let infiniteShareTimes = playerData.instance.getInfiniteTimes();
              // if (infiniteShareTimes >= constants.MAX_INFINITE_TIMES) {


              this.spAdIcon.node.active = true;
              this.lbAd.string = t('shop.receive'); // } else {
              //     this.spAdIcon.node.active = true;
              //     this.lbAd.string = infiniteShareTimes + '/' + constants.MAX_INFINITE_TIMES;
              // }
            });
          } else {
            this.showBuy(true);
          }
        }

        onBtnCloseClick() {
          this.close();
        }

        onBtnBuyClick() {
          GameLogic.instance.addGold(-this.cost);
          clientEvent.dispatchEvent('updateInfiniteShareTimes');
          this.rewardProp();
          this.close();
        }

        rewardProp() {
          let itemInfo = {};
          itemInfo['itemType'] = constants.REWARD_TYPE.PROP;
          itemInfo['itemSubType'] = this.propId;
          itemInfo['itemAmount'] = this.countPerBuy;
          uiManager.instance.showDialog('lottery/reward', [itemInfo, false, constants.SHARE_FUNCTION.BUY_INFINITE]);
        }

        onBtnReceiveClick() {
          // let infiniteShareTimes = playerData.instance.getInfiniteTimes();
          // if (infiniteShareTimes >= constants.MAX_INFINITE_TIMES) {
          //     playerData.instance.exchangeInfiniteProp(); //消耗次数
          //     this.rewardProp();
          // }
          _cjsExports.showRewardAd("onBtnBuyReceiveClick", "1", _cjsExports$1.getAdReward());
        }

        onBtnReceiveClickCallback(s) {
          if (s) {
            this.rewardProp();
            this.close();
          }
        }

        close() {
          uiManager.instance.hideDialog('props/buy');
        }

        updateGold() {
          this.lbGoldNum.string = utils.formatMoney(playerData.instance.getGold());
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "lbTitle", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "lbNum", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "lbDesc", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "lbGold", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "lbGoldNum", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "lbAd", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "spProp", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "spAdIcon", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "btnBuy", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "nodeBtnBuy", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "nodeBtnAd", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "imgShare", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "imgAd", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/balance.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './constants.ts', './clientEvent.ts', './sceneManager.ts', './playerData.ts', './uiManager.ts', './audioManager.ts', './LanguageData.ts', './PlatformBridge.js', './PlatformBridge.mjs_cjs=&original=.js', './gameLogic.ts', './ConstValue.js', './ConstValue.mjs_cjs=&original=.js'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, Component, Animation, view, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, constants, clientEvent, SceneManager, playerData, uiManager, AudioManager, t, _cjsExports, GameLogic, _cjsExports$1;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      Component = module.Component;
      Animation = module.Animation;
      view = module.view;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      clientEvent = module.clientEvent;
    }, function (module) {
      SceneManager = module.SceneManager;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      AudioManager = module.AudioManager;
    }, function (module) {
      t = module.t;
    }, function (module) {
      _cjsExports = module.default;
    }, null, function (module) {
      GameLogic = module.GameLogic;
    }, function (module) {
      _cjsExports$1 = module.default;
    }, null],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _temp;

      cclegacy._RF.push({}, "22cecTzEh5L6o8yC7/SYP4X", "balance", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let Balance = exports('Balance', (_dec = ccclass('Balance'), _dec2 = property(Node), _dec(_class = (_class2 = (_temp = class Balance extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "lbLevel", _descriptor, this);

          _initializerDefineProperty(this, "lbScore", _descriptor2, this);

          _initializerDefineProperty(this, "lbHighest", _descriptor3, this);

          _initializerDefineProperty(this, "lbGold", _descriptor4, this);

          _initializerDefineProperty(this, "arrStar", _descriptor5, this);

          _initializerDefineProperty(this, "arrStarLight", _descriptor6, this);

          _initializerDefineProperty(this, "ndBtnDouble", _descriptor7, this);

          _initializerDefineProperty(this, "spBtnDouble", _descriptor8, this);

          _initializerDefineProperty(this, "ani", _descriptor9, this);

          _initializerDefineProperty(this, "aniGold", _descriptor10, this);

          _initializerDefineProperty(this, "sfAd", _descriptor11, this);

          _initializerDefineProperty(this, "sfShare", _descriptor12, this);

          _initializerDefineProperty(this, "nativeAd", _descriptor13, this);

          _defineProperty(this, "isFirstInvite", void 0);

          _defineProperty(this, "goldNum", void 0);

          _defineProperty(this, "isOver", void 0);

          _defineProperty(this, "soundStar", void 0);

          _defineProperty(this, "openRewardType", void 0);
        }

        show() {
          Global.balance = this;
          let self = this;

          _cjsExports.showNativeAd((frame, string) => {
            let sc = self.nativeAd.getComponent("NativeAdBig");

            if (sc) {
              sc.setDateShow();
              sc.setSprite(frame);
              sc.setString(string);
            }
          });

          _cjsExports.showInterstitialAd();

          this.aniGold.node.active = true;
          this.isFirstInvite = false;
          let ret = playerData.instance.finishLevel(playerData.instance.level, playerData.instance.score);
          let levelVal = playerData.instance.getCurrentLevel()['ID'] + '';
          this.goldNum = ret.gold;
          this.isOver = false;
          this.lbGold.string = ret.gold.toString();
          this.lbLevel.string = ret.levelId;
          this.lbScore.string = ret.score;
          this.lbHighest.string = t('fight.highest') + playerData.instance.getHighestScoreByLevel(ret.levelId);
          this.soundStar = 0;
          let stars = playerData.instance.arrStars;
          this.arrStar[0].active = ret.star > 0;
          this.arrStarLight[0].active = ret.star > 0;
          this.arrStar[1].active = ret.star > 1;
          this.arrStarLight[1].active = ret.star > 1;
          this.arrStar[2].active = ret.star > 2;
          this.arrStarLight[2].active = ret.star > 2;
          this.ani.play("balanceShow");
          this.ani.once(Animation.EventType.FINISHED, () => {
            this.ani.play('balanceIdle');
          }, this);

          if (this.goldNum > 0) {
            GameLogic.instance.getOpenRewardType(constants.SHARE_FUNCTION.FILL_SIGN, (err, type) => {
              if (!err) {
                this.openRewardType = type;

                switch (type) {
                  case constants.OPEN_REWARD_TYPE.AD:
                    this.ndBtnDouble.active = true;
                    this.spBtnDouble.spriteFrame = this.sfAd;
                    this.aniGold.play();
                    break;

                  case constants.OPEN_REWARD_TYPE.SHARE:
                    this.ndBtnDouble.active = true;
                    this.aniGold.play();
                    this.spBtnDouble.spriteFrame = this.sfShare;
                    break;

                  case constants.OPEN_REWARD_TYPE.NULL:
                    this.ndBtnDouble.active = false;
                    break;
                }
              } else {
                this.close();
              }
            });
          } else {
            this.ndBtnDouble.active = false;
          }
        }

        onShowStar() {
          if (this.arrStar[this.soundStar].active) {
            AudioManager.instance.playSound(constants.AUDIO_SOUND.FINISH_STAR, false);
          }

          this.soundStar++;
        }

        onDisable() {}

        onBtnNextClick() {
          if (Global.onClickNextCount < 3) {
            Global.onClickNextCount++;
          }

          if (Global.onClickNextCount == 3) {
            Global.onClickNextCount = 0; //todo 展示插屏视频

            let adWidth = 0.7 * view.getFrameSize().width;
            let adHeight = adWidth * 3 / 2;
            console.log('gamemanager showInterstitialAd: adWidth:' + adWidth + ", adHeight:" + adHeight);

            _cjsExports.showInterstitialAd("gamenext", _cjsExports$1.getAdInterstitialVideo(), adWidth, adHeight);
          }

          GameLogic.instance.customEventStatistics(constants.ANALYTICS_TYPE.BALANCE_NEXT);

          if (this.isOver) {
            return;
          }

          this.isOver = true;
          playerData.instance.nextLevel();
          this.close();
          clientEvent.dispatchEvent('newLevel');
        }

        onBtnRetryClick() {
          this.close();
          GameLogic.instance.customEventStatistics(constants.ANALYTICS_TYPE.BALANCE_PLAY_AGAIN);
          GameLogic.instance.resetLevel();
        }

        onBtnCloseClick() {
          GameLogic.instance.customEventStatistics(constants.ANALYTICS_TYPE.BALANCE_CLOSE);
          this.close();
          SceneManager.instance.loadScene('pve', [], (err, result) => {
            if (err) {
              console.error(err.message || err);
              return;
            }
          });
        }

        onBtnDoubleClick() {
          if (this.openRewardType === constants.OPEN_REWARD_TYPE.SHARE) {
            GameLogic.instance.share(constants.SHARE_FUNCTION.BALANCE, {}, err => {
              if (!err) {
                this.showReward();
              }
            });
            GameLogic.instance.customEventStatistics(constants.ANALYTICS_TYPE.BALANCE_SHARE);
          } else {
            // GameLogic.instance.showRewardAd((err: any) => {
            //     if (!err) {
            //         this.showReward();
            //     }
            // });
            _cjsExports.showRewardAd("onBtnBalanceReceiveClick", "1", _cjsExports$1.getAdReward());
          }
        }

        onBtnDoubleClickCallback(s) {
          if (s) {
            this.showReward();
          }
        }

        showReward() {
          if (!this.isFirstInvite) {
            this.isFirstInvite = true;
            let itemInfo = {};
            itemInfo.itemType = constants.REWARD_TYPE.GOLD;
            itemInfo.itemSubType = 0;
            itemInfo.itemAmount = this.goldNum;
            this.aniGold.node.active = false;
            uiManager.instance.showDialog('lottery/reward', [itemInfo, false, constants.SHARE_FUNCTION.BALANCE]);
          }
        }

        close() {
          uiManager.instance.hideDialog('fight/balance');
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "lbLevel", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "lbScore", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "lbHighest", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "lbGold", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "arrStar", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "arrStarLight", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "ndBtnDouble", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "spBtnDouble", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "ani", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "aniGold", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "sfAd", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "sfShare", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "nativeAd", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/linkLine.ts", ['cc', './_rollupPluginModLoBabelHelpers.js'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, Animation, Vec3, misc, _applyDecoratedDescriptor, _initializerDefineProperty;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      Animation = module.Animation;
      Vec3 = module.Vec3;
      misc = module.misc;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _temp;

      cclegacy._RF.push({}, "23fc7Zdwd5LN4VPatBdx7mq", "linkLine", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let LinkLine = exports('LinkLine', (_dec = ccclass('LinkLine'), _dec(_class = (_class2 = (_temp = class LinkLine extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "animation", _descriptor, this);
        }

        show() {
          this.animation.play('linkLineShow');
          this.animation.once(Animation.EventType.FINISHED, () => {
            this.animation.play('linkLineNormal');
          });
        }

        setLinePosition(posStart, posEnd) {
          let posOffset = posEnd.clone().subtract(posStart);
          let pos = new Vec3(posStart.x + posOffset.x / 2, posStart.y + posOffset.y / 2, 0);
          this.node.position = pos;
          let degree = 0;

          if (posOffset.x !== 0) {
            degree = misc.radiansToDegrees(Math.atan(posOffset.y / posOffset.x));
          } else {
            degree = 90;
          }

          this.node.eulerAngles = new Vec3(0, 0, degree);
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "animation", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/RotateAnim.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, Component, tween, _decorator;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Component = module.Component;
      tween = module.tween;
      _decorator = module._decorator;
    }],
    execute: function () {
      var _dec, _class;

      cclegacy._RF.push({}, "25a71l2hqdCFLv1gLRc3RxN", "RotateAnim", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      /**
       * Predefined variables
       * Name = RotateAnim
       * DateTime = Tue Mar 01 2022 12:15:53 GMT+0800 (中国标准时间)
       * Author = qiaopc
       * FileBasename = RotateAnim.ts
       * FileBasenameNoExtension = RotateAnim
       * URL = db://assets/scripts/jijia/RotateAnim.ts
       * ManualUrl = https://docs.cocos.com/creator/3.4/manual/zh/
       *
       */

      let RotateAnim = exports('RotateAnim', (_dec = ccclass('RotateAnim'), _dec(_class = class RotateAnim extends Component {
        // [1]
        // dummy = '';
        // [2]
        // @property
        // serializableDummy = 0;
        onLoad() {
          tween(this.node).repeatForever(tween(this.node).by(1.5, {
            angle: 360
          })).start();
        }

        start() {// [3]
        } // update (deltaTime: number) {
        //     // [4]
        // }


      }) || _class));
      /**
       * [1] Class member could be defined like this.
       * [2] Use `property` decorator if your want the member to be serializable.
       * [3] Your initialization goes here.
       * [4] Your update function goes here.
       *
       * Learn more about scripting: https://docs.cocos.com/creator/3.4/manual/zh/scripting/
       * Learn more about CCClass: https://docs.cocos.com/creator/3.4/manual/zh/scripting/decorator.html
       * Learn more about life-cycle callbacks: https://docs.cocos.com/creator/3.4/manual/zh/scripting/life-cycle-callbacks.html
       */

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/showTarget.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './clientEvent.ts', './playerData.ts', './showTargetCake.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, Animation, instantiate, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, clientEvent, playerData, ShowTargetCake;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      Animation = module.Animation;
      instantiate = module.instantiate;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      clientEvent = module.clientEvent;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      ShowTargetCake = module.ShowTargetCake;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp;

      cclegacy._RF.push({}, "2c1036ANX5HcIKmghpPMpLE", "showTarget", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ShowTarget = exports('ShowTarget', (_dec = ccclass('ShowTarget'), _dec(_class = (_class2 = (_temp = class ShowTarget extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "pfCake", _descriptor, this);

          _initializerDefineProperty(this, "nodeTargetGroup", _descriptor2, this);

          _initializerDefineProperty(this, "aniTarget", _descriptor3, this);

          _defineProperty(this, "_parent", void 0);
        }

        show(parent, callback) {
          this._parent = parent;
          this.aniTarget.play('showTarget');
          this.aniTarget.once(Animation.EventType.FINISHED, () => {
            this.node && this.node.destroy();

            if (callback) {
              callback();
            }
          }, this);

          for (let target in playerData.instance.dictTargets) {
            let nodeTarget = instantiate(this.pfCake);
            nodeTarget.parent = this.nodeTargetGroup;
            nodeTarget.getComponent(ShowTargetCake).show(target, this);
          }
        }

        showFlyEffect(cake, srcWorldPos) {
          let targetWorldPos = this._parent.getTargetWorldPos(cake);

          if (targetWorldPos) {
            this._parent._fightScene.effectGroup.playTargetCakeFlyEffect(cake, srcWorldPos, targetWorldPos, () => {
              clientEvent.dispatchEvent('showTargetCake', cake);
            });
          } else {
            clientEvent.dispatchEvent('showTargetCake', cake);
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "pfCake", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "nodeTargetGroup", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "aniTarget", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/signinReward.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './resourceUtil.ts', './constants.ts', './clientEvent.ts', './localConfig.ts', './playerData.ts', './uiManager.ts', './LanguageData.ts', './PlatformBridge.js', './PlatformBridge.mjs_cjs=&original=.js', './gameLogic.ts'], function (exports) {
  'use strict';

  var cclegacy, SpriteFrame, Sprite, Label, Animation, Node, _decorator, Component, UITransform, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, resourceUtil, constants, clientEvent, localConfig, playerData, uiManager, t, _cjsExports, GameLogic;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      SpriteFrame = module.SpriteFrame;
      Sprite = module.Sprite;
      Label = module.Label;
      Animation = module.Animation;
      Node = module.Node;
      _decorator = module._decorator;
      Component = module.Component;
      UITransform = module.UITransform;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      clientEvent = module.clientEvent;
    }, function (module) {
      localConfig = module.localConfig;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      t = module.t;
    }, function (module) {
      _cjsExports = module.default;
    }, null, function (module) {
      GameLogic = module.GameLogic;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _temp;

      cclegacy._RF.push({}, "332caaRRoVO04/rOFgXW9L6", "signinReward", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let signInReward = exports('signInReward', (_dec = ccclass('signInReward'), _dec2 = property(SpriteFrame), _dec3 = property(SpriteFrame), _dec4 = property(Sprite), _dec5 = property(Label), _dec6 = property(Animation), _dec7 = property(Node), _dec(_class = (_class2 = (_temp = class signInReward extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "sfDiamond", _descriptor, this);

          _initializerDefineProperty(this, "sfGold", _descriptor2, this);

          _initializerDefineProperty(this, "spIcon", _descriptor3, this);

          _initializerDefineProperty(this, "lbRewardValue", _descriptor4, this);

          _initializerDefineProperty(this, "aniGetItem", _descriptor5, this);

          _initializerDefineProperty(this, "nativeAd", _descriptor6, this);

          _defineProperty(this, "itemInfo", void 0);

          _defineProperty(this, "currentDay", void 0);

          _defineProperty(this, "callback", void 0);

          _defineProperty(this, "isLast", void 0);

          _defineProperty(this, "itemType", void 0);

          _defineProperty(this, "itemAmount", void 0);

          _defineProperty(this, "itemSubType", void 0);
        }

        show(itemInfo, callback, isLast) {
          let self = this;
          console.log("showNativeAd00");

          _cjsExports.showNativeAd(frame => {
            console.log("showNativeAd0");
            let sc = self.nativeAd.getComponent("NativeAdBig");
            console.log("showNativeAd1");

            if (sc) {
              console.log("showNativeAd2");
              sc.setSprite(frame);
              console.log("showNativeAd3");
            }
          });

          _cjsExports.showCustomAd(false);

          this.itemInfo = itemInfo;
          this.currentDay = itemInfo['ID'];
          this.callback = callback;
          this.isLast = isLast;
          this.itemType = itemInfo["itemType"];
          this.itemAmount = itemInfo["itemAmount"];
          this.itemSubType = itemInfo["itemSubType"];
          this.aniGetItem.play('getItemShow');
          this.aniGetItem.once(Animation.EventType.FINISHED, () => {
            this.aniGetItem.play('getItemIdle');
          }, this);
          this.setRewardPage();
        }

        setRewardPage() {
          const uiTraSpIcon = this.spIcon.getComponent(UITransform);

          switch (this.itemType) {
            case constants.REWARD_TYPE.DIAMOND:
              this.spIcon.spriteFrame = this.sfDiamond;
              this.lbRewardValue.string = this.itemAmount;
              break;

            case constants.REWARD_TYPE.GOLD:
              this.spIcon.spriteFrame = this.sfGold;
              this.lbRewardValue.string = this.itemAmount;
              uiTraSpIcon.width = 257;
              uiTraSpIcon.height = 166;
              break;

            case constants.REWARD_TYPE.PROP:
              let propId = this.itemSubType;
              let propData = localConfig.instance.queryByID('prop', propId + '');
              resourceUtil.setPropIcon("00" + propId, this.spIcon, () => {});
              uiTraSpIcon.width = 168;
              uiTraSpIcon.height = 168;
              let txt = t('table_prop.' + propData.name);
              this.lbRewardValue.string = txt + t('') + ' x ' + this.itemAmount;
              break;
          }
        }

        onBtnReceiveClick() {
          this.addReward();

          if (this.isLast) {
            //当前的isLast
            let isReceive = null;
            GameLogic.instance.getOpenRewardType(constants.SHARE_FUNCTION.FILL_SIGN, (err, type) => {
              if (!err) {
                switch (type) {
                  case constants.OPEN_REWARD_TYPE.AD:
                    isReceive = playerData.instance.getSignInReceivedInfo()['isAllReceived'];
                    break;

                  case constants.OPEN_REWARD_TYPE.SHARE:
                    isReceive = playerData.instance.getSignInReceivedInfo()['isAllReceived'];
                    break;

                  case constants.OPEN_REWARD_TYPE.NULL:
                    isReceive = playerData.instance.getSignInReceivedInfo()['isTodayReceived'];
                    break;
                }
              } else {
                isReceive = playerData.instance.getSignInReceivedInfo()['isAllReceived'];
              }
            });

            if (!isReceive) {
              //null：是今天否领取完，分享广告：是否全部领取完，如果没有则接着显示signIn界面
              uiManager.instance.showDialog('signIn/signIn');
            } else {
              //直接隐藏自己
              uiManager.instance.hideDialog("signIn/signInReward");
            }
          }

          uiManager.instance.shiftFromPopupSeq('signIn/signInReward'); //关闭当前奖励界面，显示下一个

          _cjsExports.hideCustomAd();
        }

        addReward() {
          switch (this.itemType) {
            case constants.REWARD_TYPE.DIAMOND:
              GameLogic.instance.addDiamond(this.itemAmount);
              break;

            case constants.REWARD_TYPE.GOLD:
              GameLogic.instance.addGold(this.itemAmount);
              break;

            case constants.REWARD_TYPE.PROP:
              GameLogic.instance.addProp(this.itemSubType, this.itemAmount);
              break;
          }

          if (this.currentDay) {
            playerData.instance.updateSignInReceivedDays(this.currentDay);
            clientEvent.dispatchEvent('updateSignIn');
          }

          if (this.callback) {
            this.callback();
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "sfDiamond", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "sfGold", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "spIcon", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "lbRewardValue", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "aniGetItem", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "nativeAd", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/LocalizedMaterial.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './LanguageData.ts'], function (exports) {
  'use strict';

  var cclegacy, Material, _decorator, Component, MeshRenderer, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, ready, init, _language;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Material = module.Material;
      _decorator = module._decorator;
      Component = module.Component;
      MeshRenderer = module.MeshRenderer;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      ready = module.ready;
      init = module.init;
      _language = module._language;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _temp, _dec3, _dec4, _class4, _class5, _descriptor3, _temp2;

      cclegacy._RF.push({}, "35069qDXPFL47Ep1p+WLvRd", "LocalizedMaterial", undefined);

      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      let LocalizedMaterialItem = (_dec = ccclass('LocalizedMaterialItem'), _dec2 = property({
        type: Material
      }), _dec(_class = (_class2 = (_temp = class LocalizedMaterialItem {
        constructor() {
          _initializerDefineProperty(this, "language", _descriptor, this);

          _initializerDefineProperty(this, "material", _descriptor2, this);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "language", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 'zh';
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "material", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class);
      let LocalizedMaterial = exports('LocalizedMaterial', (_dec3 = ccclass('LocalizedMaterial'), _dec4 = property({
        type: LocalizedMaterialItem
      }), _dec3(_class4 = executeInEditMode(_class4 = (_class5 = (_temp2 = class LocalizedMaterial extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "mesh", null);

          _initializerDefineProperty(this, "materialsList", _descriptor3, this);
        }

        onLoad() {
          if (!ready) {
            init('zh');
          }

          this.fetchRender();
        }

        fetchRender() {
          let mesh = this.getComponent(MeshRenderer);

          if (mesh) {
            this.mesh = mesh;
            this.updateMat();
            return;
          }
        }

        updateMat() {
          for (let i = 0; i < this.materialsList.length; i++) {
            const item = this.materialsList[i]; // @ts-ignore

            if (item.language === _language) {
              // @ts-ignore
              this.mesh && this.mesh.setMaterial(item.material, 0);
            }
          }
        }

      }, _temp2), _descriptor3 = _applyDecoratedDescriptor(_class5.prototype, "materialsList", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _class5)) || _class4) || _class4));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/multiScrollView.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './utils.ts', './localConfig.ts', './playerData.ts', './loadsh.ts', './pveSlotUI.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, NodePool, instantiate, UITransform, Size, Vec3, Vec2, view, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, utils, localConfig, playerData, loadsh, PveSlotUI;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      NodePool = module.NodePool;
      instantiate = module.instantiate;
      UITransform = module.UITransform;
      Size = module.Size;
      Vec3 = module.Vec3;
      Vec2 = module.Vec2;
      view = module.view;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      utils = module.utils;
    }, function (module) {
      localConfig = module.localConfig;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      loadsh = module.loadsh;
    }, function (module) {
      PveSlotUI = module.PveSlotUI;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp;

      cclegacy._RF.push({}, "3e6b57QbUBJ9rTvcQwwnAgL", "multiScrollView", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let MultiScrollView = exports('MultiScrollView', (_dec = ccclass('MultiScrollView'), _dec(_class = (_class2 = (_temp = class MultiScrollView extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "scrollView", _descriptor, this);

          _initializerDefineProperty(this, "pve1Prefab", _descriptor2, this);

          _initializerDefineProperty(this, "pve2Prefab", _descriptor3, this);

          _defineProperty(this, "updateTimer", void 0);

          _defineProperty(this, "updateInterval", void 0);

          _defineProperty(this, "lastPositionY", void 0);

          _defineProperty(this, "pool", void 0);

          _defineProperty(this, "pool1", void 0);

          _defineProperty(this, "pool2", void 0);

          _defineProperty(this, "contentNode", void 0);

          _defineProperty(this, "pve1Node", void 0);

          _defineProperty(this, "parent", void 0);

          _defineProperty(this, "isChange", void 0);

          _defineProperty(this, "arrayPrefab", void 0);

          _defineProperty(this, "positions", void 0);

          _defineProperty(this, "isNeedScroll", void 0);

          _defineProperty(this, "currentPosition", void 0);

          _defineProperty(this, "cloudPrefab", void 0);

          _defineProperty(this, "positionCloud1", void 0);

          _defineProperty(this, "positionCloud2", void 0);
        }

        onLoad() {
          this.updateTimer = 0; //更新时间

          this.updateInterval = 0.2; //更新间隔

          this.lastPositionY = 0;
          this.pool = new NodePool(); //关卡对象池

          this.pool1 = new NodePool(); //云层1对象池

          this.pool2 = new NodePool(); //云层2对象池

          this.contentNode = this.scrollView.content;
          this.pve1Node = instantiate(this.pve1Prefab);
          this.contentNode.addChild(this.pve1Node, 999); //显示在最底层
        }

        start() {
          this.show();
        }

        onEnable() {
          this.contentNode.on('size-changed', this.sizeChange, this);
        }

        onDisable() {
          this.contentNode.off('size-changed', this.sizeChange, this);
        }

        init(parent) {
          this.parent = parent;
        }

        show() {
          this.isChange = true;
          this.isNeedScroll = true;
          this.positions = [];
          var pve = utils.objectToArray(localConfig.instance.getTable('level'));
          var y;
          var height = -100; // 回弹范围

          var pve1Data = pve.slice(0, 1); //第一层包含1个关卡

          this.pve1Node.setPosition(0, height); //

          var uiTraContent = this.contentNode.getComponent(UITransform);
          const size = uiTraContent.contentSize;
          uiTraContent.setContentSize(new Size(size.width, this.pve1Node.getComponent(UITransform).height + height));
          this.pve1Node.getComponent(PveSlotUI).show(this, pve1Data, -1);
          this.arrayPrefab = loadsh.chunk(loadsh.drop(pve, 1), 22); //除第一层外包含22个关卡

          var length = this.arrayPrefab.length;
          const heightPve2 = this.pve2Prefab.data.getComponent(UITransform).height;

          for (var i = 0; i < length; i++) {
            y = size.height; //关卡无重合部分

            this.positions.push(new Vec3(0, y, 0));
            uiTraContent.setContentSize(new Size(size.width, y + heightPve2));
          }

          uiTraContent.setContentSize(new Size(size.width, size.height - heightPve2 / 3));
          this.addNode();
          var currentLevel = playerData.instance.getCurrentLevel();
          var index = loadsh.findIndex(pve, function (n) {
            return n.ID === currentLevel.ID;
          });
          let idxPage = index / 22;
          this.currentPosition = idxPage >= 0 ? this.positions[Math.floor(idxPage)] : new Vec2(0, 0);
          this.currentPosition = new Vec3(this.currentPosition.x, this.currentPosition.y, 0);
          let idxLevel = index % 22 + 1;
          this.currentPosition.y = this.currentPosition.y + this.pve2Prefab.data.getChildByName('level' + idxLevel).y;
          this.currentPosition.y -= view.getVisibleSize().height / 2;
          this.scrollToNode();
        }

        update(dt) {
          this.scrolling();
          this.updateTimer += dt;

          if (this.updateTimer < this.updateInterval) {
            return; // we don't need to do the math every frame
          }

          this.updateTimer = 0;
          this.addNode();
        }

        addNode() {
          if (!this.arrayPrefab) return;
          var itemHeight;

          for (var i = 0; i < this.arrayPrefab.length; i++) {
            itemHeight = this.pve2Prefab.data.getComponent(UITransform).height;
            this.updateNode(i, itemHeight, this.contentNode, this.pool, this.positions, this.pve2Prefab, this.arrayPrefab);
          }

          this.isChange = false;
        }

        updateNode(index, itemHeight, node, pool, positions, prefab, contents) {
          var child;
          var viewPos = this.getPositionInView(node, positions[index]);

          if (this.isOverBorder(viewPos, itemHeight)) {
            child = node.getChildByName(String(index));

            if (child) {
              this.remove(child, node, pool);
            }
          } else {
            child = node.getChildByName(String(index));

            if (!child) {
              this.create(child, index, node, pool, positions, prefab, contents);
            } else if (this.isChange) {
              var pveSlotUI = child.getComponent(PveSlotUI);
              if (pveSlotUI) pveSlotUI.show(this, contents[index], index);
              child.setPosition(positions[index]);
              child.tag = index;
            }
          }
        }

        create(child, index, node, pool, positions, prefab, contents) {
          if (pool.size() > 0) {
            // 通过 size 接口判断对象池中是否有空闲的对象
            child = pool.get();
          } else {
            // 如果没有空闲对象，也就是对象池中备用对象不够时，我们就用 cc.instantiate 重新创建
            child = instantiate(prefab);
          }

          child.setPosition(positions[index]);
          node.addChild(child);
          child.setSiblingIndex(0);
          child.name = String(index);
          var pveSlotUI = child.getComponent(PveSlotUI);
          if (pveSlotUI) pveSlotUI.show(this, contents[index], index);
        }

        remove(child, node, pool) {
          pool.put(child);
          node.removeChild(child, false);
        }

        getPositionInView(node, position) {
          var worldPos = node.getComponent(UITransform).convertToWorldSpaceAR(position);
          var viewPos = this.scrollView.node.getComponent(UITransform).convertToNodeSpaceAR(worldPos);
          return viewPos;
        }

        isOverBorder(viewPos, itemHeight) {
          var height = this.scrollView.node.getComponent(UITransform).height;
          var borderHeight = height + height / 2 + itemHeight / 2;
          return viewPos.y > borderHeight || viewPos.y < -borderHeight;
        }

        onDestory() {
          this.pool.clear();
          this.pool1.clear();
          this.pool2.clear();
        }

        sizeChange() {
          var size = this.contentNode.getComponent(UITransform);
          this.node.getComponent(UITransform).setContentSize(size);
        }

        scrollToNode() {
          if (this.isNeedScroll) {
            this.scrollView.scrollTo(new Vec2(0, this.currentPosition.y / (this.scrollView.node.getComponent(UITransform).height - view.getCanvasSize().height)), 0.1);
          }
        }

        scrolling() {
          var position = this.contentNode.getPosition();
          this.lastPositionY = position.y;
        }

        createCloud() {
          this.positionCloud1 = [];
          this.positionCloud2 = [];
          var winHeight = view.getCanvasSize().height;
          var totalHeight = this.contentNode.getComponent(UITransform).height;
          var n = Math.ceil(totalHeight / winHeight);
          var i;

          for (i = 0; i < n; i++) {
            this.positionCloud1.push(this.randomPosition());
          }

          for (i = 0; i < n; i++) {
            this.positionCloud2.push(this.randomPosition());
          }
        }

        randomPosition() {
          var winHeight = view.getCanvasSize().height;
          var totalHeight = this.scrollView.getMaxScrollOffset().y;
          var x = utils.getRandomInt(300, 400);
          var y = utils.getRandomInt(winHeight / 2, totalHeight);
          var symbol = utils.getRandomInt(0, 1);

          if (symbol) {
            return new Vec2(x, y);
          } else {
            return new Vec2(-x, y);
          }
        }

        getCloudPrefabMaxHeight() {
          var max = 0;
          loadsh.forEach(this.cloudPrefab, function (n) {
            if (max < n.data.height) {
              max = n.data.height;
            }
          });
          return max;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "scrollView", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "pve1Prefab", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "pve2Prefab", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/unLockProp.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './resourceUtil.ts', './constants.ts', './clientEvent.ts', './localConfig.ts', './playerData.ts', './uiManager.ts', './PlatformBridge.js', './PlatformBridge.mjs_cjs=&original=.js', './gameLogic.ts', './ConstValue.js', './ConstValue.mjs_cjs=&original=.js'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, Component, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, resourceUtil, constants, clientEvent, localConfig, playerData, uiManager, _cjsExports, GameLogic, _cjsExports$1;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      Component = module.Component;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      clientEvent = module.clientEvent;
    }, function (module) {
      localConfig = module.localConfig;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      _cjsExports = module.default;
    }, null, function (module) {
      GameLogic = module.GameLogic;
    }, function (module) {
      _cjsExports$1 = module.default;
    }, null],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _temp;

      cclegacy._RF.push({}, "44716UPwaNDPLwthoATscTT", "unLockProp", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let UnLockProp = exports('UnLockProp', (_dec = ccclass('UnLockProp'), _dec2 = property(Node), _dec(_class = (_class2 = (_temp = class UnLockProp extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "lbNum", _descriptor, this);

          _initializerDefineProperty(this, "lbName", _descriptor2, this);

          _initializerDefineProperty(this, "spIcon", _descriptor3, this);

          _initializerDefineProperty(this, "spBtnReceive", _descriptor4, this);

          _initializerDefineProperty(this, "sfReceive", _descriptor5, this);

          _initializerDefineProperty(this, "sfAd", _descriptor6, this);

          _initializerDefineProperty(this, "sfShare", _descriptor7, this);

          _initializerDefineProperty(this, "ndBtnGoStart", _descriptor8, this);

          _initializerDefineProperty(this, "nativeAd", _descriptor9, this);

          _defineProperty(this, "_fightUI", void 0);

          _defineProperty(this, "callback", void 0);

          _defineProperty(this, "level", void 0);

          _defineProperty(this, "unLoclProp", void 0);

          _defineProperty(this, "propItem", void 0);

          _defineProperty(this, "openRewardType", void 0);
        }

        show(callback, fightUI) {
          Global.unLockProp = this;
          let self = this;
          console.log("showNativeAd00");

          _cjsExports.showNativeAd(frame => {
            console.log("showNativeAd0");
            let sc = self.nativeAd.getComponent("NativeAdBig");
            console.log("showNativeAd1");

            if (sc) {
              console.log("showNativeAd2");
              sc.setSprite(frame);
              console.log("showNativeAd3");
            }
          });

          _cjsExports.showCustomAd(false);

          this._fightUI = fightUI;
          this.callback = callback;
          this.level = playerData.instance.getCurrentLevelInfo().ID;
          this.unLoclProp = constants.UNLOCK_PROP_ID[this.level - 2];
          this.propItem = localConfig.instance.queryByID('prop', this.unLoclProp);
          GameLogic.instance.getOpenRewardType(constants.SHARE_FUNCTION.FIGHT, (err, type) => {
            if (!err) {
              this.openRewardType = type;

              switch (type) {
                case constants.OPEN_REWARD_TYPE.AD:
                  this.spBtnReceive.spriteFrame = this.sfAd;
                  break;

                case constants.OPEN_REWARD_TYPE.SHARE:
                  this.spBtnReceive.spriteFrame = this.sfShare;
                  break;

                case constants.OPEN_REWARD_TYPE.NULL:
                  this.spBtnReceive.spriteFrame = this.sfReceive;
                  break;
              }
            } else {
              this.close();
            }
          });
          this.ndBtnGoStart.active = false;
          this.scheduleOnce(() => {
            this.ndBtnGoStart.active = true;
          }, constants.NORMAL_SHOW_TIME);
          this.init();
        }

        init() {
          this.lbNum.string = 1 .toString();
          this.lbName.string = this.propItem.name;
          resourceUtil.setPropIcon(this.propItem.icon, this.spIcon, () => {});
        }

        onBtnReceiveClick() {
          switch (this.openRewardType) {
            case constants.OPEN_REWARD_TYPE.AD:
              // GameLogic.instance.showRewardAd((err: any) => {
              //     if (!err) {
              //         this.showUnlockProp();
              //         GameLogic.instance.addProp(this.propItem.ID, 1);
              //     }
              // })
              _cjsExports.showRewardAd("onBtnUnLockPropReceiveClick", "1", _cjsExports$1.getAdReward());

              break;

            case constants.OPEN_REWARD_TYPE.SHARE:
              GameLogic.instance.share(constants.SHARE_FUNCTION.FIGHT, {}, err => {
                if (!err) {
                  this.showUnlockProp();
                  GameLogic.instance.addProp(this.propItem.ID, 1);
                }
              });
              break;

            case constants.OPEN_REWARD_TYPE.NULL:
              this.showUnlockProp();
              GameLogic.instance.addProp(this.propItem.ID, 1);
              break;
          }
        }

        onBtnReceiveClickCallback(s) {
          if (s) {
            this.showUnlockProp();
            GameLogic.instance.addProp(this.propItem.ID, 1);
          }
        }

        showUnlockProp() {
          this.close();

          this._fightUI.showUnlockProp(this.propItem.ID, () => {
            playerData.instance.updateUnLockInfo(this.propItem.ID);
            clientEvent.dispatchEvent('updateUnlockProp');
            this.callback();
          });
        }

        onBtnCloseClick() {
          this.close();
          this.showUnlockProp();
        }

        close() {
          uiManager.instance.hideDialog('fight/unLockProp');

          _cjsExports.hideCustomAd();
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "lbNum", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "lbName", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "spIcon", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "spBtnReceive", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "sfReceive", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "sfAd", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "sfShare", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "ndBtnGoStart", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "nativeAd", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/shopPropsOperation.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './localConfig.ts', './LanguageData.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, localConfig, t;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      localConfig = module.localConfig;
    }, function (module) {
      t = module.t;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _temp;

      cclegacy._RF.push({}, "4a0f7h1SXdPto0QRIGkEQAJ", "shopPropsOperation", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ShopPropsOperation = exports('ShopPropsOperation', (_dec = ccclass('ShopPropsOperation'), _dec(_class = (_class2 = (_temp = class ShopPropsOperation extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "lbTitle", _descriptor, this);

          _initializerDefineProperty(this, "lbDesc", _descriptor2, this);

          _initializerDefineProperty(this, "spTip", _descriptor3, this);

          _initializerDefineProperty(this, "arrSftip", _descriptor4, this);

          _defineProperty(this, "type", void 0);
        }

        show(type) {
          this.node.active = true;
          this.type = type;
          this.refreshUI();
        }

        hide() {
          this.node.active = false;
        }

        refreshUI() {
          let prop = localConfig.instance.queryByID('prop', this.type);
          this.lbTitle.string = t('table_prop.' + prop.name);
          this.lbDesc.string = t('table_prop.' + prop.desc);
          this.spTip.spriteFrame = this.arrSftip[this.type - 1];
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "lbTitle", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "lbDesc", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "spTip", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "arrSftip", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/animationUI.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './clientEvent.ts', './loadsh.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, Animation, AnimationClip, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, clientEvent, loadsh;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      Animation = module.Animation;
      AnimationClip = module.AnimationClip;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      clientEvent = module.clientEvent;
    }, function (module) {
      loadsh = module.loadsh;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _temp;

      cclegacy._RF.push({}, "4deb69dGUBOpb+oc1zl98nw", "animationUI", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let AnimationUI = exports('AnimationUI', (_dec = ccclass('AnimationUI'), _dec(_class = (_class2 = (_temp = class AnimationUI extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "isPlayEnableAnimation", _descriptor, this);

          _initializerDefineProperty(this, "enableAnimationName", _descriptor2, this);

          _initializerDefineProperty(this, "isPlayDisableAnimation", _descriptor3, this);

          _initializerDefineProperty(this, "disableAnimationName", _descriptor4, this);

          _initializerDefineProperty(this, "disableAnimationReverse", _descriptor5, this);

          _initializerDefineProperty(this, "disableAnimationSpeed", _descriptor6, this);

          _defineProperty(this, "animation", void 0);

          _defineProperty(this, "clips", void 0);

          _defineProperty(this, "disableAnimationWrapMode", void 0);

          _defineProperty(this, "disableAnimationDefaultSpeed", void 0);

          _defineProperty(this, "closeCallback", void 0);
        }

        onLoad() {
          this.animation = this.node.getComponent(Animation);

          if (!this.animation) {
            return;
          }

          this.clips = this.animation.clips;
          var clip = this.isAnimationExist(this.disableAnimationName);

          if (clip) {
            this.disableAnimationWrapMode = AnimationClip.WrapMode.Default;
            this.disableAnimationDefaultSpeed = clip.speed;
          }
        }

        onEnable() {
          if (!this.animation) return;

          if (this.isPlayEnableAnimation && this.isAnimationExist(this.enableAnimationName)) {
            this.animation.getState(this.enableAnimationName).wrapMode = AnimationClip.WrapMode.Default;
            this.animation.play(this.enableAnimationName);
          }
        }

        close(callback) {
          this.closeCallback = callback;

          if (!this.animation) {
            this.closeFinish();
            return;
          }

          var clip = this.isAnimationExist(this.disableAnimationName);

          if (this.isPlayDisableAnimation && clip) {
            this.animation.once(Animation.EventType.FINISHED, this.closeFinish, this);
            this.animation.play(this.disableAnimationName);

            if (this.disableAnimationReverse) {
              this.animation.getState(this.disableAnimationName).wrapMode = AnimationClip.WrapMode.Reverse;
            }
          } else {
            this.closeFinish();
          }
        }

        closeFinish() {
          if (this.closeCallback) {
            this.closeCallback();
          } else {
            this.node.active = false;
          }
        }

        isAnimationExist(animationName) {
          return loadsh.find(this.clips, function (clip) {
            return clip.name === animationName;
          });
        }

        clickFinish(param) {
          clientEvent.dispatchEvent('finishClickAnimation', param);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "isPlayEnableAnimation", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return false;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "enableAnimationName", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return '';
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "isPlayDisableAnimation", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return false;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "disableAnimationName", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return '';
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "disableAnimationReverse", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return false;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "disableAnimationSpeed", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/linkContent.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './poolManager.ts', './resourceUtil.ts', './constants.ts', './linkItem.ts', './clientEvent.ts', './playerData.ts', './loadsh.ts', './audioManager.ts', './gameLogic.ts', './linkLine.ts', './fightHandGuide.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, UITransform, Node, Vec3, Animation, Prefab, instantiate, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, poolManager, resourceUtil, constants, LinkItem, clientEvent, playerData, loadsh, AudioManager, GameLogic, LinkLine, FightHandGuide;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      UITransform = module.UITransform;
      Node = module.Node;
      Vec3 = module.Vec3;
      Animation = module.Animation;
      Prefab = module.Prefab;
      instantiate = module.instantiate;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      poolManager = module.poolManager;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      LinkItem = module.LinkItem;
    }, function (module) {
      clientEvent = module.clientEvent;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      loadsh = module.loadsh;
    }, function (module) {
      AudioManager = module.AudioManager;
    }, function (module) {
      GameLogic = module.GameLogic;
    }, function (module) {
      LinkLine = module.LinkLine;
    }, function (module) {
      FightHandGuide = module.FightHandGuide;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _temp;

      cclegacy._RF.push({}, "4f6b3WtEbBAH4oYBaofOW/U", "linkContent", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let CELL_WIDTH = 80;
      let CELL_HEIGHT = 80;
      let ITEM_WIDTH = 60;
      let ITEM_HEIGHT = 60;
      let LinkContent = exports('LinkContent', (_dec = ccclass('LinkContent'), _dec(_class = (_class2 = (_temp = class LinkContent extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "pfCake", _descriptor, this);

          _initializerDefineProperty(this, "pfLine", _descriptor2, this);

          _initializerDefineProperty(this, "nodeLineGroup", _descriptor3, this);

          _initializerDefineProperty(this, "nodeLinkOverEffect", _descriptor4, this);

          _initializerDefineProperty(this, "nodeLinkGroup", _descriptor5, this);

          _defineProperty(this, "lastOperationTime", void 0);

          _defineProperty(this, "isShowHandGuide", void 0);

          _defineProperty(this, "_fightScene", void 0);

          _defineProperty(this, "dictCakes", void 0);

          _defineProperty(this, "arrLinks", void 0);

          _defineProperty(this, "arrLines", void 0);

          _defineProperty(this, "levelInfo", void 0);

          _defineProperty(this, "currentCake", void 0);

          _defineProperty(this, "currentNode", void 0);

          _defineProperty(this, "preNode", void 0);

          _defineProperty(this, "clearScore", void 0);

          _defineProperty(this, "clearCake", void 0);

          _defineProperty(this, "cntTrigger", void 0);

          _defineProperty(this, "allTriggerOverCb", void 0);

          _defineProperty(this, "currentPropTouchNode", void 0);

          _defineProperty(this, "isRefreshing", void 0);

          _defineProperty(this, "arrConnected", void 0);

          _defineProperty(this, "nodeHand", void 0);
        }

        show(fightScene) {
          const uiTran = this.node.getComponent(UITransform);
          CELL_WIDTH = uiTran.width / 8;
          CELL_HEIGHT = uiTran.height / 8;
          ITEM_WIDTH = CELL_WIDTH - 25;
          ITEM_HEIGHT = CELL_HEIGHT - 25;
          this.lastOperationTime = 0;
          this.isShowHandGuide = false;
          this._fightScene = fightScene;
          this.dictCakes = {};
          this.arrLinks = [];
          this.arrLines = [];
          this.levelInfo = playerData.instance.getCurrentLevelInfo();
          this.initCake();
        }

        createCake(index, cake, isShowRightNow) {
          let nodeCake = poolManager.instance.getNode(this.pfCake, this.nodeLinkGroup);
          nodeCake.position = this.getScreenPosByIndex(index);
          nodeCake.opacity = 255;
          let linkItem = nodeCake.getComponent(LinkItem);
          linkItem.show(index, cake, isShowRightNow, this);
          this.dictCakes[index] = nodeCake;
          return nodeCake;
        }

        initCake(callback) {
          let arrRandom = this.levelInfo.cakes.split('|');

          for (let idxRow = 0; idxRow < constants.LINK_ROWS_COUNT; idxRow++) {
            for (let idxCol = 0; idxCol < constants.LINK_COLS_COUNT; idxCol++) {
              let key = idxCol + idxRow * constants.LINK_COLS_COUNT;
              let randomCake = arrRandom[loadsh.random(0, arrRandom.length - 1)];
              this.createCake(key, randomCake, false);
            }
          }

          this.showAllLinkItem(true, () => {
            if (callback) {
              callback();
            }

            this.lastOperationTime = 0;
          });
        }

        showAllLinkItem(isShow, callback) {
          let times = constants.LINK_ROWS_COUNT + constants.LINK_ROWS_COUNT;

          for (let idx = 0; idx < times; idx++) {
            for (let idxCol = 0; idxCol < constants.LINK_COLS_COUNT; idxCol++) {
              if (idxCol > idx) {
                break;
              }

              for (let idxRow = 0; idxRow < constants.LINK_ROWS_COUNT; idxRow++) {
                if (idxRow > idx) {
                  break;
                }

                if (idxRow + idxCol === idx) {
                  let idxItem = this.getIndexByPos(idxCol, idxRow);

                  if (this.dictCakes.hasOwnProperty(idxItem)) {
                    if (isShow) {
                      this.dictCakes[idxItem].getComponent(LinkItem).playShowAction(0.05 * idx);
                    } else {
                      this.dictCakes[idxItem].getComponent(LinkItem).playHideAction(0.05 * idx, false);
                    }
                  }
                }
              }
            }
          }

          if (callback) {
            this.scheduleOnce(callback, times * 0.05 + 0.5);
          }
        }

        onEnable() {
          this.node.on(Node.EventType.TOUCH_START, this.onTouchStart, this);
          this.node.on(Node.EventType.TOUCH_MOVE, this.onTouchMove, this);
          this.node.on(Node.EventType.TOUCH_END, this.onTouchEnded, this);
          this.node.on(Node.EventType.TOUCH_CANCEL, this.onTouchCancel, this);
        }

        onDisable() {
          this.node.off(Node.EventType.TOUCH_START, this.onTouchStart, this);
          this.node.off(Node.EventType.TOUCH_MOVE, this.onTouchMove, this);
          this.node.off(Node.EventType.TOUCH_END, this.onTouchEnded, this);
          this.node.off(Node.EventType.TOUCH_CANCEL, this.onTouchCancel, this);
        }

        getCakeNodeByTouchPos(pos) {
          let startPos = this.nodeLinkGroup.getComponent(UITransform).convertToWorldSpaceAR(new Vec3(0, 0, 0));
          let offsetPos = pos.clone().subtract(startPos);
          let col = Math.floor(offsetPos.x / CELL_WIDTH);
          let row = Math.floor(offsetPos.y / CELL_HEIGHT);
          let key = col + row * constants.LINK_COLS_COUNT;
          let ret = this.dictCakes[key];

          if (ret) {
            if (Math.abs(offsetPos.x - ret.x) > ITEM_WIDTH / 2 || Math.abs(offsetPos.y - ret.y) > ITEM_HEIGHT / 2) {
              ret = null; //已经点超出区域了
            }
          }

          return ret;
        }

        drawLine() {
          let idxLine = 0;

          if (this.arrLinks.length > 1) {
            let nodeStart = this.arrLinks[0];
            let linkItemStart = nodeStart.getComponent(LinkItem);
            let posLinkStart = this.getPosByIndex(linkItemStart.index);
            let posChildStart = new Vec3((posLinkStart.x + 1 / 2) * CELL_WIDTH, (posLinkStart.y + 1 / 2) * CELL_HEIGHT, 0);
            let arrLinesPoint = [];

            for (let idx = 1; idx < this.arrLinks.length; idx++) {
              let nodeEnd = this.arrLinks[idx];
              let linkItemEnd = nodeEnd.getComponent(LinkItem);
              let posLinkEnd = this.getPosByIndex(linkItemEnd.index);
              let posChildEnd = new Vec3((posLinkEnd.x + 1 / 2) * CELL_WIDTH, (posLinkEnd.y + 1 / 2) * CELL_HEIGHT, 0);
              arrLinesPoint.push({
                'start': posChildStart.clone(),
                'end': posChildEnd.clone()
              });
              posChildStart = posChildEnd;
            }

            for (; idxLine < arrLinesPoint.length; idxLine++) {
              let objLine = arrLinesPoint[idxLine];
              let linkLine = null;
              let lineNode = null;

              if (idxLine < this.arrLines.length) {
                lineNode = this.arrLines[idxLine];
                linkLine = lineNode.getComponent(LinkLine);
              } else {
                lineNode = poolManager.instance.getNode(this.pfLine, this.nodeLineGroup);
                this.arrLines.push(lineNode);
                linkLine = lineNode.getComponent(LinkLine);
                linkLine.show();
              }

              lineNode.getComponent(LinkLine).setLinePosition(objLine.start, objLine.end);
            }
          }

          if (idxLine < this.arrLines.length) {
            for (let idxRemove = idxLine; idxRemove < this.arrLines.length; idxRemove++) {
              poolManager.instance.putNode(this.arrLines[idxRemove]);
            }

            this.arrLines.splice(idxLine, this.arrLines.length);
          }
        }

        clearLine() {
          for (let idx = 0; idx < this.arrLines.length; idx++) {
            poolManager.instance.putNode(this.arrLines[idx]);
          }

          this.arrLines = [];
        }

        hideDiffCake() {
          for (let index in this.dictCakes) {
            let node = this.dictCakes[index];

            if (node.getComponent(LinkItem).cake !== this.currentCake) {
              node.opacity = 50; //半透明？
            }
          }
        }

        showAllCake() {
          for (let index in this.dictCakes) {
            let node = this.dictCakes[index];
            node.opacity = 255;
          }
        }

        checkStep() {}

        onTouchStart(touchEvent) {
          if (!this._fightScene || this._fightScene.isLevelOver || !this._fightScene.isLevelStart) {
            this.currentNode = null;
            this.arrLinks = [];
            return;
          }

          let node = this.getCakeNodeByTouchPos(touchEvent.getUILocation());

          if (node) {
            this.stopGuideHand();
            this.arrLinks = [node];
            this.currentNode = node;
            let linkItem = this.currentNode.getComponent(LinkItem);
            this.currentCake = linkItem.cake;
            this.preNode = null;
            linkItem.showSelect(true);
            AudioManager.instance.playSound(constants.AUDIO_SOUND.CLICK_CAKE, false);
            this.drawLine();
            this.hideDiffCake();
          }
        }

        onTouchMove(touchEvent) {
          if (!this.currentNode) {
            return;
          }

          let node = this.getCakeNodeByTouchPos(touchEvent.getUILocation());

          if (node && node !== this.currentNode) {
            let linkItem = node.getComponent(LinkItem);

            if (this.currentCake === linkItem.cake) {
              if (this.preNode === node) {
                let oldLinkItem = this.currentNode.getComponent(LinkItem);
                oldLinkItem.showSelect(false);

                if (oldLinkItem.isSpecial) {
                  oldLinkItem.showSpecial(false);
                }

                this.currentNode = this.preNode;
                this.arrLinks.pop();
                this.preNode = this.arrLinks[this.arrLinks.length - 2];
                this.drawLine();
                return;
              }

              if (this.arrLinks.indexOf(node) !== -1) {
                return;
              }

              let posNode = this.getPosByIndex(linkItem.index);
              let currentItem = this.currentNode.getComponent(LinkItem);
              let posCurrent = this.getPosByIndex(currentItem.index);

              if (Math.abs(posNode.x - posCurrent.x) <= 1 && Math.abs(posNode.y - posCurrent.y) <= 1) {
                this.preNode = this.currentNode;
                this.currentNode = node;
                this.arrLinks.push(node);
                linkItem.showSelect(true);
                AudioManager.instance.playSound(constants.AUDIO_SOUND.CLICK_CAKE, false);
                let cntCurrent = this.arrLinks.length;

                if (cntCurrent >= 6 && (cntCurrent === 6 || (cntCurrent - 6) % 4 === 0)) {
                  linkItem.showSpecial(true);
                }

                this.drawLine();
              }
            }
          }
        }

        onTouchEnded(touchEvent) {
          this.touchOver();
        }

        onTouchCancel(touchEvent) {
          this.touchOver();
        }

        getScreenPosByIndex(index) {
          let pos = this.getPosByIndex(index);
          return new Vec3((pos.x + 1 / 2) * CELL_WIDTH, (pos.y + 1 / 2) * CELL_HEIGHT, 0);
        }

        getPosByIndex(index) {
          return new Vec3(index % constants.LINK_COLS_COUNT, Math.floor(index / constants.LINK_COLS_COUNT), 0);
        }

        getIndexByPos(col, row) {
          return row * constants.LINK_COLS_COUNT + col;
        }

        touchOver() {
          if (!this.isShowHandGuide) {
            if (this.arrLinks.length >= 3) {
              AudioManager.instance.playSound(constants.AUDIO_SOUND.FINISH_LINK, false);
              this.clearLinks();
            } else {
              for (let idx = 0; idx < this.arrLinks.length; idx++) {
                this.arrLinks[idx].getComponent(LinkItem).showSelect(false);
              }

              this.arrLinks = [];
              this.preNode = null;
            }

            this.currentNode = null;
            this.clearLine();
            this.showAllCake();
            this.checkStep();
          }
        }

        clearItemByEffect(trigger, effectType, isIncludeSelf, isPlus) {
          let pos = this.getPosByIndex(trigger);

          switch (effectType) {
            case constants.SPECIAL_EFFECT.HORIZONTAL:
              this.clearScore += 500;

              if (!isPlus) {
                AudioManager.instance.playSound(constants.AUDIO_SOUND.LINE_BOMB, false);
              }

              this._fightScene.effectGroup.showSkillLineEffect(this.getItemWorldPosByIndex(trigger), true);

              for (let idx = 0; idx < constants.LINK_COLS_COUNT; idx++) {
                if (idx !== pos.x || isIncludeSelf) {
                  let index = this.getIndexByPos(idx, pos.y);

                  if (this.dictCakes.hasOwnProperty(index)) {
                    let linkItem = this.dictCakes[index].getComponent(LinkItem);

                    if (this.clearCake.hasOwnProperty(linkItem.cake)) {
                      this.clearCake[linkItem.cake] += 1;
                    } else {
                      this.clearCake[linkItem.cake] = 1;
                    }

                    linkItem.showDestory();
                    delete this.dictCakes[index];

                    if (linkItem.index !== trigger) {
                      if (linkItem.getEffect()) {
                        this.clearItemByEffect(linkItem.index, linkItem.getEffect(), isIncludeSelf);
                      } else {
                        this.clearScore += 50;
                      }
                    }
                  }
                }
              }

              break;

            case constants.SPECIAL_EFFECT.VERTICAL:
              this.clearScore += 500;

              if (!isPlus) {
                AudioManager.instance.playSound(constants.AUDIO_SOUND.LINE_BOMB, false);
              }

              this._fightScene.effectGroup.showSkillLineEffect(this.getItemWorldPosByIndex(trigger), false);

              for (let idx = 0; idx < constants.LINK_ROWS_COUNT; idx++) {
                if (idx !== pos.y || isIncludeSelf) {
                  let index = this.getIndexByPos(pos.x, idx);

                  if (this.dictCakes.hasOwnProperty(index)) {
                    let linkItem = this.dictCakes[index].getComponent(LinkItem);

                    if (this.clearCake.hasOwnProperty(linkItem.cake)) {
                      this.clearCake[linkItem.cake] += 1;
                    } else {
                      this.clearCake[linkItem.cake] = 1;
                    }

                    linkItem.showDestory();
                    delete this.dictCakes[index];

                    if (linkItem.index !== trigger) {
                      if (linkItem.getEffect()) {
                        this.clearItemByEffect(linkItem.index, linkItem.getEffect(), isIncludeSelf);
                      } else {
                        this.clearScore += 50;
                      }
                    }
                  }
                }
              }

              break;

            case constants.SPECIAL_EFFECT.PLUS:
              AudioManager.instance.playSound(constants.AUDIO_SOUND.PLUS_BOMB, false);
              this.clearItemByEffect(trigger, constants.SPECIAL_EFFECT.HORIZONTAL, isIncludeSelf, true);
              this.clearItemByEffect(trigger, constants.SPECIAL_EFFECT.VERTICAL, isIncludeSelf, true);
              break;

            case constants.SPECIAL_EFFECT.CENTER:
              this.clearScore += 1500;

              this._fightScene.effectGroup.showSkillRangeEffect(this.getItemWorldPosByIndex(trigger));

              for (let idxOffsetRow = -2; idxOffsetRow <= 2; idxOffsetRow++) {
                for (let idxOffsetCol = -2; idxOffsetCol <= 2; idxOffsetCol++) {
                  if (idxOffsetRow === 0 && idxOffsetCol === 0 && !isIncludeSelf) {
                    continue;
                  }

                  let posNew = new Vec3(pos.x + idxOffsetRow, pos.y + idxOffsetCol, 0);

                  if (posNew.x < 0 || posNew.x > constants.LINK_COLS_COUNT || posNew.y < 0 || posNew.y > constants.LINK_ROWS_COUNT) {
                    continue;
                  }

                  if (Math.abs(posNew.x - pos.x) + Math.abs(posNew.y - pos.y) <= 2) {
                    let index = this.getIndexByPos(posNew.x, posNew.y);

                    if (this.dictCakes.hasOwnProperty(index)) {
                      let linkItem = this.dictCakes[index].getComponent(LinkItem);

                      if (this.clearCake.hasOwnProperty(linkItem.cake)) {
                        this.clearCake[linkItem.cake] += 1;
                      } else {
                        this.clearCake[linkItem.cake] = 1;
                      }

                      linkItem.showDestory();
                      delete this.dictCakes[index];

                      if (linkItem.index !== trigger) {
                        if (linkItem.getEffect()) {
                          this.clearItemByEffect(linkItem.index, linkItem.getEffect(), isIncludeSelf);
                        } else {
                          this.clearScore += 50;
                        }
                      }
                    }
                  }
                }
              }

              break;
          }
        }

        clearLinks() {
          let dictGenerator = {};
          let dictEffect = {};
          this.clearScore = 0;

          for (let idx = 0; idx < this.arrLinks.length; idx++) {
            let linkItem = this.arrLinks[idx].getComponent(LinkItem);
            let effect = linkItem.getEffect();

            if (effect) {
              dictEffect[linkItem.index] = effect;
            }

            if (linkItem.isSpecial) {
              let effect = null;

              if (idx === 5) {
                let random = loadsh.random(0, 1);
                effect = random ? constants.SPECIAL_EFFECT.HORIZONTAL : constants.SPECIAL_EFFECT.VERTICAL;
                this.clearScore += 1000;
              } else {
                let offset = idx - 5;
                let offsetSpare = offset / 4 % 2;
                effect = offsetSpare ? constants.SPECIAL_EFFECT.PLUS : constants.SPECIAL_EFFECT.CENTER;

                if (effect === constants.SPECIAL_EFFECT.PLUS) {
                  this.clearScore += 2000;
                } else {
                  this.clearScore += 3000;
                }
              }

              linkItem.setSpecialType(effect);
              dictGenerator[linkItem.index] = effect;
            } else if (!effect) {
              this.clearScore += 50;
            }

            linkItem.showDestory();
            delete this.dictCakes[linkItem.index];
          }

          this.clearCake = {};

          for (let trigger in dictEffect) {
            this.clearItemByEffect(trigger, dictEffect[trigger], false);
          }

          playerData.instance.addScore(this.clearScore);
          let cntLink = this.arrLinks.length;
          GameLogic.instance.finishLink(this.currentCake, cntLink);
          let sound = null;

          if (cntLink >= 22) {
            sound = constants.AUDIO_SOUND.UNBELIEVABLE;
          } else if (cntLink >= 18) {
            sound = constants.AUDIO_SOUND.AMAZING;
          } else if (cntLink >= 14) {
            sound = constants.AUDIO_SOUND.EXCELLENT;
          } else if (cntLink >= 10) {
            sound = constants.AUDIO_SOUND.GREAT;
          } else if (cntLink >= 6) {
            sound = constants.AUDIO_SOUND.GOOD;
          }

          if (sound) {
            AudioManager.instance.playSound(sound, false);
          }

          this.finishTargetsBatch();
          this.arrLinks = [];

          if (Object.keys(dictGenerator).length > 0) {
            this.scheduleOnce(() => {
              this._fightScene.showFlyEffect(dictGenerator, () => {
                GameLogic.instance.checkGame();
              });
            }, 0.1);
          } else {
            GameLogic.instance.checkGame();
          }

          this.scheduleOnce(this.fillEmptyCell, 0.3);
        }
        /**
         * 填补空缺的位置
         */


        fillEmptyCell() {
          for (let idxCol = 0; idxCol < constants.LINK_COLS_COUNT; idxCol++) {
            let emptyRow = -1;

            for (let idxRow = 0; idxRow < constants.LINK_ROWS_COUNT; idxRow++) {
              let index = idxRow * constants.LINK_COLS_COUNT + idxCol;

              if (!this.dictCakes.hasOwnProperty(index)) {
                if (emptyRow === -1) {
                  emptyRow = idxRow;
                }
              } else if (emptyRow !== -1) {
                let emptyIndex = emptyRow * constants.LINK_COLS_COUNT + idxCol;
                this.dictCakes[emptyIndex] = this.dictCakes[index];
                let linkItem = this.dictCakes[emptyIndex].getComponent(LinkItem);
                linkItem.index = emptyIndex;
                linkItem.playMove2Index(emptyIndex);
                delete this.dictCakes[index];
                emptyRow = emptyRow + 1; //往上移动一层
              }
            }

            if (emptyRow !== -1) {
              let arrRandom = this.levelInfo.cakes.split('|');

              for (let idxRow = emptyRow; idxRow < constants.LINK_ROWS_COUNT; idxRow++) {
                let index = idxRow * constants.LINK_COLS_COUNT + idxCol;
                let showIndex = (constants.LINK_ROWS_COUNT + idxRow - emptyRow) * constants.LINK_COLS_COUNT + idxCol;
                let randomCake = arrRandom[loadsh.random(0, arrRandom.length - 1)];
                this.createCakeForFill(index, randomCake, showIndex);
              }
            }
          }

          this.scheduleOnce(() => {
            this.checkIsBlocked();
          }, 0.2);
        }

        createCakeForFill(index, cake, showIndex) {
          let nodeCake = poolManager.instance.getNode(this.pfCake, this.nodeLinkGroup);
          nodeCake.position = this.getScreenPosByIndex(showIndex);
          nodeCake.opacity = 255;
          let linkItem = nodeCake.getComponent(LinkItem);
          linkItem.show(index, cake, true, this);
          linkItem.playMove2Index(index);
          this.dictCakes[index] = nodeCake;
          return nodeCake;
        }

        getItemWorldPosByIndex(index) {
          let screenPos = this.getScreenPosByIndex(index);
          return this.nodeLinkGroup.getComponent(UITransform).convertToWorldSpaceAR(new Vec3(screenPos.x, screenPos.y, 0));
        }

        getNoEffectLinkItemIndex() {
          let idx = 0;

          while (1) {
            let random = loadsh.random(0, constants.LINK_ROWS_COUNT * constants.LINK_COLS_COUNT - 1);

            if (this.dictCakes.hasOwnProperty(random)) {
              let node = this.dictCakes[random];
              let linkItem = node.getComponent(LinkItem);

              if (!linkItem.isSpecial && !linkItem.getEffect()) {
                return linkItem.index;
              }
            }

            idx++;

            if (idx > 30) {
              //避免无限循环出现卡住的问题
              return null;
            }
          }
        }

        markLinkItemEffect(index, effect) {
          if (this.dictCakes.hasOwnProperty(index)) {
            this.dictCakes[index].getComponent(LinkItem).markEffect(effect);
          }
        }

        addEffect(index, effect) {
          if (this.dictCakes.hasOwnProperty(index)) {
            this.dictCakes[index].getComponent(LinkItem).showEffect(effect);
          }
        }

        delayClearItem(delayIdx, index, effect) {
          this.scheduleOnce(() => {
            this.cntTrigger--;

            if (this.dictCakes.hasOwnProperty(index)) {
              this.clearScore = 0;
              this.clearCake = {};
              this.clearItemByEffect(index, effect, true);
              playerData.instance.addScore(this.clearScore);
              this.finishTargetsBatch();
            }

            if (this.cntTrigger <= 0 && this.allTriggerOverCb) {
              this.allTriggerOverCb();
            }
          }, delayIdx * 0.2);
        }

        triggerAllSpecialEffect(callback) {
          let idx = 0;

          for (let idxRow = 0; idxRow < constants.LINK_ROWS_COUNT; idxRow++) {
            for (let idxCol = 0; idxCol < constants.LINK_COLS_COUNT; idxCol++) {
              let index = this.getIndexByPos(idxCol, idxRow);

              if (this.dictCakes.hasOwnProperty(index)) {
                let linkItem = this.dictCakes[index].getComponent(LinkItem);

                if (linkItem && linkItem.getEffect()) {
                  this.delayClearItem(idx, index, linkItem.getEffect());
                  idx++;
                }
              }
            }
          }

          this.cntTrigger = idx;
          this.allTriggerOverCb = callback;

          if (this.cntTrigger <= 0 && this.allTriggerOverCb) {
            this.allTriggerOverCb();
          }
        }

        finishTargetsBatch() {
          for (let cake in this.clearCake) {
            playerData.instance.finishTarget(cake, this.clearCake[cake]);
            clientEvent.dispatchEvent('updateTargets', cake);
          }

          clientEvent.dispatchEvent('updateStep');
        }

        showLinkFinishEffect(callback) {
          resourceUtil.createEffect('fight/frame/frame', (err, effect) => {
            if (err) {
              if (callback) {
                callback(err);
              }

              return;
            }

            let ani = effect.getComponent(Animation);
            ani.play('frame');
            ani.once(Animation.EventType.FINISHED, () => {
              effect && effect.destroy();

              if (callback) {
                callback(null);
              }
            }, this);
          }, this.nodeLinkOverEffect);
        }

        checkIsBlocked() {
          for (let idxRow = 0; idxRow < constants.LINK_ROWS_COUNT; idxRow++) {
            for (let idxCol = 0; idxCol < constants.LINK_COLS_COUNT; idxCol++) {
              let index = this.getIndexByPos(idxCol, idxRow);

              if (this.dictCakes.hasOwnProperty(index)) {
                let linkItem = this.dictCakes[index].getComponent(LinkItem);

                if (linkItem) {
                  let ret = this.checkItemChannelIsClear(index, linkItem.cake);

                  if (ret) {
                    return;
                  }
                }
              }
            }
          }

          this.refreshLinkItems();
        }

        checkItemChannelIsClear(index, cake, posOld) {
          let pos = this.getPosByIndex(index);
          let idxClear = 0;

          for (let row = pos.y - 1; row <= pos.y + 1; row++) {
            for (let col = pos.x - 1; col <= pos.x + 1; col++) {
              if (row < 0 || col < 0 || row >= constants.LINK_ROWS_COUNT || col >= constants.LINK_COLS_COUNT) {
                continue;
              }

              if (row !== pos.y || col !== pos.x) {
                if (posOld && posOld.x === col && posOld.y === row) {
                  continue;
                }

                let idxItem = this.getIndexByPos(col, row);

                if (this.dictCakes.hasOwnProperty(idxItem)) {
                  let linkItem = this.dictCakes[idxItem].getComponent(LinkItem);

                  if (linkItem && linkItem.cake === cake) {
                    if (posOld) {
                      return true;
                    } else {
                      let isClear = this.checkItemChannelIsClear(idxItem, cake, pos);

                      if (isClear) {
                        return true;
                      }

                      idxClear++;

                      if (idxClear >= 2) {
                        return true;
                      }
                    }
                  }
                }
              }
            }
          }

          return false;
        }

        onPropTouchStart(touchEvent) {
          let node = this.getCakeNodeByTouchPos(touchEvent.getUILocation());

          if (node) {
            node.setScale(0.9, 0.9, 0.9);
          }

          this.currentPropTouchNode = node;
        }

        onPropTouchEnd(touchEvent) {
          if (!this.currentPropTouchNode) {
            return -1;
          }

          this.currentPropTouchNode.setScale(1, 1, 1);
          let node = this.getCakeNodeByTouchPos(touchEvent.getUILocation());

          if (node === this.currentPropTouchNode) {
            let linkItem = node.getComponent(LinkItem);
            return linkItem.index;
          }

          this.currentPropTouchNode = null;
          return -1;
        }

        onPropTouchCancel(touchEvent) {
          if (this.currentPropTouchNode) {
            this.currentPropTouchNode.setScale(1, 1, 1);
            this.currentPropTouchNode = null;
          }

          return -1;
        }

        refreshLinkItems() {
          if (this.isRefreshing) {
            return false;
          }

          this.isRefreshing = true;
          this.showAllLinkItem(false, () => {
            this.initCake(() => {
              this.isRefreshing = false;
            });
          });
          return true;
        }

        destoryCake(targetId) {
          if (this.dictCakes.hasOwnProperty(targetId)) {
            let nodeItem = this.dictCakes[targetId];
            let linkItem = nodeItem.getComponent(LinkItem);
            linkItem.showDestory();
            delete this.dictCakes[targetId];
            this.clearScore = 0;
            this.clearCake = {};
            this.clearCake[linkItem.cake] = 1;

            if (linkItem.getEffect()) {
              this.clearItemByEffect(targetId, linkItem.getEffect(), false);
            } else {
              this.clearScore = 50;
            }

            playerData.instance.addScore(this.clearScore); //默认加50

            this.finishTargetsBatch();
            GameLogic.instance.checkGame();
            this.scheduleOnce(this.fillEmptyCell, 0.3);
          }
        }

        getConnectCake(index, cake, posOld) {
          let pos = this.getPosByIndex(index);

          for (let row = pos.y - 1; row <= pos.y + 1; row++) {
            for (let col = pos.x - 1; col <= pos.x + 1; col++) {
              if (row < 0 || col < 0 || row >= constants.LINK_ROWS_COUNT || col >= constants.LINK_COLS_COUNT) {
                continue;
              }

              if (row !== pos.y || col !== pos.x) {
                if (posOld && posOld.x === col && posOld.y === row) {
                  continue;
                }

                let idxItem = this.getIndexByPos(col, row);

                if (this.dictCakes.hasOwnProperty(idxItem)) {
                  let linkItem = this.dictCakes[idxItem].getComponent(LinkItem);

                  if (linkItem && linkItem.cake === cake) {
                    if (posOld) {
                      this.arrConnected.push(idxItem);
                      return true;
                    } else {
                      let len = this.arrConnected.length;
                      let isClear = this.getConnectCake(idxItem, cake, pos);

                      if (isClear) {
                        this.arrConnected.splice(len, 0, idxItem);
                        return true;
                      }
                    }
                  }
                }
              }
            }
          }

          return false;
        }

        getConnectCakeByIndex(idx, arrTarget) {
          this.arrConnected = [];

          if (this.dictCakes.hasOwnProperty(idx)) {
            this.arrConnected.push(idx);
            let linkItem = this.dictCakes[idx].getComponent(LinkItem);

            if (linkItem) {
              if (arrTarget) {
                if (arrTarget.indexOf(linkItem.cake) !== -1) {
                  this.getConnectCake(idx, linkItem.cake);

                  if (this.arrConnected.length >= 3) {
                    return true;
                  }
                }
              } else {
                this.getConnectCake(idx, linkItem.cake);

                if (this.arrConnected.length >= 3) {
                  return true;
                }
              }
            }
          }

          return false;
        }

        findConnectPathForGuide(isFindTarget) {
          let arrTarget = null;

          if (isFindTarget) {
            arrTarget = [];

            for (var target in playerData.instance.dictTargets) {
              if (playerData.instance.dictTargets[target]) {
                arrTarget.push(target);
              }
            }
          }

          let max = constants.LINK_ROWS_COUNT * constants.LINK_COLS_COUNT;
          let half = max / 2 + constants.LINK_COLS_COUNT / 2;
          let halfLeft = half - 1;
          let halfRight = half;
          let isFind = false;

          while (!isFind && (halfRight < max || halfLeft >= 0)) {
            this.arrConnected = [];

            if (halfRight < max) {
              let isFind = this.getConnectCakeByIndex(halfRight, arrTarget);

              if (isFind) {
                return true;
              }
            }

            if (halfLeft > 0) {
              isFind = this.getConnectCakeByIndex(halfLeft, arrTarget);

              if (isFind) {
                return true;
              }
            }

            halfRight++;
            halfLeft--;
          }

          return false;
        }

        showGuideLine(index) {
          this.arrLinks = [];

          for (let idx = 0; idx <= index; idx++) {
            let cake = this.dictCakes[this.arrConnected[idx]];

            if (cake) {
              this.arrLinks.push(cake);
            }
          }

          this.drawLine();
        }

        showGuideHand() {
          this.isShowHandGuide = true;
          let isFind = this.findConnectPathForGuide(true);

          if (!isFind) {
            isFind = this.findConnectPathForGuide(false);
          }

          if (isFind) {
            let arrPath = [];

            for (let idx = 0; idx < this.arrConnected.length; idx++) {
              arrPath.push(this.getScreenPosByIndex(this.arrConnected[idx]));
              let linkItem = this.dictCakes[this.arrConnected[idx]].getComponent(LinkItem);
              linkItem.showSelect(true);
            }

            if (!this.nodeHand) {
              resourceUtil.loadRes('prefab/fight/fightHandGuide', Prefab, (err, prefab) => {
                let node = instantiate(prefab);
                node.parent = this.node;
                this.nodeHand = node;
                this.nodeHand.getComponent(FightHandGuide).showGuide(arrPath, index => {
                  this.showGuideLine(index);
                });
              });
            } else {
              this.nodeHand.active = true;
              this.nodeHand.getComponent(FightHandGuide).showGuide(arrPath, index => {
                this.showGuideLine(index);
              });
            }
          }
        }

        stopGuideHand() {
          this.isShowHandGuide = false;
          this.lastOperationTime = 0;

          if (this.arrConnected && this.dictCakes) {
            for (let idx = 0; idx < this.arrConnected.length; idx++) {
              let nodeItem = this.dictCakes[this.arrConnected[idx]];

              if (nodeItem) {
                let linkItem = nodeItem.getComponent(LinkItem);
                linkItem.showSelect(false);
              }
            }
          }

          if (this.nodeHand) {
            this.nodeHand.destroy();
            this.nodeHand = null;
          }

          this.arrLinks = [];
          this.drawLine();
        }

        update(dt) {
          if (this._fightScene.isLevelOver || !this._fightScene.isLevelStart || this.isShowHandGuide || this.currentNode || this._fightScene.isShowOperationUI) {
            return;
          }

          this.lastOperationTime += dt;

          if (this.lastOperationTime > 5) {
            this.showGuideHand();
            this.lastOperationTime = 0;
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "pfCake", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "pfLine", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "nodeLineGroup", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "nodeLinkOverEffect", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "nodeLinkGroup", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/reward.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './resourceUtil.ts', './constants.ts', './localConfig.ts', './uiManager.ts', './LanguageData.ts', './PlatformBridge.js', './PlatformBridge.mjs_cjs=&original=.js', './gameLogic.ts', './ConstValue.js', './ConstValue.mjs_cjs=&original=.js'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, Component, Animation, UITransform, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, resourceUtil, constants, localConfig, uiManager, t, _cjsExports, GameLogic, _cjsExports$1;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      Component = module.Component;
      Animation = module.Animation;
      UITransform = module.UITransform;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      localConfig = module.localConfig;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      t = module.t;
    }, function (module) {
      _cjsExports = module.default;
    }, null, function (module) {
      GameLogic = module.GameLogic;
    }, function (module) {
      _cjsExports$1 = module.default;
    }, null],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _temp;

      cclegacy._RF.push({}, "511b6KMY/hH0J3ytfJAXF3B", "reward", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let Reward = exports('Reward', (_dec = ccclass('Reward'), _dec2 = property(Node), _dec(_class = (_class2 = (_temp = class Reward extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "sfDiamond", _descriptor, this);

          _initializerDefineProperty(this, "sfGold", _descriptor2, this);

          _initializerDefineProperty(this, "spIcon", _descriptor3, this);

          _initializerDefineProperty(this, "lbRewardValue", _descriptor4, this);

          _initializerDefineProperty(this, "aniGetItem", _descriptor5, this);

          _initializerDefineProperty(this, "ndBtnNormalReceive", _descriptor6, this);

          _initializerDefineProperty(this, "ndBtnDoubleReceive", _descriptor7, this);

          _initializerDefineProperty(this, "ndBtnvideo", _descriptor8, this);

          _initializerDefineProperty(this, "ndBtnReceive", _descriptor9, this);

          _defineProperty(this, "itemType", void 0);

          _defineProperty(this, "itemAmount", void 0);

          _defineProperty(this, "itemSubType", void 0);

          _defineProperty(this, "shareFunction", void 0);

          _defineProperty(this, "openRewardType", void 0);
        }

        onLoad() {}

        show(itemInfo, isDoubleReceive, shareFunction) {
          Global.reward = this;
          console.log("ttttt", Global.onLineRewardCount, "--", Global.onLineReward);

          if (Global.onLineRewardCount == 1 && Global.onLineReward) {
            this.ndBtnvideo.active = false;
          } else if (Global.onLineRewardCount > 1 && Global.onLineReward) {
            this.ndBtnvideo.active = true;
          } else {
            this.ndBtnvideo.active = false;
          }

          Global.onLineReward = false;
          this.itemType = itemInfo["itemType"];
          this.itemAmount = itemInfo["itemAmount"];
          this.itemSubType = itemInfo["itemSubType"];
          this.shareFunction = shareFunction;
          this.aniGetItem.play('getItemShow');
          this.aniGetItem.once(Animation.EventType.FINISHED, () => {
            this.aniGetItem.play('getItemIdle');
          }, this);
          this.setRewardPage();

          if (isDoubleReceive) {
            this.ndBtnReceive.active = false;
            GameLogic.instance.getOpenRewardType(this.shareFunction, (err, type) => {
              if (!err) {
                this.openRewardType = type;

                switch (type) {
                  case constants.OPEN_REWARD_TYPE.AD:
                    this.ndBtnDoubleReceive.active = true;
                    break;

                  case constants.OPEN_REWARD_TYPE.SHARE:
                    this.ndBtnDoubleReceive.active = true;
                    break;

                  case constants.OPEN_REWARD_TYPE.NULL:
                    this.ndBtnDoubleReceive.active = false;
                    break;
                }
              } else {
                this.close();
              }
            });
            this.ndBtnNormalReceive.active = false;
            this.scheduleOnce(this.normalBtnCallback, constants.NORMAL_SHOW_TIME);
          } else {
            this.ndBtnNormalReceive.active = false;
            this.ndBtnDoubleReceive.active = false;
            this.ndBtnReceive.active = true;
          }
        }

        normalBtnCallback() {
          this.ndBtnNormalReceive.active = true;
        }

        setRewardPage() {
          const uiTraSpIcon = this.spIcon.getComponent(UITransform);

          switch (this.itemType) {
            case constants.REWARD_TYPE.DIAMOND:
              this.spIcon.spriteFrame = this.sfDiamond;
              this.lbRewardValue.string = 'x' + this.itemAmount;
              break;

            case constants.REWARD_TYPE.GOLD:
              this.spIcon.spriteFrame = this.sfGold;
              this.lbRewardValue.string = 'x' + this.itemAmount;
              uiTraSpIcon.width = 257;
              uiTraSpIcon.height = 166;
              break;

            case constants.REWARD_TYPE.PROP:
              let propData = localConfig.instance.queryByID('prop', this.itemSubType);
              uiTraSpIcon.width = 168;
              uiTraSpIcon.height = 168;
              resourceUtil.setPropIcon(propData.icon, this.spIcon, () => {});
              let txt = t('table_prop.' + propData.name);
              this.lbRewardValue.string = txt + t('') + ' x ' + this.itemAmount;
              break;
          }
        }

        onBtnNormalReceiveClick() {
          if (this.ndBtnReceive.active == false) {
            this.addReward();
            this.close();
          } else {
            if (this.ndBtnvideo.active) {
              _cjsExports.showRewardAd("onBtnNormalReceiveClick", "1", _cjsExports$1.getAdReward());
            } else {
              this.addReward();
              this.close();
            }
          }
        }

        onBtnNormalReceiveClickCallback(s) {
          if (s) {
            this.addReward();
            this.close();
          }
        }

        onBtnDoubleReceiveClick() {
          switch (this.openRewardType) {
            case constants.OPEN_REWARD_TYPE.AD:
              // GameLogic.instance.showRewardAd((err: any) => {
              //     if (!err) {
              //         this.itemAmount *= 2;
              //         this.showDoubleReward();
              //     }
              // })
              _cjsExports.showRewardAd("onBtnDoubleReceiveClick", "1", _cjsExports$1.getAdReward());

              break;

            case constants.OPEN_REWARD_TYPE.SHARE:
              GameLogic.instance.share(this.shareFunction, {}, err => {
                if (!err) {
                  this.itemAmount *= 2;
                  this.showDoubleReward();
                }
              });
              break;
          }
        }

        onBtnDoubleReceiveClickCallback(s) {
          console.log("onBtnDoubleReceiveClickCallback", s);

          if (s) {
            this.itemAmount *= 2;
            this.showDoubleReward();
          }
        }

        addReward() {
          switch (this.itemType) {
            case constants.REWARD_TYPE.DIAMOND:
              GameLogic.instance.addDiamond(this.itemAmount);
              break;

            case constants.REWARD_TYPE.GOLD:
              GameLogic.instance.addGold(this.itemAmount);
              break;

            case constants.REWARD_TYPE.PROP:
              GameLogic.instance.addProp(this.itemSubType, this.itemAmount);
              break;
          }
        }

        showDoubleReward() {
          this.unschedule(this.normalBtnCallback);
          let itemInfo = {};
          itemInfo['itemType'] = this.itemType;
          itemInfo['itemSubType'] = this.itemSubType;
          itemInfo['itemAmount'] = this.itemAmount;
          uiManager.instance.showDialog('lottery/reward', [itemInfo, false, this.shareFunction]);
          this.close();
        }

        close() {
          uiManager.instance.shiftFromPopupSeq('lottery/reward');
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "sfDiamond", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "sfGold", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "spIcon", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "lbRewardValue", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "aniGetItem", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "ndBtnNormalReceive", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "ndBtnDoubleReceive", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "ndBtnvideo", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "ndBtnReceive", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/util.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, _decorator;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }],
    execute: function () {
      var _dec, _class;

      cclegacy._RF.push({}, "51238kLGAFBiLoz3gxcwxtH", "util", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let util = exports('util', (_dec = ccclass("util"), _dec(_class = class util {
        /**
         * !#zh 拷贝object。
         */

        /**
         * 深度拷贝
         * @param {any} sObj 拷贝的对象
         * @returns 
         */
        static clone(sObj) {
          if (sObj === null || typeof sObj !== "object") {
            return sObj;
          }

          let s = {};

          if (sObj.constructor === Array) {
            s = [];
          }

          for (let i in sObj) {
            if (sObj.hasOwnProperty(i)) {
              s[i] = this.clone(sObj[i]);
            }
          }

          return s;
        }
        /**
         * 将object转化为数组
         * @param { any} srcObj  
         * @returns 
         */


        static objectToArray(srcObj) {
          let resultArr = []; // to array

          for (let key in srcObj) {
            if (!srcObj.hasOwnProperty(key)) {
              continue;
            }

            resultArr.push(srcObj[key]);
          }

          return resultArr;
        }
        /**
         * !#zh 将数组转化为object。
         */

        /**
         * 将数组转化为object。
         * @param { any} srcObj 
         * @param { string} objectKey 
         * @returns 
         */


        static arrayToObject(srcObj, objectKey) {
          let resultObj = {}; // to object

          for (var key in srcObj) {
            if (!srcObj.hasOwnProperty(key) || !srcObj[key][objectKey]) {
              continue;
            }

            resultObj[srcObj[key][objectKey]] = srcObj[key];
          }

          return resultObj;
        }
        /**
         * 根据权重,计算随机内容
         * @param {arrany} weightArr 
         * @param {number} totalWeight 权重
         * @returns 
         */


        static getWeightRandIndex(weightArr, totalWeight) {
          let randWeight = Math.floor(Math.random() * totalWeight);
          let sum = 0;

          for (var weightIndex = 0; weightIndex < weightArr.length; weightIndex++) {
            sum += weightArr[weightIndex];

            if (randWeight < sum) {
              break;
            }
          }

          return weightIndex;
        }
        /**
         * 从n个数中获取m个随机数
         * @param {Number} n   总数
         * @param {Number} m    获取数
         * @returns {Array} array   获取数列
         */


        static getRandomNFromM(n, m) {
          let array = [];
          let intRd = 0;
          let count = 0;

          while (count < m) {
            if (count >= n + 1) {
              break;
            }

            intRd = this.getRandomInt(0, n);
            var flag = 0;

            for (var i = 0; i < count; i++) {
              if (array[i] === intRd) {
                flag = 1;
                break;
              }
            }

            if (flag === 0) {
              array[count] = intRd;
              count++;
            }
          }

          return array;
        }
        /**
         * 获取随机整数
         * @param {Number} min 最小值
         * @param {Number} max 最大值
         * @returns 
         */


        static getRandomInt(min, max) {
          let r = Math.random();
          let rr = r * (max - min + 1) + min;
          return Math.floor(rr);
        }
        /**
         * 获取字符串长度
         * @param {string} render 
         * @returns 
         */


        static getStringLength(render) {
          let strArr = render;
          let len = 0;

          for (let i = 0, n = strArr.length; i < n; i++) {
            let val = strArr.charCodeAt(i);

            if (val <= 255) {
              len = len + 1;
            } else {
              len = len + 2;
            }
          }

          return Math.ceil(len / 2);
        }
        /**
         * 判断传入的参数是否为空的Object。数组或undefined会返回false
         * @param obj
         */


        static isEmptyObject(obj) {
          let result = true;

          if (obj && obj.constructor === Object) {
            for (var key in obj) {
              if (obj.hasOwnProperty(key)) {
                result = false;
                break;
              }
            }
          } else {
            result = false;
          }

          return result;
        }
        /**
         * 判断是否是新的一天
         * @param {Object|Number} dateValue 时间对象 todo MessageCenter 与 pve 相关的时间存储建议改为 Date 类型
         * @returns {boolean}
         */


        static isNewDay(dateValue) {
          // todo：是否需要判断时区？
          var oldDate = new Date(dateValue);
          var curDate = new Date();
          var oldYear = oldDate.getYear();
          var oldMonth = oldDate.getMonth();
          var oldDay = oldDate.getDate();
          var curYear = curDate.getYear();
          var curMonth = curDate.getMonth();
          var curDay = curDate.getDate();

          if (curYear > oldYear) {
            return true;
          } else {
            if (curMonth > oldMonth) {
              return true;
            } else {
              if (curDay > oldDay) {
                return true;
              }
            }
          }

          return false;
        }
        /**
         * 获取对象属性数量
         * @param {object}o 对象
         * @returns 
         */


        static getPropertyCount(o) {
          var n,
              count = 0;

          for (n in o) {
            if (o.hasOwnProperty(n)) {
              count++;
            }
          }

          return count;
        }
        /**
         * 返回一个差异化数组（将array中diff里的值去掉）
         * @param array
         * @param diff
         */


        static difference(array, diff) {
          let result = [];

          if (array.constructor !== Array || diff.constructor !== Array) {
            return result;
          }

          let length = array.length;

          for (let i = 0; i < length; i++) {
            if (diff.indexOf(array[i]) === -1) {
              result.push(array[i]);
            }
          }

          return result;
        }

        static _stringToArray(string) {
          // 用于判断emoji的正则们
          var rsAstralRange = '\\ud800-\\udfff';
          var rsZWJ = '\\u200d';
          var rsVarRange = '\\ufe0e\\ufe0f';
          var rsComboMarksRange = '\\u0300-\\u036f';
          var reComboHalfMarksRange = '\\ufe20-\\ufe2f';
          var rsComboSymbolsRange = '\\u20d0-\\u20ff';
          var rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange;
          var reHasUnicode = RegExp('[' + rsZWJ + rsAstralRange + rsComboRange + rsVarRange + ']');
          var rsFitz = '\\ud83c[\\udffb-\\udfff]';
          var rsOptVar = '[' + rsVarRange + ']?';
          var rsCombo = '[' + rsComboRange + ']';
          var rsModifier = '(?:' + rsCombo + '|' + rsFitz + ')';
          var reOptMod = rsModifier + '?';
          var rsAstral = '[' + rsAstralRange + ']';
          var rsNonAstral = '[^' + rsAstralRange + ']';
          var rsRegional = '(?:\\ud83c[\\udde6-\\uddff]){2}';
          var rsSurrPair = '[\\ud800-\\udbff][\\udc00-\\udfff]';
          var rsOptJoin = '(?:' + rsZWJ + '(?:' + [rsNonAstral, rsRegional, rsSurrPair].join('|') + ')' + rsOptVar + reOptMod + ')*';
          var rsSeq = rsOptVar + reOptMod + rsOptJoin;
          var rsSymbol = '(?:' + [rsNonAstral + rsCombo + '?', rsCombo, rsRegional, rsSurrPair, rsAstral].join('|') + ')';
          var reUnicode = RegExp(rsFitz + '(?=' + rsFitz + ')|' + rsSymbol + rsSeq, 'g');

          var hasUnicode = function (val) {
            return reHasUnicode.test(val);
          };

          var unicodeToArray = function (val) {
            return val.match(reUnicode) || [];
          };

          var asciiToArray = function (val) {
            return val.split('');
          };

          return hasUnicode(string) ? unicodeToArray(string) : asciiToArray(string);
        } // 模拟传msg的uuid


        static simulationUUID() {
          function s4() {
            return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1);
          }

          return s4() + s4() + '-' + s4() + '-' + s4() + '-' + s4() + '-' + s4() + s4() + s4();
        }

        static trim(str) {
          return str.replace(/(^\s*)|(\s*$)/g, "");
        }
        /**
         * 判断当前时间是否在有效时间内
         * @param {String|Number} start 起始时间。带有时区信息
         * @param {String|Number} end 结束时间。带有时区信息
         */


        static isNowValid(start, end) {
          var startTime = new Date(start);
          var endTime = new Date(end);
          var result = false;

          if (startTime.getDate() + '' !== 'NaN' && endTime.getDate() + '' !== 'NaN') {
            var curDate = new Date();
            result = curDate < endTime && curDate > startTime;
          }

          return result;
        }
        /**
         * 返回相隔天数
         * @param start 
         * @param end 
         * @returns 
         */


        static getDeltaDays(start, end) {
          start = new Date(start);
          end = new Date(end);
          let startYear = start.getFullYear();
          let startMonth = start.getMonth() + 1;
          let startDate = start.getDate();
          let endYear = end.getFullYear();
          let endMonth = end.getMonth() + 1;
          let endDate = end.getDate();
          start = new Date(startYear + '/' + startMonth + '/' + startDate + ' GMT+0800').getTime();
          end = new Date(endYear + '/' + endMonth + '/' + endDate + ' GMT+0800').getTime();
          let deltaTime = end - start;
          return Math.floor(deltaTime / (24 * 60 * 60 * 1000));
        }
        /**
         * 获取数组最小值
         * @param array 数组
         * @returns 
         */


        static getMin(array) {
          let result = null;

          if (array.constructor === Array) {
            let length = array.length;

            for (let i = 0; i < length; i++) {
              if (i === 0) {
                result = Number(array[0]);
              } else {
                result = result > Number(array[i]) ? Number(array[i]) : result;
              }
            }
          }

          return result;
        }
        /**
         * 格式化两位小数点
         * @param time 
         * @returns 
         */


        static formatTwoDigits(time) {
          //@ts-ignore
          return (Array(2).join(0) + time).slice(-2);
        }
        /**
         * 根据格式返回时间
         * @param date  时间
         * @param fmt 格式
         * @returns 
         */


        static formatDate(date, fmt) {
          let o = {
            "M+": date.getMonth() + 1,
            //月份
            "d+": date.getDate(),
            //日
            "h+": date.getHours(),
            //小时
            "m+": date.getMinutes(),
            //分
            "s+": date.getSeconds(),
            //秒
            "q+": Math.floor((date.getMonth() + 3) / 3),
            //季度
            "S": date.getMilliseconds() //毫秒

          };
          if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (date.getFullYear() + "").substr(4 - RegExp.$1.length));

          for (let k in o) if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, RegExp.$1.length === 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));

          return fmt;
        }
        /**
         * 获取格式化后的日期（不含小时分秒）
         */


        static getDay() {
          let date = new Date();
          return date.getFullYear() + '-' + (date.getMonth() + 1) + '-' + date.getDate();
        }
        /**
         * 格式化名字，XXX...
         * @param {string} name 需要格式化的字符串 
         * @param {number}limit 
         * @returns {string} 返回格式化后的字符串XXX...
         */


        static formatName(name, limit) {
          limit = limit || 6;

          var nameArray = this._stringToArray(name);

          var str = '';
          var length = nameArray.length;

          if (length > limit) {
            for (var i = 0; i < limit; i++) {
              str += nameArray[i];
            }

            str += '...';
          } else {
            str = name;
          }

          return str;
        }
        /**
         * 格式化钱数，超过10000 转换位 10K   10000K 转换为 10M
         * @param {number}money 需要被格式化的数值
         * @returns {string}返回 被格式化的数值
         */


        static formatMoney(money) {
          let arrUnit = ['', 'K', 'M', 'G', 'T', 'P', 'E', 'Z', 'Y', 'B', 'N', 'D'];
          let strValue = '';

          for (let idx = 0; idx < arrUnit.length; idx++) {
            if (money >= 10000) {
              money /= 1000;
            } else {
              strValue = Math.floor(money) + arrUnit[idx];
              break;
            }
          }

          if (strValue === '') {
            strValue = Math.floor(money) + 'U'; //超过最大值就加个U
          }

          return strValue;
        }
        /**
         * 格式化数值
         * @param {number}value 需要被格式化的数值
         * @returns {string}返回 被格式化的数值
         */


        static formatValue(value) {
          let arrUnit = [];
          let strValue = '';

          for (let i = 0; i < 26; i++) {
            arrUnit.push(String.fromCharCode(97 + i));
          }

          for (let idx = 0; idx < arrUnit.length; idx++) {
            if (value >= 10000) {
              value /= 1000;
            } else {
              strValue = Math.floor(value) + arrUnit[idx];
              break;
            }
          }

          return strValue;
        }
        /**
         * 根据剩余秒数格式化剩余时间 返回 HH:MM:SS
         * @param {Number} leftSec 
         */


        static formatTimeForSecond(leftSec, withoutSeconds = false) {
          let timeStr = '';
          let sec = leftSec % 60;
          let leftMin = Math.floor(leftSec / 60);
          leftMin = leftMin < 0 ? 0 : leftMin;
          let hour = Math.floor(leftMin / 60);
          let min = leftMin % 60;

          if (hour > 0) {
            timeStr += hour > 9 ? hour.toString() : '0' + hour;
            timeStr += ':';
          } else {
            timeStr += '00:';
          }

          timeStr += min > 9 ? min.toString() : '0' + min;

          if (!withoutSeconds) {
            timeStr += ':';
            timeStr += sec > 9 ? sec.toString() : '0' + sec;
          }

          return timeStr;
        }
        /**
         *  根据剩余毫秒数格式化剩余时间 返回 HH:MM:SS
         *
         * @param {Number} ms
         */


        static formatTimeForMillisecond(ms) {
          let second = Math.floor(ms / 1000 % 60);
          let minute = Math.floor(ms / 1000 / 60 % 60);
          let hour = Math.floor(ms / 1000 / 60 / 60);
          return {
            'hour': hour,
            'minute': minute,
            'second': second
          };
        }
        /**
         * 将数组内容进行随机排列
         * @param {Array}arr 需要被随机的数组 
         * @returns 
         */


        static rand(arr) {
          let arrClone = this.clone(arr); // 首先从最大的数开始遍历，之后递减

          for (let i = arrClone.length - 1; i >= 0; i--) {
            // 随机索引值randomIndex是从0-arrClone.length中随机抽取的
            const randomIndex = Math.floor(Math.random() * (i + 1)); // 下面三句相当于把从数组中随机抽取到的值与当前遍历的值互换位置

            const itemIndex = arrClone[randomIndex];
            arrClone[randomIndex] = arrClone[i];
            arrClone[i] = itemIndex;
          } // 每一次的遍历都相当于把从数组中随机抽取（不重复）的一个元素放到数组的最后面（索引顺序为：len-1,len-2,len-3......0）


          return arrClone;
        }
        /**
         * 获得开始和结束两者之间相隔分钟数
         *
         * @static
         * @param {number} start
         * @param {number} end
         * @memberof Util
         */


        static getOffsetMimutes(start, end) {
          let offSetTime = end - start;
          let minute = Math.floor(offSetTime % (1000 * 60 * 60) / (1000 * 60));
          return minute;
        }
        /**
         * 返回指定小数位的数值
         * @param {number} num 
         * @param {number} idx 
         */


        static formatNumToFixed(num, idx = 0) {
          return Number(num.toFixed(idx));
        }
        /**
         * 用于数值到达另外一个目标数值之间进行平滑过渡运动效果
         * @param {number} targetValue 目标数值 
         * @param {number} curValue 当前数值
         * @param {number} ratio    过渡比率
         * @returns 
         */


        static lerp(targetValue, curValue, ratio = 0.25) {
          let v = curValue;

          if (targetValue > curValue) {
            v = curValue + (targetValue - curValue) * ratio;
          } else if (targetValue < curValue) {
            v = curValue - (curValue - targetValue) * ratio;
          }

          return v;
        }
        /**
         * 数据解密
         * @param {String} str 
         */


        static decrypt(b64Data) {
          let n = 6;

          if (b64Data.length % 2 === 0) {
            n = 7;
          }

          let decodeData = '';

          for (var idx = 0; idx < b64Data.length - n; idx += 2) {
            decodeData += b64Data[idx + 1];
            decodeData += b64Data[idx];
          }

          decodeData += b64Data.slice(b64Data.length - n + 1);
          decodeData = this._base64Decode(decodeData);
          return decodeData;
        }
        /**
        * 数据加密
        * @param {String} str 
        */


        static encrypt(str) {
          let b64Data = this._base64encode(str);

          let n = 6;

          if (b64Data.length % 2 === 0) {
            n = 7;
          }

          let encodeData = '';

          for (let idx = 0; idx < (b64Data.length - n + 1) / 2; idx++) {
            encodeData += b64Data[2 * idx + 1];
            encodeData += b64Data[2 * idx];
          }

          encodeData += b64Data.slice(b64Data.length - n + 1);
          return encodeData;
        } //public method for encoding

        /**
         * base64加密
         * @param {string}input 
         * @returns 
         */


        static _base64encode(input) {
          let keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
          let output = "",
              chr1,
              chr2,
              chr3,
              enc1,
              enc2,
              enc3,
              enc4,
              i = 0;
          input = this._utf8Encode(input);

          while (i < input.length) {
            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);
            enc1 = chr1 >> 2;
            enc2 = (chr1 & 3) << 4 | chr2 >> 4;
            enc3 = (chr2 & 15) << 2 | chr3 >> 6;
            enc4 = chr3 & 63;

            if (isNaN(chr2)) {
              enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
              enc4 = 64;
            }

            output = output + keyStr.charAt(enc1) + keyStr.charAt(enc2) + keyStr.charAt(enc3) + keyStr.charAt(enc4);
          }

          return output;
        }
        /**
         * utf-8 加密
         * @param string 
         * @returns 
         */


        static _utf8Encode(string) {
          string = string.replace(/\r\n/g, "\n");
          let utftext = "";

          for (let n = 0; n < string.length; n++) {
            let c = string.charCodeAt(n);

            if (c < 128) {
              utftext += String.fromCharCode(c);
            } else if (c > 127 && c < 2048) {
              utftext += String.fromCharCode(c >> 6 | 192);
              utftext += String.fromCharCode(c & 63 | 128);
            } else {
              utftext += String.fromCharCode(c >> 12 | 224);
              utftext += String.fromCharCode(c >> 6 & 63 | 128);
              utftext += String.fromCharCode(c & 63 | 128);
            }
          }

          return utftext;
        }
        /**
         * utf-8解密
         * @param utftext 
         * @returns 
         */


        static _utf8Decode(utftext) {
          let string = "";
          let i = 0;
          let c = 0;
          let c2 = 0;
          let c3 = 0;

          while (i < utftext.length) {
            c = utftext.charCodeAt(i);

            if (c < 128) {
              string += String.fromCharCode(c);
              i++;
            } else if (c > 191 && c < 224) {
              c2 = utftext.charCodeAt(i + 1);
              string += String.fromCharCode((c & 31) << 6 | c2 & 63);
              i += 2;
            } else {
              c2 = utftext.charCodeAt(i + 1);
              c3 = utftext.charCodeAt(i + 2);
              string += String.fromCharCode((c & 15) << 12 | (c2 & 63) << 6 | c3 & 63);
              i += 3;
            }
          }

          return string;
        }
        /**
         * base64解密
         * @param {string}input 解密字符串
         * @returns 
         */


        static _base64Decode(input) {
          let keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
          let output = "";
          let chr1;
          let chr2;
          let chr3;
          let enc1;
          let enc2;
          let enc3;
          let enc4;
          let i = 0;
          input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

          while (i < input.length) {
            enc1 = keyStr.indexOf(input.charAt(i++));
            enc2 = keyStr.indexOf(input.charAt(i++));
            enc3 = keyStr.indexOf(input.charAt(i++));
            enc4 = keyStr.indexOf(input.charAt(i++));
            chr1 = enc1 << 2 | enc2 >> 4;
            chr2 = (enc2 & 15) << 4 | enc3 >> 2;
            chr3 = (enc3 & 3) << 6 | enc4;
            output = output + String.fromCharCode(chr1);

            if (enc3 != 64) {
              output = output + String.fromCharCode(chr2);
            }

            if (enc4 != 64) {
              output = output + String.fromCharCode(chr3);
            }
          }

          output = this._utf8Decode(output);
          return output;
        }
        /**
         * 获取当前机型性能是否为低端机
         */


        static checkIsLowPhone() {
          if (window.wx) {
            //微信性能数值参考:https://developers.weixin.qq.com/minigame/dev/guide/performance/perf-benchmarkLevel.html
            let nowBenchmarkLevel = -1; //nowBenchmarkLevel = -1性能未知

            const sys = window.wx.getSystemInfoSync();
            const isIOS = sys.system.indexOf('iOS') >= 0;

            if (isIOS) {
              //微信不支持IO性能等级
              const model = sys.model; // iPhone 5s 及以下 设定为超低端机

              const ultraLowPhoneType = ['iPhone1,1', 'iPhone1,2', 'iPhone2,1', 'iPhone3,1', 'iPhone3,3', 'iPhone4,1', 'iPhone5,1', 'iPhone5,2', 'iPhone5,3', 'iPhone5,4', 'iPhone6,1', 'iPhone6,2']; // iPhone 6 ~ iPhone SE 设定为超低端机

              const lowPhoneType = ['iPhone6,2', 'iPhone7,1', 'iPhone7,2', 'iPhone8,1', 'iPhone8,2', 'iPhone8,4']; // iPhone 7 ~ iPhone X 设定为中端机

              const middlePhoneType = ['iPhone9,1', 'iPhone9,2', 'iPhone9,3', 'iPhone9,4', 'iPhone10,1', 'iPhone10,2', 'iPhone10,3', 'iPhone10,4', 'iPhone10,5', 'iPhone10,6']; // iPhone XS 及以上 设定为高端机

              const highPhoneType = ['iPhone11,2', 'iPhone11,4', 'iPhone11,6', 'iPhone11,8', 'iPhone12,1', 'iPhone12,3', 'iPhone12,5', 'iPhone12,8'];

              for (let i = 0; i < ultraLowPhoneType.length; i++) {
                if (model.indexOf(ultraLowPhoneType[i]) >= 0) nowBenchmarkLevel = 5;
              }

              for (let i = 0; i < lowPhoneType.length; i++) {
                if (model.indexOf(lowPhoneType[i]) >= 0) nowBenchmarkLevel = 10;
              }

              for (let i = 0; i < middlePhoneType.length; i++) {
                if (model.indexOf(middlePhoneType[i]) >= 0) nowBenchmarkLevel = 20;
              }

              for (let i = 0; i < highPhoneType.length; i++) {
                if (model.indexOf(highPhoneType[i]) >= 0) nowBenchmarkLevel = 30;
              }
            } else {
              nowBenchmarkLevel = sys.benchmarkLevel;
            }

            if (nowBenchmarkLevel < 22) {
              //22的具体参数可参考微信官方
              return true;
            } else {
              return false;
            }
          } else {
            return false;
          }
        }

      }) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/effectManager.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './poolManager.ts', './resourceUtil.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, find, Vec3, AnimationComponent, ParticleSystemComponent, AnimationClip, _defineProperty, poolManager, resourceUtil;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      find = module.find;
      Vec3 = module.Vec3;
      AnimationComponent = module.AnimationComponent;
      ParticleSystemComponent = module.ParticleSystemComponent;
      AnimationClip = module.AnimationClip;
    }, function (module) {
      _defineProperty = module.defineProperty;
    }, function (module) {
      poolManager = module.poolManager;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }],
    execute: function () {
      var _dec, _class, _class2, _temp;

      cclegacy._RF.push({}, "554baRvdXVCaZZeXFSvvApe", "effectManager", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let EffectManager = exports('EffectManager', (_dec = ccclass('EffectManager'), _dec(_class = (_temp = _class2 = class EffectManager extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "_ndParent", null);
        }

        get ndParent() {
          if (!this._ndParent) {
            this._ndParent = find("effectManager");
          }

          return this._ndParent;
        }

        static get instance() {
          if (this._instance) {
            return this._instance;
          }

          this._instance = new EffectManager();
          return this._instance;
        }
        /**
         * 播放动画
         * @param {string} path 动画节点路径
         * @param {string} aniName 
         * @param {vec3} worPos 世界坐标
         * @param {boolean} isLoop 是否循环
         * @param {boolean} isRecycle 是否回收
         * @param {number} [scale=1] 缩放倍数 
         * @param {Function} [callback=()=>{}] 回调函数 
         */


        playAni(path, aniName, worPos = new Vec3(), isLoop = false, isRecycle = false, scale = 1, callback = () => {}) {
          let childName = path.split("/")[1];
          let ndEffect = this.ndParent.getChildByName(childName);

          let cb = () => {
            var _ndEffect, _ndEffect2, _ndEffect3;

            (_ndEffect = ndEffect) === null || _ndEffect === void 0 ? void 0 : _ndEffect.setScale(new Vec3(scale, scale, scale));
            (_ndEffect2 = ndEffect) === null || _ndEffect2 === void 0 ? void 0 : _ndEffect2.setWorldPosition(worPos);
            let ani = (_ndEffect3 = ndEffect) === null || _ndEffect3 === void 0 ? void 0 : _ndEffect3.getComponent(AnimationComponent);
            ani.play(aniName);
            let aniState = ani.getState(aniName);

            if (aniState) {
              if (isLoop) {
                aniState.wrapMode = AnimationClip.WrapMode.Loop;
              } else {
                aniState.wrapMode = AnimationClip.WrapMode.Normal;
              }
            }

            ani.once(AnimationComponent.EventType.FINISHED, () => {
              callback && callback();

              if (isRecycle && ndEffect) {
                poolManager.instance.putNode(ndEffect);
              }
            });
          };

          if (!ndEffect) {
            resourceUtil.loadModelRes(path).then(prefab => {
              ndEffect = poolManager.instance.getNode(prefab, this.ndParent);
              ndEffect.setScale(new Vec3(scale, scale, scale));
              ndEffect.setWorldPosition(worPos);
              cb();
            });
          } else {
            cb();
          }
        }
        /**
         * 移除特效
         * @param {string} name  特效名称
         * @param {Node}} ndParent 特效父节点
         */


        removeEffect(name, ndParent = this.ndParent) {
          let ndEffect = ndParent.getChildByName(name);

          if (ndEffect) {
            let arrAni = ndEffect.getComponentsInChildren(AnimationComponent);
            arrAni.forEach(element => {
              element.stop();
            });
            let arrParticle = ndEffect === null || ndEffect === void 0 ? void 0 : ndEffect.getComponentsInChildren(ParticleSystemComponent);
            arrParticle.forEach(element => {
              element === null || element === void 0 ? void 0 : element.clear();
              element === null || element === void 0 ? void 0 : element.stop();
            });
            poolManager.instance.putNode(ndEffect);
          }
        }
        /**
         * 播放粒子特效
         * @param {string} path 特效路径
         * @param {vec3}worPos 特效世界坐标 
         * @param {number} [recycleTime=0] 特效节点回收时间，如果为0，则使用默认duration
         * @param  {number} [scale=1] 缩放倍数
         * @param {vec3} eulerAngles 特效角度
         * @param {Function} [callback=()=>{}] 回调函数
         */


        playParticle(path, worPos, recycleTime = 0, scale = 1, eulerAngles, callback) {
          resourceUtil.loadEffectRes(path).then(prefab => {
            let ndEffect = poolManager.instance.getNode(prefab, this.ndParent);
            ndEffect.setScale(new Vec3(scale, scale, scale));
            ndEffect.setWorldPosition(worPos);

            if (eulerAngles) {
              ndEffect.eulerAngles = eulerAngles;
            }

            let maxDuration = 0;
            let arrParticle = ndEffect.getComponentsInChildren(ParticleSystemComponent);
            arrParticle.forEach(item => {
              item.simulationSpeed = 1;
              item === null || item === void 0 ? void 0 : item.clear();
              item === null || item === void 0 ? void 0 : item.stop();
              item === null || item === void 0 ? void 0 : item.play();
              let duration = item.duration;
              maxDuration = duration > maxDuration ? duration : maxDuration;
            });
            let seconds = recycleTime && recycleTime > 0 ? recycleTime : maxDuration;
            setTimeout(() => {
              if (ndEffect.parent) {
                callback && callback();
                poolManager.instance.putNode(ndEffect);
              }
            }, seconds * 1000);
          });
        }
        /**
         * 播放节点下面的动画和粒子
         *
         * @param {Node} targetNode 特效挂载节点
         * @param {string} effectPath 特效路径
         * @param {boolean} [isPlayAni=true] 是否播放动画
         * @param {boolean} [isPlayParticle=true] 是否播放特效
         * @param {number} [recycleTime=0] 特效节点回收时间，如果为0，则使用默认duration
         * @param {number} [scale=1] 缩放倍数
         * @param {Vec3} [pos=new Vec3()] 位移
         * @param {Function} [callback=()=>{}] 回调函数
         * @returns
         * @memberof EffectManager
         */


        playEffect(targetNode, effectPath, isPlayAni = true, isPlayParticle = true, recycleTime = 0, scale = 1, pos = new Vec3(), eulerAngles, callback) {
          if (!targetNode.parent) {
            //父节点被回收的时候不播放
            return;
          }

          resourceUtil.loadEffectRes(effectPath).then(prefab => {
            let ndEffect = poolManager.instance.getNode(prefab, targetNode);
            ndEffect.setScale(new Vec3(scale, scale, scale));
            ndEffect.setPosition(pos);

            if (eulerAngles) {
              ndEffect.eulerAngles = eulerAngles;
            }

            let maxDuration = 0;

            if (isPlayAni) {
              let arrAni = ndEffect.getComponentsInChildren(AnimationComponent);
              arrAni.forEach((element, idx) => {
                var _element$defaultClip;

                element === null || element === void 0 ? void 0 : element.play();
                let aniName = element === null || element === void 0 ? void 0 : (_element$defaultClip = element.defaultClip) === null || _element$defaultClip === void 0 ? void 0 : _element$defaultClip.name;

                if (aniName) {
                  let aniState = element.getState(aniName);

                  if (aniState) {
                    let duration = aniState.duration;
                    maxDuration = duration > maxDuration ? duration : maxDuration;
                    aniState.speed = 1;
                  }
                }
              });
            }

            if (isPlayParticle) {
              let arrParticle = ndEffect.getComponentsInChildren(ParticleSystemComponent);
              arrParticle.forEach(element => {
                element.simulationSpeed = 1;
                element === null || element === void 0 ? void 0 : element.clear();
                element === null || element === void 0 ? void 0 : element.stop();
                element === null || element === void 0 ? void 0 : element.play();
                let duration = element.duration;
                maxDuration = duration > maxDuration ? duration : maxDuration;
              });
            }

            let seconds = recycleTime && recycleTime > 0 ? recycleTime : maxDuration;
            setTimeout(() => {
              if (ndEffect.parent) {
                callback && callback();
                poolManager.instance.putNode(ndEffect);
              }
            }, seconds * 1000);
          });
        }

      }, _defineProperty(_class2, "_instance", void 0), _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/storageManager.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './util.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, sys, log, _defineProperty, util;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      sys = module.sys;
      log = module.log;
    }, function (module) {
      _defineProperty = module.defineProperty;
    }, function (module) {
      util = module.util;
    }],
    execute: function () {
      var _dec, _class, _class2, _temp;

      cclegacy._RF.push({}, "5689348bSJGyYo12WGa6eeJ", "storageManager", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let StorageManager = exports('StorageManager', (_dec = ccclass("StorageManager"), _dec(_class = (_temp = _class2 = class StorageManager {
        constructor() {
          _defineProperty(this, "_jsonData", {});

          _defineProperty(this, "_path", null);

          _defineProperty(this, "KEY_CONFIG", 'link');

          _defineProperty(this, "_markSave", false);

          _defineProperty(this, "_saveTimer", -1);
        }

        static get instance() {
          if (this._instance) {
            return this._instance;
          }

          this._instance = new StorageManager();

          this._instance.start();

          return this._instance;
        }

        start() {
          this._jsonData = {
            "userId": ""
          };
          this._path = this._getConfigPath();
          var content;

          if (sys.isNative) {
            var valueObject = jsb.fileUtils.getValueMapFromFile(this._path);
            content = valueObject[this.KEY_CONFIG];
          } else {
            content = sys.localStorage.getItem(this.KEY_CONFIG);
          } // // 解密代码
          // if (cc.game.config["encript"]) {
          //     var newContent = new Xxtea("upgradeHeroAbility").xxteaDecrypt(content);
          //     if (newContent && newContent.length > 0) {
          //         content = newContent;
          //     }
          // }


          if (content && content.length) {
            if (content.startsWith('@')) {
              content = content.substring(1);
              content = util.decrypt(content);
            }

            try {
              //初始化操作
              var jsonData = JSON.parse(content);
              this._jsonData = jsonData;
            } catch (excepaiton) {}
          } //启动无限定时器，每1秒保存一次数据，而不是无限保存数据
          // this._saveTimer = setInterval(() =>{
          //     this.scheduleSave();
          // }, 500);
          //每隔5秒保存一次数据，主要是为了保存最新在线时间，方便离线奖励时间判定


          this._saveTimer = setInterval(() => {
            this.scheduleSave();
          }, 5000);
        }
        /**
         * 存储配置文件，不保存到本地
         * @param {string}key  关键字
         * @param {any}value  存储值
         */


        setConfigDataWithoutSave(key, value) {
          let account = this._jsonData.userId;

          if (this._jsonData[account]) {
            this._jsonData[account][key] = value;
          } else {
            console.error("no account can not save");
          }
        }
        /**
           * 存储配置文件，保存到本地
           * @param {string}key  关键字
           * @param {any}value  存储值
           */


        setConfigData(key, value) {
          this.setConfigDataWithoutSave(key, value);
          this._markSave = true; //标记为需要存储，避免一直在写入，而是每隔一段时间进行写入
        }
        /**
         * 根据关键字获取数值
         * @param {string} key 关键字
         * @returns 
         */


        getConfigData(key) {
          let account = this._jsonData.userId;

          if (this._jsonData[account]) {
            var value = this._jsonData[account][key];
            return value ? value : "";
          } else {
            log("no account can not load");
            return "";
          }
        }
        /**
         * 设置全局数据
         * @param {string} key 关键字
         * @param {any}value  存储值
         * @returns 
         */


        setGlobalData(key, value) {
          this._jsonData[key] = value;
          this.save();
        }
        /**
         * 获取全局数据
         * @param {string} key 关键字
         * @returns 
         */


        getGlobalData(key) {
          return this._jsonData[key];
        }
        /**
         * 设置用户唯一标示符
         * @param {string} userId 用户唯一标示符
         * @param {any}value  存储值
         * @returns 
         */


        setUserId(userId) {
          this._jsonData.userId = userId;

          if (!this._jsonData[userId]) {
            this._jsonData[userId] = {};
          }

          this.save();
        }
        /**
         * 获取用户唯一标示符
         * @returns {string}
         */


        getUserId() {
          return this._jsonData.userId;
        }
        /**
         * 定时存储
         * @returns 
         */


        scheduleSave() {
          if (!this._markSave) {
            return;
          }

          this.save();
        }
        /**
         * 标记为已修改
         */


        markModified() {
          this._markSave = true;
        }
        /**
         * 保存配置文件
         * @returns 
         */


        save() {
          // 写入文件
          var str = JSON.stringify(this._jsonData); // // 加密代码
          // if (cc.game.config["encript"]) {
          //     str = new Xxtea("upgradeHeroAbility").xxteaEncrypt(str);
          // }

          let zipStr = '@' + util.encrypt(str); // let zipStr = str;

          this._markSave = false;

          if (!sys.isNative) {
            var ls = sys.localStorage;
            ls.setItem(this.KEY_CONFIG, zipStr);
            return;
          }

          var valueObj = {};
          valueObj[this.KEY_CONFIG] = zipStr;
          jsb.fileUtils.writeToFile(valueObj, this._getConfigPath()); // jsb.fileUtils.writeToFile(valueObj);
        }
        /**
         * 获取配置文件路径
         * @returns 获取配置文件路径
         */


        _getConfigPath() {
          let platform = sys.platform;
          let path = "";

          if (platform === sys.OS.WINDOWS) {
            path = "src/conf";
          } else if (platform === sys.OS.LINUX) {
            path = "./conf";
          } else {
            if (sys.isNative) {
              path = jsb.fileUtils.getWritablePath();
              path = path + "conf";
            } else {
              path = "src/conf";
            }
          }

          return path;
        }

      }, _defineProperty(_class2, "_instance", void 0), _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/shopItem.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './resourceUtil.ts', './constants.ts', './clientEvent.ts', './localConfig.ts', './playerData.ts', './uiManager.ts', './gameLogic.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, resourceUtil, constants, clientEvent, localConfig, playerData, uiManager, GameLogic;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      clientEvent = module.clientEvent;
    }, function (module) {
      localConfig = module.localConfig;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      GameLogic = module.GameLogic;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _descriptor13, _temp;

      cclegacy._RF.push({}, "583beWcByBAYIU3DaI3EGJj", "shopItem", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ShopItem = exports('ShopItem', (_dec = ccclass('ShopItem'), _dec(_class = (_class2 = (_temp = class ShopItem extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spIcon", _descriptor, this);

          _initializerDefineProperty(this, "lbPrise", _descriptor2, this);

          _initializerDefineProperty(this, "ndGold", _descriptor3, this);

          _initializerDefineProperty(this, "lbNum", _descriptor4, this);

          _initializerDefineProperty(this, "lbProcess", _descriptor5, this);

          _initializerDefineProperty(this, "aniLight", _descriptor6, this);

          _initializerDefineProperty(this, "exBtnBuy", _descriptor7, this);

          _initializerDefineProperty(this, "ndNumber", _descriptor8, this);

          _initializerDefineProperty(this, "spBtnBuy", _descriptor9, this);

          _initializerDefineProperty(this, "sfBuy", _descriptor10, this);

          _initializerDefineProperty(this, "sfShare", _descriptor11, this);

          _initializerDefineProperty(this, "sfAd", _descriptor12, this);

          _initializerDefineProperty(this, "sfReceive", _descriptor13, this);

          _defineProperty(this, "info", void 0);

          _defineProperty(this, "parent", void 0);

          _defineProperty(this, "id", void 0);

          _defineProperty(this, "price", void 0);

          _defineProperty(this, "countPerBuy", void 0);

          _defineProperty(this, "icon", void 0);

          _defineProperty(this, "animState", void 0);

          _defineProperty(this, "totalPrice", void 0);

          _defineProperty(this, "times", void 0);

          _defineProperty(this, "maxTimes", void 0);

          _defineProperty(this, "rewardType", void 0);
        }

        onEnable() {
          clientEvent.on('updateGold', this.refreshBtn, this);
          clientEvent.on('updateInfiniteShareTimes', this.updateInfiniteShareTimes, this);
        }

        onDisable() {
          clientEvent.off('updateGold', this.refreshBtn, this);
          clientEvent.off('updateInfiniteShareTimes', this.updateInfiniteShareTimes, this);
        }

        setInfo(info, parent) {
          this.info = info;
          this.parent = parent;
          this.id = info.ID;
          this.price = info.price;
          this.countPerBuy = info.countPerBuy;
          this.icon = info.icon;
          this.refreshUI();
          this.refreshBtn();
        }

        refreshUI() {
          this.animState = 'shopPropertyIdle';
          this.aniLight.play(this.animState);
          resourceUtil.setPropIcon(this.icon, this.spIcon, () => {});
          let propItem = localConfig.instance.queryByID('prop', this.id);
          this.totalPrice = this.countPerBuy * this.price;
          this.lbNum.string = propItem.countPerBuy;
          this.times = playerData.instance.getInfiniteTimes();
          this.maxTimes = constants.MAX_INFINITE_TIMES;

          if (this.info.ID !== constants.PROP_ID.INFINITE) {
            this.lbPrise.string = this.totalPrice;
            this.lbProcess.node.active = false;
          } else {
            GameLogic.instance.getOpenRewardType(constants.SHARE_FUNCTION.BUY_INFINITE, (err, type) => {
              if (!err) {
                this.rewardType = type;

                switch (type) {
                  case constants.OPEN_REWARD_TYPE.AD:
                    this.spBtnBuy.spriteFrame = this.sfAd;
                    this.ndGold.active = false;
                    this.updateInfiniteShareTimes();
                    break;

                  case constants.OPEN_REWARD_TYPE.SHARE:
                    this.spBtnBuy.spriteFrame = this.sfShare;
                    this.ndGold.active = false;
                    this.updateInfiniteShareTimes();
                    break;

                  case constants.OPEN_REWARD_TYPE.NULL:
                    this.spBtnBuy.spriteFrame = this.sfBuy;
                    this.lbProcess.node.active = false;
                    this.lbPrise.string = this.totalPrice;
                    break;
                }

                this.refreshBtn();
              }
            });
          }
        }

        refreshBtn() {
          if (typeof this.rewardType === 'number' && this.rewardType !== constants.OPEN_REWARD_TYPE.NULL) {
            this.exBtnBuy.interactable = true;
          } else {
            this.exBtnBuy.interactable = playerData.instance.getGold() >= this.totalPrice;
          }
        }

        onBtnBuyClick() {
          uiManager.instance.showDialog('props/buy', [this.id, constants.ANALYTICS_TYPE.SHOP_PROP_PER_BUY]);
          this.parent.showAllItemUnSelect();
          this.showSelect();
        }

        onItemClick() {
          this.parent.showAllItemUnSelect();
          this.parent.hideRandPropSelect();
          this.showSelect();
        }

        showSelect() {
          this.animState = 'shopPropertySelect';
          this.aniLight.play(this.animState);
          this.parent.shopPropsOperationScript.show(this.id);
        }

        showUnSelect() {
          if (this.animState === 'shopPropertyIdle') return;
          this.animState = 'shopPropertyIdle';
          this.aniLight.play(this.animState);
        }

        updateInfiniteShareTimes() {
          this.spBtnBuy.node.setScale(1, 1, 1);

          if (this.id === constants.PROP_ID.INFINITE) {
            this.spBtnBuy.spriteFrame = this.sfReceive;
            this.spBtnBuy.node.setScale(1.3, 1.3, 1.3);
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spIcon", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "lbPrise", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "ndGold", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "lbNum", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "lbProcess", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "aniLight", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "exBtnBuy", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "ndNumber", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "spBtnBuy", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "sfBuy", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "sfShare", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "sfAd", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor13 = _applyDecoratedDescriptor(_class2.prototype, "sfReceive", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/NativeAdBig.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './PlatformBridge.js', './PlatformBridge.mjs_cjs=&original=.js'], function (exports) {
  'use strict';

  var cclegacy, Node, Sprite, Label, _decorator, Component, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, _cjsExports;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Sprite = module.Sprite;
      Label = module.Label;
      _decorator = module._decorator;
      Component = module.Component;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      _cjsExports = module.default;
    }, null],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _temp;

      cclegacy._RF.push({}, "5bf8fRSpj5A6YqFejPMQEoz", "NativeAdBig", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let NewClass = exports('default', (_dec = property(Node), _dec2 = property(Sprite), _dec3 = property(Node), _dec4 = property(Node), _dec5 = property(Label), ccclass(_class = (_class2 = (_temp = class NewClass extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "Ad", _descriptor, this);

          _initializerDefineProperty(this, "AdSprite", _descriptor2, this);

          _initializerDefineProperty(this, "adButtonNode", _descriptor3, this);

          _initializerDefineProperty(this, "AdSpriteBg", _descriptor4, this);

          _initializerDefineProperty(this, "descLabel", _descriptor5, this);

          _defineProperty(this, "show", true);
        } // LIFE-CYCLE CALLBACKS:
        // onLoad () {}


        start() {}

        onClickOpen() {
          _cjsExports.onClickNativeAdOpen();

          if (this.AdSpriteBg) {
            this.AdSpriteBg.active = false;
          }

          this.AdSprite.node.active = false;
          this.adButtonNode.active = false;
        }

        setSprite(frame) {
          if (!this.show) {
            return;
          }

          if (frame != null) {
            // self.node.getComponent(cc.Sprite).spriteFrame=frame;
            console.log("nativeadbig->", frame);

            if (this.AdSpriteBg) {
              this.AdSpriteBg.active = true;
            }

            this.AdSprite.node.active = true;
            this.adButtonNode.active = true;
            this.AdSprite.spriteFrame = frame;
          }
        }

        setDateShow() {
          var today = new Date();
          var today_time = this.FormatDate(today);
          console.log("当前日期-：", today_time);

          if (today_time < '2022-7-6') {
            console.log("当前日期-：this.show = false");
            this.show = false;
          } else {
            console.log("当前日期-：this.show = true");
            this.show = true;
          }
        }

        FormatDate(strTime) {
          var date = new Date(strTime);
          return date.getFullYear() + "-" + (date.getMonth() + 1) + "-" + date.getDate();
        }

        setString(desc) {
          if (desc) {
            if (this.descLabel) {
              this.descLabel.string = desc;
            }
          }
        }

        onClickClose() {
          _cjsExports.onClickNativeAdClose();

          if (this.AdSpriteBg) {
            this.AdSpriteBg.active = false;
          }

          this.AdSprite.node.active = false;
          this.adButtonNode.active = false;
        } // update (dt) {}


      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "Ad", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "AdSprite", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "adButtonNode", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "AdSpriteBg", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "descLabel", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/audioManager.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './resourceUtil.ts', './storageManager.ts', './loadsh.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Node, director, game, AudioSource, AudioClip, _defineProperty, resourceUtil, StorageManager, loadsh;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Node = module.Node;
      director = module.director;
      game = module.game;
      AudioSource = module.AudioSource;
      AudioClip = module.AudioClip;
    }, function (module) {
      _defineProperty = module.defineProperty;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }, function (module) {
      StorageManager = module.StorageManager;
    }, function (module) {
      loadsh = module.loadsh;
    }],
    execute: function () {
      var _dec, _class, _class2, _temp;

      cclegacy._RF.push({}, "5e2ecZFEJFEHoCgx6lXVYHB", "audioManager", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let AudioManager = exports('AudioManager', (_dec = ccclass("AudioManager"), _dec(_class = (_temp = _class2 = class AudioManager {
        constructor() {
          _defineProperty(this, "_persistRootNode", null);

          _defineProperty(this, "_audioSources", []);

          _defineProperty(this, "dictWeaponSoundIndex", {});

          _defineProperty(this, "musicVolume", 0.8);

          _defineProperty(this, "soundVolume", 1);

          _defineProperty(this, "audios", {});

          _defineProperty(this, "arrSound", []);
        }

        static get instance() {
          if (this._instance) {
            return this._instance;
          }

          this._instance = new AudioManager();
          return this._instance;
        }

        init() {
          if (this._persistRootNode) return; //避免切换场景初始化报错

          this._persistRootNode = new Node('audio');
          director.getScene().addChild(this._persistRootNode);
          game.addPersistRootNode(this._persistRootNode);
          this.musicVolume = this.getAudioSetting(true) ? 0.8 : 0;
          this.soundVolume = this.getAudioSetting(false) ? 1 : 0;
        }

        _getAudioSource(clip) {
          let result;

          for (let i = 0; i < this._audioSources.length; ++i) {
            let audioSource = this._audioSources[i];

            if (!audioSource.playing) {
              result = audioSource;
              break;
            }
          }

          if (!result) {
            result = this._persistRootNode.addComponent(AudioSource);

            this._audioSources.push(result);
          }

          result.node.off(AudioSource.EventType.ENDED);
          result.clip = clip;
          result.currentTime = 0;
          return result;
        }

        getAudioSetting(isMusic) {
          let state;

          if (isMusic) {
            state = StorageManager.instance.getGlobalData('music');
          } else {
            state = StorageManager.instance.getGlobalData('sound');
          } // console.log('Config for [' + (isMusic ? 'Music' : 'Sound') + '] is ' + state);


          return !state || state === 'true' ? true : false;
        }
        /**
         * 播放音乐
         * @param {String} name 音乐名称可通过constants.AUDIO_MUSIC 获取
         * @param {Boolean} loop 是否循环播放
         */


        playMusic(name, loop) {
          let path = 'audio/music/' + name; //微信特殊处理，除一开场的音乐，其余的放在子包里头
          // if (name !== 'click') {
          //     path =  path; //微信特殊处理，除一开场的音乐，其余的放在子包里头
          // }

          resourceUtil.loadRes(path, AudioClip, (err, clip) => {
            let source = this._getAudioSource(clip);

            let tmp = {
              source,
              isMusic: true
            };
            this.audios[name] = tmp;
            source.volume = this.musicVolume;
            source.loop = loop;
            source.play();
          });
        }
        /**
         * 播放音效
         * @param {String} name 音效名称可通过constants.AUDIO_SOUND 获取
         * @param {Boolean} loop 是否循环播放
         */


        playSound(name, loop = false) {
          if (!this.soundVolume) {
            return;
          } //音效一般是多个的，不会只有一个


          let path = 'audio/sound/'; // if (name !== 'click') {
          //     path = path; //微信特殊处理，除一开场的音乐，其余的放在子包里头
          // }

          resourceUtil.loadRes(path + name, AudioClip, (err, clip) => {
            let source = this._getAudioSource(clip);

            let tmp = {
              source,
              isMusic: false
            };
            this.arrSound.push(tmp);

            if (loop) {
              this.audios[name] = tmp;
            }

            source.volume = this.soundVolume;
            source.loop = loop;
            source.play();
            source.node.on(AudioSource.EventType.ENDED, () => {
              loadsh.remove(this.arrSound, obj => {
                return obj.source === tmp.source;
              });
            });
          });
        }

        stop(name) {
          if (this.audios.hasOwnProperty(name)) {
            let audio = this.audios[name];
            audio.source.stop();
          }
        }

        stopAll() {
          for (const i in this.audios) {
            if (this.audios.hasOwnProperty(i)) {
              let audio = this.audios[i];
              audio.source.stop();
            }
          }
        }

        getMusicVolume() {
          return this.musicVolume;
        }

        setMusic(flag) {
          this.musicVolume = flag;

          for (let item in this.audios) {
            if (this.audios.hasOwnProperty(item) && this.audios[item].isMusic) {
              // this.changeState(item, flag);
              let audio = this.audios[item];
              audio.source.volume = this.musicVolume;
            }
          }
        } //看广告时先将音乐暂停


        pauseAll() {
          console.log("pause all music!!!");

          for (let item in this.audios) {
            if (this.audios.hasOwnProperty(item)) {
              let audio = this.audios[item];
              audio.source.pause();
            }
          }
        }

        resumeAll() {
          for (let item in this.audios) {
            if (this.audios.hasOwnProperty(item)) {
              let audio = this.audios[item];
              audio.source.play();
            }
          }
        }

        openMusic() {
          this.setMusic(0.8);
          StorageManager.instance.setGlobalData('music', 'true');
        }

        closeMusic() {
          this.setMusic(0);
          StorageManager.instance.setGlobalData('music', 'false');
        }

        openSound() {
          this.setSound(1);
          StorageManager.instance.setGlobalData('sound', 'true');
        }

        closeSound() {
          this.setSound(0);
          StorageManager.instance.setGlobalData('sound', 'false');
        }

        setSound(flag) {
          this.soundVolume = flag;

          for (let item in this.audios) {
            if (this.audios.hasOwnProperty(item) && !this.audios[item].isMusic) {
              // this.changeState(item, flag);
              let audio = this.audios[item];
              audio.source.volume = this.soundVolume;
            }
          }

          for (let idx = 0; idx < this.arrSound.length; idx++) {
            let audio = this.arrSound[idx];
            audio.source.volume = this.soundVolume;
          }
        }

        stopSingleSound(name) {
          if (this.audios.hasOwnProperty(name) && !this.audios[name].isMusic) {
            let audio = this.audios[name];
            audio.source.stop();
          }
        }

      }, _defineProperty(_class2, "_instance", void 0), _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/pveSlotUI.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './constants.ts', './playerData.ts', './levelUI.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, instantiate, UITransform, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, constants, playerData, LevelUI;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      instantiate = module.instantiate;
      UITransform = module.UITransform;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      LevelUI = module.LevelUI;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp;

      cclegacy._RF.push({}, "61998EPL8lJqYcj54CvjY6+", "pveSlotUI", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let PveSlotUI = exports('PveSlotUI', (_dec = ccclass('PveSlotUI'), _dec(_class = (_class2 = (_temp = class PveSlotUI extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "levelNodes", _descriptor, this);

          _initializerDefineProperty(this, "prefabLevel", _descriptor2, this);

          _initializerDefineProperty(this, "prefabCloud", _descriptor3, this);

          _defineProperty(this, "index", void 0);

          _defineProperty(this, "_parent", void 0);

          _defineProperty(this, "levelArray", void 0);
        }

        show(parent, pveData, index) {
          this.index = index;
          this._parent = parent;
          this.levelArray = pveData;
          this.addLevelNodes();
        }

        addLevelNodes() {
          let curLevel = playerData.instance.getCurrentLevel();
          let curLevenName = parseInt(curLevel.name);
          let total = this.levelArray.length;
          let lastHeight = 0;

          for (let i = 0; i < total; i++) {
            this.levelNodes[i].active = true;
            let levelUI = this.levelNodes[i].getComponentInChildren(LevelUI);

            if (!levelUI) {
              let child = instantiate(this.prefabLevel);
              child.active = true;
              child.setPosition(0, 0);
              this.levelNodes[i].addChild(child);
            }

            let name = this.levelArray[i].name;

            if (parseInt(name) < curLevenName) {
              // 已完成
              this.levelArray[i].status = constants.PVE_LEVEL_STATUS.DONE;
            } else if (parseInt(name) === curLevenName) {
              // 当前等级
              this.levelArray[i].status = constants.PVE_LEVEL_STATUS.DOING;
            } else {
              //  未完成
              this.levelArray[i].status = constants.PVE_LEVEL_STATUS.UNDONE;
            }

            let ID = this.levelArray[i].ID;

            if (playerData.instance.history.hasOwnProperty(ID)) {
              this.levelArray[i].star = playerData.instance.history[ID].star;
            }

            levelUI = this.levelNodes[i].getComponentInChildren(LevelUI);
            levelUI.init(this.levelArray[i]);
            lastHeight = this.levelNodes[i].position.y;
          }

          this.showCloudsUponLevels(lastHeight);
          let cnt = this.levelNodes.length;

          for (let idx = this.levelArray.length; idx < cnt; idx++) {
            this.levelNodes[idx].removeAllChildren();
            this.levelNodes[idx].active = false;
          }
        }

        showCloudsUponLevels(lastHeight) {
          let isNode = this.node.getChildByName('cloud');

          if (isNode) {
            this.node.removeChild(isNode);
          }

          let multi = 0;
          let height = lastHeight;

          if (this.index < 0) {
            multi = 0;
          } else {
            multi = this.index;
            height = height + 430; // prefab1的高度530减去回弹范围100
          }

          const nodeHeight = this.node.getComponent(UITransform).height;
          height = height + nodeHeight * multi; // 最后一个level节点的高度

          let topY = nodeHeight + this.node.position.y;

          let contentY = this._parent.contentNode.getComponent(UITransform).height; // content的总高度


          let nodeCloud = instantiate(this.prefabCloud);
          const nodeCloudHeight = nodeCloud.getComponent(UITransform).height;
          let diff = Math.floor(Math.abs(contentY - height) / nodeCloudHeight);

          if (diff && Math.abs(topY - height) > nodeCloudHeight) {
            nodeCloud.setPosition(0, lastHeight + nodeCloudHeight / 2);
            nodeCloud.active = true;
            this.node.addChild(nodeCloud);
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "levelNodes", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "prefabLevel", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "prefabCloud", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/pveUI.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './constants.ts', './clientEvent.ts', './utils.ts', './playerData.ts', './uiManager.ts', './gameLogic.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, Animation, Sprite, Vec3, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, constants, clientEvent, utils, playerData, uiManager, GameLogic;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      Animation = module.Animation;
      Sprite = module.Sprite;
      Vec3 = module.Vec3;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      clientEvent = module.clientEvent;
    }, function (module) {
      utils = module.utils;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      GameLogic = module.GameLogic;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _temp;

      cclegacy._RF.push({}, "61b9axYpi9De7EZBUlEuYVP", "pveUI", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let PveUI = exports('PveUI', (_dec = ccclass('PveUI'), _dec(_class = (_class2 = (_temp = class PveUI extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "multiScrollView", _descriptor, this);

          _initializerDefineProperty(this, "settingNode", _descriptor2, this);

          _initializerDefineProperty(this, "introductionNode", _descriptor3, this);

          _initializerDefineProperty(this, "ndLotteryBtn", _descriptor4, this);

          _initializerDefineProperty(this, "ndLotteryTips", _descriptor5, this);

          _initializerDefineProperty(this, "lbLotterySpareTimes", _descriptor6, this);

          _initializerDefineProperty(this, "sfBlueDot", _descriptor7, this);

          _initializerDefineProperty(this, "sfRedDot", _descriptor8, this);

          _initializerDefineProperty(this, "lbGold", _descriptor9, this);

          _initializerDefineProperty(this, "ndSignRedDot", _descriptor10, this);

          _initializerDefineProperty(this, "ndShopRedDot", _descriptor11, this);

          _defineProperty(this, "rewardType", void 0);

          _defineProperty(this, "debugIdx", void 0);

          _defineProperty(this, "debugTimer", void 0);
        }

        onEnable() {
          clientEvent.on('updateSignIn', this.checkSignInRedDot, this);
          clientEvent.on('updateLotterySpareTimes', this.updateLotterySpareTimes, this);
          clientEvent.on('updateGold', this.updateGold, this);
          clientEvent.on('updateShopPropInfo', this.checkShopRedDot, this);
        }

        onDisable() {
          clientEvent.off('updateSignIn', this.checkSignInRedDot, this);
          clientEvent.off('updateLotterySpareTimes', this.updateLotterySpareTimes, this);
          clientEvent.off('updateGold', this.updateGold, this);
          clientEvent.off('updateShopPropInfo', this.checkShopRedDot, this);
        }

        start() {
          if (playerData.instance.playerInfo.isNew) {
            this.introductionNode.active = true;
          } else {
            this.introductionNode.active = false;
          }

          this.refreshUI();
          this.checkSignInRedDot();
          this.checkShopRedDot();
          this.updateLotterySpareTimes();
        }

        refreshUI() {
          this.updateGold();
        }

        onBtnBack() {}

        onBtnSettingClick() {
          GameLogic.instance.showInterStitialAd(() => {
            uiManager.instance.showDialog('dialog/setting');
          });
        }

        onBtnSignClick() {
          uiManager.instance.showDialog('signIn/signIn');
        }

        onBtnLotteryClick() {
          uiManager.instance.showDialog('lottery/lottery');
        }

        onBtnIntrodutionClick() {
          this.introductionNode.active = false; // playerData.instance.updateIsNew();
        }

        updateLotterySpareTimes() {
          GameLogic.instance.getOpenRewardType(constants.SHARE_FUNCTION.LOTTERY, (err, type) => {
            if (!err) {
              this.rewardType = type;
            }
          });
          let spareTimes = playerData.instance.getLotterySpareTimes(false);
          let spareMoreTimes = playerData.instance.getLotterySpareTimes(true); //更多抽奖剩余次数

          this.ndLotteryTips.active = spareTimes > 0 || spareMoreTimes > 0;
          this.lbLotterySpareTimes.string = spareTimes.toString();
          let ani = this.ndLotteryBtn.getComponent(Animation);

          if (spareTimes > 0 || spareMoreTimes > 0) {
            if (!spareTimes) {
              //如果三次抽取完了
              if (this.rewardType !== constants.OPEN_REWARD_TYPE.NULL) {
                this.lbLotterySpareTimes.string = spareMoreTimes.toString();
                this.ndLotteryTips.getComponent(Sprite).spriteFrame = this.sfBlueDot;
                ani.play();
              } else {
                this.ndLotteryTips.active = false;
                ani.stop();
                this.ndLotteryBtn.getChildByName('pveIconLotterya').eulerAngles = new Vec3(0, 0, 0);
              }
            } else {
              ani.play();
            }
          } else {
            ani.stop();
            this.ndLotteryBtn.getChildByName('pveIconLotterya').eulerAngles = new Vec3(0, 0, 0);
          }
        }

        updateGold() {
          this.lbGold.string = utils.formatMoney(playerData.instance.getGold());
        }

        onBtnShopClick() {
          uiManager.instance.showDialog('shop/shop');
        }

        checkSignInRedDot() {
          playerData.instance.updateSignInCurrentDay(); //更新最新的可领取日期

          GameLogic.instance.getOpenRewardType(constants.SHARE_FUNCTION.FILL_SIGN, (err, type) => {
            if (!err) {
              switch (type) {
                case constants.OPEN_REWARD_TYPE.AD:
                  this.ndSignRedDot.active = !playerData.instance.getSignInReceivedInfo().isAllReceived;
                  break;

                case constants.OPEN_REWARD_TYPE.SHARE:
                  this.ndSignRedDot.active = !playerData.instance.getSignInReceivedInfo().isAllReceived;
                  break;

                case constants.OPEN_REWARD_TYPE.NULL:
                  this.ndSignRedDot.active = !playerData.instance.getSignInReceivedInfo().isTodayReceived;
                  break;
              }
            }
          });
        }

        checkShopRedDot() {
          if (!playerData.instance.playerInfo.hasOwnProperty('shopPropInfo')) {
            playerData.instance.resetShopPropInfo();
            playerData.instance.updateShopPropInfo(false); //第一次设置为可以领取
          }

          this.ndShopRedDot.active = playerData.instance.playerInfo.shopPropInfo['receiveStatus'] === constants.REWARD_STATUS.RECEIVABLE;
        }

        onBtnDebugClick() {
          if (!this.debugIdx) {
            this.debugIdx = 0;
          }

          const MAX_TIMES = 8;
          this.debugIdx++;

          if (this.debugIdx > MAX_TIMES) {
            uiManager.instance.showDialog('debug/password', []);
          } else if (!this.debugTimer) {
            var _this = this;

            this.debugTimer = setTimeout(function () {
              _this.debugTimer = null;

              if (_this.debugIdx < MAX_TIMES) {
                _this.debugIdx = 0;
              }
            }, 3000);
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "multiScrollView", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "settingNode", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "introductionNode", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "ndLotteryBtn", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "ndLotteryTips", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "lbLotterySpareTimes", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "sfBlueDot", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "sfRedDot", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "lbGold", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "ndSignRedDot", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "ndShopRedDot", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/stopPropagation.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, Component, _decorator;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Component = module.Component;
      _decorator = module._decorator;
    }],
    execute: function () {
      var _dec, _class;

      cclegacy._RF.push({}, "628d0zbx11LV4NaSW232uP9", "stopPropagation", undefined);

      const {
        ccclass
      } = _decorator;
      let StopPropagation = exports('StopPropagation', (_dec = ccclass('StopPropagation'), _dec(_class = class StopPropagation extends Component {
        onLoad() {}

        onEnable() {
          this.node.on('touchstart', function (event) {
            event.stopPropagation();
          });
          this.node.on('touchend', function (event) {
            event.stopPropagation();
          });
          this.node.on('touchmove', function (event) {
            event.stopPropagation();
          });
          this.node.on('touchcancel', function (event) {
            event.stopPropagation();
          });
          this.node.on('mousedown', function (event) {
            event.stopPropagation();
          });
          this.node.on('mouseenter', function (event) {
            event.stopPropagation();
          });
          this.node.on('mousemove', function (event) {
            event.stopPropagation();
          });
          this.node.on('mouseleave', function (event) {
            event.stopPropagation();
          });
          this.node.on('mouseup', function (event) {
            event.stopPropagation();
          });
          this.node.on('mousewheel', function (event) {
            event.stopPropagation();
          });
        }

        onDisable() {
          this.node.off('touchstart', function (event) {
            event.stopPropagation();
          });
          this.node.off('touchend', function (event) {
            event.stopPropagation();
          });
          this.node.off('touchmove', function (event) {
            event.stopPropagation();
          });
          this.node.off('touchcancel', function (event) {
            event.stopPropagation();
          });
          this.node.off('mousedown', function (event) {
            event.stopPropagation();
          });
          this.node.off('mouseenter', function (event) {
            event.stopPropagation();
          });
          this.node.off('mousemove', function (event) {
            event.stopPropagation();
          });
          this.node.off('mouseleave', function (event) {
            event.stopPropagation();
          });
          this.node.off('mouseup', function (event) {
            event.stopPropagation();
          });
          this.node.off('mousewheel', function (event) {
            event.stopPropagation();
          });
        }

      }) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/gameLogic.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './constants.ts', './clientEvent.ts', './sceneManager.ts', './playerData.ts', './uiManager.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, _defineProperty, _applyDecoratedDescriptor, _initializerDefineProperty, constants, clientEvent, SceneManager, playerData, uiManager;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      _defineProperty = module.defineProperty;
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      clientEvent = module.clientEvent;
    }, function (module) {
      SceneManager = module.SceneManager;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      uiManager = module.uiManager;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _class3, _temp;

      cclegacy._RF.push({}, "72a86eT/GZB8K0okUbOBKut", "gameLogic", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let GameLogic = exports('GameLogic', (_dec = ccclass('GameLogic'), _dec(_class = (_class2 = (_temp = _class3 = class GameLogic {
        constructor() {
          _initializerDefineProperty(this, "isConnect", _descriptor, this);

          _defineProperty(this, "channel", void 0);

          _defineProperty(this, "timer", void 0);
        }

        static get instance() {
          if (this._instance) {
            return this._instance;
          }

          this._instance = new GameLogic();
          return this._instance;
        }

        onAppShow(res) {
          console.log('onAppShow', res);

          if (res.scene === 1037 && res.query) {
            let paramStr = 'game_id';

            if (res.query.hasOwnProperty(paramStr)) {
              let gameId = res.query[paramStr];
              this.channel = gameId;

              if (gameId) {
                this.customEventStatistics(constants.ANALYTICS_TYPE.CHANNEL, {
                  channel: gameId
                });
              }
            }
          } else if (res.scene === 1044) {
            this.channel = 'share';
          } else if (res.scene) {
            this.channel = res.scene + '';
          }
        }

        afterLogin() {
          this.startTick();
          setTimeout(() => {
            if (playerData.instance.isOpenOffLineReward(constants.OFFLINE_REWARD * 60 * 1000)) {
              uiManager.instance.showDialog('pve/offLineReward', [{
                itemType: constants.REWARD_TYPE.GOLD,
                itemAmount: 500,
                itemSubType: 0
              }]);
            }

            this.convertSignInDataFormat();

            if (!playerData.instance.isNewBee) {
              this.checkSignIn();
            }
          }, 1000);
        }

        startTick() {
          if (this.timer) {
            clearInterval(this.timer);
          }

          this.timer = setInterval(this.onTick.bind(this), 1000);
        }

        onTick() {
          if (SceneManager.instance.isStop) {
            return;
          }

          let onlineRewardInfo = playerData.instance.getOnlineRewardInfo();

          if (onlineRewardInfo['value'].receiveStatus === constants.REWARD_STATUS.UNRECEIVABLE) {
            this.addUsedTime();
          }

          this.checkShopPropInfo();
        }

        checkShopPropInfo() {
          if (!playerData.instance.playerInfo.hasOwnProperty('shopPropInfo')) {
            playerData.instance.resetShopPropInfo();
            playerData.instance.updateShopPropInfo(false); //第一次设置为可以领取
          } else {
            let shopPropInfo = playerData.instance.playerInfo.shopPropInfo;
            let shopCreateDate = shopPropInfo['createDate'];
            let shopReceiveStatus = shopPropInfo['receiveStatus'];
            let isReceived = shopPropInfo['isReceived'];
            let isTimeOut = Date.now() - shopCreateDate >= constants.SHOP_COUNTDOWN_HOURS * 3600000;

            if (isTimeOut && shopReceiveStatus !== constants.REWARD_STATUS.RECEIVABLE) {
              playerData.instance.updateShopPropInfo(false);
              clientEvent.dispatchEvent('updateShopPropInfo');
            }
          }
        }

        checkSignIn() {
          playerData.instance.updateSignInCurrentDay();

          if (!playerData.instance.getSignInReceivedInfo().isTodayReceived) {
            //如果今天还没签到则弹出
            uiManager.instance.showDialog('signIn/signIn');
          }
        }

        addUsedTime() {
          let usedTime = playerData.instance.getOnlineRewardInfo()['usedTime'];
          let spareTime = playerData.instance.getCountdownTime() * 60 * 1000 - usedTime * 1000;

          if (spareTime <= 0) {
            playerData.instance.updateOnlineRewardInfo(false); //显示可领取按钮
          }

          playerData.instance.addUsedTime();
        }

        convertSignInDataFormat() {
          if (playerData.instance.playerInfo.hasOwnProperty('signInInfo') && playerData.instance.playerInfo['signInInfo'].hasOwnProperty('value')) {
            playerData.instance.convertSignInDataFormat(playerData.instance.playerInfo['signInInfo']);
          }
        }

        finishLink(cake, value) {
          playerData.instance.finishLink(cake, value);
          clientEvent.dispatchEvent('updateTargets', cake);
          clientEvent.dispatchEvent('updateStep');
        }

        checkGame() {
          if (playerData.instance.isLevelFinish()) {
            clientEvent.dispatchEvent('levelFinished');
            return;
          }

          if (playerData.instance.isGameOver()) {
            clientEvent.dispatchEvent('gameOver');
            return;
          }
        }

        resetLevel() {
          playerData.instance.startNewLevel();
          clientEvent.dispatchEvent('newLevel');
        }

        showRewardAd(callback) {
          callback && callback(null);
        }

        showInterStitialAd(callback) {
          callback(null);
        }

        share(funStr, objQuery, callback, isShowConfirmAfterFailed) {
          callback();
        }

        addDiamond(num) {
          playerData.instance.addDiamond(num);
          clientEvent.dispatchEvent('updateDiamond');
        }

        addGold(num) {
          playerData.instance.addGold(num);
          clientEvent.dispatchEvent('updateGold');
        }

        addProp(propId, num) {
          playerData.instance.addProp(propId, num);
          clientEvent.dispatchEvent('updateProp', propId);
        }

        getOpenRewardType(funStr, callback) {
          callback(null, constants.OPEN_REWARD_TYPE.AD);
        }

        customEventStatistics(eventType, objParams) {}

        requestWithPost(url, data, callback) {
          let xhr = new XMLHttpRequest();

          xhr.onreadystatechange = function () {
            if (xhr.readyState == 4) {
              if (xhr.status >= 200 && xhr.status < 400) {
                let dataObj = xhr.responseText;

                try {
                  dataObj = JSON.parse(xhr.responseText);
                } catch (exception) {
                  console.error(xhr.responseText);
                }

                callback(null, dataObj);
              } else {
                callback('failed', xhr.status);
              }
            }
          };

          xhr.open("POST", url, true);
          xhr.setRequestHeader('Content-Type', 'application/json');
          xhr.send(JSON.stringify(data));
        }

      }, _defineProperty(_class3, "_instance", void 0), _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "isConnect", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return false;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/resourceUtil.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, resources, error, Prefab, SpriteFrame, Texture2D, instantiate, find, isValid, Sprite, _decorator;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      resources = module.resources;
      error = module.error;
      Prefab = module.Prefab;
      SpriteFrame = module.SpriteFrame;
      Texture2D = module.Texture2D;
      instantiate = module.instantiate;
      find = module.find;
      isValid = module.isValid;
      Sprite = module.Sprite;
      _decorator = module._decorator;
    }],
    execute: function () {
      var _dec, _class;

      cclegacy._RF.push({}, "7844e1bOwZK+7JMYjENQU5v", "resourceUtil", undefined);

      const {
        ccclass
      } = _decorator;
      let resourceUtil = exports('resourceUtil', (_dec = ccclass("resourceUtil"), _dec(_class = class resourceUtil {
        /**
        * 加载资源
        * @param url   资源路径
        * @param type  资源类型
        * @param cb    回调
        * @method loadRes
        */
        static loadRes(url, type, cb = () => {}) {
          resources.load(url, (err, res) => {
            if (err) {
              error(err.message || err);
              cb(err, res);
              return;
            }

            cb && cb(null, res);
          });
        }
        /**
         * 获取特效prefab
         * @param modulePath 路径
         * @returns 
         */


        static loadEffectRes(modulePath) {
          return new Promise((resolve, reject) => {
            this.loadRes(`prefab/effect/${modulePath}`, Prefab, (err, prefab) => {
              if (err) {
                console.error('effect load failed', modulePath);
                reject && reject();
                return;
              }

              resolve && resolve(prefab);
            });
          });
        }
        /**
         * 获取模型数据
         * @param modulePath 模型路径
         * @returns 
         */


        static loadModelRes(modulePath) {
          return new Promise((resolve, reject) => {
            this.loadRes(`prefab/model/${modulePath}`, Prefab, (err, prefab) => {
              if (err) {
                console.error("model load failed", modulePath);
                reject && reject();
                return;
              }

              resolve && resolve(prefab);
            });
          });
        }
        /**
         * 获取多模型数据
         * @param path 资源路径
         * @param arrName 资源名称
         * @param progressCb 过程回调函数
         * @param completeCb 完成回调函数
         */


        static loadModelResArr(path, arrName, progressCb, completeCb) {
          let arrUrls = arrName.map(item => {
            return `${path}/${item}`;
          });
          resources.load(arrUrls, Prefab, progressCb, completeCb);
        }
        /**
         * 获取贴图资源
         * @param path 贴图路径
         * @returns 
         */


        static loadSpriteFrameRes(path) {
          return new Promise((resolve, reject) => {
            this.loadRes(path, SpriteFrame, (err, img) => {
              if (err) {
                console.error('spriteFrame load failed!', path, err);
                reject && reject();
                return;
              }

              let texture = new Texture2D();
              texture.image = img;
              let sf = new SpriteFrame();
              sf.texture = texture;
              resolve && resolve(sf);
            });
          });
        }
        /**
         * 获取关卡数据
         * @param level 关卡
         * @param cb 回调函数
         */


        static getMap(level, cb) {
          let levelStr = 'map'; //前面补0

          if (level >= 100) {
            levelStr += level;
          } else if (level >= 10) {
            levelStr += '0' + level;
          } else {
            levelStr += '00' + level;
          }

          this.loadRes(`map/config/${levelStr}`, null, (err, txtAsset) => {
            if (err) {
              cb(err, txtAsset);
              return;
            }

            let content = '';

            if (txtAsset._file) {
              //@ts-ignore
              if (window['LZString']) {
                //@ts-ignore
                content = window['LZString'].decompressFromEncodedURIComponent(txtAsset._file);
              }

              var objJson = JSON.parse(content);
              cb(null, objJson);
            } else if (txtAsset.text) {
              //@ts-ignore
              if (window['LZString']) {
                //@ts-ignore
                content = window['LZString'].decompressFromEncodedURIComponent(txtAsset.text);
              }

              var objJson = JSON.parse(content);
              cb(null, objJson);
            } else if (txtAsset.json) {
              cb(null, txtAsset.json);
            } else {
              cb('failed');
            }
          });
        }
        /**
         * 获取关卡数据
         * @param type 关卡类型
         * @param arrName 资源名称
         * @param progressCb 过程回调函数
         * @param completeCb 完成回调函数
         */


        static getMapObj(type, arrName, progressCb, completeCb) {
          let arrUrls = [];

          for (let idx = 0; idx < arrName.length; idx++) {
            arrUrls.push(`map/${type}/${arrName[idx]}`);
          }

          resources.load(arrUrls, Prefab, progressCb, completeCb);
        }
        /**
         * 获取UI prefab
         * @param prefabPath prefab路径 
         * @param cb 回调函数
         */


        static getUIPrefabRes(prefabPath, cb) {
          this.loadRes("prefab/ui/" + prefabPath, Prefab, cb);
        }
        /**
         * 创建ui界面
         * @param path ui路径
         * @param cb 回调函数
         * @param parent 父节点
         */


        static createUI(path, cb, parent) {
          this.getUIPrefabRes(path, function (err, prefab) {
            if (err) return;
            let node = instantiate(prefab);
            node.setPosition(0, 0, 0);

            if (!parent) {
              parent = find("Canvas");
            }

            parent.addChild(node);
            cb && cb(null, node);
          });
        }
        /**
         * 获取json数据
         * @param fileName 文件名
         * @param cb 回调函数 
         */


        static getJsonData(fileName, cb) {
          this.loadRes("datas/" + fileName, null, function (err, content) {
            if (err) {
              error(err.message || err);
              return;
            }

            if (content.json) {
              cb(err, content.json);
            } else {
              cb('failed!!!');
            }
          });
        }
        /**
         * 获取文本数据
         * @param fileName 文件名
         * @param cb  回调函数
         */


        static getTextData(fileName, cb) {
          this.loadRes("datas/" + fileName, null, function (err, content) {
            if (err) {
              error(err.message || err);
              return;
            }

            let text = content.text;
            cb(err, text);
          });
        }
        /**
         * 设置精灵贴图
         * @param path 资源路径
         * @param sprite 精灵
         * @param cb 回调函数
         */


        static setSpriteFrame(path, sprite, cb) {
          this.loadRes(path + '/spriteFrame', SpriteFrame, (err, spriteFrame) => {
            if (err) {
              console.error('set sprite frame failed! err:', path, err);
              cb(err);
              return;
            }

            if (sprite && isValid(sprite)) {
              sprite.spriteFrame = spriteFrame;
              cb(null);
            }
          });
        }
        /**
         * 设置道具图标
         *
         * @param {number} prop
         * @param {cc.Sprite} sprite
         * @param {fn} cb
         */


        static setPropIcon(prop, sprite, cb) {
          this.setSpriteFrame('gamePackages/textures/icons/props/' + prop, sprite, cb);
        }
        /**
         * sprite置灰或者复原
         *
         * @param {object} node
         * @param {boolean} flag
         */


        static setGray(node, flag) {
          var sprites = node.getComponentsInChildren(Sprite);

          for (var i = 0; i < sprites.length; ++i) {
            var sprite = sprites[i];

            if (flag) {
              sprite.grayscale = true; // sprite.state(Sprite.BlendState.//GRAY);
            } else {
              sprite.grayscale = false; // sprite.setState(Sprite.BlendState.);
            }
          }
        }
        /**
         * 根据英雄的文件名获取头像
         */


        static setAvatar(avatarUrl, sprite, cb) {
          return; // if (!avatarUrl || !avatarUrl.startsWith('http')) {
          //     return;
          // }
          // var suffix = "png";
          // loader.load({ url: avatarUrl, type: suffix }, function (err: any, tex: any) {
          //     if (err) {
          //         console.error('set avatar failed! err:', avatarUrl, err);
          //         cb(err);
          //         return;
          //     }
          //     var spriteFrame = new SpriteFrame(tex, Rect(0, 0, tex.width, tex.height));
          //     if (sprite && isValid(sprite)) {
          //         sprite.spriteFrame = spriteFrame;
          //         cb(null);
          //     }
          // });
        }
        /**
         * 设置蛋糕图片
         * @param {string} cake 蛋糕图片名称
         * @param {cc.Sprite} sprite  
         * @param {function} cb 回调函数
         */


        static setCakeIcon(cake, sprite, cb) {
          this.setSpriteFrame('gamePackages/textures/icons/cakes/' + cake, sprite, cb);
        }

        static createEffect(path, cb, parent) {
          this.loadRes("/gamePackages/effects/" + path, Prefab, function (err, prefab) {
            if (err) {
              cb('err', null);
              return;
            }

            var node = instantiate(prefab);

            if (!parent) {
              parent = find("Canvas");
            }

            parent.addChild(node);
            cb(null, node);
          });
        }

        static getEffectPrefab(path, callback) {
          this.loadRes("gamePackages/effects/" + path, Prefab, callback);
        }

      }) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/loginScene.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './constants.ts', './clientEvent.ts', './storageManager.ts', './localConfig.ts', './sceneManager.ts', './playerData.ts', './uiManager.ts', './audioManager.ts', './LanguageData.ts', './PlatformBridge.js', './PlatformBridge.mjs_cjs=&original=.js', './gameLogic.ts', './ConstValue.js', './ConstValue.mjs_cjs=&original=.js', './AdUtils.js', './AdUtils.mjs_cjs=&original=.js'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, sys, profiler, game, Game, view, director, _defineProperty, constants, clientEvent, StorageManager, localConfig, SceneManager, playerData, uiManager, AudioManager, init, t, _cjsExports, GameLogic, _cjsExports$1, _cjsExports$2;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      sys = module.sys;
      profiler = module.profiler;
      game = module.game;
      Game = module.Game;
      view = module.view;
      director = module.director;
    }, function (module) {
      _defineProperty = module.defineProperty;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      clientEvent = module.clientEvent;
    }, function (module) {
      StorageManager = module.StorageManager;
    }, function (module) {
      localConfig = module.localConfig;
    }, function (module) {
      SceneManager = module.SceneManager;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      AudioManager = module.AudioManager;
    }, function (module) {
      init = module.init;
      t = module.t;
    }, function (module) {
      _cjsExports = module.default;
    }, null, function (module) {
      GameLogic = module.GameLogic;
    }, function (module) {
      _cjsExports$1 = module.default;
    }, null, function (module) {
      _cjsExports$2 = module.default;
    }, null],
    execute: function () {
      var _dec, _class, _temp;

      cclegacy._RF.push({}, "78951xH1B5FbIWkKgRGXo5v", "loginScene", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let LoginScene = exports('LoginScene', (_dec = ccclass('LoginScene'), _dec(_class = (_temp = class LoginScene extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "currentStep", null);

          _defineProperty(this, "isLoadCsvFinishd", false);

          _defineProperty(this, "bottomBannerAd", void 0);
        }

        onLoad() {
          init('zh');

          if (sys.os == sys.OS.ANDROID) {
            _cjsExports.initCocosSuccess();

            Global.addInitCallback("ScriptWatermelon", this.onInitSuccess.bind(this));
            this.prepareRewardAd();
          } // this.showBannerAd();


          profiler.hideStats(); //初始化音频

          AudioManager.instance.init();
          AudioManager.instance.playMusic(constants.AUDIO_MUSIC.BACKGROUND, true); //初始化玩家数据

          playerData.instance.loadGlobalCache();

          if (!playerData.instance.userId) {
            playerData.instance.generateRandomAccount();
            console.log("###生成随机userId", playerData.instance.userId);
          }

          playerData.instance.loadFromCache();

          if (!playerData.instance.playerInfo || !playerData.instance.playerInfo.createDate) {
            playerData.instance.createPlayerInfo();
          } //记录离线时间


          game.on(Game.EVENT_HIDE, () => {
            if (!playerData.instance.settings) {
              playerData.instance.settings = {};
            }

            playerData.instance.settings.hideTime = Date.now();
            playerData.instance.saveAll();
            StorageManager.instance.save();
          }); //加载CSV相关配置

          console.log("_loadCSV->00!!");
          localConfig.instance.loadConfig(() => {
            console.log("_loadCSV->07");
            this.isLoadCsvFinishd = true;
          });
        }

        showBannerAd() {
          console.log("showbannerad--2");
          let adWidth = Math.round(720 * view.getFrameSize().width / view.getVisibleSize().width);
          let adHeight = Math.round(adWidth * 90 / 600);
          let adBottomMargin = 0;
          console.log("BannerAd->", adWidth, ",", adHeight, ",", adBottomMargin);

          this.bottomBannerAd = function () {
            _cjsExports.showBannerAd(_cjsExports$1.AdScene.GameScene, _cjsExports$1.getAdBannerBig(), adWidth, adHeight, true, adBottomMargin, false);
          };

          if (Global.VIVOQuickGameEnv) {
            _cjsExports.showBannerAd(_cjsExports$1.AdScene.GameScene, _cjsExports$1.getAdBannerBig(), adWidth, adHeight, true, adBottomMargin, false);
          }

          this.refreshBannerAdSchedule();
        }

        refreshBannerAdSchedule() {
          if (Global.VIVOQuickGameEnv) {
            return;
          }

          let adWidth = Math.round(720 * view.getFrameSize().width / view.getVisibleSize().width);
          let adHeight = Math.round(adWidth * 90 / 600);
          let adBottomMargin = 0;
          console.log("BannerAd->", adWidth, ",", adHeight, ",", adBottomMargin);

          _cjsExports.showBannerAd(_cjsExports$1.AdScene.GameScene, _cjsExports$1.getAdBannerBig(), adWidth, adHeight, true, adBottomMargin, false);

          this.unschedule(this.bottomBannerAd);
          this.schedule(this.bottomBannerAd, 35);
        } //第一次进入视频预加载


        prepareRewardAd() {
          // let gameOnLoadRewardAd = sys.localStorage.getItem("GameOnLoadRewardAd");
          // if (!gameOnLoadRewardAd) {
          // console.log("gameOnLoadRewardAd->", gameOnLoadRewardAd);
          _cjsExports.prepareRewardAd("GameOnLoad", "0", _cjsExports$1.getAdReward()); //todo


          let adWidth = Math.round(720 * view.getFrameSize().width / view.getVisibleSize().width);
          let adHeight = Math.round(adWidth * 90 / 600); // let adBottomMargin = Math.floor((30 * cc.view.getFrameSize().height / 1280));

          let adBottomMargin = 0;
          console.log("show banner ad big->", adWidth, "-", adHeight, "-", adBottomMargin);

          _cjsExports.prepareBannerAd(_cjsExports$1.AdScene.GameScene, _cjsExports$1.getAdBannerBig(), adWidth, adHeight, false);

          console.log("show banner ad big->2");
          sys.localStorage.setItem("GameOnLoadRewardAd", "1");
          console.log("show banner ad big->3");
          console.log('prepareRewardAd->prepareInterstitialAd:');

          _cjsExports$2.prepareInterstitialAd(_cjsExports$1.AdScene.XiGuaInterstitial);

          let adWidth1 = 0.7 * view.getFrameSize().width;
          let adHeight1 = adWidth1 * 3 / 2;

          _cjsExports.prepareInterstitialAd(_cjsExports$1.AdScene.XiGuaInterstitial, _cjsExports$1.getAdInterstitialVideo(), adWidth1, adHeight1, false); // }

        }

        onInitSuccess() {
          console.log("DAXIGUA_onInitSuccess");

          if (Global.OPPOGameEnv || Global.VIVOGameEnv || Global.XIAOMIGameEnv) {
            _cjsExports.checkPermission(false, 'android.permission.READ_PHONE_STATE,android.permission.READ_EXTERNAL_STORAGE,android.permission.WRITE_EXTERNAL_STORAGE');
          } else {
            _cjsExports.checkPermission(false, 'android.permission.READ_PHONE_STATE,android.permission.READ_EXTERNAL_STORAGE,android.permission.WRITE_EXTERNAL_STORAGE,android.permission.ACCESS_COARSE_LOCATION,android.permission.ACCESS_FINE_LOCATION');
          } // this.checkHotUpdate();

        }

        showLoadingUI() {
          var _this = this;

          this.currentStep = 0;

          var loginTimeOut = function () {
            uiManager.instance.showTips(t("login/timeout"), function () {
              _this.showLoadingUI();
            });
          };

          this.scheduleOnce(loginTimeOut, 30);
          uiManager.instance.showDialog('common/loading');
          SceneManager.instance.load([function (cb) {
            _this.currentStep = 1;

            _this.loadSubPackage(cb);
          }, function (cb) {
            _this.currentStep = 2;

            _this.loadGameSubPackage(cb);
          }, function (cb) {
            _this.currentStep = 3;

            _this.unschedule(loginTimeOut);

            _this.enterMainScene(cb);
          }], function (err, result) {
            if (err) {
              console.error(err.message || err);
              return;
            }
          });
        }

        loadSubPackage(cb) {
          cb();
        }

        loadGameSubPackage(cb) {
          cb();
        }

        enterMainScene(cb) {
          var _this = this;

          let targetScene = playerData.instance.isNewBee ? 'fight' : 'pve';

          var onSceneLoaded = function () {
            _this.currentStep = 4;
            cb();
            director.preloadScene(targetScene, function () {
              director.loadScene(targetScene, function () {
                _this.currentStep = 5;
                clientEvent.dispatchEvent("onSceneChanged");
                GameLogic.instance.afterLogin();
              });
            });
          };

          director.preloadScene(targetScene, onSceneLoaded);
        }

        onBtnVisitorLoginClick() {
          if (!this.isLoadCsvFinishd) {
            console.log("!this.isLoadCsvFinishd->return"); // return;
          }

          this.showLoadingUI();
        }

      }, _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/adStepItem.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './resourceUtil.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, resourceUtil;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp;

      cclegacy._RF.push({}, "7bc1e52TulKuq/projnBb/o", "adStepItem", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let AdStepItem = exports('AdStepItem', (_dec = ccclass('AdStepItem'), _dec(_class = (_class2 = (_temp = class AdStepItem extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spPropIcon", _descriptor, this);

          _initializerDefineProperty(this, "lbPropNum", _descriptor2, this);

          _initializerDefineProperty(this, "ndFinishedIcon", _descriptor3, this);

          _defineProperty(this, "cakeInfo", void 0);
        }

        setInfo(cakeInfo) {
          this.cakeInfo = cakeInfo;
          resourceUtil.setCakeIcon(cakeInfo.name, this.spPropIcon, () => {});
          this.lbPropNum.string = cakeInfo.num ? cakeInfo.num : '';
          this.ndFinishedIcon.active = !cakeInfo.num;

          if (cakeInfo.num > 0) {
            this.spPropIcon.grayscale = false;
          } else {
            this.spPropIcon.grayscale = true;
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spPropIcon", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "lbPropNum", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "ndFinishedIcon", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/offLineReward.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './resourceUtil.ts', './constants.ts', './localConfig.ts', './uiManager.ts', './LanguageData.ts', './PlatformBridge.js', './PlatformBridge.mjs_cjs=&original=.js', './gameLogic.ts', './ConstValue.js', './ConstValue.mjs_cjs=&original=.js'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, Component, Animation, UITransform, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, resourceUtil, constants, localConfig, uiManager, t, _cjsExports, GameLogic, _cjsExports$1;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      Component = module.Component;
      Animation = module.Animation;
      UITransform = module.UITransform;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      localConfig = module.localConfig;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      t = module.t;
    }, function (module) {
      _cjsExports = module.default;
    }, null, function (module) {
      GameLogic = module.GameLogic;
    }, function (module) {
      _cjsExports$1 = module.default;
    }, null],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _temp;

      cclegacy._RF.push({}, "7bf14l0xJZIx6dTAV7YPTWD", "offLineReward", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let OffLineReward = exports('OffLineReward', (_dec = ccclass('OffLineReward'), _dec2 = property(Node), _dec(_class = (_class2 = (_temp = class OffLineReward extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "sfDiamond", _descriptor, this);

          _initializerDefineProperty(this, "sfGold", _descriptor2, this);

          _initializerDefineProperty(this, "spIcon", _descriptor3, this);

          _initializerDefineProperty(this, "lbRewardValue", _descriptor4, this);

          _initializerDefineProperty(this, "aniGetItem", _descriptor5, this);

          _initializerDefineProperty(this, "ndThreeReceive", _descriptor6, this);

          _initializerDefineProperty(this, "ndNormalReceive", _descriptor7, this);

          _initializerDefineProperty(this, "nativeAd", _descriptor8, this);

          _defineProperty(this, "itemInfo", void 0);

          _defineProperty(this, "rewardType", void 0);

          _defineProperty(this, "itemType", void 0);

          _defineProperty(this, "itemAmount", void 0);

          _defineProperty(this, "itemSubType", void 0);
        }

        show(itemInfo) {
          Global.offLineReward = this;
          let self = this;
          console.log("showNativeAd00");

          _cjsExports.showNativeAd(frame => {
            console.log("showNativeAd0");
            let sc = self.nativeAd.getComponent("NativeAdBig");
            console.log("showNativeAd1");

            if (sc) {
              console.log("showNativeAd2");
              sc.setSprite(frame);
              console.log("showNativeAd3");
            }
          });

          _cjsExports.showCustomAd(false);

          this.itemInfo = itemInfo;
          this.itemType = itemInfo["itemType"];
          this.itemAmount = itemInfo["itemAmount"];
          this.itemSubType = itemInfo["itemSubType"];
          this.aniGetItem.play('getItemShow');
          this.aniGetItem.once(Animation.EventType.FINISHED, () => {
            this.aniGetItem.play('getItemIdle');
          }, this);
          this.showUI();
          this.ndNormalReceive.active = false;
          this.scheduleOnce(() => {
            this.ndNormalReceive.active = true;
          }, constants.NORMAL_SHOW_TIME);
        }

        showUI() {
          const uiTraSpIcon = this.spIcon.getComponent(UITransform);

          switch (this.itemType) {
            case constants.REWARD_TYPE.DIAMOND:
              this.spIcon.spriteFrame = this.sfDiamond;
              this.lbRewardValue.string = 'x' + this.itemAmount;
              break;

            case constants.REWARD_TYPE.GOLD:
              this.spIcon.spriteFrame = this.sfGold;
              this.lbRewardValue.string = 'x' + this.itemAmount;
              uiTraSpIcon.width = 257;
              uiTraSpIcon.height = 166;
              break;

            case constants.REWARD_TYPE.PROP:
              let propId = "00" + this.itemSubType;
              let propData = localConfig.instance.queryByID('prop', propId + '');
              uiTraSpIcon.width = 168;
              uiTraSpIcon.height = 168;
              resourceUtil.setPropIcon(propId, this.spIcon, () => {});
              let txt = t('table_prop.' + propData.name);
              this.lbRewardValue.string = txt + t('') + ' x ' + this.itemAmount;
              break;
          }

          GameLogic.instance.getOpenRewardType(constants.SHARE_FUNCTION.OFFLINE, (err, type) => {
            this.rewardType = type;

            if (!err) {
              this.ndThreeReceive.active = type !== constants.OPEN_REWARD_TYPE.NULL;
            } else {
              this.close();
            }
          });
        }

        showAd() {
          _cjsExports.showRewardAd("onBtnOffLineReceiveClick", "1", _cjsExports$1.getAdReward()); // GameLogic.instance.showRewardAd((err: any) => {
          //     if (!err) {
          //         this.showReward();
          //     }
          // });

        }

        onBtnOffLineReceiveClickCallback(s) {
          if (s) {
            this.showReward();
          }
        }

        showShare() {
          GameLogic.instance.share(constants.SHARE_FUNCTION.OFFLINE, {}, err => {
            if (!err) {
              this.showReward();
            }
          });
        }

        onBtnThreeReceiveClick() {
          this.showAd(); // if (this.rewardType === constants.OPEN_REWARD_TYPE.AD) {
          // } else if (this.rewardType === constants.OPEN_REWARD_TYPE.SHARE) {
          //     this.showShare();
          // }
        }

        showReward() {
          uiManager.instance.showDialog('lottery/reward', [{
            itemType: constants.REWARD_TYPE.GOLD,
            itemAmount: this.itemAmount * 3,
            itemSubType: 0
          }, false, constants.SHARE_FUNCTION.OFFLINE]);
          this.close();
        }

        onBtnNormalClick() {
          GameLogic.instance.addGold(this.itemAmount);
          this.close();
        }

        close() {
          uiManager.instance.shiftFromPopupSeq('pve/offLineReward');

          _cjsExports.hideCustomAd();
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "sfDiamond", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "sfGold", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "spIcon", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "lbRewardValue", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "aniGetItem", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "ndThreeReceive", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "ndNormalReceive", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "nativeAd", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/loading.ts", ['cc', './_rollupPluginModLoBabelHelpers.js'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, _applyDecoratedDescriptor, _initializerDefineProperty;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _temp;

      cclegacy._RF.push({}, "7c72f8OVs9Jgr00M87vUcnZ", "loading", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let Loading = exports('Loading', (_dec = ccclass('Loading'), _dec(_class = (_class2 = (_temp = class Loading extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "txtTips", _descriptor, this);

          _initializerDefineProperty(this, "aniLoading", _descriptor2, this);
        }

        show(tips) {
          if (tips) {
            this.txtTips.string = tips;
          } else {
            this.txtTips.string = "";
          }
        }

        onEnable() {
          this.aniLoading.play();
        }

        onDisable() {
          this.aniLoading.stop();
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "txtTips", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "aniLoading", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/adStep.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './constants.ts', './playerData.ts', './uiManager.ts', './PlatformBridge.js', './PlatformBridge.mjs_cjs=&original=.js', './gameLogic.ts', './ConstValue.js', './ConstValue.mjs_cjs=&original=.js', './adStepItem.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, instantiate, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, constants, playerData, uiManager, _cjsExports, GameLogic, _cjsExports$1, AdStepItem;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      instantiate = module.instantiate;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      _cjsExports = module.default;
    }, null, function (module) {
      GameLogic = module.GameLogic;
    }, function (module) {
      _cjsExports$1 = module.default;
    }, null, function (module) {
      AdStepItem = module.AdStepItem;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _temp;

      cclegacy._RF.push({}, "85a6dBiKRxKkILjS8dfOBYF", "adStep", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let AdStep = exports('AdStep', (_dec = ccclass('AdStep'), _dec(_class = (_class2 = (_temp = class AdStep extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "ndContent", _descriptor, this);

          _initializerDefineProperty(this, "pbAdStepItem", _descriptor2, this);

          _initializerDefineProperty(this, "imgAd", _descriptor3, this);

          _initializerDefineProperty(this, "imgShare", _descriptor4, this);

          _initializerDefineProperty(this, "spBtn", _descriptor5, this);

          _initializerDefineProperty(this, "ndBtnPlayAgain", _descriptor6, this);

          _defineProperty(this, "callback", void 0);

          _defineProperty(this, "rewardType", void 0);
        }

        show(callback) {
          Global.adStep = this;
          this.callback = callback;
          GameLogic.instance.getOpenRewardType(constants.SHARE_FUNCTION.LACK_STEP, (err, type) => {
            if (!err) {
              this.rewardType = type;

              switch (type) {
                case constants.OPEN_REWARD_TYPE.AD:
                  this.spBtn.spriteFrame = this.imgAd;
                  break;

                case constants.OPEN_REWARD_TYPE.SHARE:
                  this.spBtn.spriteFrame = this.imgShare;
                  break;

                case constants.OPEN_REWARD_TYPE.NULL:
                  this.onBtnCloseClick(); //不支持奖励

                  break;
              }
            }
          });
          let dictTargets = playerData.instance.dictTargets;
          this.ndContent.removeAllChildren();

          for (let key in dictTargets) {
            let cakeInfo = {
              name: key,
              num: dictTargets[key]
            };
            let node = instantiate(this.pbAdStepItem);
            node.parent = this.ndContent;
            let adStepItemScript = node.getComponent(AdStepItem);
            adStepItemScript.setInfo(cakeInfo);
          }

          this.ndBtnPlayAgain.active = false;
          this.scheduleOnce(() => {
            this.ndBtnPlayAgain.active = true;
          }, constants.NORMAL_SHOW_TIME);
        }

        onBtnCloseClick() {
          if (this.callback) {
            this.callback('close');
          }

          this.close();
        }

        onBtnPlayClick() {
          if (this.rewardType === constants.OPEN_REWARD_TYPE.AD) {
            // GameLogic.instance.showRewardAd((err: any) => {
            //     if (!err) {
            //         this.close();
            //         if (this.callback) {
            //             this.callback(null);
            //         }
            //     }
            // });
            _cjsExports.showRewardAd("onBtnAdStepReceiveClick", "1", _cjsExports$1.getAdReward());
          } else {
            GameLogic.instance.share(constants.SHARE_FUNCTION.START_REWARD, {}, err => {
              if (!err) {
                this.close();

                if (this.callback) {
                  this.callback(err);
                }
              }
            });
          }
        }

        onBtnPlayClickCallback(s) {
          if (s) {
            this.close();

            if (this.callback) {
              this.callback(null);
            }
          }
        }

        close() {
          uiManager.instance.hideDialog('fight/adStep');
        }

        onBtnPlayAgain() {
          this.close();
          GameLogic.instance.resetLevel();
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "ndContent", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "pbAdStepItem", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "imgAd", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "imgShare", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "spBtn", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "ndBtnPlayAgain", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/levelPanel.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './constants.ts', './utils.ts', './localConfig.ts', './playerData.ts', './uiManager.ts', './LanguageData.ts', './PlatformBridge.js', './PlatformBridge.mjs_cjs=&original=.js', './propItem.ts', './targetCake.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, Component, instantiate, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, constants, utils, localConfig, playerData, uiManager, t, _cjsExports, PropItem, TargetCake;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      Component = module.Component;
      instantiate = module.instantiate;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      utils = module.utils;
    }, function (module) {
      localConfig = module.localConfig;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      t = module.t;
    }, function (module) {
      _cjsExports = module.default;
    }, null, function (module) {
      PropItem = module.PropItem;
    }, function (module) {
      TargetCake = module.TargetCake;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _temp;

      cclegacy._RF.push({}, "8622524wZFNZK4SKvWm789R", "levelPanel", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let LevelPanel = exports('LevelPanel', (_dec = ccclass('LevelPanel'), _dec2 = property(Node), _dec(_class = (_class2 = (_temp = class LevelPanel extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "arrStarList", _descriptor, this);

          _initializerDefineProperty(this, "lbHighScore", _descriptor2, this);

          _initializerDefineProperty(this, "lbLevelNum", _descriptor3, this);

          _initializerDefineProperty(this, "pbPropItem", _descriptor4, this);

          _initializerDefineProperty(this, "pbTargetCake", _descriptor5, this);

          _initializerDefineProperty(this, "ndStartList", _descriptor6, this);

          _initializerDefineProperty(this, "ndPropList", _descriptor7, this);

          _initializerDefineProperty(this, "ndCakeList", _descriptor8, this);

          _initializerDefineProperty(this, "nativeAd", _descriptor9, this);

          _defineProperty(this, "levelInfo", void 0);

          _defineProperty(this, "callback", void 0);
        }

        show(levelInfo, callback) {
          let self = this;

          _cjsExports.showNativeAd((frame, string) => {
            let sc = self.nativeAd.getComponent("NativeAdBig");

            if (sc) {
              sc.setDateShow();
              sc.setSprite(frame);
              sc.setString(string);
            }
          });

          _cjsExports.showInterstitialAd();

          this.levelInfo = levelInfo;
          this.callback = callback;
          this.lbLevelNum.string = levelInfo.name;
          this.lbHighScore.string = t('pve.highest') + " " + playerData.instance.getHighestScoreByLevel(levelInfo.name);
          let arrCake = levelInfo.targets.split("|");
          let arrCakeList = this.ndCakeList.children;

          if (this.ndCakeList.children.length > arrCake.length) {
            for (let j = arrCake.length; j < this.ndCakeList.children.length; j++) {
              this.ndCakeList.children[j].active = false;
            }
          }

          for (let i = 0; i < arrCake.length; i++) {
            let cakeInfo = arrCake[i];
            let node = null;

            if (i < arrCakeList.length) {
              node = arrCakeList[i];
            } else {
              node = instantiate(this.pbTargetCake);
              node.parent = this.ndCakeList;
            }

            node.active = true;
            let targetCakeScript = node.getComponent(TargetCake);
            targetCakeScript.setInfo(cakeInfo);
          }

          let dictProp = localConfig.instance.getTable('prop');
          let arrProp = utils.objectToArray(dictProp);
          let arrPropList = this.ndPropList.children;

          for (let j = 0; j < arrProp.length; j++) {
            let ndProp = null;
            let propInfo = arrProp[j];

            if (j < arrPropList.length) {
              ndProp = arrPropList[j];
            } else {
              ndProp = instantiate(this.pbPropItem);
              ndProp.parent = this.ndPropList;
            }

            let propItemScript = ndProp.getComponent(PropItem);
            propItemScript.setInfo(propInfo);
          }

          let history = playerData.instance.history;

          if (history[this.levelInfo.ID]) {
            let starNum = history[this.levelInfo.ID].star;

            for (let k = 0; k < constants.MAX_GRADE_OF_EACH_PVE_LEVEL; k++) {
              if (k < starNum) {
                this.arrStarList[k].active = true;
              } else {
                this.arrStarList[k].active = false;
              }
            }
          } else {
            this.arrStarList.forEach(element => {
              element.active = false;
            });
          }
        }

        onBtnStartClick() {
          this.callback();
        }

        onBtnCloseClick() {
          uiManager.instance.hideDialog('pve/levelPanel');
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "arrStarList", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "lbHighScore", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "lbLevelNum", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "pbPropItem", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "pbTargetCake", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "ndStartList", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "ndPropList", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "ndCakeList", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "nativeAd", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/signIn.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './constants.ts', './clientEvent.ts', './localConfig.ts', './playerData.ts', './animationUI.ts', './uiManager.ts', './buttonEx.ts', './LanguageData.ts', './PlatformBridge.js', './PlatformBridge.mjs_cjs=&original=.js', './gameLogic.ts', './ConstValue.js', './ConstValue.mjs_cjs=&original=.js', './signInItem.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, Component, Widget, instantiate, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, constants, clientEvent, localConfig, playerData, AnimationUI, uiManager, ButtonEx, t, _cjsExports, GameLogic, _cjsExports$1, SignInItem;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      Component = module.Component;
      Widget = module.Widget;
      instantiate = module.instantiate;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      clientEvent = module.clientEvent;
    }, function (module) {
      localConfig = module.localConfig;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      AnimationUI = module.AnimationUI;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      ButtonEx = module.ButtonEx;
    }, function (module) {
      t = module.t;
    }, function (module) {
      _cjsExports = module.default;
    }, null, function (module) {
      GameLogic = module.GameLogic;
    }, function (module) {
      _cjsExports$1 = module.default;
    }, null, function (module) {
      SignInItem = module.SignInItem;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _temp;

      cclegacy._RF.push({}, "8885akyBoFF94Jx+V7yERfJ", "signIn", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      const MIN_CHILD_COUNT = 1;
      let SignIn = exports('SignIn', (_dec = ccclass('SignIn'), _dec2 = property(Node), _dec(_class = (_class2 = (_temp = class SignIn extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "prefabItem", _descriptor, this);

          _initializerDefineProperty(this, "iconList", _descriptor2, this);

          _initializerDefineProperty(this, "ndSeventhItem", _descriptor3, this);

          _initializerDefineProperty(this, "ndBtnDoubleReceive", _descriptor4, this);

          _initializerDefineProperty(this, "arrDay", _descriptor5, this);

          _initializerDefineProperty(this, "ndBtnNormalReceive", _descriptor6, this);

          _initializerDefineProperty(this, "nativeAd", _descriptor7, this);

          _defineProperty(this, "currentDay", void 0);

          _defineProperty(this, "arrReceived", void 0);

          _defineProperty(this, "arrAfterFillSignIn", void 0);

          _defineProperty(this, "isTodayReceived", void 0);

          _defineProperty(this, "arrSignInItemScript", void 0);

          _defineProperty(this, "signInItemScript", void 0);

          _defineProperty(this, "openRewardType", void 0);
        }

        onEnable() {
          clientEvent.on('updateSignIn', this.updateSignIn, this);
        }

        onDisable() {
          clientEvent.off('updateSignIn', this.updateSignIn, this);
        }

        onLoad() {
          Global.signIn = this;
        }

        show() {
          let self = this;

          _cjsExports.showNativeAd((frame, string) => {
            let sc = self.nativeAd.getComponent("NativeAdBig");

            if (sc) {
              sc.setDateShow();
              sc.setSprite(frame);
              sc.setString(string);
            }
          });

          _cjsExports.showInterstitialAd();

          playerData.instance.updateSignInCurrentDay();
          let signInInfo = playerData.instance.playerInfo['signInInfo'];
          console.log('###signInfo', signInInfo);
          this.currentDay = signInInfo['currentDay']; //当前日期

          this.arrReceived = signInInfo['receivedDays']; //已经领取的日期数组

          this.arrAfterFillSignIn = signInInfo['afterFillSignInDays']; //已经补签后可领取的日期数组

          this.showSignInInfo();
          this.ndSeventhItem.setSiblingIndex(constants.ZORDER.TIPS);
          this.updateSignIn();
          this.isTodayReceived = playerData.instance.getSignInReceivedInfo()['isTodayReceived'];
          this.ndBtnNormalReceive.active = false;

          if (this.isTodayReceived) {
            this.scheduleOnce(this.showNormalBtnCallback, 1);
          } else {
            this.scheduleOnce(this.showNormalBtnCallback, constants.NORMAL_SHOW_TIME);
          }
        }

        updateSignIn() {
          this.ndBtnDoubleReceive.getComponent(ButtonEx).interactable = !playerData.instance.getSignInReceivedInfo()['isTodayReceived'];
          console.log('###getSignInReceivedInfo', playerData.instance.getSignInReceivedInfo());
        }

        showNormalBtnCallback() {
          this.ndBtnNormalReceive.active = true;
          this.node.getComponent(Widget).enabled = true;
          this.ndBtnNormalReceive.getComponent(Widget).enabled = true;
          this.ndBtnNormalReceive.getComponent(Widget).bottom = 205;
          console.log('bottom', this.ndBtnNormalReceive.getComponent(Widget).bottom);
          console.log('enable', this.ndBtnNormalReceive.getComponent(Widget).enabled);
        }

        showSignInInfo() {
          let tbSignIn = localConfig.instance.getTable("signIn");

          let _this = this;

          this.arrSignInItemScript = [];

          for (var idx in tbSignIn) {
            let day = tbSignIn[idx].ID;
            let isReceived = this.arrReceived.includes(Number(day)) ? true : false; //从签到数组中判断是否已经领取

            if (day <= this.currentDay) {
              tbSignIn[idx].status = isReceived ? constants.SIGN_REWARD_STATUS.RECEIVED : constants.SIGN_REWARD_STATUS.RECEIVABLE; //状态设置为已领取或者可领取

              if (tbSignIn[idx].status === constants.SIGN_REWARD_STATUS.RECEIVABLE && day < this.currentDay) {
                tbSignIn[idx].status = constants.SIGN_REWARD_STATUS.FILLSIGNIN;

                if (this.arrAfterFillSignIn.includes(day)) {
                  tbSignIn[idx].status = constants.SIGN_REWARD_STATUS.AFTER_FILLSIGNIN;
                }
              }
            } else {
              //不可领取
              tbSignIn[idx].status = constants.SIGN_REWARD_STATUS.UNRECEIVABLE;
            }

            let node = _this.iconList[Number(idx) - 1]; //idx从1开始


            let signInItemNode = null;

            if (node.children.length <= MIN_CHILD_COUNT) {
              signInItemNode = instantiate(_this.prefabItem);
              node.addChild(signInItemNode);
              signInItemNode.setPosition(0, 0);
            } else {
              signInItemNode = node.getChildByName('signInItem');
            }

            this.signInItemScript = signInItemNode.getComponent(SignInItem);
            this.signInItemScript.init(tbSignIn[idx], _this);

            if (!this.arrSignInItemScript.includes(this.signInItemScript)) {
              this.arrSignInItemScript.push(this.signInItemScript);
            }

            let DayLabel = this.arrDay[Number(idx) - 1];
            DayLabel.string = t('sign.day%{value}', {
              value: idx
            });
          }
        }

        receiveReward(itemInfo, isDouble, callback) {
          let day = itemInfo["ID"];

          if (this.currentDay < day) {
            //大于可领奖天数点击图标不能领取
            return;
          }

          let isLast = false; //某一天的签到奖励的最后一个弹窗(礼包弹出3个),判断是否需要再次显示签到界面

          let type = itemInfo.rewardType;

          if (type === constants.REWARD_TYPE.GIFT) {
            //如果奖励等于礼包
            let arrGift = playerData.instance.parseGift(itemInfo.subType);

            for (let i = 0; i < arrGift.length; i++) {
              let giftItemInfo = {}; //每个弹窗的数据

              giftItemInfo['ID'] = itemInfo['ID'];
              giftItemInfo['itemType'] = arrGift[i]['type'];
              giftItemInfo['itemSubType'] = arrGift[i]['subType'];
              giftItemInfo['itemAmount'] = isDouble ? Number(arrGift[i]['amount']) * 2 : arrGift[i]['amount'];
              isLast = i === arrGift.length - 1 ? true : false;
              uiManager.instance.pushToPopupSeq('signIn/signInReward', 'signinReward', [giftItemInfo, callback, isLast]);
            }
          } else {
            let normalItemInfo = {};
            normalItemInfo['ID'] = itemInfo['ID'];
            normalItemInfo['itemType'] = itemInfo['rewardType'];
            normalItemInfo['itemSubType'] = itemInfo['subType'];
            normalItemInfo['itemAmount'] = isDouble ? Number(itemInfo['amount']) * 2 : itemInfo['amount'];
            isLast = true;
            uiManager.instance.pushToPopupSeq('signIn/signInReward', 'signinReward', [normalItemInfo, callback, isLast]);
          }

          uiManager.instance.hideDialog('signIn/signIn');
          this.unschedule(this.showNormalBtnCallback);
        }

        receiveClick(isDouble) {
          for (let j = 0; j < this.arrSignInItemScript.length; j++) {
            let element = this.arrSignInItemScript[j];

            if (element.itemInfo["status"] === constants.SIGN_REWARD_STATUS.RECEIVABLE) {
              element._parent.receiveReward(element.itemInfo, isDouble, () => {
                element.markReceived();
              });

              break;
            }
          }
        }

        onBtnDoubleReceiveClick() {
          GameLogic.instance.getOpenRewardType(constants.SHARE_FUNCTION.SIGN, (err, type) => {
            if (!err) {
              this.openRewardType = type;

              switch (type) {
                case constants.OPEN_REWARD_TYPE.AD:
                  this.showAd();
                  break;

                case constants.OPEN_REWARD_TYPE.SHARE:
                  this.showShare();
                  break;

                case constants.OPEN_REWARD_TYPE.NULL:
                  this.receiveClick(false);
                  break;
              }
            } else {
              this.node.getComponent(AnimationUI).close();
            }
          });
        }

        showAd() {
          _cjsExports.showRewardAd("onBtnSignDoubleReceiveClick", "1", _cjsExports$1.getAdReward()); // GameLogic.instance.showRewardAd((err: any) => {
          //     if (!err) {
          //     }
          // });

        }

        showAdCallback(s) {
          if (s) {
            this.receiveClick(true);
          }
        }

        showShare() {
          GameLogic.instance.share(constants.SHARE_FUNCTION.SIGN, {}, err => {
            if (!err) {
              this.receiveClick(true);
            }
          });
        }

        onBtnNormalReceiveClick() {
          this.onBtnCloseClick();
        }

        onBtnCloseClick() {
          uiManager.instance.hideDialog('signIn/signIn');
          uiManager.instance.hideDialog('signIn/signInReward');
          this.unschedule(this.showNormalBtnCallback);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "prefabItem", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "iconList", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "ndSeventhItem", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "ndBtnDoubleReceive", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "arrDay", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "ndBtnNormalReceive", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "nativeAd", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/MessageUISc.ts", ['cc', './_rollupPluginModLoBabelHelpers.js'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, Component, _applyDecoratedDescriptor, _initializerDefineProperty;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      Component = module.Component;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _temp;

      cclegacy._RF.push({}, "94528kdkiJHD52w72Z3flQP", "MessageUISc", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let NewClass = exports('default', (_dec = property(Node), _dec2 = property(Node), ccclass(_class = (_class2 = (_temp = class NewClass extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "userAggrement", _descriptor, this);

          _initializerDefineProperty(this, "privacyPolicy", _descriptor2, this);
        } // LIFE-CYCLE CALLBACKS:


        onLoad() {
          if (Global.OPPOQuickGameEnv || Global.VIVOQuickGameEnv) {
            this.userAggrement.active = false; // this.privacyPolicy.active = false;
          }
        }

        start() {} // update (dt) {}


      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "userAggrement", [_dec], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "privacyPolicy", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/effectGroup.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './poolManager.ts', './resourceUtil.ts', './constants.ts', './clientEvent.ts', './audioManager.ts', './fightNum.ts', './showTargetCake.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, UITransform, Animation, TweenSystem, tween, Vec3, Prefab, Label, instantiate, Sprite, _defineProperty, poolManager, resourceUtil, constants, clientEvent, AudioManager, FightNum, ShowTargetCake;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      UITransform = module.UITransform;
      Animation = module.Animation;
      TweenSystem = module.TweenSystem;
      tween = module.tween;
      Vec3 = module.Vec3;
      Prefab = module.Prefab;
      Label = module.Label;
      instantiate = module.instantiate;
      Sprite = module.Sprite;
    }, function (module) {
      _defineProperty = module.defineProperty;
    }, function (module) {
      poolManager = module.poolManager;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      clientEvent = module.clientEvent;
    }, function (module) {
      AudioManager = module.AudioManager;
    }, function (module) {
      FightNum = module.FightNum;
    }, function (module) {
      ShowTargetCake = module.ShowTargetCake;
    }],
    execute: function () {
      var _dec, _class, _temp;

      cclegacy._RF.push({}, "97452hq2+JOY4wRZ0jvZvzu", "effectGroup", undefined);

      const {
        ccclass
      } = _decorator;
      let EffectGroup = exports('EffectGroup', (_dec = ccclass('EffectGroup'), _dec(_class = (_temp = class EffectGroup extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "_fightScene", void 0);
        }

        show(fightScene) {
          this._fightScene = fightScene;
        }

        showStarFlyEffect(srcWorldPos, effectType, callback, target) {
          const uiTra = this.node.getComponent(UITransform);
          let srcPos = uiTra.convertToNodeSpaceAR(srcWorldPos);
          resourceUtil.getEffectPrefab('fight/linkStar/linkStar', (err, prefab) => {
            if (err) {
              callback.apply(target, [err]);
              return;
            }

            let effectNode = poolManager.instance.getNode(prefab, this.node);
            effectNode.position = srcPos;
            let ani = effectNode.getComponent(Animation);
            ani.once(Animation.EventType.FINISHED, () => {
              let targetIndex = this._fightScene.linkContent.getNoEffectLinkItemIndex();

              if (targetIndex) {
                this._fightScene.linkContent.markLinkItemEffect(targetIndex, effectType);

                let targetWorldPos = this._fightScene.linkContent.getItemWorldPosByIndex(targetIndex);

                let targetPos = uiTra.convertToNodeSpaceAR(targetWorldPos);
                AudioManager.instance.playSound(constants.AUDIO_SOUND.FLY_STAR, false); // effectNode.stopActionByTag(TAG_STAR_MOVE_ACTION);

                TweenSystem.instance.ActionManager.removeAllActionsFromTarget(effectNode);
                let duration = targetPos.clone().subtract(srcPos).length() / 1200;
                tween(effectNode).to(duration, {
                  position: targetPos
                }, {
                  easing: 'backIn'
                }).call(() => {
                  let ani = effectNode.getComponent(Animation);
                  ani.once(Animation.EventType.FINISHED, () => {
                    poolManager.instance.putNode(effectNode);
                  });
                  ani.play('linkStarOver');
                  callback.apply(target, [null, targetIndex, effectType]);
                }).start(); // let moveAction = cc.moveTo(duration, targetPos).easing(cc.easeIn(1.0));
                // let seqAction = cc.sequence(moveAction, cc.callFunc((node) => {
                //     let ani = node.getComponent(Animation);
                //     ani.once(Animation.EventType.FINISHED, () => {
                //         poolManager.instance.putNode(node);
                //     });
                //     ani.play('linkStarOver');
                //     callback.apply(target, [null, targetIndex, effectType]);
                // }, this));
                // seqAction.setTag(TAG_STAR_MOVE_ACTION);
                // effectNode.runAction(seqAction);
              } else {
                poolManager.instance.putNode(effectNode);
                callback.apply(target, ['error']);
                return;
              }
            });
            ani.play('linkStarFly');
          });
        }

        showStarAfterLevelFinished(srcWorldPos, effectType, callback, target, targetIndex) {
          const uiTra = this.node.getComponent(UITransform);
          let srcPos = uiTra.convertToNodeSpaceAR(srcWorldPos);
          resourceUtil.getEffectPrefab('fight/linkStar/linkStar', (err, prefab) => {
            if (err) {
              callback.apply(target, [err]);
              return;
            }

            let effectNode = poolManager.instance.getNode(prefab, this.node);
            effectNode.position = srcPos;
            let ani = effectNode.getComponent(Animation);
            ani.play('linkStarScale');

            if (!targetIndex) {
              targetIndex = this._fightScene.linkContent.getNoEffectLinkItemIndex();
            }

            if (targetIndex) {
              this._fightScene.linkContent.markLinkItemEffect(targetIndex, effectType);

              let targetWorldPos = this._fightScene.linkContent.getItemWorldPosByIndex(targetIndex);

              let targetPos = uiTra.convertToNodeSpaceAR(targetWorldPos);
              AudioManager.instance.playSound(constants.AUDIO_SOUND.SPARE_STEP, false);
              TweenSystem.instance.ActionManager.removeAllActionsFromTarget(effectNode); // let bezier = [srcPos, new Vec3((targetPos.x - srcPos.x) / 2 + srcPos.x, srcPos.y + 500, 0), targetPos];

              tween(effectNode).to(0.33, {
                position: srcPos
              }).to(0.33, {
                position: new Vec3((targetPos.x - srcPos.x) / 2 + srcPos.x, srcPos.y + 500, 0)
              }).to(0.33, {
                position: targetPos
              }).call(() => {
                let ani = effectNode.getComponent(Animation);
                ani.once(Animation.EventType.FINISHED, () => {
                  poolManager.instance.putNode(effectNode);
                });
                ani.play('linkStarOver');
                callback.apply(target, [null, targetIndex, effectType]);
              }).start(); // let bezierForward = cc.bezierTo(1, bezier);
              // let seqAction = cc.sequence(bezierForward, cc.callFunc(, this));
              // seqAction.setTag(TAG_STAR_MOVE_ACTION);
              // effectNode.runAction(seqAction);
            } else {
              poolManager.instance.putNode(effectNode);
              callback.apply(target, ['error']);
              return;
            }
          });
        }

        showLinkItemDestroyEffect(srcWorldPos, score) {
          let srcPos = this.node.getComponent(UITransform).convertToNodeSpaceAR(srcWorldPos);
          resourceUtil.getEffectPrefab("fight/effectHide/effectHide", (err, prefab) => {
            if (err) {
              return;
            }

            let effect = poolManager.instance.getNode(prefab, this.node);
            effect.position = srcPos;
            let ani = effect.getComponent(Animation);
            ani.once(Animation.EventType.FINISHED, () => {
              poolManager.instance.putNode(effect);
              this.showAfterDestroyEffect(srcPos);
            }, this);
            ani.play('effectHide');
            this.showLinkItemScore(srcPos, score);
          });
        }

        showLinkItemScore(srcPos, score) {
          resourceUtil.loadRes('prefab/fight/fightNum', Prefab, (err, prefab) => {
            if (err) {
              return;
            }

            let effect = poolManager.instance.getNode(prefab, this.node);
            effect.position = new Vec3(srcPos.x, srcPos.y + 40);
            effect.zIndex = constants.ZORDER.FIGHT_NUM; //数字统一堆前面

            let fightNum = effect.getComponent(FightNum);
            fightNum.show(score, () => {
              poolManager.instance.putNode(effect);
            });
          });
        }

        showAfterDestroyEffect(srcPos) {
          let targetWorldPos = this._fightScene.fightUI.getProgressBarWorldPos();

          let targetPos = this.node.getComponent(UITransform).convertToNodeSpaceAR(targetWorldPos);

          if (!targetPos) {
            return;
          }

          resourceUtil.getEffectPrefab("fight/eliminate/eliminate", (err, prefab) => {
            if (err) {
              return;
            }

            let effect = poolManager.instance.getNode(prefab, this.node);
            effect.position = srcPos;
            let duration = targetPos.clone().subtract(srcPos).length() / 1000;
            tween(effect).to(duration, {
              position: targetPos
            }).call(() => {
              poolManager.instance.putNode(effect);
              clientEvent.dispatchEvent('updateScore');
            }).start(); // let moveAction = cc.moveTo(duration, targetPos);
            // let seqAction = cc.sequence(moveAction, cc.callFunc((node) => {
            //     poolManager.instance.putNode(node);
            //     clientEvent.dispatchEvent('updateScore');
            // }, this));
            // effect.runAction(seqAction);
          });
        }

        showSkillLineEffect(targetWorldPos, isHorizontal) {
          let targetPos = this.node.getComponent(UITransform).convertToNodeSpaceAR(targetWorldPos);
          resourceUtil.getEffectPrefab("fight/effectSkillLine/effectSkillLine", (err, prefab) => {
            if (err) {
              return;
            }

            let effect = poolManager.instance.getNode(prefab, this.node);
            effect.position = targetPos;
            effect.setRotationFromEuler(0, 0, 0);

            if (!isHorizontal) {
              effect.setRotationFromEuler(0, 0, 90);
            }

            let ani = effect.getComponent(Animation);
            ani.play('effectSkillLine');
            ani.once(Animation.EventType.FINISHED, () => {
              poolManager.instance.putNode(effect);
            }, this);
          });
        }

        showSkillRangeEffect(targetWorldPos) {
          let targetPos = this.node.getComponent(UITransform).convertToNodeSpaceAR(targetWorldPos);
          resourceUtil.getEffectPrefab("fight/effectSkillRange/effectSkillRange", (err, prefab) => {
            if (err) {
              return;
            }

            let effect = poolManager.instance.getNode(prefab, this.node);
            effect.position = targetPos;
            AudioManager.instance.playSound(constants.AUDIO_SOUND.RANGE_BOMB, false);
            let ani = effect.getComponent(Animation);
            ani.play('effectSkillRange');
            ani.once(Animation.EventType.FINISHED, () => {
              poolManager.instance.putNode(effect);
            }, this);
          });
        }

        playTargetCakeFlyEffect(cake, srcWorldPos, targetWorldPos, callback) {
          resourceUtil.createUI('fight/showTargetCake', (err, node) => {
            if (err) {
              callback(err, node);
              return;
            }

            const uiTra = this.node.getComponent(UITransform);
            let srcPos = uiTra.convertToNodeSpaceAR(srcWorldPos);
            let targetPos = uiTra.convertToNodeSpaceAR(targetWorldPos);
            node.position = srcPos;
            node.getComponent(ShowTargetCake).onlyShowCake(cake);
            let duration = targetPos.clone().subtract(srcPos).length() / 1000;
            tween(node).to(duration, {
              position: targetPos
            }).call(node => {
              node && node.destroy();
              callback();
            }).start(); // let moveAction = cc.moveTo(duration, targetPos);
            // let seqAction = cc.sequence(moveAction, cc.callFunc((node) => {
            //     node && node.destroy();
            //     callback();
            // }, this));
            // node.runAction(seqAction);
          }, this.node);
        }

        showBonusTime(callback) {
          resourceUtil.createEffect('fight/bonusTime/bonusTime', (err, node) => {
            if (err) {
              callback(err, node);
              return;
            }

            let ani = node.getComponent(Animation);
            ani.play('bonusTime');
            ani.once(Animation.EventType.FINISHED, () => {
              node && node.destroy();
              callback(null);
            }, this);
          }, this.node);
        }

        useInfiniteProp(propWorldPos, infiniteWorldPos) {
          let srcPos = this.node.getComponent(UITransform).convertToNodeSpaceAR(propWorldPos);
          resourceUtil.createEffect('fight/propUse/propUse', (err, node) => {
            if (err) {
              return;
            }

            node.position = srcPos;
            let ani = node.getComponent(Animation);
            ani.play('propUse');
            ani.on(Animation.EventType.FINISHED, () => {
              node && node.destroy();
              this.showUnlimitedOrNumber(infiniteWorldPos, true, null);
            });
          }, this.node);
        }

        showUnlimitedOrNumber(srcWorldPos, isInfinite, number) {
          let srcPos = this.node.getComponent(UITransform).convertToNodeSpaceAR(srcWorldPos);
          resourceUtil.createEffect('fight/unlimited/unlimited', (err, node) => {
            if (err) {
              return;
            }

            node.position = srcPos;
            let ani = node.getComponent(Animation);
            let homeIconNode = node.getChildByName('homeIcon');
            let infiniteNode = homeIconNode.getChildByName('homeIconUnlimited');
            let txtNode = homeIconNode.getChildByName('txt');
            infiniteNode.active = isInfinite;
            txtNode.active = !isInfinite;

            if (!isInfinite && number > 0) {
              txtNode.getComponent(Label).string = number;
            }

            ani.play('unlimitedStart');
            ani.on(Animation.EventType.FINISHED, () => {
              if (isInfinite) {
                ani.play('unlimitedIdle');
              } else {
                node && node.destroy();
                clientEvent.dispatchEvent('updateStep');
              }
            });
          }, this.node);
        }

        removeLastEffect() {
          let arrLast = [];
          let unlimitedNode = this.node.getChildByName('unlimited');
          if (unlimitedNode) arrLast.push(unlimitedNode);

          if (arrLast.length !== 0) {
            arrLast.forEach(element => {
              element.removeFromParent();
            });
          }
        }

        showUnlockProp(targetWorldPos, propId, callback) {
          resourceUtil.getEffectPrefab("fight/propGet/propGet", (err, prefab) => {
            if (err) {
              return;
            }

            let node = instantiate(prefab);
            node.setScale(2, 2, 2);
            node.parent = this.node;
            let targetNodePos = this.node.getComponent(UITransform).convertToNodeSpaceAR(targetWorldPos);
            let id = '00' + propId;
            let propIcon = node.getChildByName('prop');
            resourceUtil.setPropIcon(id, propIcon.getComponent(Sprite), () => {});
            let ani = node.getComponent(Animation);
            ani.play('propGetStart'); // let moveAction = cc.moveTo(duration, targetNodePos).easing(cc.easeCubicActionOut());
            // let seq = cc.sequence(moveAction, cc.callFunc(() => {
            //     ani.play('propGetOver');
            //     ani.on(Animation.EventType.FINISHED, () => {
            //         node && node.destroy();
            //     }, this);
            //     if (callback) {
            //         callback();
            //     }
            // }))

            ani.on(Animation.EventType.FINISHED, () => {
              let duration = targetNodePos.clone().subtract(node.position).length() / 500;
              tween(node).to(duration, {
                position: targetNodePos,
                scale: new Vec3(1, 1, 1)
              }, {
                easing: 'cubicInOut'
              }).call(() => {
                ani.play('propGetOver');
                ani.on(Animation.EventType.FINISHED, () => {
                  node && node.destroy();
                }, this);

                if (callback) {
                  callback();
                }
              }).start();
            }, this);
          });
        }

      }, _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/showTargetCake.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './resourceUtil.ts', './playerData.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, Animation, UITransform, Vec3, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, resourceUtil, playerData;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      Animation = module.Animation;
      UITransform = module.UITransform;
      Vec3 = module.Vec3;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }, function (module) {
      playerData = module.playerData;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _temp;

      cclegacy._RF.push({}, "9c9c8xtNVNNdaML8iBVjy6C", "showTargetCake", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ShowTargetCake = exports('ShowTargetCake', (_dec = ccclass('ShowTargetCake'), _dec(_class = (_class2 = (_temp = class ShowTargetCake extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spCake", _descriptor, this);

          _initializerDefineProperty(this, "lbCake", _descriptor2, this);

          _initializerDefineProperty(this, "aniCake", _descriptor3, this);

          _initializerDefineProperty(this, "nodeValue", _descriptor4, this);

          _initializerDefineProperty(this, "nodePanel", _descriptor5, this);

          _defineProperty(this, "cake", void 0);
        }

        show(cake, parent) {
          this.cake = cake;
          resourceUtil.setCakeIcon(this.cake, this.spCake, () => {});
          this.lbCake.string = playerData.instance.getTargetValue(cake);
          this.aniCake.play('showTargetCakeShow');
          this.aniCake.once(Animation.EventType.FINISHED, () => {
            this.aniCake.play('showTargetCakeOver');
            parent.showFlyEffect(this.cake, this.spCake.node.getComponent(UITransform).convertToWorldSpaceAR(new Vec3(0, 0, 0)));
          }, this);
        }

        onlyShowCake(cake) {
          resourceUtil.setCakeIcon(cake, this.spCake, () => {});
          this.nodeValue.active = false;
          this.nodePanel.active = false;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spCake", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "lbCake", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "aniCake", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "nodeValue", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "nodePanel", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/signInItem.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './constants.ts', './playerData.ts', './gameLogic.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, Vec3, UITransform, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, constants, playerData, GameLogic;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      Vec3 = module.Vec3;
      UITransform = module.UITransform;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      GameLogic = module.GameLogic;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _temp;

      cclegacy._RF.push({}, "9ed24FbGtFK/r/yqUqxT4pv", "signInItem", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let SignInItem = exports('SignInItem', (_dec = ccclass('SignInItem'), _dec(_class = (_class2 = (_temp = class SignInItem extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "lbAmount", _descriptor, this);

          _initializerDefineProperty(this, "spIcon", _descriptor2, this);

          _initializerDefineProperty(this, "spPan", _descriptor3, this);

          _initializerDefineProperty(this, "sfDiamond", _descriptor4, this);

          _initializerDefineProperty(this, "sfGold", _descriptor5, this);

          _initializerDefineProperty(this, "sfGift", _descriptor6, this);

          _initializerDefineProperty(this, "ndLight", _descriptor7, this);

          _initializerDefineProperty(this, "ndTick", _descriptor8, this);

          _initializerDefineProperty(this, "ndBtnFillSignIn", _descriptor9, this);

          _initializerDefineProperty(this, "ndBtnReceive", _descriptor10, this);

          _initializerDefineProperty(this, "ndMenu", _descriptor11, this);

          _defineProperty(this, "isReceived", void 0);

          _defineProperty(this, "_parent", void 0);

          _defineProperty(this, "itemInfo", void 0);

          _defineProperty(this, "openRewardType", void 0);
        }

        start() {
          this.isReceived = false;
        }

        init(itemInfo, parent) {
          this._parent = parent;
          this.itemInfo = itemInfo;
          this.setIcon(itemInfo["rewardType"]);
          this.setStatus(itemInfo["status"]);
          GameLogic.instance.getOpenRewardType(constants.SHARE_FUNCTION.FILL_SIGN, (err, type) => {
            if (!err) {
              this.openRewardType = type;

              switch (type) {
                case constants.OPEN_REWARD_TYPE.AD:
                  break;

                case constants.OPEN_REWARD_TYPE.SHARE:
                  break;

                case constants.OPEN_REWARD_TYPE.NULL:
                  this.ndBtnFillSignIn.active = false;
                  break;
              }
            } // else {
            //     this.close();
            // }

          });
        }

        setIcon(type) {
          let v3_init = new Vec3();
          const uiTraSpIcon = this.spIcon.getComponent(UITransform);

          switch (type) {
            case constants.REWARD_TYPE.DIAMOND:
              this.spIcon.spriteFrame = this.sfDiamond;
              uiTraSpIcon.width = 165;
              uiTraSpIcon.height = 126;
              v3_init.set(this.spIcon.node.position);
              v3_init.y = 56;
              this.spIcon.node.setPosition(v3_init);
              break;

            case constants.REWARD_TYPE.GOLD:
              this.spIcon.spriteFrame = this.sfGold;
              uiTraSpIcon.width = 165;
              uiTraSpIcon.height = 126;
              v3_init.set(this.spIcon.node.position);
              v3_init.y = 56;
              this.spIcon.node.setPosition(v3_init);
              break;

            case constants.REWARD_TYPE.GIFT:
              this.spIcon.spriteFrame = this.sfGift;
              break;
          }

          if (this.itemInfo['ID'] <= 6) {
            v3_init.set(0.6, 0.6, 0.6);
            this.spPan.node.setScale(v3_init);
          } else {
            v3_init.set(this.ndTick.position);
            v3_init.y = 50;
            this.ndTick.setPosition(v3_init);
          }

          v3_init.set(this.ndMenu.position);
          v3_init.y = -50;
          this.ndMenu.setPosition(v3_init);
        }

        setStatus(status) {
          switch (status) {
            case constants.SIGN_REWARD_STATUS.RECEIVED:
              this.showItemUI(false, true, false, false);
              break;

            case constants.SIGN_REWARD_STATUS.RECEIVABLE:
              this.showItemUI(true, false, false, false);
              break;

            case constants.SIGN_REWARD_STATUS.UNRECEIVABLE:
              this.showItemUI(false, false, false, false);
              break;

            case constants.SIGN_REWARD_STATUS.FILLSIGNIN:
              this.showItemUI(false, false, true, false);
              break;

            case constants.SIGN_REWARD_STATUS.AFTER_FILLSIGNIN:
              this.showItemUI(true, false, false, true);
              break;
          }
        }

        showItemUI(isShowLight, isShowTick, isShowBtnFillSignIn, isShowBtnReceive) {
          this.ndLight.active = isShowLight;
          this.ndTick.active = isShowTick;
          this.ndBtnFillSignIn.active = isShowBtnFillSignIn;
          this.ndBtnReceive.active = isShowBtnReceive;
        }

        onBtnReceiveClick() {
          if (this.itemInfo["status"] === constants.SIGN_REWARD_STATUS.AFTER_FILLSIGNIN || this.itemInfo["status"] === constants.SIGN_REWARD_STATUS.RECEIVABLE) {
            this._parent.receiveReward(this.itemInfo, false, this.markReceived.bind(this));
          }
        }

        markReceived() {
          this.itemInfo["status"] = constants.SIGN_REWARD_STATUS.RECEIVED;
          this.setStatus(this.itemInfo["status"]);
        }

        markAfterFillSignIn() {
          this.itemInfo["status"] = constants.SIGN_REWARD_STATUS.AFTER_FILLSIGNIN;
          this.setStatus(this.itemInfo["status"]);
          playerData.instance.updateSignInFillSignInDays(this.itemInfo['ID'], false);
        }

        onBtnFillSignInClick() {
          switch (this.openRewardType) {
            case constants.OPEN_REWARD_TYPE.AD:
              GameLogic.instance.showRewardAd(err => {
                if (!err) {
                  this.markAfterFillSignIn();
                }
              });
              break;

            case constants.OPEN_REWARD_TYPE.SHARE:
              GameLogic.instance.share(constants.SHARE_FUNCTION.FILL_SIGN, {}, err => {
                if (!err) {
                  this.markAfterFillSignIn();
                }
              });
              break;

            case constants.OPEN_REWARD_TYPE.NULL:
              break;
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "lbAmount", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "spIcon", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "spPan", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "sfDiamond", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "sfGold", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "sfGift", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "ndLight", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "ndTick", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "ndBtnFillSignIn", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "ndBtnReceive", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "ndMenu", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/VIVOGameBridge.js", ['./cjs-loader.mjs', './ConstValue.js'], function (exports, module) {
  'use strict';

  var loader, __cjsMetaURL$1;

  return {
    setters: [function (module) {
      loader = module.default;
    }, function (module) {
      __cjsMetaURL$1 = module.__cjsMetaURL;
    }],
    execute: function () {
      exports('default', void 0);

      let _cjsExports;

      loader.define(module.meta.url, function (exports$1, _require, module, __filename, __dirname) {
        let require = loader.createRequireWithReqMap({
          "./ConstValue": __cjsMetaURL$1
        }, _require);

        (function () {
          const ConstValue = require("./ConstValue");

          const VIVOGameBridge = {
            QQGameRewardAdInitComplete: false,
            QQGameRewardAd: null,
            QQGameAdCurScene: null,
            QQGameInterstitialAdInitComplete: false,
            QQGameInterstitialAd: null,
            QQGameFeedAd: null,
            QQGameBannerAd: null,
            QQGameBlockAd: null,
            QQGameAppBox: null,
            QQGameBlockAdNeedClose: false,
            showRewardAd: function (scene, fromId, adId) {
              //qqqiaopc
              if (!VIVOGameBridge.QQGameRewardAdInitComplete) {
                VIVOGameBridge.QQGameRewardAd = qg.createRewardedVideoAd({
                  posId: "54eb3207557242e6a3e8af2973d29a71"
                });
                VIVOGameBridge.QQGameRewardAdInitComplete = true;
              }

              try {
                if (VIVOGameBridge.QQGameAdCloseHandler) {
                  VIVOGameBridge.QQGameRewardAd.offClose(VIVOGameBridge.QQGameAdCloseHandler);
                  console.log("---videoAd.offClose 卸载成功---");
                }
              } catch (e) {
                console.log("---videoAd.offClose 卸载失败---");
                console.error(e);
              }

              VIVOGameBridge.QQGameAdCurScene = scene;
              VIVOGameBridge.QQGameRewardAd.onClose(VIVOGameBridge.QQGameAdCloseHandler);
              VIVOGameBridge.QQGameRewardAd.load().then(() => {
                console.log('激励视频加载成功');
                VIVOGameBridge.QQGameRewardAd.show().then(() => {
                  console.log('激励视频 广告显示成功');
                }).catch(err => {
                  console.log('激励视频 广告显示失败');
                  Global.onRewardAdCallback(false, scene);
                });
              }).catch(err => {
                console.log('激励视频加载失败');
                Global.onRewardAdCallback(false, scene);
              });
            },
            showBannerAd: function (scene, adId, expressViewWidth, expressViewHeight, isBottom, margin, displayBackground) {
              console.log("vivo->showbannerad");
              let adWidth = parseInt(cc.view.getFrameSize().width);
              let adHeight = parseInt(adWidth * 2 / 3);
              let adTop = Math.round(cc.view.getFrameSize().height - adHeight);

              if (VIVOGameBridge.QQGameBannerAd) {
                VIVOGameBridge.QQGameBannerAd.destroy();
              }

              setTimeout(function () {
                VIVOGameBridge.QQGameBannerAd = qg.createBannerAd({
                  posId: '4e57ebc2ea6a418fbf0ed4be801c3772',
                  style: {// left: adLeft,
                    // top: adTop,
                    // width: adWidth > 300 ? adWidth : 300,
                    // height: adHeight,
                  }
                }); // VIVOGameBridge.QQGameBannerAd.style.top = Math.round(cc.view.getFrameSize().height - (size.height));
                // VIVOGameBridge.QQGameBannerAd.style.left = Math.round((cc.view.getFrameSize().width - size.width) / 2);
                // console.log('Resize后正式宽高:', size.width, size.height, VIVOGameBridge.QQGameBannerAd.style.top, VIVOGameBridge.QQGameBannerAd.style.left);

                VIVOGameBridge.QQGameBannerAd.show().then(() => {
                  console.log('bannerAd show ok');
                }).catch(res => {
                  console.log('bannerAd show error', res);
                });
              }, 3000);
            },
            hideBannerAd: function () {
              if (VIVOGameBridge.QQGameBannerAd) {
                VIVOGameBridge.QQGameBannerAd.destroy();
              }
            },
            // showFeedAd: function (scene, adId, expressViewWidth, expressViewHeight,
            //     isBottom, margin, displayBackground) {
            //     //qiaopc todo
            //     let adTop = Math.round(cc.view.getFrameSize().height - (margin + expressViewHeight));
            //     let adLeft = Math.round((cc.view.getFrameSize().width - expressViewWidth) / 2);
            //     console.log("QQGameFeedAd->", adTop, "-", adLeft, "-", expressViewWidth, "-", expressViewHeight)
            //     VIVOGameBridge.QQGameFeedAd = qq.createBannerAd({
            //         adUnitId: '0bb6658fecbe4c37192011288a54365b',
            //         style: {
            //             left: adLeft,
            //             top: adTop,
            //             width: expressViewWidth > 300 ? expressViewWidth : 300,
            //             height: expressViewHeight,
            //         }
            //     });
            //     VIVOGameBridge.QQGameFeedAd.onResize(size => {
            //         console.log('Resize后正式宽高:', size.width, size.height);
            //         VIVOGameBridge.QQGameFeedAd.style.top = adTop;
            //         VIVOGameBridge.QQGameFeedAd.style.left = adLeft;
            //         VIVOGameBridge.QQGameFeedAd.show().then(() => {
            //             console.log('bannerAd show ok')
            //         }).catch((res) => {
            //             console.log('bannerAd show error', res)
            //         });
            //     });
            // },
            // hideFeedAd: function () {
            //     if (VIVOGameBridge.QQGameFeedAd) {
            //         VIVOGameBridge.QQGameFeedAd.destroy();
            //     }
            // },
            showBlockAd: function (callback) {
              //qiaopc todo
              if (!Global.QQGameEnv) return;
              VIVOGameBridge.QQGameBlockAdNeedClose = false;

              if (VIVOGameBridge.QQGameBlockAd) {
                VIVOGameBridge.QQGameBlockAd.destroy();
              }

              let expressViewWidth = 300;
              let expressViewHeight = 500;
              let adTop = cc.view.getFrameSize().height - parseInt(350 * cc.view.getFrameSize().height / cc.winSize.height);
              let adLeft = 10;
              console.log("QQGameshowBlockAd->", adTop, "-", adLeft, "-", expressViewWidth, "-", expressViewHeight);
              VIVOGameBridge.QQGameBlockAd = qq.createBlockAd({
                adUnitId: '16a963085b6bf9c35848b27c01527efe',
                size: 5,
                orientation: 'landscape',
                style: {
                  left: adLeft,
                  top: adTop
                }
              });
              VIVOGameBridge.QQGameBlockAd.onResize(size => {
                if (VIVOGameBridge.QQGameBlockAdNeedClose) {
                  return;
                }

                console.log('showBlockAd Resize后正式宽高:', size.width, size.height, size);
                VIVOGameBridge.QQGameBlockAd.style.top = adTop;
                VIVOGameBridge.QQGameBlockAd.style.left = adLeft;
                VIVOGameBridge.QQGameBlockAd.show().then(() => {
                  console.log('showBlockAd show ok');

                  if (typeof callback == "function") {
                    callback();
                  }
                }).catch(res => {
                  console.log('showBlockAd show error', res);
                });
              });
            },
            hideBlockAd: function () {
              if (!Global.QQGameEnv) return;
              VIVOGameBridge.QQGameBlockAdNeedClose = true;

              if (VIVOGameBridge.QQGameBlockAd) {
                VIVOGameBridge.QQGameBlockAd.destroy();
              }
            },
            showAppBox: function () {
              if (qg.createBoxPortalAd) {
                VIVOGameBridge.QQGameAppBox = qg.createBoxPortalAd({
                  posId: 'd00b5541f547434796d26637b8a6d05a',
                  image: '',
                  marginTop: 300
                });
                VIVOGameBridge.QQGameAppBox.onError(function (err) {
                  console.log("盒子九宫格广告加载失败", JSON.stringify(err));
                });
                VIVOGameBridge.QQGameAppBox.onClose(function () {
                  console.log('close');

                  if (boxPortalAd.isDestroyed) {
                    return;
                  } // 当九宫格关闭之后，再次展示Icon


                  VIVOGameBridge.QQGameAppBox.show();
                }); // 广告数据加载成功后展示

                VIVOGameBridge.QQGameAppBox.show().then(function () {
                  console.log('show success');
                });
              } else {
                console.log('暂不支持互推盒子相关 API');
              }
            },
            hideAppBox: function () {
              if (VIVOGameBridge.QQGameAppBox) {
                VIVOGameBridge.QQGameAppBox.isDestroyed = true;
                VIVOGameBridge.QQGameAppBox.destroy();
              }
            },
            hideAppBox: function () {
              if (VIVOGameBridge.QQGameAppBox) {
                VIVOGameBridge.QQGameAppBox.destroy();
              }
            },
            QQGameAdCloseHandler: function (res) {
              // 用户点击了【关闭广告】按钮
              if (res && res.isEnded || res === undefined) {
                // 正常播放结束，可以下发奖励
                console.log("QQad播放完毕");

                if (VIVOGameBridge.QQGameAdCurScene) {
                  Global.onRewardAdCallback(true, VIVOGameBridge.QQGameAdCurScene);
                }
              } else {
                //提前关闭小程序
                console.log("QQad提前关闭");

                if (VIVOGameBridge.QQGameAdCurScene) {
                  Global.onRewardAdCallback(false, VIVOGameBridge.QQGameAdCurScene);
                }
              }
            },
            QQGameInterstitialAdCloseHandler: function () {
              console.log("QQshowInterstitialAd->close");
              Global.onInterstitialAdDismissCallback(ConstValue.AdScene.XiGuaInterstitial);
            },
            QQGameInterstitialAdErrorHandler: function (e) {
              console.log("QQshowInterstitialAd->error", e);
              Global.onInterstitialAdDismissCallback(ConstValue.AdScene.XiGuaInterstitial);
            },
            QQGameInterstitialAdOnLoadHandler: function () {
              console.log('QQshowInterstitialAd->onLoad event emit');
              /* 建议放在需要展示插屏广告的时机执行 */

              VIVOGameBridge.QQGameInterstitialAd.show().catch(err => {
                console.error('QQshowInterstitialAd->show', err);
                Global.onInterstitialAdDismissCallback(ConstValue.AdScene.XiGuaInterstitial);
              });
            },
            showInterstitialAd: function () {
              if (!VIVOGameBridge.QQGameInterstitialAdInitComplete) {
                /* 建议放在onReady里执行，提前加载广告 */
                VIVOGameBridge.QQGameInterstitialAd = qg.createInterstitialAd({
                  posId: 'b55ed9d328ec4acc8d887d9e39812e16'
                });
                VIVOGameBridge.QQGameInterstitialAdInitComplete = true;
              } // InterstitialAd.load().catch((err) => {
              //       console.error('load',err)}
              //     )        
              // InterstitialAd.onLoad(() => {  
              //     console.log('onLoad event emit')
              //     InterstitialAd.show().catch((err) => {  console.error('show',err)})
              // })
              // InterstitialAd.onClose(() => {  console.log('close event emit')})      
              // InterstitialAd.onError((e) => {  console.log('error', e)})   

              /* 建议放在需要展示插屏广告的时机执行 */


              try {
                if (VIVOGameBridge.QQGameInterstitialAdCloseHandler) {
                  VIVOGameBridge.QQGameInterstitialAd.offClose(VIVOGameBridge.QQGameInterstitialAdCloseHandler);
                  console.log("---QQGameInterstitialAd.offClose 卸载成功---");
                }
              } catch (e) {
                console.log("---QQGameInterstitialAd.offClose 卸载失败---");
                console.error(e);
              }

              try {
                if (VIVOGameBridge.QQGameInterstitialAdErrorHandler) {
                  VIVOGameBridge.QQGameInterstitialAd.offError(VIVOGameBridge.QQGameInterstitialAdErrorHandler);
                  console.log("---QQGameInterstitialAd.offError 卸载成功---");
                }
              } catch (e) {
                console.log("---QQGameInterstitialAd.offError 卸载失败---");
                console.error(e);
              }

              try {
                if (VIVOGameBridge.QQGameInterstitialAdOnLoadHandler) {
                  VIVOGameBridge.QQGameInterstitialAd.offLoad(VIVOGameBridge.QQGameInterstitialAdOnLoadHandler);
                  console.log("---QQGameInterstitialAd.offLoad 卸载成功---");
                }
              } catch (e) {
                console.log("---QQGameInterstitialAd.offLoad 卸载失败---");
                console.error(e);
              }

              VIVOGameBridge.QQGameInterstitialAd.load().catch(err => {
                console.error('QQshowInterstitialAd->load', err);
                Global.onInterstitialAdDismissCallback(ConstValue.AdScene.XiGuaInterstitial);
              });
              VIVOGameBridge.QQGameInterstitialAd.onLoad(VIVOGameBridge.QQGameInterstitialAdOnLoadHandler);
              VIVOGameBridge.QQGameInterstitialAd.onClose(VIVOGameBridge.QQGameInterstitialAdCloseHandler);
              VIVOGameBridge.QQGameInterstitialAd.onError(VIVOGameBridge.QQGameInterstitialAdErrorHandler);
            },

            onClickShare(text) {
              canvas.toTempFilePath({
                x: 0,
                y: 1000,
                width: 1250,
                height: 1000,
                destWidth: 500,
                destHeight: 400,
                success: res => {
                  qq.shareAppMessage({
                    title: text ? text : '',
                    imageUrl: res.tempFilePath,

                    success(res) {
                      console.log("****转发成功!!!");
                    },

                    fail(res) {
                      console.log("****转发失败!!!");
                    }

                  });
                }
              });
            },

            addColorSign() {
              qq.addColorSign();
            },

            saveAppToDesktop() {
              qq.saveAppToDesktop();
            },

            customAd: null,

            showCustomAd(isbottom) {
              // 720*300
              // 高度 = 屏幕宽度 *300 /720
              // 屏幕高度 - 高度 - 按钮高度
              let adWidth = parseInt(cc.view.getFrameSize().width) * 3;
              let adHeight = parseInt(adWidth * 2 / 3);
              let adTop = Math.round(cc.view.getFrameSize().height - adHeight);
              let top = cc.view.getFrameSize().height * 3 - parseInt(adWidth * 300 / 720) - 200;
              console.log("vivo原生模板广告->top->", cc.view.getFrameSize().height, parseInt(adWidth * 300 / 720), adWidth, top);

              if (qg.createCustomAd) {
                console.log("vivo原生模板广告存在");

                if (isbottom) {
                  VIVOGameBridge.customAd = qg.createCustomAd({
                    posId: '9bc6c2385ae149a79535d3aafe807227'
                  });
                } else {
                  VIVOGameBridge.customAd = qg.createCustomAd({
                    posId: '9bc6c2385ae149a79535d3aafe807227',
                    style: {
                      left: 0,
                      top: top
                    }
                  });
                }

                VIVOGameBridge.customAd.onError(err => {
                  console.log("原生模板广告加载失败", err);
                });
                VIVOGameBridge.customAd.show().then(() => {
                  console.log('原生模板广告展示完成');
                }).catch(err => {
                  console.log('原生模板广告展示失败', JSON.stringify(err));
                });
              } else {
                console.log("vivo原生模板广告Api不存在");
              }
            },

            hideCustomAd() {
              if (VIVOGameBridge.customAd) {
                VIVOGameBridge.customAd.hide();
              }
            }

          };
          window.VIVOGameBridge = VIVOGameBridge;
        })();

        _cjsExports = exports('default', module.exports);
      });

      const __cjsMetaURL = exports('__cjsMetaURL', module.meta.url);
    }
  };
});

System.register("chunks:///_virtual/loadsh.ts", ['cc', './_rollupPluginModLoBabelHelpers.js'], function (exports) {
  'use strict';

  var cclegacy, _decorator, _defineProperty;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      _defineProperty = module.defineProperty;
    }],
    execute: function () {
      var _dec, _class, _class2, _temp;

      cclegacy._RF.push({}, "a40a4pGR6lCqo0coR1W4kAl", "loadsh", undefined);

      const {
        ccclass
      } = _decorator;
      let loadsh = exports('loadsh', (_dec = ccclass("loadsh"), _dec(_class = (_temp = _class2 = class loadsh {
        /* class member could be defined like this */
        // dummy = '';

        /**
         * 遍历 collection（集合）元素，返回 predicate（断言函数）第一个返回真值的第一个元素
         * @param  {any} collection 一个用来迭代的集合
         * @param {Function} predicate 每次迭代调用的函数。
         * @returns 返回匹配元素，否则返回 undefined。
         */
        static find(collection, predicate) {
          var result;

          if (!Array.isArray(collection)) {
            collection = loadsh._toArray(collection);
          }

          result = collection.filter(predicate);

          if (result.length) {
            return result[0];
          }

          return undefined;
        }
        /**
         * 调用 iteratee 遍历 collection(集合) 中的每个元素
         * @param  {any} collection 一个用来迭代的集合
         * @param {Function} iteratee 每次迭代调用的函数。
         */


        static forEach(collection, iteratee) {
          if (!Array.isArray(collection)) {
            var array = loadsh._toArrayKey(collection);

            array.forEach(function (value, index, arr) {
              var key1 = value['key'];
              var value1 = value['value'];
              iteratee(value1, key1, collection);
            });
          } else {
            collection.forEach(iteratee);
          }
        }
        /**
         * 深度拷贝
         * @param {any} sObj 拷贝的对象
         * @returns 
         */


        static cloneDeep(sObj) {
          if (sObj === null || typeof sObj !== "object") {
            return sObj;
          }

          let s = {};

          if (sObj.constructor === Array) {
            s = [];
          }

          for (let i in sObj) {
            if (sObj.hasOwnProperty(i)) {
              s[i] = loadsh.cloneDeep(sObj[i]);
            }
          }

          return s;
        }
        /**
         * 创建一个数组， value（值） 是 iteratee（迭代函数）遍历 collection（集合）中的每个元素后返回的结果。
         * @param {Array|Object} collection  一个用来迭代的集合.
         * @param {Function} predicate  一个迭代函数，用来转换key（键
         * @returns {Array} 返回一个组成集合数组
         */


        static map(collection, iteratee) {
          if (!Array.isArray(collection)) {
            collection = loadsh._toArray(collection);
          }

          let arr = [];
          collection.forEach(function (value, index, array) {
            arr.push(iteratee(value, index, array));
          });
          return arr;
        }
        /**
         * 
         * @param srcObj 
         * @returns 
         */


        static _toArrayKey(srcObj) {
          var resultArr = []; // to array

          for (var key in srcObj) {
            if (!srcObj.hasOwnProperty(key)) {
              continue;
            }

            resultArr.push({
              key: key,
              value: srcObj[key]
            });
          }

          return resultArr;
        }

        static _toArray(srcObj) {
          let resultArr = []; // to array

          for (var key in srcObj) {
            if (!srcObj.hasOwnProperty(key)) {
              continue;
            }

            resultArr.push(srcObj[key]);
          }

          return resultArr;
        }
        /**
         * 遍历 collection（集合）元素，返回 predicate（断言函数）返回真值 的所有元素的数组。
         * @param {Array|Object} collection  一个用来迭代的集合.
         * @param {Function} predicate  一个迭代函数，用来转换key（键
         * @returns 返回一个新的过滤后的数组。
         */


        static filter(collection, iteratees) {
          if (!Array.isArray(collection)) {
            collection = loadsh._toArray(collection);
          }

          return collection.filter(iteratees);
        }
        /**
         * 执行深比较来确定两者的值是否相等。
         * @param {any}x 
         * @param {any}y 
         * @returns {boolean} 如果 两个值完全相同，那么返回 true，否则返回 false。
         */


        static isEqual(x, y) {
          var in1 = x instanceof Object;
          var in2 = y instanceof Object;

          if (!in1 || !in2) {
            return x === y;
          }

          if (Object.keys(x).length !== Object.keys(y).length) {
            return false;
          }

          for (var p in x) {
            var a = x[p] instanceof Object;
            var b = y[p] instanceof Object;

            if (a && b) {
              return loadsh.isEqual(x[p], y[p]);
            } else if (x[p] !== y[p]) {
              return false;
            }
          }

          return true;
        }
        /**
         * 接收一个要移除值的数组。
         * @param {Array} array 修改的数组
         * @param {Array} value 移除值的数组
         * @param  {Function} comparator comparator（比较器）调用每个元素。
         * @returns 
         */


        static pullAllWith(array, value, comparator) {
          value.forEach(function (item) {
            var res = array.filter(function (n) {
              return comparator(n, item);
            });
            res.forEach(function (item) {
              var index = array.indexOf(item);

              if (array.indexOf(item) !== -1) {
                array.splice(index, 1);
              }
            });
          });
          return array;
        }
        /**
         * 返回当前时间戳
         * @returns 
         */


        static now() {
          return Date.now();
        }
        /**
         * 接收一个要移除值的数组。
         * @param {Array} array 修改的数组
         * @param {Array} value 移除值的数组
         * @returns 
         */


        static pullAll(array, value) {
          value.forEach(function (item) {
            var index = array.indexOf(item);

            if (array.indexOf(item) !== -1) {
              array.splice(index, 1);
            }
          });
          return array;
        }
        /**
         * 从右到左遍历集合中每一个元素的。
         * @param {Array|Object} collection  一个用来迭代的集合.
         * @param {Function} predicate  一个迭代函数
         */


        static forEachRight(collection, iteratee) {
          if (!Array.isArray(collection)) {
            collection = loadsh._toArray(collection);
          } //@ts-ignore


          for (var i = collection.length - 1; i >= 0; i--) {
            //@ts-ignore
            var ret = iteratee(collection[i]);
            if (!ret) break;
          }
        }
        /**
         * 检查字符串string是否以 target 开头。
         * @param {string} str 要检索的字符串。
         * @param {string}target  要检查的字符串。
         * @param {number}position 检索的位置。
         * @returns 
         */


        static startsWith(str, target, position) {
          str = str.substr(position);
          return str.startsWith(target);
        }
        /**
         * 检查字符串string是否以 target 结束。
         * @param {string} str 要检索的字符串。
         * @param {string}target  要检查的字符串。
         * @param {number}position 检索的位置。
         * @returns 
         */


        static endsWith(str, target, position) {
          str = str.substr(position);
          return str.endsWith(target);
        }
        /**
         * 移除数组中predicate（断言）返回为真值的所有元素
         * @param {Array} array  一个用来迭代的集合.
         * @param {Function} predicate  一个迭代函数
         * @returns 
         */


        static remove(array, predicate) {
          var result = [];
          var indexes = [];
          array.forEach(function (item, index) {
            if (predicate(item)) {
              result.push(item);
              indexes.push(index);
            }
          });

          loadsh._basePullAt(array, indexes);

          return result;
        }

        static _basePullAt(array, indexes) {
          var length = array ? indexes.length : 0;
          var lastIndex = length - 1;
          var previous;

          while (length--) {
            var index = indexes[length];

            if (length === lastIndex || index !== previous) {
              previous = index;
              Array.prototype.splice.call(array, index, 1);
            }
          }

          return array;
        }
        /**
         * 返回第一个通过 predicate 判断为真值的元素的索引值
         * @param {Array} array  一个用来迭代的集合.
         * @param {Function} predicate  一个迭代函数
         * @param {number} fromIndex 开始查找索引值
         * @returns 
         */


        static findIndex(array, predicate, fromIndex) {
          array = array.slice(fromIndex);
          var i;

          if (typeof predicate === "function") {
            for (i = 0; i < array.length; i++) {
              if (predicate(array[i])) {
                return i;
              }
            }
          } else if (Array.isArray(predicate)) {
            for (i = 0; i < array.length; i++) {
              var key = predicate[0];
              var vaule = true; //@ts-ignore

              if (predicate.length > 1) {
                vaule = predicate[1];
              }

              if (array[i][key] === vaule) {
                return i;
              }
            }
          } else {
            for (i = 0; i < array.length; i++) {
              if (array[i] === predicate) {
                return i;
              }
            }
          }

          return -1;
        }
        /**
         * 创建一个新数组，将array与任何数组 或 值连接在一起。
         * @returns 
         */


        static concat() {
          var length = arguments.length;

          if (!length) {
            return [];
          }

          var array = arguments[0];
          var index = 1;

          while (index < length) {
            array = array.concat(arguments[index]);
            index++;
          }

          return array;
        }
        /**
         * 检查 value 是否是原始Number数值型 或者 对象。
         * @param {any }value 
         * @returns 
         */


        static isNumber(value) {
          return typeof value === 'number';
        }
        /**
         * 返回首次 value 在数组array中被找到的 索引值
         * @param {Array}array 
         * @param {any}value 
         * @param {number} fromIndex 
         * @returns 
         */


        static indexOf(array, value, fromIndex) {
          array = array.slice(fromIndex);
          return array.indexOf(value);
        }
        /**
         * 将 array 中的所有元素转换为由 separator 分隔的字符串。
         * @param {any} array 要转换的数组
         * @param {string} separator 分隔元素。
         * @returns 
         */


        static join(array, separator) {
          if (array === null) return '';
          var result = '';
          array.forEach(function (item) {
            result += item + separator;
          });
          return result.substr(0, result.length - 1);
        }
        /**
         * 根据separator 拆分字符串string。
         * @param {string} str 要转换的数组
         * @param {RegExp|string} separator 分隔元素。
         * @param {number} limit 限制结果的数量。
         * @returns 
         */


        static split(str, separator, limit) {
          return str.split(separator, limit);
        }
        /**
         * 计算 array 中的最大值。 如果 array 是 空的或者假值将会返回 undefined。
         * @param {Array}array 
         * @returns 
         */


        static max(array) {
          if (array && array.length) {
            var result;

            for (var i = 0; i < array.length; i++) {
              if (i === 0) {
                result = array[0];
              } else if (result < array[i]) {
                result = array[i];
              }
            }

            return result;
          }

          return undefined;
        }
        /**
         * 创建一个切片数组，去除array前面的n个元素。（n默认值为1。）
         * @param {Array}array : 要查询的数组。
         * @param {number}n 要去除的元素个数。
         * @returns 
         */


        static drop(array, n) {
          var length = array === null ? 0 : array.length;

          if (!length) {
            return [];
          }

          return array.slice(n);
        }
        /**
         * 将array递归为一维数组。
         * @param {Array} arr 
         * @returns 
         */


        static flattenDeep(arr) {
          return arr.reduce(function (prev, cur) {
            return prev.concat(Array.isArray(cur) ? loadsh.flattenDeep(cur) : cur);
          }, []);
        }
        /**
         * 创建一个去重后的array数组副本。使用了SameValueZero 做等值比较。只有第一次出现的元素才会被保留。
         * @param {Array} array 
         * @returns 
         */


        static uniq(array) {
          let result = [];
          array.forEach(function (item) {
            if (result.indexOf(item) === -1) {
              result.push(item);
            }
          });
          return result;
        }
        /**
         * 检查 value 是否是 NaN。
         * @param {any}value 
         * @returns 
         */


        static isNaN(value) {
          // An `NaN` primitive is the only value that is not equal to itself.
          // Perform the `toStringTag` check first to avoid errors with some
          // ActiveX objects in IE.
          return loadsh.isNumber(value) && value !== +value;
        }
        /**
         * 将数组（array）拆分成多个 size 长度的区块，并将这些区块组成一个新数组
         * @param {Array}array 
         * @param {number}size 
         * @returns 
         */


        static chunk(array, size) {
          var length = array === null ? 0 : array.length;

          if (!length || size < 1) {
            return [];
          }

          var result = [];

          while (array.length > size) {
            result.push(array.slice(0, size));
            array = array.slice(size);
          }

          result.push(array);
          return result;
        }
        /**
         * 转换 value 为一个有限数字
         * @param {any} value 
         * @returns 
         */


        static toFinite(value) {
          var INFINITY = 1 / 0;
          var MAX_INTEGER = 1.7976931348623157e+308;

          if (!value) {
            return value === 0 ? value : 0;
          }

          value = Number(value);

          if (value === INFINITY || value === -INFINITY) {
            var sign = value < 0 ? -1 : 1;
            return sign * MAX_INTEGER;
          }

          return value === value ? value : 0;
        }
        /**
         * 判断是否为对象
         * @param {any}value  
         * @returns {boolean}
         */


        static isObject(value) {
          var type = typeof value;
          return value !== null && (type === 'object' || type === 'function');
        }
        /**
         * 
         * @param value 
         * @returns 
         */


        static isLength(value) {
          return typeof value === 'number' && value > -1 && value % 1 === 0 && value <= loadsh.MAX_SAFE_INTEGER;
        }

        static _isArrayLike(value) {
          return value !== null && loadsh.isLength(value.length)
          /*&& !isFunction(value)*/
          ;
        }
        /**
         * 返回数组总符合条件的最大值
         * @param {Array} array  一个用来迭代的集合.
         * @param {Function} predicate  一个迭代函数
         * @returns {Object} 返回最大值
         */


        static maxBy(array, predicate) {
          if (array && array.length) {
            var result;
            var objResult;

            for (var i = 0; i < array.length; i++) {
              if (i === 0) {
                result = predicate(array[0]);
                objResult = array[0];
              } else if (result < array[i]) {
                result = array[i];
                objResult = array[i];
              }
            }

            return objResult;
          }

          return undefined;
        }
        /**
         * 返回数组总符合条件的最小值
         * @param {Array} array  一个用来迭代的集合.
         * @param {Function} predicate  一个迭代函数
         * @returns {Object} 返回最小值
         */


        static minBy(array, predicate) {
          if (array && array.length) {
            let result;
            let objResult;

            for (var i = 0; i < array.length; i++) {
              if (i === 0) {
                result = predicate(array[0]);
                objResult = array[0];
              } else if (result > array[i]) {
                result = predicate(array[i]);
                objResult = array[i];
              }
            }

            return objResult;
          }

          return undefined;
        }
        /**
         * 返回复合迭代函数的总和
         * @param {Array|Object} collection  一个用来迭代的集合.
         * @param {Function} predicate  一个迭代函数
         * @returns {Object} 返回总和
         */


        static sumBy(collection, predicate) {
          let sum = 0;

          for (let key in collection) {
            //@ts-ignore
            sum += predicate(collection[key]);
          }

          return sum;
        }
        /**
         * 返回复合迭代函数的次数
         * @param {Array|Object} collection  一个用来迭代的集合.
         * @param {Function} predicate  一个迭代函数，用来转换key（键
         * @returns {Object} 返回一个组成集合对象
         */


        static countBy(collection, predicate) {
          let objRet = {};

          for (let key in collection) {
            let value = predicate(key);

            if (objRet.hasOwnProperty(value)) {
              objRet[value] += 1;
            } else {
              objRet[value] = 1;
            }
          }

          return objRet;
        }
        /**
         * 取随机数
         * @param min 
         * @param max 
         * @returns 
         */


        static random(min, max) {
          var r = Math.random();
          var rr = r * (max - min + 1) + min;
          return Math.floor(rr);
        }

      }, _defineProperty(_class2, "MAX_SAFE_INTEGER", 9007199254740991), _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/fightScene.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './constants.ts', './clientEvent.ts', './localConfig.ts', './playerData.ts', './loadsh.ts', './uiManager.ts', './audioManager.ts', './PlatformBridge.js', './PlatformBridge.mjs_cjs=&original=.js', './gameLogic.ts', './ConstValue.js', './ConstValue.mjs_cjs=&original=.js', './linkContent.ts', './effectGroup.ts', './fightUI.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, view, profiler, UITransform, Rect, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, constants, clientEvent, localConfig, playerData, loadsh, uiManager, AudioManager, _cjsExports, GameLogic, _cjsExports$1, LinkContent, EffectGroup, FightUI;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      view = module.view;
      profiler = module.profiler;
      UITransform = module.UITransform;
      Rect = module.Rect;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      clientEvent = module.clientEvent;
    }, function (module) {
      localConfig = module.localConfig;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      loadsh = module.loadsh;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      AudioManager = module.AudioManager;
    }, function (module) {
      _cjsExports = module.default;
    }, null, function (module) {
      GameLogic = module.GameLogic;
    }, function (module) {
      _cjsExports$1 = module.default;
    }, null, function (module) {
      LinkContent = module.LinkContent;
    }, function (module) {
      EffectGroup = module.EffectGroup;
    }, function (module) {
      FightUI = module.FightUI;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp;

      cclegacy._RF.push({}, "aa4e3RbxGxHyqBA31aqKi9Q", "fightScene", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let FightScene = exports('FightScene', (_dec = ccclass('FightScene'), _dec(_class = (_class2 = (_temp = class FightScene extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "nodeLinkContent", _descriptor, this);

          _initializerDefineProperty(this, "nodeFightUI", _descriptor2, this);

          _initializerDefineProperty(this, "nodeEffectGroup", _descriptor3, this);

          _defineProperty(this, "linkContent", void 0);

          _defineProperty(this, "fightUI", void 0);

          _defineProperty(this, "effectGroup", void 0);

          _defineProperty(this, "isLevelOver", void 0);

          _defineProperty(this, "spareStar", void 0);

          _defineProperty(this, "allFlyFinishCb", void 0);

          _defineProperty(this, "reliveByAd", void 0);

          _defineProperty(this, "isLevelStart", void 0);

          _defineProperty(this, "dictPropsUseTimes", void 0);

          _defineProperty(this, "isShowOperationUI", void 0);

          _defineProperty(this, "bottomBannerAd", void 0);
        }

        onLoad() {
          this.showBannerAd();
        }

        showBannerAd() {
          console.log("showbannerad--2");
          let adWidth = Math.round(720 * view.getFrameSize().width / view.getVisibleSize().width);
          let adHeight = Math.round(adWidth * 90 / 600);
          let adBottomMargin = 0;
          console.log("BannerAd->", adWidth, ",", adHeight, ",", adBottomMargin);

          this.bottomBannerAd = function () {
            _cjsExports.showBannerAd(_cjsExports$1.AdScene.GameScene, _cjsExports$1.getAdBannerBig(), adWidth, adHeight, true, adBottomMargin, false);
          };

          if (Global.VIVOQuickGameEnv) {
            _cjsExports.showBannerAd(_cjsExports$1.AdScene.GameScene, _cjsExports$1.getAdBannerBig(), adWidth, adHeight, true, adBottomMargin, false);
          }

          this.refreshBannerAdSchedule();
        }

        refreshBannerAdSchedule() {
          if (Global.VIVOQuickGameEnv) {
            return;
          }

          let adWidth = Math.round(720 * view.getFrameSize().width / view.getVisibleSize().width);
          let adHeight = Math.round(adWidth * 90 / 600);
          let adBottomMargin = 0;
          console.log("BannerAd->", adWidth, ",", adHeight, ",", adBottomMargin);

          _cjsExports.showBannerAd(_cjsExports$1.AdScene.GameScene, _cjsExports$1.getAdBannerBig(), adWidth, adHeight, true, adBottomMargin, false);

          this.unschedule(this.bottomBannerAd);
          this.schedule(this.bottomBannerAd, 35);
        }

        onDestroy() {
          _cjsExports.hideBannerAd();
        }

        start() {
          profiler.hideStats();
          playerData.instance.startNewLevel();
          this.linkContent = this.nodeLinkContent.getComponent(LinkContent);
          this.fightUI = this.nodeFightUI.getComponent(FightUI);
          this.effectGroup = this.nodeEffectGroup.getComponent(EffectGroup);
          this.effectGroup.show(this);
          this.onNewLevel();
          AudioManager.instance.stop(constants.AUDIO_MUSIC.BACKGROUND);
          AudioManager.instance.playMusic(constants.AUDIO_MUSIC.FIGHT, true);
        }

        onEnable() {
          clientEvent.on('levelFinished', this.onLevelFinished, this);
          clientEvent.on('gameOver', this.onGameOver, this);
          clientEvent.on('newLevel', this.onNewLevel, this);
          clientEvent.on('useProp', this.useProp, this);
        }

        onDisable() {
          clientEvent.off('levelFinished', this.onLevelFinished, this);
          clientEvent.off('gameOver', this.onGameOver, this);
          clientEvent.off('newLevel', this.onNewLevel, this);
          clientEvent.off('useProp', this.useProp, this);
          AudioManager.instance.stop(constants.AUDIO_MUSIC.FIGHT); // AudioManager.instance.playMusic(constants.AUDIO_MUSIC.BACKGROUND, true);
        }

        onLevelFinished() {
          this.isLevelOver = true;

          if (playerData.instance.spareStep > 0 && !playerData.instance.curLevelInfo.infinite) {
            this.showBonusTime(() => {
              let step = playerData.instance.spareStep;
              this.spareStar = step;

              if (step > 0) {
                this.allFlyFinishCb = this.triggerAllSpecialEffect;

                for (let idx = 0; idx < step; idx++) {
                  this.scheduleOnce(() => {
                    playerData.instance.reduceStep();
                    clientEvent.dispatchEvent('updateStep');
                    let srcWorldPos = this.fightUI.getStepWorldPos();
                    let rand = loadsh.random(0, 1);
                    let effect = rand ? constants.SPECIAL_EFFECT.HORIZONTAL : constants.SPECIAL_EFFECT.VERTICAL;
                    this.effectGroup.showStarAfterLevelFinished(srcWorldPos, effect, this.showFlyEffectOver, this);
                  }, idx * 0.2);
                }
              } else {
                this.triggerAllSpecialEffect();
              }
            });
          } else {
            this.triggerAllSpecialEffect();
          }
        }

        showBonusTime(callback) {
          AudioManager.instance.playSound(constants.AUDIO_SOUND.BONUS_TIME, false);
          this.scheduleOnce(() => {
            this.effectGroup.showBonusTime(() => {
              this.linkContent.showLinkFinishEffect(callback);
            });
          }, 0.2);
        }

        onGameOver() {
          if (this.isLevelOver) {
            return;
          }

          this.isLevelOver = true;

          if (this.reliveByAd) {
            this.showGameOverUI();
          } else {
            this.reliveByAd = true;
            uiManager.instance.showDialog('fight/adStep', [err => {
              if (!err) {
                playerData.instance.addStep(5);
                this.isLevelOver = false;
                clientEvent.dispatchEvent('updateStep', false);
              } else {
                this.showGameOverUI();
              }
            }]);
          }
        }

        showGameOverUI() {
          uiManager.instance.showDialog("fight/balanceFailed");
        }

        onNewLevel() {
          this.isLevelStart = false; //等弹窗结束后在确定是否开始

          this.isLevelOver = false;
          this.reliveByAd = false; //步数用完时可通过让玩家选择是否要通过广告增加步数，仅能使用一次

          this.dictPropsUseTimes = {}; //道具使用次数

          this.effectGroup.removeLastEffect(); //删除上一关卡特效

          if (this.linkContent.dictCakes) {
            this.linkContent.showAllLinkItem(false, () => {
              this.linkContent.show(this);
              this.fightUI.show(this);

              if (playerData.instance.isNeedOpenUnlockPanel()) {
                uiManager.instance.showDialog('fight/unLockProp', [this.showTargets.bind(this), this.fightUI]);
              } else {
                this.showTargets();
              }
            });
          } else {
            this.linkContent.show(this);
            this.fightUI.show(this);

            if (playerData.instance.hasSeenGuide()) {
              if (playerData.instance.isNeedOpenUnlockPanel()) {
                uiManager.instance.showDialog('fight/unLockProp', [this.showTargets.bind(this), this.fightUI]);
              } else {
                this.showTargets();
              }
            } else {
              uiManager.instance.showDialog('fight/fightGuide', [() => {
                playerData.instance.finishSeenGuide();

                if (playerData.instance.isNeedOpenUnlockPanel()) {
                  uiManager.instance.showDialog('fight/unLockProp', [this.showTargets.bind(this) // this.fightUI
                  ]);
                } else {
                  this.showTargets();
                }
              }]);
            }
          }

          this.linkContent.stopGuideHand();
        }

        showTargets() {
          this.fightUI.showTargetsAni(() => {
            this.showAdRewardAsk();
            this.isLevelStart = true;
          });
        }

        showAdRewardAsk() {
          if (playerData.instance.level > 3) {
            uiManager.instance.showDialog('fight/adProp', [err => {
              if (!err) {
                this.showAdRewardOver(true);
              } else {
                this.showAdRewardOver(false);
              }
            }]);
          } else {
            this.showAdRewardOver(false);
          }
        }

        showAdRewardOver(isReward) {
          if (isReward) {
            this.spareStar = 2;
            this.allFlyFinishCb = null;

            for (let idx = 0; idx < 2; idx++) {
              this.scheduleOnce(() => {
                let srcWorldPos = this.fightUI.getStepWorldPos();
                let rand = loadsh.random(0, 1);
                let effect = rand ? constants.SPECIAL_EFFECT.HORIZONTAL : constants.SPECIAL_EFFECT.VERTICAL;
                this.effectGroup.showStarAfterLevelFinished(srcWorldPos, effect, this.showFlyEffectOver, this);
              }, idx * 0.2);
            }
          }
        }

        showFlyEffect(dictGenerator, callback) {
          this.allFlyFinishCb = callback;
          this.spareStar = 0;

          for (let index in dictGenerator) {
            let srcWorldPos = this.linkContent.getItemWorldPosByIndex(index);
            this.spareStar++;
            this.effectGroup.showStarFlyEffect(srcWorldPos, dictGenerator[index], this.showFlyEffectOver, this);
          }
        }

        showFlyEffectOver(error, idxTarget, effectType) {
          this.spareStar--;

          if (error) {
            return;
          }

          this.spareStar = this.spareStar < 0 ? 0 : this.spareStar;
          this.linkContent.addEffect(idxTarget, effectType);

          if (this.spareStar === 0) {
            if (this.allFlyFinishCb) {
              this.allFlyFinishCb();
            }
          }
        }

        triggerAllSpecialEffect() {
          this.linkContent.triggerAllSpecialEffect(() => {
            this.scheduleOnce(() => {
              this.linkContent.fillEmptyCell();
            }, 0.3);
            this.scheduleOnce(() => {
              if (!playerData.instance.balanceOverAdTimes) {
                playerData.instance.balanceOverAdTimes = 1;
              }

              playerData.instance.balanceOverAdTimes++;

              if (playerData.instance.balanceOverAdTimes > 2) {
                GameLogic.instance.showInterStitialAd(dataObj => {
                  uiManager.instance.showDialog("fight/balance");
                });
                playerData.instance.balanceOverAdTimes = 1;
              } else {
                uiManager.instance.showDialog("fight/balance");
              }
            }, 2);
          });
        }

        getLinkContentRect() {
          let pos = this.nodeLinkContent.position;
          const uiTra = this.nodeLinkContent.getComponent(UITransform);
          return new Rect(pos.x, pos.y, uiTra.width, uiTra.height);
        }

        isPropCanUse(propId) {
          let prop = localConfig.instance.queryByID('prop', propId);

          if (prop) {
            if (this.dictPropsUseTimes.hasOwnProperty(propId)) {
              let times = this.dictPropsUseTimes[propId];

              if (times >= prop.limit) {
                return false;
              }
            }

            return true;
          }

          return true;
        }

        showPropOperationUI(prop, posWorld) {
          this.linkContent.stopGuideHand();
          this.isShowOperationUI = true;
          uiManager.instance.showDialog('fight/fightPropsOperation', [prop, posWorld, this.getLinkContentRect(), this, () => {
            this.isShowOperationUI = false;
          }]);
        }

        useProp(propId, triggerIndex) {
          switch (propId) {
            case constants.PROP_ID.HAMMER:
              if (!triggerIndex || triggerIndex < 0) {
                return;
              }

              this.linkContent.destoryCake(triggerIndex);
              break;

            case constants.PROP_ID.MAGIC:
              if (!triggerIndex || triggerIndex < 0) {
                return;
              }

              let srcWorldPos = this.fightUI.getStepWorldPos();
              this.spareStar = 1;
              let rand = loadsh.random(0, 1);
              let effect = rand ? constants.SPECIAL_EFFECT.HORIZONTAL : constants.SPECIAL_EFFECT.VERTICAL;
              this.allFlyFinishCb = null;
              this.effectGroup.showStarAfterLevelFinished(srcWorldPos, effect, this.showFlyEffectOver, this, triggerIndex);
              break;

            case constants.PROP_ID.REFRESH:
              this.linkContent.stopGuideHand();

              if (!this.linkContent.refreshLinkItems()) {
                return;
              }

              break;

            case constants.PROP_ID.INFINITE:
              playerData.instance.curLevelInfo.infinite = true;
              this.fightUI.showInfinite();
              break;
          }

          if (this.dictPropsUseTimes.hasOwnProperty(propId)) {
            this.dictPropsUseTimes[propId]++;
          } else {
            this.dictPropsUseTimes[propId] = 1;
          }

          playerData.instance.costProp(propId);
          clientEvent.dispatchEvent('updateProp', propId);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "nodeLinkContent", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "nodeFightUI", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "nodeEffectGroup", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/constant.ts", ['cc', './_rollupPluginModLoBabelHelpers.js'], function (exports) {
  'use strict';

  var cclegacy, _defineProperty;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }, function (module) {
      _defineProperty = module.defineProperty;
    }],
    execute: function () {
      cclegacy._RF.push({}, "b08f08kiOlEA7e6qUWa7AnA", "constant", undefined);

      class constant {}

      exports('constant', constant);

      _defineProperty(constant, "GAME_NAME", 'template');

      _defineProperty(constant, "GAME_VERSION", '1.0.1');

      _defineProperty(constant, "GAME_FRAME", 60);

      _defineProperty(constant, "GAME_INIT_FRAME", 60);

      _defineProperty(constant, "LOCAL_CACHE", {
        PLAYER: 'player',
        //玩家基础数据缓存，如金币砖石等信息，暂时由客户端存储，后续改由服务端管理
        SETTINGS: 'settings',
        //设置相关，所有杂项都丢里面进去
        DATA_VERSION: 'dataVersion',
        //数据版本
        ACCOUNT: 'account',
        //玩家账号
        // TMP_DATA: 'tmpData',             //临时数据，不会存储到云盘
        HISTORY: "history",
        //关卡通关数据
        BAG: "bag" //玩家背包，即道具列表，字典类型

      });

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/PlatformBridge.js", ['./cjs-loader.mjs'], function (exports, module) {
  'use strict';

  var loader;
  return {
    setters: [function (module) {
      loader = module.default;
    }],
    execute: function () {
      exports('default', void 0);

      let _cjsExports;

      loader.define(module.meta.url, function (exports$1, _require, module, __filename, __dirname) {
        let require = loader.createRequireWithReqMap({
          "./PlatformBridge": __cjsMetaURL
        }, _require);

        (function () {
          const PlatformBridge = require("./PlatformBridge");

          const JAVA_CLASS = "com/smart/game/cocos2dx/bridge/JavaScriptToJavaBridge";
          const NATIVE_OC_CLASS = "JavaScriptToObjectC"; //const WeChatWebBridge = require("WeChatWebBridge");
          //const WeChatGameBridge = require("WeChatGameBridge");

          module.exports.initCocosSuccess = function () {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "initCocosSuccess", "()V");
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
              jsb.reflection.callStaticMethod(NATIVE_OC_CLASS, "initCocosSuccess");
            }
          };
          /**
           * @param {String} scene 场景 
           */


          module.exports.authFromWeixin = function (scene) {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "authFromWeixin", "(Ljava/lang/String;)V", scene);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
              jsb.reflection.callStaticMethod(NATIVE_OC_CLASS, "authFromWeixin:", scene);
            } else if (cc.sys.isBrowser) {
              WeChatWebBridge.openWXAuthorize();
            }
          };
          /**
           * 
           * @param {String} eventId 
           */


          module.exports.onEvent = function (eventId) {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "onEvent", "(Ljava/lang/String;)V", eventId);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
              jsb.reflection.callStaticMethod(NATIVE_OC_CLASS, "onEvent:", eventId);
            }

            if (cc.sys.isBrowser) {
              try {
                if (_czc) {
                  _czc.push(["_trackEvent", eventId, "ok", "", 1, ""]);

                  console.log("onEvent->:", eventId, "");
                } else {
                  console.log("onEvent-error->: [_CZC not define in CocosCreator]");
                }
              } catch (e) {
                console.log("onEvent-error->: [_CZC not define in CocosCreator]");
              }
            }
          };
          /**
           * 
           * @param {String} eventId 
           * @param {String} label 
           */


          module.exports.onEventLabel = function (eventId, label) {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "onEvent", "(Ljava/lang/String;Ljava/lang/String;)V", eventId, label);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
              jsb.reflection.callStaticMethod(NATIVE_OC_CLASS, "onEvent::", eventId, label);
            }

            if (cc.sys.isBrowser) {
              try {
                if (_czc) {
                  _czc.push(["_trackEvent", eventId, "ok", label, 1, ""]);

                  console.log("onEvent->:", eventId, label);
                } else {
                  console.log("onEvent-error->: [_CZC not define in CocosCreator]");
                }
              } catch (e) {
                console.log("onEvent-error->: [_CZC not define in CocosCreator]");
              }
            }
          };
          /**
           * 
           * @param {String} eventId 
           * @param {String} values 
           */


          module.exports.onEventMap = function (eventId, values) {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "onEventMap", "(Ljava/lang/String;Ljava/lang/String;)V", eventId, values);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
              jsb.reflection.callStaticMethod(NATIVE_OC_CLASS, "onEventMap::", eventId, values);
            }
          };
          /**
           * 
           * @param {String} eventId 
           * @param {String} mapString 
           * @param {Number} value 
           */


          module.exports.onEventValue = function (eventId, mapString, value) {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "onEventValue", "(Ljava/lang/String;Ljava/lang/String;I)V", eventId, mapString, value);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
              jsb.reflection.callStaticMethod(NATIVE_OC_CLASS, "onEventValue:::", eventId, mapString, value);
            }

            if (cc.sys.isBrowser) {
              try {
                if (_czc) {
                  _czc.push(["_trackEvent", eventId, "ok", mapString, value, ""]);

                  console.log("onEvent->:", eventId, "-", mapString, "-", value);
                } else {
                  console.log("onEvent-error->: [_CZC not define in CocosCreator]");
                }
              } catch (error) {
                console.log("onEvent-error->: [_CZC not define in CocosCreator]");
              }
            }
          };
          /**
           * 
           * @param {String} scene 
           * @param {String} adId 
           */


          module.exports.showCustomAd = function (adTop) {
            console.log("showCustomAd");

            if (cc.sys.isBrowser) {
              return;
            }

            if (cc.sys.platform == cc.sys.ANDROID) ;else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && !Global.QQGameEnv) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && Global.QQGameEnv) ;else if (Global.OPPOQuickGameEnv) {
              return OPPOGameBridge.showCustomAd(adTop);
            } else if (Global.VIVOQuickGameEnv) ;
          };

          module.exports.showCustomAd = function (isBottom) {
            if (Global.VIVOQuickGameEnv) {
              return VIVOGameBridge.showCustomAd(isBottom);
            }
          };

          module.exports.hideCustomAd = function () {
            if (Global.VIVOQuickGameEnv) {
              return VIVOGameBridge.hideCustomAd();
            }
          };
          /**
           * 
           * @param {String} scene 
           * @param {String} adId 
           */


          module.exports.showNativeAd = function (callback) {
            console.log("showNativeAd");

            if (cc.sys.isBrowser) {
              return;
            }

            if (cc.sys.platform == cc.sys.ANDROID) ;else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && !Global.QQGameEnv) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && Global.QQGameEnv) ;else if (Global.OPPOQuickGameEnv) {
              return OPPOGameBridge.showNativeAdBig(callback);
            } else if (Global.VIVOQuickGameEnv) ;
          };

          module.exports.onClickNativeAdClose = function () {
            console.log("showNativeAd");
            if (cc.sys.platform == cc.sys.ANDROID) ;else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && !Global.QQGameEnv) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && Global.QQGameEnv) ;else if (Global.OPPOQuickGameEnv) {
              return OPPOGameBridge.hideNativeAdBig();
            } else if (Global.VIVOQuickGameEnv) ;
          };

          module.exports.onClickNativeAdOpen = function () {
            console.log("showNativeAd");
            if (cc.sys.platform == cc.sys.ANDROID) ;else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && !Global.QQGameEnv) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && Global.QQGameEnv) ;else if (Global.OPPOQuickGameEnv) {
              return OPPOGameBridge.onClickNativeAdBig();
            } else if (Global.VIVOQuickGameEnv) ;
          };
          /**
           * 
           * @param {String} scene 
           * @param {String} adId 
           */


          module.exports.showNativeIconAd = function (callback) {
            console.log("showNativeAd");

            if (cc.sys.isBrowser) {
              return;
            }

            if (cc.sys.platform == cc.sys.ANDROID) ;else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && !Global.QQGameEnv) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && Global.QQGameEnv) ;else if (Global.OPPOQuickGameEnv) {
              return OPPOGameBridge.showNativeAdIcon(callback);
            } else if (Global.VIVOQuickGameEnv) ;
          };

          module.exports.onClickNativeAdIconClose = function () {
            console.log("showNativeAd");
            if (cc.sys.platform == cc.sys.ANDROID) ;else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && !Global.QQGameEnv) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && Global.QQGameEnv) ;else if (Global.OPPOQuickGameEnv) {
              return OPPOGameBridge.hideNativeAdIcon();
            } else if (Global.VIVOQuickGameEnv) ;
          };

          module.exports.onClickNativeAdIconOpen = function () {
            console.log("showNativeAd");
            if (cc.sys.platform == cc.sys.ANDROID) ;else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && !Global.QQGameEnv) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && Global.QQGameEnv) ;else if (Global.OPPOQuickGameEnv) {
              return OPPOGameBridge.onClickNativeAdIcon();
            } else if (Global.VIVOQuickGameEnv) ;
          };
          /**
           * 
           * @param {String} scene 
           * @param {String} fromId 
           * @param {String} adId 
           */


          module.exports.showRewardAd = function (scene, fromId, adId) {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "showRewardAd", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V", scene, fromId, adId);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
              jsb.reflection.callStaticMethod(NATIVE_OC_CLASS, "showRewardAd:::", scene, fromId, adId);
            } else if (cc.sys.platform == cc.sys.WECHAT_GAME && !Global.QQGameEnv) {
              Toast("广告正在路上", {
                gravity: "BOTTOM"
              });
              Global.onRewardAdCallback(false, scene);
            } else if (cc.sys.platform == cc.sys.WECHAT_GAME && Global.QQGameEnv) {
              QQGameBridge.showRewardAd(scene, fromId, adId);
            } else if (Global.OPPOQuickGameEnv) {
              OPPOGameBridge.showRewardAd(scene, fromId, adId);
            } else if (Global.VIVOQuickGameEnv) {
              VIVOGameBridge.showRewardAd(scene, fromId, adId);
            }

            if (cc.sys.isBrowser) {
              Global.onRewardAdCallback(true, scene);
              return;
            }
          };
          /**
           * 
           * @param {String} scene 
           * @param {String} adId 
           */


          module.exports.showBannerAd = function (scene, adId, expressViewWidth, expressViewHeight, isBottom, margin, displayBackground) {
            console.log("showbannerad", scene, adId);

            if (Global.XIAOMIGameEnv) {
              let temp = window.performance.now() + 60 * 2 * 1000 - PlatformBridge.interstitialAdCloseLastTime;

              if (temp < 60 * 2 * 1000) {
                console.log("插屏需要2分钟间隔:", temp);
                return;
              }

              PlatformBridge.interstitialAdIsShowing = true;
            }

            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "showBannerAd", "(Ljava/lang/String;Ljava/lang/String;IIZIZ)V", scene, adId, expressViewWidth, expressViewHeight, isBottom, margin, displayBackground);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
              jsb.reflection.callStaticMethod(NATIVE_OC_CLASS, "showBannerAd::", scene, adId, expressViewWidth, expressViewHeight, isBottom, margin, displayBackground);
            } else if (cc.sys.platform == cc.sys.WECHAT_GAME && !Global.QQGameEnv) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && Global.QQGameEnv) {
              QQGameBridge.showBannerAd(scene, adId, expressViewWidth, expressViewHeight, isBottom, margin, displayBackground);
            } else if (Global.OPPOQuickGameEnv) {
              OPPOGameBridge.showBannerAd(scene, adId, expressViewWidth, expressViewHeight, isBottom, margin, displayBackground);
            } else if (Global.VIVOQuickGameEnv) {
              VIVOGameBridge.showBannerAd(scene, adId, expressViewWidth, expressViewHeight, isBottom, margin, displayBackground);
            }

            if (cc.sys.isBrowser) {
              try {
                let adId;

                if (expressViewHeight < Math.round(expressViewWidth * 200 / 600)) {
                  adId = window.SSUIVideoBannerS;
                  window.webplusNativeBridge.showBannerAd(scene, scene, adId, window.AD_BOTTOM_FLOAT_PLACEMENT, 0, 5000, expressViewHeight);
                } else {
                  adId = window.SSUIVideoBannerM; // window.webplusNativeBridge.showFeedAd(scene, scene, adId, window.AD_BOTTOM_FLOAT_PLACEMENT, 0, expressViewWidth, expressViewHeight);

                  window.webplusNativeBridge.showBannerAd(scene, scene, adId, window.AD_BOTTOM_FLOAT_PLACEMENT, 0, 5000, expressViewHeight);
                }

                PlatformBridge.onEventLabel("ShowBannerAd", adId);
              } catch (e) {
                console.log("showBannerAd-error->: " + e);
              }
            }
          }; // 上次关闭插屏广告的时间


          module.exports.interstitialAdCloseLastTime = 0, module.exports.interstitialAdIsShowing = false, module.exports.hideBannerAd = function () {
            if (PlatformBridge.interstitialAdIsShowing) {
              PlatformBridge.interstitialAdCloseLastTime = window.performance.now() + 60 * 2 * 1000;
              PlatformBridge.interstitialAdIsShowing = false;
            }

            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "hideBannerAd", "()V");
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
              jsb.reflection.callStaticMethod(NATIVE_OC_CLASS, "hideBannerAd");
            } else if (cc.sys.platform == cc.sys.WECHAT_GAME && !Global.QQGameEnv) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && Global.QQGameEnv) {
              QQGameBridge.hideBannerAd();
            } else if (Global.OPPOQuickGameEnv) {
              OPPOGameBridge.hideBannerAd();
            } else if (Global.VIVOQuickGameEnv) ;

            if (cc.sys.isBrowser) {
              window.webplusNativeBridge.closeBannerOrFeedAd(window.AD_BOTTOM_FLOAT_PLACEMENT);
            }
          };

          module.exports.dismissBannerAdCallback = function (scene) {
            console.log("dismissBannerAdCallback");

            if (PlatformBridge.interstitialAdIsShowing) {
              PlatformBridge.interstitialAdCloseLastTime = window.performance.now() + 60 * 2 * 1000;
              PlatformBridge.interstitialAdIsShowing = false;
            }
          };

          module.exports.prepareBannerAd = function (scene, adId, expressViewWidth, expressViewHeight, displayBackground) {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "prepareBannerAd", "(Ljava/lang/String;Ljava/lang/String;IIZ)V", scene, adId, expressViewWidth, expressViewHeight, displayBackground);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
              jsb.reflection.callStaticMethod(NATIVE_OC_CLASS, "prepareBannerAd::", scene, adId, expressViewWidth, expressViewHeight, displayBackground);
            } else if (cc.sys.platform == cc.sys.WECHAT_GAME) ;
          };

          module.exports.prepareInterstitialAd = function (scene, adId, expressViewWidth, expressViewHeight, displayBackground) {
            console.log('platformbridge->prepareInterstitialAd:');

            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "prepareInterstitialAd", "(Ljava/lang/String;Ljava/lang/String;II)V", scene, adId, expressViewWidth, expressViewHeight);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
              jsb.reflection.callStaticMethod(NATIVE_OC_CLASS, "prepareInterstitialAd::", scene, adId, expressViewWidth, expressViewHeight, displayBackground);
            } else if (cc.sys.platform == cc.sys.WECHAT_GAME) ;
          };

          module.exports.prepareFeedAd = function (scene, adId, expressViewWidth, expressViewHeight, displayBackground) {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "prepareFeedAd", "(Ljava/lang/String;Ljava/lang/String;IIZ)V", scene, adId, expressViewWidth, expressViewHeight, displayBackground);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
              jsb.reflection.callStaticMethod(NATIVE_OC_CLASS, "prepareFeedAd::", scene, adId, expressViewWidth, expressViewHeight, displayBackground);
            } else if (cc.sys.platform == cc.sys.WECHAT_GAME) ;
          };
          /**
           * 
           * @param {String} scene 
           * @param {String} adId 
           */


          module.exports.showFeedAd = function (scene, adId, expressViewWidth, expressViewHeight, isBottom, margin, displayBackground) {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "showFeedAd", "(Ljava/lang/String;Ljava/lang/String;IIZIZ)V", scene, adId, expressViewWidth, expressViewHeight, isBottom, margin, displayBackground);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
              jsb.reflection.callStaticMethod(NATIVE_OC_CLASS, "showFeedAd::", scene, adId, expressViewWidth, expressViewHeight, isBottom, margin, displayBackground);
            } else if (cc.sys.platform == cc.sys.WECHAT_GAME && !Global.QQGameEnv) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && Global.QQGameEnv) {
              QQGameBridge.showFeedAd(scene, adId, expressViewWidth, expressViewHeight, isBottom, margin, displayBackground);
            }
          };

          module.exports.hideFeedAd = function () {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "hideFeedAd", "()V");
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
              jsb.reflection.callStaticMethod(NATIVE_OC_CLASS, "hideFeedAd");
            } else if (cc.sys.platform == cc.sys.WECHAT_GAME && !Global.QQGameEnv) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && Global.QQGameEnv) {
              QQGameBridge.hideFeedAd();
            }
          }; //积木广告


          module.exports.showBlockAd = function (callback) {
            if (cc.sys.platform == cc.sys.ANDROID) ;else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && !Global.QQGameEnv) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && Global.QQGameEnv) {
              QQGameBridge.showBlockAd(callback);
            }
          }; //oppo 超休闲专区


          module.exports.jumpLeisureSubject = function () {
            if (cc.sys.platform == cc.sys.ANDROID) {
              if (Global.OPPOGameEnv) {
                console.log("oppogameenv->jumpLeisureSubject");
                jsb.reflection.callStaticMethod(JAVA_CLASS, "jumpLeisureSubject", "()V");
              }
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && !Global.QQGameEnv) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && Global.QQGameEnv) ;
          };

          module.exports.hideBlockAd = function () {
            if (cc.sys.platform == cc.sys.ANDROID) ;else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && !Global.QQGameEnv) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && Global.QQGameEnv) {
              QQGameBridge.hideBlockAd();
            }
          };
          /**
           * Android 1.4.2(1040200)及以后版本支持
           * @param {String} scene 
           * @param {String} adId 
           */


          module.exports.showSplashAd = function (scene, adId) {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "showSplashAd", "(Ljava/lang/String;Ljava/lang/String;)V", scene, adId);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
              jsb.reflection.callStaticMethod(NATIVE_OC_CLASS, "showSplashAd::", scene, adId);
            } else if (cc.sys.platform == cc.sys.WECHAT_GAME) ;
          };
          /**
           * Android 1.4.3(1040300)及以后版本支持
           * @param {*} scene 
           * @param {*} adId 
           * @param {*} expressViewWidth 
           * @param {*} expressViewHeight 
           */


          module.exports.showInterstitialAd = function (scene, adId, expressViewWidth, expressViewHeight) {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "showInterstitialAd", "(Ljava/lang/String;Ljava/lang/String;II)V", scene, adId, expressViewWidth, expressViewHeight);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
              jsb.reflection.callStaticMethod(NATIVE_OC_CLASS, "showInterstitialAd::", scene, adId, expressViewWidth, expressViewHeight);
            } else if (cc.sys.platform == cc.sys.WECHAT_GAME && !Global.QQGameEnv) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && Global.QQGameEnv) {
              QQGameBridge.showInterstitialAd();
            } else if (Global.VIVOQuickGameEnv) {
              VIVOGameBridge.showInterstitialAd();
            }

            if (cc.sys.isBrowser) {
              let callback = {
                onError: function (scene) {
                  console.log("showInterstitialAd onError:", scene);
                  window.Global.onInterstitialAdCallback(false, scene);
                },
                onAdLoaded: function (scene) {
                  console.log("showInterstitialAd onAdLoaded:", scene);
                  window.Global.onInterstitialAdCallback(true, scene);
                },
                onAdClose: function (scene) {
                  console.log("showInterstitialAd onAdClose:", scene);
                  window.Global.onInterstitialAdDismissCallback(scene);
                }
              };
              window.webplusNativeBridge.showInterstitialAd(scene, scene, window.SSUIVideoInterstitial, callback);
              PlatformBridge.onEventLabel("showInterstitialAd", window.SSUIVideoInterstitial);
            }
          };

          module.exports.prepareRewardAd = function (scene, fromId, adId) {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "prepareRewardAd", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V", scene, fromId, adId);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && !Global.QQGameEnv) ;else if (cc.sys.platform == cc.sys.WECHAT_GAME && Global.QQGameEnv) ;
          };

          module.exports.finish = function () {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "finish", "()V");
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
              jsb.reflection.callStaticMethod(NATIVE_OC_CLASS, "finish");
            } else if (cc.sys.platform == cc.sys.WECHAT_GAME || Global.VIVOQuickGameEnv || Global.OPPOQuickGameEnv) {
              Toast("请在右上角点击关闭", {
                gravity: "BOTTOM"
              });
            }

            if (cc.sys.isBrowser) {
              window.history.go(-1);
              window.webplusNativeBridge.showToast("请在右上角点击关闭");
            }
          };

          module.exports.startBrowser = function (url) {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "startBrowser", "(Ljava/lang/String;)V", url);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
              jsb.reflection.callStaticMethod(NATIVE_OC_CLASS, "startBrowser:", url);
            }
          };

          module.exports.showToast = function (text) {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "showToast", "(Ljava/lang/String;)V", text);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) ;
          };

          module.exports.setKeepScreenOn = function (value) {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "setKeepScreenOn", "(Z)V", value);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
              jsb.reflection.callStaticMethod(NATIVE_OC_CLASS, "setKeepScreenOn:", value);
            }
          };

          module.exports.subscribeMessageForWeixin = function (scene) {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "subscribeMessageForWeixin", "(I)V", scene);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
              jsb.reflection.callStaticMethod(NATIVE_OC_CLASS, "subscribeMessageForWeixin:", scene);
            } else if (cc.sys.platform === cc.sys.WECHAT_GAME) {
              WeChatGameBridge.subscribeMessage(scene);
            }
          };

          module.exports.shareToWX = function (scene, title, description, url, WxOpensence) {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "shareToWX", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V", scene, title, description, url);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
              jsb.reflection.callStaticMethod(NATIVE_OC_CLASS, "shareToWX:shareTitle:des:url:", scene, title, description, url);
            } else if (cc.sys.platform === cc.sys.WECHAT_GAME) ;
          };
          /**
           * 
           * @param {String} nickName 
           * @param {String} headIconPath 
           * @param {Boolean} maybeLogout 
           */


          module.exports.startSettingActivity = function (nickName, headIconPath, maybeLogout) {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "startSettingActivity", "(Ljava/lang/String;Ljava/lang/String;Z)V", nickName, headIconPath, maybeLogout);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) ;
          };
          /**
           * 
           * Android 1.2.0(1020000)及以后版本支持
           * 
           * @param {String} url 
           * @param {int} startTime 
           * @param {int} cycleTime 
           * @param {int} perJinbiNumber 
           * @param {int} maxJinbiNumber 
           */


          module.exports.startBrowserShowJinbi = function (url, startTime, cycleTime, perJinbiNumber, maxJinbiNumber) {
            if (cc.sys.platform == cc.sys.ANDROID) {
              console.log("startBrowserShowJinbi ");
              jsb.reflection.callStaticMethod(JAVA_CLASS, "startBrowserShowJinbi", "(Ljava/lang/String;IIII)V", url, startTime, cycleTime, perJinbiNumber, maxJinbiNumber);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) ;
          };
          /**
           * 
           * @param {Boolean} force 
           */


          module.exports.checkPermission = function (force, permissions) {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "checkPermission", "(ZLjava/lang/String;)V", force, permissions);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) ;
          };
          /**
           * 
           * @param {String} scene 
           * @param {String} text 
           */


          module.exports.shareTextToWX = function (scene, text) {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "shareTextToWX", "(Ljava/lang/String;Ljava/lang/String;)V", scene, text);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) ;
          };
          /**
           * 
           * @param {String} scene 
           * @param {String} imgPath 
           */


          module.exports.shareImageToWX = function (scene, imgPath) {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "shareImageToWX", "(Ljava/lang/String;Ljava/lang/String;)V", scene, imgPath);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) ;
          };
          /**
           * 
           * @param {String} scene 
           * @param {String} title 
           * @param {String} description 
           * @param {String} webviewurl 
           * @param {String} imgPath 
           * @param {String} miniProgramId 
           * @param {String} path 
           */


          module.exports.shareMiniProgramToWX = function (scene, title, description, webviewurl, imgPath, miniProgramId, path) {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "shareMiniProgramToWX", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V", scene, title, description, webviewurl, imgPath, miniProgramId, path);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) ;
          };
          /**
           * 
           * @param {String} scene 
           * @param {String} title 
           * @param {String} description 
           * @param {String} url 
           * @param {String} imgPath 
           */


          module.exports.shareWebPageToWX = function (scene, title, description, url, imgPath) {
            if (cc.sys.platform == cc.sys.ANDROID) {
              jsb.reflection.callStaticMethod(JAVA_CLASS, "shareWebPageToWX", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V", scene, title, description, url, imgPath);
            } else if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) ;
          };

          window.webplusJsCallback = {
            showInterstitialAd_Callback: null,
            showInterstitialAd: {
              onError: function (token) {
                console.log('webplusJsCallback.showInterstitialAd.onError' + token);
                window.webplusJsCallback.showInterstitialAd_Callback.onError(token);
              },
              onAdLoaded: function (token) {
                console.log('webplusJsCallback.showInterstitialAd.onAdLoaded' + token);
                window.webplusJsCallback.showInterstitialAd_Callback.onAdLoaded(token);
              },
              onAdClose: function (token) {
                console.log('webplusJsCallback.showInterstitialAd.onAdClose' + token);
                window.webplusJsCallback.showInterstitialAd_Callback.onAdClose(token);
              }
            },
            showRewardAd_Callback: null,
            showRewardAd: {
              onError: function (token) {
                console.log('webplusJsCallback.showRewardAd.onError: ' + token);
                window.webplusJsCallback.showRewardAd_Callback.onError(token);
              },
              onLoaded: function (token) {
                console.log('webplusJsCallback.showRewardAd.onLoaded: ' + token);
                window.webplusJsCallback.showRewardAd_Callback.onLoaded(token);
              },
              onShowed: function (token) {
                console.log('webplusJsCallback.showRewardAd.onShowed: ' + token);
                window.webplusJsCallback.showRewardAd_Callback.onShowed(token);
              },
              onRewarded: function (token) {
                console.log('webplusJsCallback.showRewardAd.onRewarded' + token);
                window.webplusJsCallback.showRewardAd_Callback.onRewarded(token);
              },
              onVideoComplete: function (token) {
                console.log('webplusJsCallback.showRewardAd.onVideoComplete' + token);
                window.webplusJsCallback.showRewardAd_Callback.onVideoComplete(token);
              },
              onClosed: function (token) {
                console.log('webplusJsCallback.showRewardAd.onClosed' + token);
                window.webplusJsCallback.showRewardAd_Callback.onClosed(token);
              }
            }
          };
          window.webplusNativeBridge = {
            logD: function (tag, msg) {
              console.log('webplusNativeBridge.logD: ' + tag + ' --> ' + msg);
              if (window.webplusJsBridge) window.webplusJsBridge.logD(tag, msg);
            },
            showToast: function (toast) {
              console.log('webplusNativeBridge.showToast: ' + toast);
              if (window.webplusJsBridge) window.webplusJsBridge.showToast(toast);
            },
            showRewardAd: function (token, fromId, aid, callback) {
              console.log('webplusNativeBridge.showRewardAd: ' + token);
              window.webplusJsCallback.showRewardAd_Callback = callback;
              if (window.webplusJsBridge) window.webplusJsBridge.showRewardAd(token, fromId, aid);
            },
            showInterstitialAd: function (token, fromId, aid, callback) {
              console.log('webplusNativeBridge.showInterstitialAd: ' + token);
              window.webplusJsCallback.showInterstitialAd_Callback = callback;
              if (window.webplusJsBridge) window.webplusJsBridge.showInterstitialAd(token, fromId, aid);
            },
            closeInterstitialAd: function () {
              console.log('webplusNativeBridge.closeInterstitialAd: ' + showType);
              if (window.webplusJsBridge) window.webplusJsBridge.closeInterstitialAd();
            },
            showBannerAd: function (token, fromId, aid, showType, autoDisappearMillis, w, h) {
              console.log('webplusNativeBridge.showBannerAd: ' + token);
              if (window.webplusJsBridge) window.webplusJsBridge.showBannerAd(token, fromId, aid, showType, autoDisappearMillis, w, h);
            },
            showFeedAd: function (token, fromId, aid, showType, autoDisappearMillis, w, h) {
              console.log('webplusNativeBridge.showFeedAd: ' + token);
              if (window.webplusJsBridge) window.webplusJsBridge.showFeedAd(token, fromId, aid, showType, autoDisappearMillis, w, h);
            },
            closeBannerOrFeedAd: function (showType) {
              console.log('webplusNativeBridge.closeBannerOrFeedAd: ' + showType);
              if (window.webplusJsBridge) window.webplusJsBridge.closeBannerOrFeedAd(showType);
            }
          };
          window.AD_CENTER_FLOAT_PLACEMENT = 0x10;
          window.AD_BOTTOM_INNER_FLOAT_PLACEMENT = 0x20;
          window.AD_BOTTOM_FLOAT_PLACEMENT = 0x02; //底部悬浮
          //视频广告位
          // window.SSUIVideoBannerS= "F227";
          // window.SSUIVideoBannerM= "E233";
          // window.SSUIVideoReward="J230";
          // window.SSUIVideoInterstitial= "B229";

          window.SSUIVideoBannerS = "F243";
          window.SSUIVideoBannerM = "F244";
          window.SSUIVideoReward = "J245";
          window.SSUIVideoInterstitial = "B229";
        })();

        _cjsExports = exports('default', module.exports);
      });

      const __cjsMetaURL = exports('__cjsMetaURL', module.meta.url);
    }
  };
});

System.register("chunks:///_virtual/LanguageData.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy, director;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      director = module.director;
    }],
    execute: function () {
      exports({
        init: init,
        t: t,
        updateSceneRenderers: updateSceneRenderers
      });

      cclegacy._RF.push({}, "b3f01X4Ik5LEbIPKXZr3JWD", "LanguageData", undefined);

      let _language = exports('_language', 'zh');

      let ready = exports('ready', false);
      /**
       * 初始化
       * @param language 
       */

      function init(language) {
        ready = exports('ready', true);
        _language = exports('_language', language);
      }
      /**
       * 翻译数据
       * @param key 
       * @param changeData 
       * @returns 
       */


      function t(key, changeData) {
        const win = window;

        if (!win.languages) {
          return key;
        }

        const searcher = key.split('.');
        let data = win.languages[_language];

        for (let i = 0; i < searcher.length; i++) {
          data = data[searcher[i]];

          if (!data) {
            return '';
          }
        }

        if (changeData) {
          for (let j in changeData) {
            data = data.replace('%{' + j + '}', changeData[j]);
          }
        }

        return data || '';
      }

      function updateSceneRenderers() {
        // very costly iterations
        const rootNodes = director.getScene().children; // walk all nodes with localize label and update

        const allLocalizedLabels = [];
        const allLocalizedSprites = [];
        const allLocalizedMaterial = [];

        for (let i = 0; i < rootNodes.length; ++i) {
          let labels = rootNodes[i].getComponentsInChildren('LocalizedLabel');
          Array.prototype.push.apply(allLocalizedLabels, labels);
          let sprites = rootNodes[i].getComponentsInChildren('LocalizedSprite');
          Array.prototype.push.apply(allLocalizedSprites, sprites);
          let meshs = rootNodes[i].getComponentsInChildren('LocalizedMaterial');
          Array.prototype.push.apply(allLocalizedMaterial, meshs);
        }

        for (let i = 0; i < allLocalizedLabels.length; ++i) {
          let label = allLocalizedLabels[i];
          if (!label.node.active) continue;
          label.updateLabel();
        } // walk all nodes with localize sprite and update


        for (let i = 0; i < allLocalizedSprites.length; ++i) {
          let sprite = allLocalizedSprites[i];
          if (!sprite.node.active) continue;
          sprite.updateSprite();
        }

        for (let i = 0; i < allLocalizedMaterial.length; ++i) {
          let mesh = allLocalizedMaterial[i];
          if (!mesh.node.active) continue;
          mesh.updateMat();
        }
      } // 供插件查询当前语言使用


      const win = window;
      win._languageData = {
        get language() {
          return _language;
        },

        init(lang) {
          init(lang);
        },

        updateSceneRenderers() {
          updateSceneRenderers();
        }

      };

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/fightHandGuide.ts", ['cc', './_rollupPluginModLoBabelHelpers.js'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, TweenSystem, tween, Animation, _applyDecoratedDescriptor, _initializerDefineProperty;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      TweenSystem = module.TweenSystem;
      tween = module.tween;
      Animation = module.Animation;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _temp;

      cclegacy._RF.push({}, "b57f2U4+lFHWYmyeEfh9N8U", "fightHandGuide", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let FightHandGuide = exports('FightHandGuide', (_dec = ccclass('FightHandGuide'), _dec(_class = (_class2 = (_temp = class FightHandGuide extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "ani", _descriptor, this);
        }

        moveOverCallback(idx, callback) {
          if (callback) {
            callback(idx);
          }
        }

        showGuide(arrPath, callback) {
          this.node.setPosition(arrPath[0]);
          TweenSystem.instance.ActionManager.removeAllActionsFromTarget(this.node);

          if (callback) {
            callback(0);
          }

          this.ani.play('handDown');
          let action = tween(this.node);
          this.ani.once(Animation.EventType.FINISHED, () => {
            for (let idx = 1; idx < arrPath.length; idx++) {
              let posTarget = arrPath[idx];
              let posOrigin = arrPath[idx - 1];
              let dis = posTarget.clone().subtract(posOrigin).length();
              action.then(tween().to(dis / 150, {
                position: posTarget
              }).call(() => {
                this.moveOverCallback(idx, callback);
              }));
            }

            action.call(() => {
              this.ani.play('handUp');
              this.ani.once(Animation.EventType.FINISHED, () => {
                this.scheduleOnce(() => {
                  this.showGuide(arrPath, callback);
                }, 0.5);
              }, this);
            });
            action.start();
          }, this);
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "ani", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/fightUI.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './resourceUtil.ts', './constants.ts', './clientEvent.ts', './localConfig.ts', './playerData.ts', './uiManager.ts', './audioManager.ts', './fightProp.ts', './LanguageData.ts', './fightTarget.ts', './showTarget.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, UITransform, Vec3, instantiate, Animation, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, resourceUtil, constants, clientEvent, localConfig, playerData, uiManager, AudioManager, FightProp, t, FightTarget, ShowTarget;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      UITransform = module.UITransform;
      Vec3 = module.Vec3;
      instantiate = module.instantiate;
      Animation = module.Animation;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      clientEvent = module.clientEvent;
    }, function (module) {
      localConfig = module.localConfig;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      AudioManager = module.AudioManager;
    }, function (module) {
      FightProp = module.FightProp;
    }, function (module) {
      t = module.t;
    }, function (module) {
      FightTarget = module.FightTarget;
    }, function (module) {
      ShowTarget = module.ShowTarget;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _temp;

      cclegacy._RF.push({}, "b70bahPE9BEa6kDxgxn3iLv", "fightUI", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let FightUI = exports('FightUI', (_dec = ccclass('FightUI'), _dec(_class = (_class2 = (_temp = class FightUI extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "nodeTargets", _descriptor, this);

          _initializerDefineProperty(this, "pfTarget", _descriptor2, this);

          _initializerDefineProperty(this, "lbStep", _descriptor3, this);

          _initializerDefineProperty(this, "lbLevel", _descriptor4, this);

          _initializerDefineProperty(this, "lbScore", _descriptor5, this);

          _initializerDefineProperty(this, "progress", _descriptor6, this);

          _initializerDefineProperty(this, "nodeProBar", _descriptor7, this);

          _initializerDefineProperty(this, "arrStars", _descriptor8, this);

          _initializerDefineProperty(this, "arrStarsBg", _descriptor9, this);

          _initializerDefineProperty(this, "nodePropGroup", _descriptor10, this);

          _initializerDefineProperty(this, "pfFightProp", _descriptor11, this);

          _initializerDefineProperty(this, "nodeInfinite", _descriptor12, this);

          _defineProperty(this, "targetProgress", void 0);

          _defineProperty(this, "_fightScene", void 0);

          _defineProperty(this, "arrTargetNode", void 0);
        }

        start() {
          this.startCustomerRandAction();
        }

        onEnable() {
          clientEvent.on('updateStep', this.updateStepInfo, this);
          clientEvent.on('updateScore', this.updateScore, this);
        }

        onDisable() {
          clientEvent.off('updateStep', this.updateStepInfo, this);
          clientEvent.off('updateScore', this.updateScore, this);
        }

        show(fightScene) {
          this.targetProgress = null;
          this._fightScene = fightScene;
          this.initTargets();
          this.updateLevelInfo();
          this.updateStepInfo();
          this.updateScore();
          this.initProps();
          this.showInfinite();

          if (playerData.instance.score === 0 && this.progress.progress > 0) {
            this.progress.progress = 0;
            this.arrStars[0].active = false;
            this.arrStars[1].active = false;
            this.arrStars[2].active = false;
          }
        }

        updateLevelInfo() {
          this.lbLevel.string = playerData.instance.level;
        }

        updateStepInfo(isInfinite) {
          if (isInfinite === false) {
            this.lbStep.node.active = false;

            this._fightScene.effectGroup.showUnlimitedOrNumber(this.nodeInfinite.getComponent(UITransform).convertToWorldSpaceAR(new Vec3(0, 0, 0)), false, playerData.instance.spareStep);
          } else if (!playerData.instance.curLevelInfo.infinite && typeof isInfinite === 'undefined') {
            this.lbStep.node.active = true;
            this.lbStep.string = playerData.instance.spareStep;
          }
        }

        updateScore() {
          let score = playerData.instance.score;
          this.lbScore.string = score;
          let pro = 0;
          let stars = playerData.instance.arrStars;

          if (score < stars[0]) {
            pro = score / stars[0] * 0.33;
          } else if (score < stars[1]) {
            pro = 0.33 + (score - stars[0]) / (stars[1] - stars[0]) * 0.33;
          } else {
            pro = 0.67 + (score - stars[1]) / (stars[2] - stars[1]) * 0.33;

            if (pro >= 1) {
              pro = 1;
            }
          }

          this.targetProgress = pro;
        }

        initTargets() {
          this.nodeTargets.removeAllChildren();
          this.arrTargetNode = [];

          for (let target in playerData.instance.dictTargets) {
            let nodeTarget = instantiate(this.pfTarget);
            nodeTarget.parent = this.nodeTargets;
            nodeTarget.getComponent(FightTarget).show(target, true);
            this.arrTargetNode.push(nodeTarget);
          }
        }

        getTargetWorldPos(cake) {
          for (let idx = 0; idx < this.arrTargetNode.length; idx++) {
            let nodeTarget = this.arrTargetNode[idx];
            let target = nodeTarget.getComponent(FightTarget);

            if (target.cake === cake) {
              return target.getCakeWorldPos();
            }
          }

          return null;
        }

        showTargetsAni(callback) {
          resourceUtil.createUI('fight/showTarget', (err, tagetNode) => {
            if (err) {
              clientEvent.dispatchEvent('showTargetCake', 'all');
              return;
            }

            tagetNode.getComponent(ShowTarget).show(this, callback);
          }, this.node);
        }

        getStepWorldPos() {
          return this.lbStep.node.getComponent(UITransform).convertToWorldSpaceAR(new Vec3(0, 0, 0));
        }

        getProgressBarWorldPos() {
          const uiTra = this.nodeProBar.getComponent(UITransform);
          return uiTra.convertToWorldSpaceAR(new Vec3(uiTra.width, 0, 0));
        }

        onBtnSettingClick() {
          uiManager.instance.showDialog('dialog/gameSetting');
        }

        onBtnQuestionClick() {
          uiManager.instance.showDialog('fight/fightGuide');
        }

        startCustomerRandAction() {
          let time = 3 + Math.random() * 3;
          this.scheduleOnce(() => {
            if (this.arrTargetNode.length <= 0) {
              this.startCustomerRandAction();
              return;
            }

            let rand = Math.floor(Math.random() * this.arrTargetNode.length);
            let node = this.arrTargetNode[rand];
            node.getComponent(FightTarget).playIdle();
            this.startCustomerRandAction();
          }, time);
        }

        update(dt) {
          if (this.targetProgress !== null) {
            let curPro = this.progress.progress;

            if (this.targetProgress !== curPro) {
              let prePro = curPro;

              if (this.targetProgress > curPro) {
                curPro += dt;
              } else {
                curPro -= dt;
              }

              if (this.targetProgress > 0) {
                curPro = curPro > this.targetProgress ? this.targetProgress : curPro;
              } else {
                curPro = curPro < 0 ? 0 : curPro;
              }

              this.progress.progress = curPro;

              if (curPro >= 1 && prePro < 1) {
                this.showStar(2);
              } else if (prePro >= 1 && curPro < 1) {
                this.arrStars[2].active = false;
              } else if (curPro >= 0.66 && (prePro < 0.66 || prePro >= 1)) {
                this.arrStars[0].active = true;

                if (prePro < 0.66) {
                  this.showStar(1);
                }
              } else if (curPro >= 0.33 && curPro < 0.66 && (prePro < 0.33 || prePro >= 0.66)) {
                this.arrStars[1].active = false;

                if (prePro < 0.33) {
                  this.showStar(0);
                }
              } else if (curPro < 0.33 && prePro >= 0.33) {
                this.arrStars[0].active = false;
                this.arrStars[1].active = false;
                this.arrStars[2].active = false;
              }
            }
          }
        }

        showStar(idx) {
          if (this.arrStars[idx].active) {
            return; //已经展示过了
          }

          resourceUtil.createEffect('fight/homeStar/homeStar', (err, node) => {
            if (err) {
              this.arrStars[idx].active = true;
              return;
            }

            AudioManager.instance.playSound(constants.AUDIO_SOUND.FINISH_STAR, false);
            let ani = node.getComponent(Animation);
            ani.play('homeStarShow');
            ani.once(Animation.EventType.FINISHED, () => {
              node && node.destroy();
              this.arrStars[idx].active = true;
            });
          }, this.arrStarsBg[idx]);
        }

        initProps() {
          this.nodePropGroup.removeAllChildren();
          this.onItemClick = this.onItemClick.bind(this);
          let tbProps = localConfig.instance.getTable('prop');

          for (let prop in tbProps) {
            let nodeProp = instantiate(this.pfFightProp);
            nodeProp.parent = this.nodePropGroup;
            let fightProp = nodeProp.getComponent(FightProp);
            fightProp.show(tbProps[prop]);
            fightProp.setClickListener(this.onItemClick);
          }
        }

        onItemClick(prop, posWorld) {
          let amount = playerData.instance.getPropAmount(prop.ID);

          if (amount <= 0) {
            uiManager.instance.showTips(t('fight.propNoEnough'));
            return;
          }

          if (!this._fightScene.isPropCanUse(prop.ID)) {
            uiManager.instance.showTips(t('fight.propExceedMaxTimes'));
            return;
          }

          if (prop.ID === constants.PROP_ID.INFINITE) {
            this._fightScene.effectGroup.useInfiniteProp(posWorld, this.nodeInfinite.getComponent(UITransform).convertToWorldSpaceAR(new Vec3(0, 0, 0)));
          }

          if (prop.ID === constants.PROP_ID.HAMMER || prop.ID === constants.PROP_ID.MAGIC) {
            this._fightScene.showPropOperationUI(prop, posWorld);
          } else {
            clientEvent.dispatchEvent('useProp', prop.ID);
          }
        }

        showInfinite() {
          if (playerData.instance.curLevelInfo) {
            if (playerData.instance.curLevelInfo.infinite) {
              this.lbStep.node.active = false;
              this.nodeInfinite.active = true;
              return;
            }
          }

          this.lbStep.node.active = true;
          this.nodeInfinite.active = false;
        }

        showUnlockProp(propId, callback) {
          let arrProp = this.nodePropGroup.children;
          let targetProp = arrProp[propId - 1];
          let targetWorldPos = targetProp.getComponent(UITransform).convertToWorldSpaceAR(new Vec3(0, 0, 0));

          this._fightScene.effectGroup.showUnlockProp(targetWorldPos, propId, callback);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "nodeTargets", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "pfTarget", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "lbStep", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "lbLevel", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "lbScore", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "progress", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "nodeProBar", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "arrStars", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "arrStarsBg", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "nodePropGroup", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "pfFightProp", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "nodeInfinite", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/adProp.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './constants.ts', './uiManager.ts', './PlatformBridge.js', './PlatformBridge.mjs_cjs=&original=.js', './gameLogic.ts', './ConstValue.js', './ConstValue.mjs_cjs=&original=.js'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, Component, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, constants, uiManager, _cjsExports, GameLogic, _cjsExports$1;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      Component = module.Component;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      _cjsExports = module.default;
    }, null, function (module) {
      GameLogic = module.GameLogic;
    }, function (module) {
      _cjsExports$1 = module.default;
    }, null],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _temp;

      cclegacy._RF.push({}, "b82eaehqfxOHIyJ+LFuGZ1c", "adProp", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let AdProp = exports('AdProp', (_dec = ccclass('AdProp'), _dec2 = property(Node), _dec(_class = (_class2 = (_temp = class AdProp extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "imgAd", _descriptor, this);

          _initializerDefineProperty(this, "imgShare", _descriptor2, this);

          _initializerDefineProperty(this, "ndBtnGoStart", _descriptor3, this);

          _initializerDefineProperty(this, "spBtn", _descriptor4, this);

          _initializerDefineProperty(this, "nativeAd", _descriptor5, this);

          _defineProperty(this, "callback", void 0);

          _defineProperty(this, "rewardType", void 0);
        }

        show(callback) {
          Global.adProp = this;
          this.callback = callback;
          this.rewardType = constants.OPEN_REWARD_TYPE.AD;
          let self = this;
          console.log("showNativeAd00");

          _cjsExports.showNativeAd(frame => {
            console.log("showNativeAd0");
            let sc = self.nativeAd.getComponent("NativeAdBig");
            console.log("showNativeAd1");

            if (sc) {
              console.log("showNativeAd2");
              sc.setSprite(frame);
              console.log("showNativeAd3");
            }
          });

          _cjsExports.showCustomAd(false);

          GameLogic.instance.getOpenRewardType(constants.SHARE_FUNCTION.START_REWARD, (err, type) => {
            if (!err) {
              this.rewardType = type;

              switch (type) {
                case constants.OPEN_REWARD_TYPE.AD:
                  this.spBtn.spriteFrame = this.imgAd;
                  break;

                case constants.OPEN_REWARD_TYPE.SHARE:
                  this.spBtn.spriteFrame = this.imgShare;
                  break;

                case constants.OPEN_REWARD_TYPE.NULL:
                  this.onBtnCloseClick(); //不支持奖励

                  break;
              }
            }
          });
          this.ndBtnGoStart.active = false;
          this.scheduleOnce(() => {
            this.ndBtnGoStart.active = true;
          }, constants.NORMAL_SHOW_TIME);
        }

        onBtnCloseClick() {
          if (this.callback) {
            this.callback('close');
          }

          this.close();
        }

        onBtnPlayClick() {
          if (this.rewardType === constants.OPEN_REWARD_TYPE.AD) {
            _cjsExports.showRewardAd("onBtnAdPropReceiveClick", "1", _cjsExports$1.getAdReward()); // GameLogic.instance.showRewardAd((err: any) => {
            //     if (!err) {
            //         this.close();
            //         if (this.callback) {
            //             this.callback(null);
            //         }
            //     } else {
            //         if (this.callback) {
            //             this.callback('failed', err);
            //         }
            //     }
            // });

          } else {
            GameLogic.instance.share(constants.SHARE_FUNCTION.START_REWARD, {}, err => {
              if (!err) {
                this.close();
              }

              if (this.callback) {
                this.callback(err);
              }
            });
          }
        }

        onBtnPlayClickCallback(s) {
          if (s) {
            this.close();

            if (this.callback) {
              this.callback(null);
            }
          } else {
            if (this.callback) {
              this.callback('failed', "err");
            }
          }
        }

        close() {
          uiManager.instance.hideDialog('fight/adProp');

          _cjsExports.hideCustomAd();
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "imgAd", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "imgShare", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "ndBtnGoStart", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "spBtn", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "nativeAd", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/setting.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './uiManager.ts', './audioManager.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, _applyDecoratedDescriptor, _initializerDefineProperty, uiManager, AudioManager;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      AudioManager = module.AudioManager;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _temp;

      cclegacy._RF.push({}, "ba66atexAVHHJdMxg2byzWt", "setting", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let Setting = exports('Setting', (_dec = ccclass('Setting'), _dec(_class = (_class2 = (_temp = class Setting extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "versionLabel", _descriptor, this);

          _initializerDefineProperty(this, "ndMusicOpen", _descriptor2, this);

          _initializerDefineProperty(this, "ndMusicClose", _descriptor3, this);

          _initializerDefineProperty(this, "ndSoundOpen", _descriptor4, this);

          _initializerDefineProperty(this, "ndSoundClose", _descriptor5, this);

          _initializerDefineProperty(this, "spMusicIcon", _descriptor6, this);

          _initializerDefineProperty(this, "spSoundIcon", _descriptor7, this);

          _initializerDefineProperty(this, "sfMusicOn", _descriptor8, this);

          _initializerDefineProperty(this, "sfMusicOff", _descriptor9, this);

          _initializerDefineProperty(this, "sfSoundOn", _descriptor10, this);

          _initializerDefineProperty(this, "sfSoundOff", _descriptor11, this);
        }

        show() {
          this.node.active = true;
          let isMusicOpen = AudioManager.instance.getAudioSetting(true);
          let isSoundOpen = AudioManager.instance.getAudioSetting(false);
          this.ndMusicOpen.active = !isMusicOpen;
          this.ndMusicClose.active = isMusicOpen;
          this.ndSoundOpen.active = !isSoundOpen;
          this.ndSoundClose.active = isSoundOpen; // this.versionLabel.string = 'Ver: ' + localConfig.instance.getVersion();

          this.spMusicIcon.spriteFrame = this.ndMusicOpen.active === true ? this.sfMusicOff : this.sfMusicOn;
          this.spSoundIcon.spriteFrame = this.ndSoundOpen.active === true ? this.sfSoundOff : this.sfSoundOn;
        }

        onBtnMusicOpenClick() {
          AudioManager.instance.openMusic();
          this.show();
        }

        onBtnMusicCloseClick() {
          AudioManager.instance.closeMusic();
          this.show();
        }

        onBtnSoundOpenClick() {
          AudioManager.instance.openSound();
          this.show();
        }

        onBtnSoundCloseClick() {
          AudioManager.instance.closeSound();
          this.show();
        }

        onBtnCloseClick() {
          uiManager.instance.hideDialog('dialog/setting');
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "versionLabel", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "ndMusicOpen", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "ndMusicClose", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "ndSoundOpen", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "ndSoundClose", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "spMusicIcon", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "spSoundIcon", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "sfMusicOn", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "sfMusicOff", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "sfSoundOn", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "sfSoundOff", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/targetCake.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './resourceUtil.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, _applyDecoratedDescriptor, _initializerDefineProperty, resourceUtil;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _temp;

      cclegacy._RF.push({}, "bd95fbKL6dI6r423PTMarGm", "targetCake", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let TargetCake = exports('TargetCake', (_dec = ccclass('TargetCake'), _dec(_class = (_class2 = (_temp = class TargetCake extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spCakeIcon", _descriptor, this);

          _initializerDefineProperty(this, "lbCakeNum", _descriptor2, this);
        }

        setInfo(cakeInfo) {
          let arrCakeInfo = cakeInfo.split('-');
          resourceUtil.setCakeIcon(arrCakeInfo[0], this.spCakeIcon, () => {});
          this.lbCakeNum.string = arrCakeInfo[1];
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spCakeIcon", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "lbCakeNum", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/PlatformPlugin.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './PlatformBridge.js', './PlatformBridge.mjs_cjs=&original=.js'], function (exports) {
  'use strict';

  var cclegacy, Node, _decorator, Component, tween, sys, game, _applyDecoratedDescriptor, _initializerDefineProperty, _cjsExports;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      _decorator = module._decorator;
      Component = module.Component;
      tween = module.tween;
      sys = module.sys;
      game = module.game;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
    }, function (module) {
      _cjsExports = module.default;
    }, null],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp;

      cclegacy._RF.push({}, "be328D0LjVMyrpkZMdE9Sdl", "PlatformPlugin", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      /**
       * Predefined variables
       * Name = PlatformPlugin
       * DateTime = Tue Mar 01 2022 10:52:33 GMT+0800 (中国标准时间)
       * Author = qiaopc
       * FileBasename = PlatformPlugin.ts
       * FileBasenameNoExtension = PlatformPlugin
       * URL = db://assets/scripts/jijia/PlatformPlugin.ts
       * ManualUrl = https://docs.cocos.com/creator/3.4/manual/zh/
       *
       */

      let PlatformPlugin = exports('PlatformPlugin', (_dec = ccclass('PlatformPlugin'), _dec2 = property(Node), _dec3 = property(Node), _dec4 = property(Node), _dec(_class = (_class2 = (_temp = class PlatformPlugin extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "moreGameBtn", _descriptor, this);

          _initializerDefineProperty(this, "yinsizhengce", _descriptor2, this);

          _initializerDefineProperty(this, "messageUI", _descriptor3, this);
        }

        onLoad() {
          if (Global.OPPOGameEnv || Global.OPPOQuickGameEnv) {
            this.moreGameBtn.active = true;
            tween(this.moreGameBtn).repeatForever(tween(this.moreGameBtn).to(0.5, {
              angle: 10
            }).to(0.5, {
              angle: -10
            })).start();
          } else {
            this.moreGameBtn.active = false;
          }

          if (Global.OPPOQuickGameEnv || Global.VIVOQuickGameEnv) {
            let yinsiClick = sys.localStorage.getItem("yinsiClick");

            if (!yinsiClick) {
              this.yinsizhengce.active = true;
            }
          } else {
            this.yinsizhengce.active = false;
          }
        }

        start() {// [3]
        } // update (deltaTime: number) {
        //     // [4]
        // }


        onClickMoreGame() {
          if (Global.QQGameEnv) {
            QQGameBridge.showAppBox();
          } else if (Global.OPPOGameEnv) {
            _cjsExports.jumpLeisureSubject();
          } else if (Global.OPPOQuickGameEnv) {
            OPPOGameBridge.showAppBox();
          }
        }

        onClickMessageBackButton() {
          this.messageUI.active = false;
        }

        onClickMessage() {
          this.messageUI.active = true;
        }

        onClickUserAggrement() {
          _cjsExports.startBrowser("http://games.jijia-co.com/static/privacy/videoprotocol.html");
        }

        onClickPrivacyPolicy() {
          if (Global.OPPOQuickGameEnv || Global.VIVOQuickGameEnv) {
            this.yinsizhengce.active = true;
          } else {
            _cjsExports.startBrowser("http://games.jijia-co.com/static/privacy/pubprivacy.html");
          }
        }

        onClickYinSiZhengCeClose() {
          sys.localStorage.setItem("yinsiClick", "1");
          this.yinsizhengce.active = false;
        } // update (dt) {}


        onClickYinSiZhengCeOK() {
          sys.localStorage.setItem("yinsiClick", "1");
          this.yinsizhengce.active = false;
        }

        onClickYinSiZhengCeQuit() {
          console.log("cc.game.end()0");
          game.end();
          console.log("cc.game.end()1");
          console.log("onClickYinSiZhengCeQuit0");
          this.yinsizhengce.active = false;
          console.log("onClickYinSiZhengCeQuit1");

          if (Global.OPPOQuickGameEnv) {
            console.log("exitApplication2");
            qg.exitApplication({
              data: "",
              success: () => {
                console.log("success");
              },
              fail: () => {
                console.log("fail");
              },
              complete: () => {
                console.log("complete");
              }
            });
            console.log("exitApplication3");
          } else if (Global.VIVOQuickGameEnv) {
            qg.exitApplication();
          }
        }

        onEnable() {
          if (Global.VIVOQuickGameEnv) {
            VIVOGameBridge.showAppBox();
          }
        }

        onDisable() {
          if (Global.VIVOQuickGameEnv) {
            VIVOGameBridge.hideAppBox();
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "moreGameBtn", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "yinsizhengce", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "messageUI", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));
      /**
       * [1] Class member could be defined like this.
       * [2] Use `property` decorator if your want the member to be serializable.
       * [3] Your initialization goes here.
       * [4] Your update function goes here.
       *
       * Learn more about scripting: https://docs.cocos.com/creator/3.4/manual/zh/scripting/
       * Learn more about CCClass: https://docs.cocos.com/creator/3.4/manual/zh/scripting/decorator.html
       * Learn more about life-cycle callbacks: https://docs.cocos.com/creator/3.4/manual/zh/scripting/life-cycle-callbacks.html
       */

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/LocalizedSprite.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './LanguageData.ts'], function (exports) {
  'use strict';

  var cclegacy, SpriteFrame, _decorator, Component, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, ready, init, _language;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      SpriteFrame = module.SpriteFrame;
      _decorator = module._decorator;
      Component = module.Component;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      ready = module.ready;
      init = module.init;
      _language = module._language;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _temp, _dec3, _dec4, _class4, _class5, _descriptor3, _temp2;

      cclegacy._RF.push({}, "c05c25C4xNAupWYMB93tIzp", "LocalizedSprite", undefined);

      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      let LocalizedSpriteItem = (_dec = ccclass('LocalizedSpriteItem'), _dec2 = property({
        type: SpriteFrame
      }), _dec(_class = (_class2 = (_temp = class LocalizedSpriteItem {
        constructor() {
          _initializerDefineProperty(this, "language", _descriptor, this);

          _initializerDefineProperty(this, "spriteFrame", _descriptor2, this);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "language", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 'zh';
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "spriteFrame", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class);
      let LocalizedSprite = exports('LocalizedSprite', (_dec3 = ccclass('LocalizedSprite'), _dec4 = property({
        type: LocalizedSpriteItem
      }), _dec3(_class4 = executeInEditMode(_class4 = (_class5 = (_temp2 = class LocalizedSprite extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "sprite", null);

          _initializerDefineProperty(this, "spriteList", _descriptor3, this);
        }

        onLoad() {
          if (!ready) {
            init('zh');
          }

          this.fetchRender();
        }

        fetchRender() {
          let sprite = this.getComponent('cc.Sprite');

          if (sprite) {
            this.sprite = sprite;
            this.updateSprite();
            return;
          }
        }

        updateSprite() {
          for (let i = 0; i < this.spriteList.length; i++) {
            const item = this.spriteList[i]; // @ts-ignore

            if (item.language === _language) {
              // @ts-ignore
              this.sprite.spriteFrame = item.spriteFrame;
              break;
            }
          }
        }

      }, _temp2), _descriptor3 = _applyDecoratedDescriptor(_class5.prototype, "spriteList", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _class5)) || _class4) || _class4));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/gameSetting.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './sceneManager.ts', './uiManager.ts', './audioManager.ts', './gameLogic.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, _applyDecoratedDescriptor, _initializerDefineProperty, SceneManager, uiManager, AudioManager, GameLogic;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
    }, function (module) {
      SceneManager = module.SceneManager;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      AudioManager = module.AudioManager;
    }, function (module) {
      GameLogic = module.GameLogic;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _temp;

      cclegacy._RF.push({}, "c0ebf+rxRpMory9l2TqXwQ/", "gameSetting", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let gameSetting = exports('gameSetting', (_dec = ccclass('gameSetting'), _dec(_class = (_class2 = (_temp = class gameSetting extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "ndMusicOpen", _descriptor, this);

          _initializerDefineProperty(this, "ndMusicClose", _descriptor2, this);

          _initializerDefineProperty(this, "ndSoundOpen", _descriptor3, this);

          _initializerDefineProperty(this, "ndSoundClose", _descriptor4, this);
        }

        show() {
          let isMusicOpen = AudioManager.instance.getAudioSetting(true);
          let isSoundOpen = AudioManager.instance.getAudioSetting(false);
          this.ndMusicOpen.active = !isMusicOpen;
          this.ndMusicClose.active = isMusicOpen;
          this.ndSoundOpen.active = !isSoundOpen;
          this.ndSoundClose.active = isSoundOpen;
        }

        onBtnHomeClick() {
          SceneManager.instance.loadScene('pve', [], (err, result) => {
            if (err) {
              console.error(err.message || err);
              return;
            }
          });
        }

        onBtnPlayAgainBtn() {
          this.onBtnCloseClick();
          GameLogic.instance.resetLevel();
        }

        onBtnMusicOpenClick() {
          AudioManager.instance.openMusic();
          this.show();
        }

        onBtnMusicCloseClick() {
          AudioManager.instance.closeMusic();
          this.show();
        }

        onBtnSoundOpenClick() {
          AudioManager.instance.openSound();
          this.show();
        }

        onBtnSoundCloseClick() {
          AudioManager.instance.closeSound();
          this.show();
        }

        onBtnCloseClick() {
          uiManager.instance.hideDialog('dialog/gameSetting');
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "ndMusicOpen", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "ndMusicClose", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "ndSoundOpen", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "ndSoundClose", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/tips.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './poolManager.ts'], function (exports) {
  'use strict';

  var cclegacy, Label, UIOpacity, _decorator, Component, UITransform, isValid, tween, Vec3, _applyDecoratedDescriptor, _initializerDefineProperty, poolManager;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Label = module.Label;
      UIOpacity = module.UIOpacity;
      _decorator = module._decorator;
      Component = module.Component;
      UITransform = module.UITransform;
      isValid = module.isValid;
      tween = module.tween;
      Vec3 = module.Vec3;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
    }, function (module) {
      poolManager = module.poolManager;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _temp;

      cclegacy._RF.push({}, "c93c6JdRlZBq6pCuKII6jKN", "tips", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let tips = exports('tips', (_dec = ccclass('tips'), _dec2 = property(Label), _dec3 = property(UIOpacity), _dec(_class = (_class2 = (_temp = class tips extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "lbTips", _descriptor, this);

          _initializerDefineProperty(this, "UIOpacityBg", _descriptor2, this);
        }

        show(content, callback) {
          var _this$lbTips, _this$lbTips$node, _this$lbTips$node$get;

          let size = (_this$lbTips = this.lbTips) === null || _this$lbTips === void 0 ? void 0 : (_this$lbTips$node = _this$lbTips.node) === null || _this$lbTips$node === void 0 ? void 0 : (_this$lbTips$node$get = _this$lbTips$node.getComponent(UITransform)) === null || _this$lbTips$node$get === void 0 ? void 0 : _this$lbTips$node$get.contentSize;

          if (!isValid(size)) {
            //size不存在，自我销毁
            poolManager.instance.putNode(this.node);
            return;
          }

          this.lbTips.string = content;
          this.UIOpacityBg.opacity = 255;
          this.node.setPosition(0, 220, 0);
          this.scheduleOnce(() => {
            tween(this.node).to(0.9, {
              position: new Vec3(0, 450, 0)
            }, {
              easing: 'smooth'
            }).call(() => {
              callback && callback();
              poolManager.instance.putNode(this.node);
            }).start();
            tween(this.UIOpacityBg).to(0.6, {
              opacity: 220
            }, {
              easing: 'smooth'
            }).to(0.3, {
              opacity: 0
            }, {
              easing: 'smooth'
            }).start();
          }, 0.8);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "lbTips", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "UIOpacityBg", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/elasticLimit.ts", ['cc', './_rollupPluginModLoBabelHelpers.js'], function (exports) {
  'use strict';

  var cclegacy, _decorator, ScrollView, Node, EventTouch, UITransform, sys, _applyDecoratedDescriptor, _initializerDefineProperty;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      ScrollView = module.ScrollView;
      Node = module.Node;
      EventTouch = module.EventTouch;
      UITransform = module.UITransform;
      sys = module.sys;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _temp;

      cclegacy._RF.push({}, "cad33aLu5lGpY9kxRqQAXUn", "elasticLimit", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ElasticLimit = exports('ElasticLimit', (_dec = ccclass('ElasticLimit'), _dec(_class = (_class2 = (_temp = class ElasticLimit extends ScrollView {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "elasticValueX", _descriptor, this);

          _initializerDefineProperty(this, "elasticValueY", _descriptor2, this);
        }

        onLoad() {
          this.node.on(Node.EventType.TOUCH_MOVE, this._onTouchMoved, this, true);
        }

        _onTouchMoved(event, captureListeners) {
          if (!this.enabledInHierarchy) return;
          if (this._hasNestedViewGroup(event, captureListeners)) return;
          let touch = event.touch;

          if (this.content) {
            this._handleMoveLogic(touch);
          }

          if (!this.cancelInnerEvents) {
            return;
          }

          let deltaMove = touch.getLocation().subtract(touch.getStartLocation());

          if (deltaMove.length > 7) {
            if (!this._touchMoved && event.target !== this.node) {
              let cancelEvent = new EventTouch(event.getTouches(), event.bubbles, Node.EventType.TOUCH_CANCEL);
              cancelEvent.type = Node.EventType.TOUCH_CANCEL;
              cancelEvent.touch = event.touch;
              cancelEvent.simulate = true;
              event.target.dispatchEvent(cancelEvent);
              this._touchMoved = true;
            }
          }

          this._stopPropagationIfTargetIsMe(event);
        }

        _onTouchEnded(event, captureListeners) {}

        _handleMoveLogic(touch) {
          let deltaMove = touch.getDelta();

          this._processDeltaMove(deltaMove);
        }

        _processDeltaMove(deltaMove) {
          this._scrollChildren(deltaMove);

          this._gatherTouchMove(deltaMove);
        }

        _scrollChildren(deltaMove) {
          this._clampDelta(deltaMove);

          let realMove = deltaMove;
          let outOfBoundary;

          if (this.elastic) {
            outOfBoundary = this._getHowMuchOutOfBoundary();
            realMove.x *= outOfBoundary.x === 0 ? 1 : this.elasticValueX;
            realMove.y *= outOfBoundary.y === 0 ? 1 : this.elasticValueY;
          }

          if (!this.elastic) {
            outOfBoundary = this._getHowMuchOutOfBoundary(realMove);
            realMove.add(outOfBoundary);
          }

          let scrollEventType = -1;
          const uiTraContent = this.content.getComponent(UITransform);
          const posContent = this.content.position;

          if (realMove.y > 0) {
            //up
            let icBottomPos = posContent.y - uiTraContent.anchorY * uiTraContent.height;

            if (icBottomPos + realMove.y > this._bottomBoundary) {
              scrollEventType = 'scroll-to-bottom';
            }
          } else if (realMove.y < 0) {
            //down
            let icTopPos = posContent.y - uiTraContent.anchorY * uiTraContent.height + uiTraContent.height;

            if (icTopPos + realMove.y <= this._topBoundary) {
              scrollEventType = 'scroll-to-top';
            }
          } else if (realMove.x < 0) {
            //left
            let icRightPos = posContent.x - uiTraContent.anchorX * uiTraContent.width + uiTraContent.width;

            if (icRightPos + realMove.x <= this._rightBoundary) {
              scrollEventType = 'scroll-to-right';
            }
          } else if (realMove.x > 0) {
            //right
            let icLeftPos = posContent.x - uiTraContent.anchorX * uiTraContent.width;

            if (icLeftPos + realMove.x >= this._leftBoundary) {
              scrollEventType = 'scroll-to-left';
            }
          }

          if (sys.isNative) {
            //@ts-ignore
            realMove = {
              array: {
                0: 1e-4,
                1: realMove.y,
                2: 0
              }
            };
          }

          this._moveContent(realMove, false); //@ts-ignore


          if (realMove.x !== 0 || realMove.y !== 0) {
            if (!this._scrolling) {
              this._scrolling = true;

              this._dispatchEvent('scroll-began');
            }

            this._dispatchEvent('scrolling');
          }

          if (scrollEventType !== -1) {
            this._dispatchEvent(scrollEventType);
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "elasticValueX", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0.5;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "elasticValueY", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0.5;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/OppoGameBridge.js", ['./cjs-loader.mjs', './ConstValue.js'], function (exports, module) {
  'use strict';

  var loader, __cjsMetaURL$1;

  return {
    setters: [function (module) {
      loader = module.default;
    }, function (module) {
      __cjsMetaURL$1 = module.__cjsMetaURL;
    }],
    execute: function () {
      exports('default', void 0);

      let _cjsExports;

      loader.define(module.meta.url, function (exports$1, _require, module, __filename, __dirname) {
        let require = loader.createRequireWithReqMap({
          "./ConstValue": __cjsMetaURL$1
        }, _require);

        (function () {
          const ConstValue = require("./ConstValue");

          const OPPOGameBridge = {
            QQGameRewardAdInitComplete: false,
            QQGameRewardAd: null,
            QQGameAdCurScene: null,
            QQGameInterstitialAdInitComplete: false,
            QQGameInterstitialAd: null,
            QQGameFeedAd: null,
            QQGameBannerAd: null,
            QQGameBlockAd: null,
            QQGameAppBox: null,
            QQGameBlockAdNeedClose: false,
            showRewardAd: function (scene, fromId, adId) {
              //qqqiaopc
              if (!OPPOGameBridge.QQGameRewardAdInitComplete) {
                OPPOGameBridge.QQGameRewardAd = qg.createRewardedVideoAd({
                  adUnitId: "553932"
                });
                OPPOGameBridge.QQGameRewardAdInitComplete = true;
              }

              try {
                if (OPPOGameBridge.QQGameAdCloseHandler) {
                  OPPOGameBridge.QQGameRewardAd.offClose(OPPOGameBridge.QQGameAdCloseHandler);
                  console.log("---videoAd.offClose 卸载成功---");
                }
              } catch (e) {
                console.log("---videoAd.offClose 卸载失败---");
                console.error(e);
              }

              OPPOGameBridge.QQGameAdCurScene = scene;
              OPPOGameBridge.QQGameRewardAd.onClose(OPPOGameBridge.QQGameAdCloseHandler);
              OPPOGameBridge.QQGameRewardAd.load().then(() => {
                console.log('激励视频加载成功');
                OPPOGameBridge.QQGameRewardAd.show().then(() => {
                  console.log('激励视频 广告显示成功');
                }).catch(err => {
                  console.log('激励视频 广告显示失败');
                  Global.onRewardAdCallback(false, scene);
                });
              }).catch(err => {
                console.log('激励视频加载失败', JSON.stringify(err));
                Global.onRewardAdCallback(false, scene);
              });
            },
            showBannerAd: function (scene, adId, expressViewWidth, expressViewHeight, isBottom, margin, displayBackground) {
              let adWidth = parseInt(cc.view.getFrameSize().width);
              let adHeight = parseInt(adWidth * 2 / 3);
              let adTop = Math.round(cc.view.getFrameSize().height - adHeight);
              let adLeft = Math.round(0);

              if (OPPOGameBridge.QQGameBannerAd) {
                OPPOGameBridge.QQGameBannerAd.destroy();
              }

              setTimeout(function () {
                OPPOGameBridge.QQGameBannerAd = qg.createBannerAd({
                  adUnitId: '553929',
                  style: {
                    left: adLeft,
                    top: adTop,
                    width: adWidth > 300 ? adWidth : 300,
                    height: adHeight
                  }
                });
                OPPOGameBridge.QQGameBannerAd.onResize(size => {
                  OPPOGameBridge.QQGameBannerAd.style.top = Math.round(cc.view.getFrameSize().height - size.height);
                  OPPOGameBridge.QQGameBannerAd.style.left = Math.round((cc.view.getFrameSize().width - size.width) / 2);
                  console.log('Resize后正式宽高:', size.width, size.height, OPPOGameBridge.QQGameBannerAd.style.top, OPPOGameBridge.QQGameBannerAd.style.left);
                  OPPOGameBridge.QQGameBannerAd.show().then(() => {
                    console.log('bannerAd show ok');
                  }).catch(res => {
                    console.log('bannerAd show error', JSON.stringify(res));
                  });
                });
              }, 1000);
            },
            hideBannerAd: function () {
              if (OPPOGameBridge.QQGameBannerAd) {
                OPPOGameBridge.QQGameBannerAd.destroy();
              }
            },
            // showFeedAd: function (scene, adId, expressViewWidth, expressViewHeight,
            //     isBottom, margin, displayBackground) {
            //     //qiaopc todo
            //     let adTop = Math.round(cc.view.getFrameSize().height - (margin + expressViewHeight));
            //     let adLeft = Math.round((cc.view.getFrameSize().width - expressViewWidth) / 2);
            //     console.log("QQGameFeedAd->", adTop, "-", adLeft, "-", expressViewWidth, "-", expressViewHeight)
            //     OPPOGameBridge.QQGameFeedAd = qq.createBannerAd({
            //         adUnitId: '0bb6658fecbe4c37192011288a54365b',
            //         style: {
            //             left: adLeft,
            //             top: adTop,
            //             width: expressViewWidth > 300 ? expressViewWidth : 300,
            //             height: expressViewHeight,
            //         }
            //     });
            //     OPPOGameBridge.QQGameFeedAd.onResize(size => {
            //         console.log('Resize后正式宽高:', size.width, size.height);
            //         OPPOGameBridge.QQGameFeedAd.style.top = adTop;
            //         OPPOGameBridge.QQGameFeedAd.style.left = adLeft;
            //         OPPOGameBridge.QQGameFeedAd.show().then(() => {
            //             console.log('bannerAd show ok')
            //         }).catch((res) => {
            //             console.log('bannerAd show error', res)
            //         });
            //     });
            // },
            // hideFeedAd: function () {
            //     if (OPPOGameBridge.QQGameFeedAd) {
            //         OPPOGameBridge.QQGameFeedAd.destroy();
            //     }
            // },
            showBlockAd: function (callback) {
              //qiaopc todo
              if (!Global.QQGameEnv) return;
              OPPOGameBridge.QQGameBlockAdNeedClose = false;

              if (OPPOGameBridge.QQGameBlockAd) {
                OPPOGameBridge.QQGameBlockAd.destroy();
              }

              let expressViewWidth = 300;
              let expressViewHeight = 500;
              let adTop = cc.view.getFrameSize().height - parseInt(350 * cc.view.getFrameSize().height / cc.winSize.height);
              let adLeft = 10;
              console.log("QQGameshowBlockAd->", adTop, "-", adLeft, "-", expressViewWidth, "-", expressViewHeight);
              OPPOGameBridge.QQGameBlockAd = qq.createBlockAd({
                adUnitId: '16a963085b6bf9c35848b27c01527efe',
                size: 5,
                orientation: 'landscape',
                style: {
                  left: adLeft,
                  top: adTop
                }
              });
              OPPOGameBridge.QQGameBlockAd.onResize(size => {
                if (OPPOGameBridge.QQGameBlockAdNeedClose) {
                  return;
                }

                console.log('showBlockAd Resize后正式宽高:', size.width, size.height, size);
                OPPOGameBridge.QQGameBlockAd.style.top = adTop;
                OPPOGameBridge.QQGameBlockAd.style.left = adLeft;
                OPPOGameBridge.QQGameBlockAd.show().then(() => {
                  console.log('showBlockAd show ok');

                  if (typeof callback == "function") {
                    callback();
                  }
                }).catch(res => {
                  console.log('showBlockAd show error', res);
                });
              });
            },
            hideBlockAd: function () {
              if (!Global.QQGameEnv) return;
              OPPOGameBridge.QQGameBlockAdNeedClose = true;

              if (OPPOGameBridge.QQGameBlockAd) {
                OPPOGameBridge.QQGameBlockAd.destroy();
              }
            },
            showAppBox: function () {
              if (qg.getSystemInfoSync().platformVersionCode >= 1076) {
                OPPOGameBridge.QQGameAppBox = qg.createGamePortalAd({
                  adUnitId: '554626'
                });
                OPPOGameBridge.QQGameAppBox.load().then(() => {
                  OPPOGameBridge.QQGameAppBox.show();
                });
              } else {
                console.log('快应用平台版本号低于1076，暂不支持互推盒子相关 API');
              }
            },
            hideAppBox: function () {
              if (OPPOGameBridge.QQGameAppBox) {
                OPPOGameBridge.QQGameAppBox.destroy();
              }
            },
            QQGameAdCloseHandler: function (res) {
              // 用户点击了【关闭广告】按钮
              if (res && res.isEnded || res === undefined) {
                // 正常播放结束，可以下发奖励
                console.log("QQad播放完毕");

                if (OPPOGameBridge.QQGameAdCurScene) {
                  Global.onRewardAdCallback(true, OPPOGameBridge.QQGameAdCurScene);
                }
              } else {
                //提前关闭小程序
                console.log("QQad提前关闭");

                if (OPPOGameBridge.QQGameAdCurScene) {
                  Global.onRewardAdCallback(false, OPPOGameBridge.QQGameAdCurScene);
                }
              }
            },
            QQGameInterstitialAdCloseHandler: function () {
              console.log("QQshowInterstitialAd->close");
              Global.onInterstitialAdDismissCallback(ConstValue.AdScene.HuluInterstitial);
            },
            QQGameInterstitialAdErrorHandler: function (e) {
              console.log("QQshowInterstitialAd->error", e);
              Global.onInterstitialAdDismissCallback(ConstValue.AdScene.HuluInterstitial);
            },
            QQGameInterstitialAdOnLoadHandler: function () {
              console.log('QQshowInterstitialAd->onLoad event emit');
              /* 建议放在需要展示插屏广告的时机执行 */

              OPPOGameBridge.QQGameInterstitialAd.show().catch(err => {
                console.error('QQshowInterstitialAd->show', err);
                Global.onInterstitialAdDismissCallback(ConstValue.AdScene.HuluInterstitial);
              });
            },
            showInterstitialAd: function () {
              if (!OPPOGameBridge.QQGameInterstitialAdInitComplete) {
                /* 建议放在onReady里执行，提前加载广告 */
                OPPOGameBridge.QQGameInterstitialAd = qq.createInterstitialAd({
                  adUnitId: '4979b75729eb0f5a8c0b5ed0d7a437ef'
                });
                OPPOGameBridge.QQGameInterstitialAdInitComplete = true;
              }

              try {
                if (OPPOGameBridge.QQGameInterstitialAdCloseHandler) {
                  OPPOGameBridge.QQGameInterstitialAd.offClose(OPPOGameBridge.QQGameInterstitialAdCloseHandler);
                  console.log("---QQGameInterstitialAd.offClose 卸载成功---");
                }
              } catch (e) {
                console.log("---QQGameInterstitialAd.offClose 卸载失败---");
                console.error(e);
              }

              try {
                if (OPPOGameBridge.QQGameInterstitialAdErrorHandler) {
                  OPPOGameBridge.QQGameInterstitialAd.offError(OPPOGameBridge.QQGameInterstitialAdErrorHandler);
                  console.log("---QQGameInterstitialAd.offError 卸载成功---");
                }
              } catch (e) {
                console.log("---QQGameInterstitialAd.offError 卸载失败---");
                console.error(e);
              }

              try {
                if (OPPOGameBridge.QQGameInterstitialAdOnLoadHandler) {
                  OPPOGameBridge.QQGameInterstitialAd.offLoad(OPPOGameBridge.QQGameInterstitialAdOnLoadHandler);
                  console.log("---QQGameInterstitialAd.offLoad 卸载成功---");
                }
              } catch (e) {
                console.log("---QQGameInterstitialAd.offLoad 卸载失败---");
                console.error(e);
              }

              OPPOGameBridge.QQGameInterstitialAd.load().catch(err => {
                console.error('QQshowInterstitialAd->load', err);
                Global.onInterstitialAdDismissCallback(ConstValue.AdScene.HuluInterstitial);
              });
              OPPOGameBridge.QQGameInterstitialAd.onLoad(OPPOGameBridge.QQGameInterstitialAdOnLoadHandler);
              OPPOGameBridge.QQGameInterstitialAd.onClose(OPPOGameBridge.QQGameInterstitialAdCloseHandler);
              OPPOGameBridge.QQGameInterstitialAd.onError(OPPOGameBridge.QQGameInterstitialAdErrorHandler);
            },

            onClickShare(text) {
              canvas.toTempFilePath({
                x: 0,
                y: 1000,
                width: 1250,
                height: 1000,
                destWidth: 500,
                destHeight: 400,
                success: res => {
                  qq.shareAppMessage({
                    title: text ? text : '',
                    imageUrl: res.tempFilePath,

                    success(res) {
                      console.log("****转发成功!!!");
                    },

                    fail(res) {
                      console.log("****转发失败!!!");
                    }

                  });
                }
              });
            },

            addColorSign() {
              qq.addColorSign();
            },

            saveAppToDesktop() {
              qq.saveAppToDesktop();
            },

            NativeAdBigResList: null,
            NativeAd: null,
            NativeAdOnLoadCallback: null,
            NativeAdOnErrorCallback: null,

            showNativeAdBig(callback) {
              console.log('原生广告加载showNativeAdBig');

              if (OPPOGameBridge.NativeAd) {
                OPPOGameBridge.NativeAd.offLoad(OPPOGameBridge.NativeAdOnLoadCallback);
                OPPOGameBridge.NativeAd.offError(OPPOGameBridge.NativeAdOnErrorCallback);
                OPPOGameBridge.NativeAd = null;
              }

              OPPOGameBridge.NativeAd = qg.createNativeAd({
                adUnitId: '553942'
              });

              OPPOGameBridge.NativeAdOnLoadCallback = function (res) {
                // console.log('原生广告加载',res.adList[0].adId,res.adList[0].title,res.adList[0].desc,res.adList[0].icon,res.adList[0].imgUrlList,res.adList[0].logoUrl,res.adList[0].clickBtnTxt,res.adList[0].creativeType,res.adList[0].interactionType)
                console.log('原生广告加载', JSON.stringify(res));
                OPPOGameBridge.NativeAdBigResList = res.adList[0];
                console.log("链接：", OPPOGameBridge.NativeAdBigResList.imgUrlList);
                cc.loader.load(res.adList[0].imgUrlList, (error, texture) => {
                  console.log("原生广告加载图片0->", JSON.stringify(error));
                  console.log("原生广告加载图片1->", texture);
                  var frame = new cc.SpriteFrame(texture); // self.node.getComponent(cc.Sprite).spriteFrame=frame;

                  OPPOGameBridge.NativeAd.reportAdShow({
                    adId: OPPOGameBridge.NativeAdBigResList.adId
                  });
                  callback(frame, res.adList[0].desc); // return frame;
                });
              };

              OPPOGameBridge.NativeAd.onLoad(OPPOGameBridge.NativeAdOnLoadCallback);

              OPPOGameBridge.NativeAdOnErrorCallback = function (err) {
                console.log("原生广告加载失败", JSON.stringify(err)); // return null;

                callback(null);
              };

              OPPOGameBridge.NativeAd.onError(OPPOGameBridge.NativeAdOnErrorCallback);
              OPPOGameBridge.NativeAd.load();
            },

            onClickNativeAdBig() {
              if (OPPOGameBridge.NativeAdBigResList) {
                if (OPPOGameBridge.NativeAd) {
                  OPPOGameBridge.NativeAd.reportAdClick({
                    adId: OPPOGameBridge.NativeAdBigResList.adId
                  });
                  OPPOGameBridge.hideNativeAdBig();
                }
              }
            },

            hideNativeAdBig() {
              if (OPPOGameBridge.NativeAd) {
                OPPOGameBridge.NativeAd.destroy();
              }
            },

            NativeAdIconResList: null,
            NativeAdIcon: null,
            NativeAdIconOnLoadCallback: null,
            NativeAdIconOnErrorCallback: null,

            showNativeAdIcon(callback) {
              console.log('原生广告Icon加载showNativeAdIcon');

              if (OPPOGameBridge.NativeAdIcon) {
                OPPOGameBridge.NativeAdIcon.offLoad(OPPOGameBridge.NativeAdIconOnLoadCallback);
                OPPOGameBridge.NativeAdIcon.offError(OPPOGameBridge.NativeAdIconOnErrorCallback);
                OPPOGameBridge.NativeAdIcon = null;
              }

              OPPOGameBridge.NativeAdIcon = qg.createNativeAd({
                adUnitId: '552888'
              });

              OPPOGameBridge.NativeAdIconOnLoadCallback = function (res) {
                // console.log('原生广告加载',res.adList[0].adId,res.adList[0].title,res.adList[0].desc,res.adList[0].icon,res.adList[0].imgUrlList,res.adList[0].logoUrl,res.adList[0].clickBtnTxt,res.adList[0].creativeType,res.adList[0].interactionType)
                console.log('原生广告加载', JSON.stringify(res));
                OPPOGameBridge.NativeAdIconResList = res.adList[0];
                console.log("链接：", OPPOGameBridge.NativeAdIconResList.iconUrlList);
                cc.loader.load(res.adList[0].iconUrlList, (error, texture) => {
                  console.log("原生广告加载图片icon0->", JSON.stringify(error));
                  console.log("原生广告加载图片icon1->", texture);
                  var frame = new cc.SpriteFrame(texture);
                  OPPOGameBridge.NativeAdIcon.reportAdShow({
                    adId: OPPOGameBridge.NativeAdIconResList.adId
                  });
                  callback(frame);
                });
              };

              OPPOGameBridge.NativeAdIcon.onLoad(OPPOGameBridge.NativeAdIconOnLoadCallback);

              OPPOGameBridge.NativeAdIconOnErrorCallback = function (err) {
                console.log("原生广告icon加载失败", JSON.stringify(err));
                callback(null);
              };

              OPPOGameBridge.NativeAdIcon.onError(OPPOGameBridge.NativeAdIconOnErrorCallback);
              OPPOGameBridge.NativeAdIcon.load();
            },

            onClickNativeAdIcon() {
              if (OPPOGameBridge.NativeAdIconResList) {
                if (OPPOGameBridge.NativeAdIcon) {
                  OPPOGameBridge.NativeAdIcon.reportAdClick({
                    adId: OPPOGameBridge.NativeAdIconResList.adId
                  });
                  OPPOGameBridge.hideNativeAdIcon();
                }
              }
            },

            hideNativeAdIcon() {
              if (OPPOGameBridge.NativeAdIcon) {
                OPPOGameBridge.NativeAdIcon.destroy();
              }
            },

            QQGameCustomAdInitComplete: false,
            QQGameCustomAd: null,
            QQGameCustomAdCloseHandler: function () {
              console.log("QQshowCustomAd->close");
              OPPOGameBridge.QQGameCustomAdInitComplete = false; // Global.onCustomAdDismissCallback(ConstValue.AdScene.HuluInterstitial);
            },
            QQGameCustomAdErrorHandler: function (e) {
              console.log("QQshowCustomAd->error", e);
              OPPOGameBridge.QQGameCustomAdInitComplete = false; // Global.onCustomAdDismissCallback(ConstValue.AdScene.HuluInterstitial);
            },
            QQGameCustomAdOnLoadHandler: function () {
              console.log('QQshowCustomAd->onLoad event emit');
              /* 建议放在需要展示插屏广告的时机执行 */

              OPPOGameBridge.QQGameCustomAd.show().catch(err => {
                console.error('QQshowCustomAd->show', err);
                Global.onCustomAdDismissCallback(ConstValue.AdScene.HuluInterstitial);
              });
            },
            showCustomAd: function (adTop) {
              if (!OPPOGameBridge.QQGameCustomAdInitComplete) {
                let adWidth = parseInt(cc.view.getFrameSize().width);
                OPPOGameBridge.QQGameCustomAd = qg.createCustomAd({
                  adUnitId: '555187',
                  style: {
                    top: adTop,
                    left: 0,
                    width: adWidth
                  }
                });
                OPPOGameBridge.QQGameCustomAdInitComplete = true;
              }

              try {
                if (OPPOGameBridge.QQGameCustomAdCloseHandler) {
                  OPPOGameBridge.QQGameCustomAd.offHide(OPPOGameBridge.QQGameCustomAdCloseHandler);
                  console.log("---QQGameCustomAd.offClose 卸载成功---");
                }
              } catch (e) {
                console.log("---QQGameCustomAd.offClose 卸载失败---");
                console.error(e);
              }

              try {
                if (OPPOGameBridge.QQGameCustomAdErrorHandler) {
                  OPPOGameBridge.QQGameCustomAd.offError(OPPOGameBridge.QQGameCustomAdErrorHandler);
                  console.log("---QQGameCustomAd.offError 卸载成功---");
                }
              } catch (e) {
                console.log("---QQGameCustomAd.offError 卸载失败---");
                console.error(e);
              }

              try {
                if (OPPOGameBridge.QQGameCustomAdOnLoadHandler) {
                  OPPOGameBridge.QQGameCustomAd.offLoad(OPPOGameBridge.QQGameCustomAdOnLoadHandler);
                  console.log("---QQGameCustomAd.offLoad 卸载成功---");
                }
              } catch (e) {
                console.log("---QQGameCustomAd.offLoad 卸载失败---");
                console.error(e);
              }

              OPPOGameBridge.QQGameCustomAd.show().then(() => {
                console.log('show success');
              }).catch(error => {
                console.log('show fail with:' + error.errCode + ',' + error.errMsg);
                Global.onCustomAdDismissCallback(ConstValue.AdScene.HuluInterstitial);
              });
              OPPOGameBridge.QQGameCustomAd.onLoad(OPPOGameBridge.QQGameCustomAdOnLoadHandler);
              OPPOGameBridge.QQGameCustomAd.onHide(OPPOGameBridge.QQGameCustomAdCloseHandler);
              OPPOGameBridge.QQGameCustomAd.onError(OPPOGameBridge.QQGameCustomAdErrorHandler);
            }
          };
          window.OPPOGameBridge = OPPOGameBridge;
        })();

        _cjsExports = exports('default', module.exports);
      });

      const __cjsMetaURL = exports('__cjsMetaURL', module.meta.url);
    }
  };
});

System.register("chunks:///_virtual/csvManager.ts", ['cc', './_rollupPluginModLoBabelHelpers.js'], function (exports) {
  'use strict';

  var cclegacy, _decorator, _defineProperty;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      _defineProperty = module.defineProperty;
    }],
    execute: function () {
      var _dec, _class, _class2, _temp;

      cclegacy._RF.push({}, "d7554BuqnJLAKibwVUWte5P", "csvManager", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      var CELL_DELIMITERS = [",", ";", "\t", "|", "^"];
      var LINE_DELIMITERS = ["\r\n", "\r", "\n"];

      var getterCast = function (value, index, cast, d) {
        if (cast instanceof Array) {
          if (cast[index] === "number") {
            return Number(d[index]);
          } else if (cast[index] === "boolean") {
            return d[index] === "true" || d[index] === "t" || d[index] === "1";
          } else {
            return d[index];
          }
        } else {
          if (!isNaN(Number(value))) {
            return Number(d[index]);
          } else if (value == "false" || value == "true" || value == "t" || value == "f") {
            return d[index] === "true" || d[index] === "t" || d[index] === "1";
          } else {
            return d[index];
          }
        }
      };

      var CSV = {
        //

        /* =========================================
            * Constants ===============================
            * ========================================= */
        STANDARD_DECODE_OPTS: {
          skip: 0,
          limit: false,
          header: false,
          cast: false,
          comment: ""
        },
        STANDARD_ENCODE_OPTS: {
          delimiter: CELL_DELIMITERS[0],
          newline: LINE_DELIMITERS[0],
          skip: 0,
          limit: false,
          header: false
        },
        quoteMark: '"',
        doubleQuoteMark: '""',
        quoteRegex: /"/g,

        /* =========================================
            * Utility Functions =======================
            * ========================================= */
        assign: function () {
          var args = Array.prototype.slice.call(arguments);
          var base = args[0];
          var rest = args.slice(1);

          for (var i = 0, len = rest.length; i < len; i++) {
            for (var attr in rest[i]) {
              base[attr] = rest[i][attr];
            }
          }

          return base;
        },
        map: function (collection, fn) {
          var results = [];

          for (var i = 0, len = collection.length; i < len; i++) {
            results[i] = fn(collection[i], i);
          }

          return results;
        },
        getType: function (obj) {
          return Object.prototype.toString.call(obj).slice(8, -1);
        },
        getLimit: function (limit, len) {
          return limit === false ? len : limit;
        },
        buildObjectConstructor: function (fields, sample, cast) {
          return function (d) {
            var object = new Object();

            var setter = function (attr, value) {
              return object[attr] = value;
            };

            if (cast) {
              fields.forEach(function (attr, idx) {
                setter(attr, getterCast(sample[idx], idx, cast, d));
              });
            } else {
              fields.forEach(function (attr, idx) {
                setter(attr, getterCast(sample[idx], idx, null, d));
              });
            } // body.push("return object;");
            // body.join(";\n");


            return object;
          };
        },
        buildArrayConstructor: function (fields, sample, cast) {
          return function (d) {
            var row = new Array(sample.length);

            var setter = function (idx, value) {
              return row[idx] = value;
            };

            if (cast) {
              fields.forEach(function (attr, idx) {
                setter(attr, getterCast(sample[idx], idx, cast, d));
              });
            } else {
              fields.forEach(function (attr, idx) {
                setter(attr, getterCast(sample[idx], idx, null, d));
              });
            }

            return row;
          };
        },
        frequency: function (coll, needle, limit) {
          if (limit === void 0) limit = false;
          var count = 0;
          var lastIndex = 0;
          var maxIndex = this.getLimit(limit, coll.length);

          while (lastIndex < maxIndex) {
            lastIndex = coll.indexOf(needle, lastIndex);
            if (lastIndex === -1) break;
            lastIndex += 1;
            count++;
          }

          return count;
        },
        mostFrequent: function (coll, needles, limit) {
          var max = 0;
          var detected;

          for (var cur = needles.length - 1; cur >= 0; cur--) {
            if (this.frequency(coll, needles[cur], limit) > max) {
              detected = needles[cur];
            }
          }

          return detected || needles[0];
        },
        unsafeParse: function (text, opts, fn) {
          var lines = text.split(opts.newline);

          if (opts.skip > 0) {
            lines.splice(opts.skip);
          }

          var fields;
          var constructor;

          function cells(lines) {
            var line = lines.shift();

            if (line.indexOf('"') >= 0) {
              // 含引号
              // 找到这行完整的数据, 找到对称的双引号
              var lastIndex = 0;
              var findIndex = 0;
              var count = 0;

              while (lines.length > 0) {
                lastIndex = line.indexOf('"', findIndex);
                if (lastIndex === -1 && count % 2 === 0) break;

                if (lastIndex !== -1) {
                  findIndex = lastIndex + 1;
                  count++;
                } else {
                  line = line + opts.newline + lines.shift();
                }
              }

              var list = [];
              var item;
              var quoteCount = 0;
              var start = 0;
              var end = 0;
              var length = line.length;

              for (var key in line) {
                if (!line.hasOwnProperty(key)) {
                  continue;
                }

                let numKey = parseInt(key);
                var value = line[key];

                if (numKey === 0 && value === '"') {
                  quoteCount++;
                  start = 1;
                }

                if (value === '"') {
                  quoteCount++;

                  if (line[numKey - 1] === opts.delimiter && start === numKey) {
                    start++;
                  }
                }

                if (value === '"' && quoteCount % 2 === 0) {
                  if (line[numKey + 1] === opts.delimiter || numKey + 1 === length) {
                    end = numKey;
                    item = line.substring(start, end);
                    list.push(item);
                    start = end + 2;
                    end = start;
                  }
                }

                if (value === opts.delimiter && quoteCount % 2 === 0) {
                  end = numKey;

                  if (end > start) {
                    item = line.substring(start, end);
                    list.push(item);
                    start = end + 1;
                    end = start;
                  } else if (end === start) {
                    list.push("");
                    start = end + 1;
                    end = start;
                  }
                }
              }

              end = length;

              if (end >= start) {
                item = line.substring(start, end);
                list.push(item);
              }

              return list;
            } else {
              return line.split(opts.delimiter);
            }
          }

          if (opts.header) {
            if (opts.header === true) {
              opts.comment = cells(lines); // 第一行是注释

              opts.cast = cells(lines); // 第二行是数据类型

              fields = cells(lines);
            } else if (this.getType(opts.header) === "Array") {
              fields = opts.header;
            }

            constructor = this.buildObjectConstructor(fields, lines[0].split(opts.delimiter), opts.cast);
          } else {
            constructor = this.buildArrayConstructor(fields, lines[0].split(opts.delimiter), opts.cast);
          }

          while (lines.length > 0) {
            var row = cells(lines);

            if (row.length > 1) {
              fn(constructor(row), fields[0]);
            }
          }

          return true;
        },
        safeParse: function (text, opts, fn) {
          var delimiter = opts.delimiter;
          var newline = opts.newline;
          var lines = text.split(newline);

          if (opts.skip > 0) {
            lines.splice(opts.skip);
          }

          return true;
        },
        encodeCells: function (line, delimiter, newline) {
          var row = line.slice(0);

          for (var i = 0, len = row.length; i < len; i++) {
            if (row[i].indexOf(this.quoteMark) !== -1) {
              row[i] = row[i].replace(this.quoteRegex, this.doubleQuoteMark);
            }

            if (row[i].indexOf(delimiter) !== -1 || row[i].indexOf(newline) !== -1) {
              row[i] = this.quoteMark + row[i] + this.quoteMark;
            }
          }

          return row.join(delimiter);
        },
        encodeArrays: function (coll, opts, fn) {
          var delimiter = opts.delimiter;
          var newline = opts.newline;

          if (opts.header && this.getType(opts.header) === "Array") {
            fn(this.encodeCells(opts.header, delimiter, newline));
          }

          for (var cur = 0, lim = this.getLimit(opts.limit, coll.length); cur < lim; cur++) {
            fn(this.encodeCells(coll[cur], delimiter, newline));
          }

          return true;
        },
        encodeObjects: function (coll, opts, fn) {
          var delimiter = opts.delimiter;
          var newline = opts.newline;
          var header;
          var row;
          header = [];
          row = [];

          for (var key in coll[0]) {
            header.push(key);
            row.push(coll[0][key]);
          }

          if (opts.header === true) {
            fn(this.encodeCells(header, delimiter, newline));
          } else if (this.getType(opts.header) === "Array") {
            fn(this.encodeCells(opts.header, delimiter, newline));
          } //@ts-ignore


          fn(this.encodeCells(row, delimiter));

          for (var cur = 1, lim = this.getLimit(opts.limit, coll.length); cur < lim; cur++) {
            row = [];

            for (var key$1 = 0, len = header.length; key$1 < len; key$1++) {
              row.push(coll[cur][header[key$1]]);
            }

            fn(this.encodeCells(row, delimiter, newline));
          }

          return true;
        },
        parse: function (text, opts, fn) {
          var rows;

          if (this.getType(opts) === "Function") {
            fn = opts;
            opts = {};
          } else if (this.getType(fn) !== "Function") {
            rows = [];
            fn = rows.push.bind(rows);
          } else {
            rows = [];
          } //@ts-ignore


          opts = this.assign({}, this.STANDARD_DECODE_OPTS, opts); //@ts-ignore

          this.opts = opts;

          if (!opts.delimiter || !opts.newline) {
            var limit = Math.min(48, Math.floor(text.length / 20), text.length);
            opts.delimiter = opts.delimiter || this.mostFrequent(text, CELL_DELIMITERS, limit);
            opts.newline = opts.newline || this.mostFrequent(text, LINE_DELIMITERS, limit);
          } // modify by jl 由表自行控制不要含有双引号.提高解析效率


          return this.unsafeParse(text, opts, fn) && (rows.length > 0 ? rows : true);
        },
        encode: function (coll, opts, fn) {
          var lines;

          if (this.getType(opts) === "Function") {
            fn = opts;
            opts = {};
          } else if (this.getType(fn) !== "Function") {
            lines = [];
            fn = lines.push.bind(lines);
          } //@ts-ignore


          opts = this.assign({}, this.STANDARD_ENCODE_OPTS, opts);

          if (opts.skip > 0) {
            coll = coll.slice(opts.skip);
          }

          return (this.getType(coll[0]) === "Array" ? this.encodeArrays : this.encodeObjects)(coll, opts, fn) && (lines.length > 0 ? lines.join(opts.newline) : true);
        }
      };
      let CSVManager = exports('CSVManager', (_dec = ccclass("CSVManager"), _dec(_class = (_temp = _class2 = class CSVManager {
        constructor() {
          _defineProperty(this, "_csvTables", {});

          _defineProperty(this, "_csvTableForArr", {});

          _defineProperty(this, "_tableCast", {});

          _defineProperty(this, "_tableComment", {});
        }

        static get instance() {
          if (this._instance) {
            return this._instance;
          }

          this._instance = new CSVManager();
          return this._instance;
        }

        addTable(tableName, tableContent, force) {
          if (this._csvTables[tableName] && !force) {
            return;
          }

          let tableData = {};
          let tableArr = [];
          let opts = {
            header: true
          };
          CSV.parse(tableContent, opts, function (row, keyName) {
            tableData[row[keyName]] = row;
            tableArr.push(row);
          });
          this._tableCast[tableName] = CSV.opts.cast;
          this._tableComment[tableName] = CSV.opts.comment;
          this._csvTables[tableName] = tableData;
          this._csvTableForArr[tableName] = tableArr; //this.csvTables[tableName].initFromText(tableContent);
        }
        /**
        * 根据表名获取表的所有内容
        * @param {string} tableName  表名
        * @returns {object} 表内容
        */


        getTableArr(tableName) {
          return this._csvTableForArr[tableName];
        }
        /**
         * 根据表名获取表的所有内容
         * @param {string} tableName  表名
         * @returns {object} 表内容
         */


        getTable(tableName) {
          return this._csvTables[tableName];
        }
        /**
         * 查询一条表内容
         * @param {string} tableName 表名
         * @param {string} key 列名
         * @param {any} value 值
         * @returns {Object} 一条表内容
         */


        queryOne(tableName, key, value) {
          var table = this.getTable(tableName);

          if (!table) {
            return null;
          }

          if (key) {
            for (var tbItem in table) {
              if (!table.hasOwnProperty(tbItem)) {
                continue;
              }

              if (table[tbItem][key] === value) {
                return table[tbItem];
              }
            }
          } else {
            return table[value];
          }
        }
        /**
         * 根据ID查询一条表内容
         * @param {string}tableName 表名
         * @param {string}ID
         * @returns {Object} 一条表内容
         */


        queryByID(tableName, ID) {
          //@ts-ignore
          return this.queryOne(tableName, null, ID);
        }
        /**
         * 查询key和value对应的所有行内容
         * @param {string} tableName 表名
         * @param {string} key 列名
         * @param {any} value 值
         * @returns {Object}
         */


        queryAll(tableName, key, value) {
          var table = this.getTable(tableName);

          if (!table || !key) {
            return null;
          }

          var ret = {};

          for (var tbItem in table) {
            if (!table.hasOwnProperty(tbItem)) {
              continue;
            }

            if (table[tbItem][key] === value) {
              ret[tbItem] = table[tbItem];
            }
          }

          return ret;
        }
        /**
         * 选出指定表里所有 key 的值在 values 数组中的数据，返回 Object，key 为 ID
         * @param {string} tableName 表名
         * @param {string} key  列名
         * @param {Array}values 数值
         * @returns 
         */


        queryIn(tableName, key, values) {
          var table = this.getTable(tableName);

          if (!table || !key) {
            return null;
          }

          var ret = {};
          var keys = Object.keys(table);
          var length = keys.length;

          for (var i = 0; i < length; i++) {
            var item = table[keys[i]];

            if (values.indexOf(item[key]) > -1) {
              ret[keys[i]] = item;
            }
          }

          return ret;
        }
        /**
         * 选出符合条件的数据。condition key 为表格的key，value 为值的数组。返回的object，key 为数据在表格的ID，value为具体数据
         * @param {string} tableName 表名
         * @param {any} condition 筛选条件
         * @returns 
         */


        queryByCondition(tableName, condition) {
          if (condition.constructor !== Object) {
            return null;
          }

          var table = this.getTable(tableName);

          if (!table) {
            return null;
          }

          var ret = {};
          var tableKeys = Object.keys(table);
          var tableKeysLength = tableKeys.length;
          var keys = Object.keys(condition);
          var keysLength = keys.length;

          for (var i = 0; i < tableKeysLength; i++) {
            var item = table[tableKeys[i]];
            var fit = true;

            for (var j = 0; j < keysLength; j++) {
              var key = keys[j];
              fit = fit && condition[key] === item[key] && !ret[tableKeys[i]];
            }

            if (fit) {
              ret[tableKeys[i]] = item;
            }
          }

          return ret;
        }

        queryOneByCondition(tableName, condition) {
          if (condition.constructor !== Object) {
            return null;
          }

          var table = this.getTable(tableName);

          if (!table) {
            return null;
          }

          var keys = Object.keys(condition);
          var keysLength = keys.length;

          for (let keyName in table) {
            var item = table[keyName];
            var fit = true;

            for (var j = 0; j < keysLength; j++) {
              var key = keys[j];
              fit = fit && condition[key] === item[key];
            }

            if (fit) {
              return item;
            }
          }

          return null;
        }

      }, _defineProperty(_class2, "_instance", void 0), _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/lottery.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './resourceUtil.ts', './constants.ts', './clientEvent.ts', './utils.ts', './localConfig.ts', './playerData.ts', './uiManager.ts', './buttonEx.ts', './LanguageData.ts', './PlatformBridge.js', './PlatformBridge.mjs_cjs=&original=.js', './gameLogic.ts', './ConstValue.js', './ConstValue.mjs_cjs=&original=.js', './lotteryItem.ts'], function (exports) {
  'use strict';

  var cclegacy, Node, Animation, Prefab, Label, _decorator, Component, Vec3, instantiate, tween, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, resourceUtil, constants, clientEvent, utils, localConfig, playerData, uiManager, ButtonEx, t, _cjsExports, GameLogic, _cjsExports$1, LotteryItem;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Animation = module.Animation;
      Prefab = module.Prefab;
      Label = module.Label;
      _decorator = module._decorator;
      Component = module.Component;
      Vec3 = module.Vec3;
      instantiate = module.instantiate;
      tween = module.tween;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      clientEvent = module.clientEvent;
    }, function (module) {
      utils = module.utils;
    }, function (module) {
      localConfig = module.localConfig;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      ButtonEx = module.ButtonEx;
    }, function (module) {
      t = module.t;
    }, function (module) {
      _cjsExports = module.default;
    }, null, function (module) {
      GameLogic = module.GameLogic;
    }, function (module) {
      _cjsExports$1 = module.default;
    }, null, function (module) {
      LotteryItem = module.LotteryItem;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _dec10, _dec11, _dec12, _dec13, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _temp;

      cclegacy._RF.push({}, "da336DqBNdPOLmRdGzIoRW8", "lottery", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let Lottery = exports('Lottery', (_dec = ccclass('Lottery'), _dec2 = property(Node), _dec3 = property(Animation), _dec4 = property(Prefab), _dec5 = property(Label), _dec6 = property(Label), _dec7 = property(Label), _dec8 = property(Label), _dec9 = property(Node), _dec10 = property(Node), _dec11 = property(Node), _dec12 = property(Node), _dec13 = property(Node), _dec(_class = (_class2 = (_temp = class Lottery extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "arrRewardNode", _descriptor, this);

          _initializerDefineProperty(this, "aniLightGroup", _descriptor2, this);

          _initializerDefineProperty(this, "pfRewardItem", _descriptor3, this);

          _initializerDefineProperty(this, "lbSpareTimes", _descriptor4, this);

          _initializerDefineProperty(this, "lbAdSpareTimes", _descriptor5, this);

          _initializerDefineProperty(this, "lbShareSpareTimes", _descriptor6, this);

          _initializerDefineProperty(this, "lbGold", _descriptor7, this);

          _initializerDefineProperty(this, "ndBtnStart", _descriptor8, this);

          _initializerDefineProperty(this, "ndBtnAd", _descriptor9, this);

          _initializerDefineProperty(this, "ndBtnShare", _descriptor10, this);

          _initializerDefineProperty(this, "ndTurnable", _descriptor11, this);

          _initializerDefineProperty(this, "nativeAd", _descriptor12, this);

          _defineProperty(this, "dictReward", {});

          _defineProperty(this, "arrRewardData", []);

          _defineProperty(this, "arrProbability", void 0);

          _defineProperty(this, "times", void 0);

          _defineProperty(this, "moreTimes", void 0);

          _defineProperty(this, "isBtnStartShow", void 0);

          _defineProperty(this, "randValue", void 0);

          _defineProperty(this, "itemNode", void 0);
        }

        ctor() {
          this.dictReward = {}; //存在预制件的字典

          this.arrRewardData = []; //存放lottery表数据的数组
        }

        onLoad() {
          Global.lottery = this;
        }

        show() {
          let self = this;

          _cjsExports.showNativeAd((frame, string) => {
            let sc = self.nativeAd.getComponent("NativeAdBig");

            if (sc) {
              sc.setDateShow();
              sc.setSprite(frame);
              sc.setString(string);
            }
          });

          _cjsExports.showInterstitialAd();

          let arrRewardInfo = [{
            x: 0,
            y: 53,
            angle: new Vec3(0, 0, -0)
          }, {
            x: 32,
            y: 44,
            angle: new Vec3(0, 0, -36)
          }, {
            x: 51,
            y: 15,
            angle: new Vec3(0, 0, -72)
          }, {
            x: 51,
            y: -18,
            angle: new Vec3(0, 0, -108)
          }, {
            x: 32,
            y: -46,
            angle: new Vec3(0, 0, -144)
          }, {
            x: 0,
            y: -56,
            angle: new Vec3(0, 0, 180)
          }, {
            x: -32.6,
            y: -45.7,
            angle: new Vec3(0, 0, 144)
          }, {
            x: -51,
            y: -18,
            angle: new Vec3(0, 0, 108)
          }, {
            x: -51,
            y: 15,
            angle: new Vec3(0, 0, 72)
          }, {
            x: -32,
            y: 42,
            angle: new Vec3(0, 0, 36)
          }];
          this.ndTurnable.children.forEach((item, idx) => {
            let itemInfo = arrRewardInfo[idx];
            item.setPosition(itemInfo.x, itemInfo.y);
            item.eulerAngles = itemInfo.angle;
          });
          this.initReward();
          this.initInfo();
          this.updateGold();
        }

        onEnable() {
          clientEvent.on('updateGold', this.updateGold, this);
        }

        onDisable() {
          clientEvent.off('updateGold', this.updateGold, this);
        }

        initReward() {
          if (this.arrRewardData.length <= 0) {
            let tbLottery = localConfig.instance.getTable('lottery');
            this.arrRewardData = utils.objectToArray(tbLottery);
          }

          this.arrProbability = [];
          let start = 0;
          this.arrRewardData.forEach((val, idx, arr) => {
            let parentNode = this.arrRewardNode[idx];
            let rewardItem = this.dictReward[idx];

            if (!this.dictReward.hasOwnProperty(idx)) {
              rewardItem = instantiate(this.pfRewardItem);
              rewardItem.setPosition(0, -42, 0);
              rewardItem.parent = parentNode;
              this.dictReward[idx] = rewardItem;
            }

            if (this.arrRewardData.length > idx) {
              let info = this.arrRewardData[idx];
              let script = rewardItem.getComponent(LotteryItem);
              script.setInfo(info);
              let min = start;
              let max = start + info.probability;
              this.arrProbability.push({
                min: min,
                max: max,
                idx: idx
              }); //区间

              start = max;
            }
          });
        }

        initInfo() {
          this.times = playerData.instance.getLotterySpareTimes(false);
          this.moreTimes = playerData.instance.getLotterySpareTimes(true);
          this.lbSpareTimes.string = `${this.times}/${constants.LOTTERY_MAX_TIMES}`;
          this.lbAdSpareTimes.string = `${this.moreTimes}/${constants.LOTTERY_AD_MAX_TIMES}`;
          this.lbShareSpareTimes.string = `${this.moreTimes}/${constants.LOTTERY_AD_MAX_TIMES}`;
          this.checkBtnStatus();
        }

        checkBtnStatus() {
          if (this.times <= 0) {
            this.showBtnShareOrAd(); //显示分享或者广告按钮

            if (this.moreTimes <= 0) {
              this.ndBtnAd.getComponent(ButtonEx).interactable = false;
              this.ndBtnShare.getComponent(ButtonEx).interactable = false;
              this.lbAdSpareTimes.node.active = false;
              this.lbShareSpareTimes.node.active = false;
              resourceUtil.setGray(this.ndBtnAd, true);
              resourceUtil.setGray(this.ndBtnShare, true);
            }
          } else {
            this.ndBtnStart.active = true;
            this.ndBtnStart.getComponent(ButtonEx).interactable = true;
          }
        }

        updateGold() {
          this.lbGold.string = utils.formatMoney(playerData.instance.getGold());
        }

        onBtnStartClick() {
          this.showSelectUI(this.ndBtnStart, this.lbSpareTimes, false);
        }

        showSelectUI(node, label, isMore) {
          this.isBtnStartShow = true;
          node.getComponent(ButtonEx).interactable = false;

          for (let i in this.dictReward) {
            this.dictReward[i].getComponent(LotteryItem).setSelect(false);
          }

          playerData.instance.addLotteryTimes(isMore);

          if (isMore) {
            this.moreTimes = playerData.instance.getLotterySpareTimes(isMore);
            label.string = `${this.moreTimes}/${constants.LOTTERY_AD_MAX_TIMES}`;
          } else {
            this.times = playerData.instance.getLotterySpareTimes(isMore);
            label.string = `${this.times}/${constants.LOTTERY_MAX_TIMES}`;
          }

          clientEvent.dispatchEvent('updateLotterySpareTimes');
          this.randValue = this.getRandValue(); // this.aniLightGroup.play();

          this.startRun();
        }

        startRun() {
          let targetAngle = 360;
          let eulZ = this.ndTurnable.eulerAngles.z;
          eulZ = eulZ % 360;
          this.ndTurnable.setRotationFromEuler(0, 0, eulZ);
          let offset = 360 - eulZ;
          let randTimes = 3 + Math.floor(Math.random() * 4); //旋转的随机次数

          tween(this.ndTurnable).to(offset / 360 + randTimes * 0.5, {
            eulerAngles: new Vec3(0, 0, targetAngle + randTimes * 360 + this.randValue * 36)
          }, {
            easing: 'circInOut'
          }).call(() => {
            this.showReward();
          }).start();
        }

        getRandValue() {
          let randIdx = -1;
          let rand = Math.floor(Math.random() * 100);

          for (let i = 0; i < this.arrProbability.length; i++) {
            let probability = this.arrProbability[i];

            if (rand >= probability.min && rand < probability.max) {
              randIdx = probability.idx;
              break;
            }
          }

          if (randIdx !== -1) {
            return randIdx;
          }

          return this.getRandValue();
        }

        showReward() {
          // this.aniLightGroup.stop();
          this.itemNode = this.dictReward[this.randValue];
          let lotteryItemScript = this.itemNode.getComponent(LotteryItem);
          lotteryItemScript.setSelect(true);

          if (this.isBtnStartShow) {
            this.checkBtnStatus();
            this.isBtnStartShow = false;
          }
        }

        onBtnAddDiamondClick() {
          uiManager.instance.showTips(t('lottery.noChargePleaseWait'));
        }

        onBtnAdClick() {
          //todo
          _cjsExports.showRewardAd("onBtnAdClick", "1", _cjsExports$1.getAdReward()); // GameLogic.instance.showRewardAd((err: any) => {
          //     if (!err) {
          //     }
          // });

        }

        onBtnAdClickCallback(s) {
          if (s) {
            this.showSelectUI(this.ndBtnAd, this.lbAdSpareTimes, true);
          }
        }

        onBtnShareClick() {
          GameLogic.instance.share(constants.SHARE_FUNCTION.LOTTERY, {}, err => {
            if (!err) {
              this.showSelectUI(this.ndBtnShare, this.lbShareSpareTimes, true);
            }
          });
        }

        showBtnShareOrAd() {
          GameLogic.instance.getOpenRewardType(constants.SHARE_FUNCTION.LOTTERY, (err, type) => {
            if (!err) {
              switch (type) {
                case constants.OPEN_REWARD_TYPE.AD:
                  this.ndBtnStart.active = false;
                  this.ndBtnShare.active = false;
                  this.ndBtnAd.active = true;
                  this.ndBtnAd.getComponent(ButtonEx).interactable = true;
                  break;

                case constants.OPEN_REWARD_TYPE.SHARE:
                  this.ndBtnStart.active = false;
                  this.ndBtnAd.active = false;
                  this.ndBtnShare.active = true;
                  this.ndBtnShare.getComponent(ButtonEx).interactable = true;
                  break;

                case constants.OPEN_REWARD_TYPE.NULL:
                  this.ndBtnStart.active = true;
                  this.ndBtnStart.getComponent(ButtonEx).interactable = false;
                  resourceUtil.setGray(this.ndBtnStart, true); //这句话放在interactable后才生效

                  this.ndBtnAd.active = false;
                  this.ndBtnShare.active = false;
                  break;
              }
            }
          });
        }

        onBtnCloseClick() {
          uiManager.instance.hideDialog('lottery/lottery');
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "arrRewardNode", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "aniLightGroup", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "pfRewardItem", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "lbSpareTimes", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "lbAdSpareTimes", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "lbShareSpareTimes", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "lbGold", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "ndBtnStart", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "ndBtnAd", [_dec10], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "ndBtnShare", [_dec11], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "ndTurnable", [_dec12], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "nativeAd", [_dec13], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/ConstValue.js", ['./cjs-loader.mjs'], function (exports, module) {
  'use strict';

  var loader;
  return {
    setters: [function (module) {
      loader = module.default;
    }],
    execute: function () {
      exports('default', void 0);

      let _cjsExports;

      loader.define(module.meta.url, function (exports$1, _require, module, __filename, __dirname) {
        let require = loader.createRequireWithReqMap({
          "./ConstValue": __cjsMetaURL
        }, _require);

        (function () {
          const ConstValue = require("./ConstValue");

          const TEST_HTTP_HOST = "http://t-grdapi.jijia-co.com/";
          const PRODUCTION_HTTP_HOST = "http://grdapi.jijia-co.com/";
          const TEST_SHARE_WX_HOST = "http://t-grdadm.jijia-co.com/grd/static/fenxiang.html";
          const PRODUCTION_SHARE_WX_HOST = "http://grdadm.jijia-co.com/grd/static/fenxiang.html";
          module.exports.TEST_WITHDRAW_URL = "http://t-grdadm.jijia-co.com/grd/static/jineduihuan.html";
          module.exports.PRODUCTION_WITHDRAW_URL = "http://grdadm.jijia-co.com/grd/static/jineduihuan.html";
          module.exports.TEST_EXCHANGE_URL = "http://t-grdadm.jijia-co.com/grd/static/daojuduihuan.html";
          module.exports.PRODUCTION_EXCHANGE_URL = "http://grdadm.jijia-co.com/grd/static/daojuduihuan.html";
          module.exports.TEST_WANFA_URL = "http://t-grdadm.jijia-co.com/grd/static/wanfa.html";
          module.exports.PRODUCTION_WANFA_URL = "http://grdadm.jijia-co.com/grd/static/wanfa.html";
          module.exports.TEST_CORN_RECODE_URL = "http://t-grdadm.jijia-co.com/grd/static/jinbijilu.html";
          module.exports.PRODUCTION_CORN_RECODE_URL = "http://grdadm.jijia-co.com/grd/static/jinbijilu.html";
          const TEST_WX_WEB_URL = "http://t-grdadm.jijia-co.com/grd/mobile/";
          const PRODUCTION_WX_WEB_URL = "http://grdadm.jijia-co.com/grd/mobile/";
          const TEST_SHARE_TO_GROUP_URL = "http://t-grdapi.jijia-co.com/gourd/link?mode=share";
          const PRODUCTION_SHARE_TO_GROUP_URL = "http://grdapi.jijia-co.com/gourd/link?mode=share";
          const TEST_WX_AUTHORIZE_URL = "http%3A%2F%2Ft-grdadm.jijia-co.com%2Fgrd%2Fmobile%2F";
          const PRODUCTION_WX_AUTHORIZE_URL = "http%3A%2F%2Fgrdadm.jijia-co.com%2Fgrd%2Fmobile%2F";
          /**
           * 
           * @param {string} path 
           * @param {*} querys   {"key":"value"}
           */

          module.exports.getUrl = function (path, querys) {
            let querysString = "?";

            if (querys != null) {
              for (let obj in querys) {
                let value = querys[obj];

                if (!Utils.isNullOrUndefined(value)) {
                  querysString += obj + "=" + value + "&";
                }
              }
            }

            if (cc.sys.isBrowser) {
              return (window.location.href.search("t-grdadm") != -1 ? TEST_HTTP_HOST : PRODUCTION_HTTP_HOST) + path + querysString.substring(0, querysString.length - 1);
            }

            return (Global.TestEnv ? TEST_HTTP_HOST : PRODUCTION_HTTP_HOST) + path + querysString.substring(0, querysString.length - 1);
          };

          module.exports.getWXWebUrl = function () {
            return Global.TestEnv ? TEST_WX_WEB_URL : PRODUCTION_WX_WEB_URL;
          };

          module.exports.getSharetoGroupUrl = function () {
            return Global.TestEnv ? TEST_SHARE_TO_GROUP_URL : PRODUCTION_SHARE_TO_GROUP_URL;
          };

          module.exports.getWXAuthorUrl = function () {
            return window.location.href.search("t-grdadm") != -1 ? TEST_WX_AUTHORIZE_URL : PRODUCTION_WX_AUTHORIZE_URL;
          };

          module.exports.getShareToWXUrl = function (path, querys) {
            let querysString = "#";

            if (querys != null) {
              for (let obj in querys) {
                let value = querys[obj];

                if (!Utils.isNullOrUndefined(value)) {
                  querysString += obj + "=" + value + "&";
                }
              }
            }

            return (window.location.href.search("t-grdadm") != -1 ? TEST_SHARE_WX_HOST : PRODUCTION_SHARE_WX_HOST) + path + querysString.substring(0, querysString.length - 1);
          };

          module.exports.AdId = {
            BannerBig: "@211",
            // 中等banner id
            Banner: "F231",
            //banner广告位id
            Splash: "A208",
            // 开屏广告广告位id
            Reward: "J209",
            // 激励视频广告位id
            Interstitial: "B210" // 插屏广告
            //葫芦庄园测试用
            // BannerBig: "F178", // 中等banner id
            // Banner: "F178",//banner广告位id
            // Splash: "A167",// 开屏广告广告位id
            // Reward: "J177",// 激励视频广告位id
            // Interstitial: "B196",// 插屏广告
            // Feed: "C176",// 信息流广告位id
            // Banner: "F190",//大西瓜banner广告位id
            // Splash: "A167",// 开屏广告广告位id
            // Reward: "J177",// 激励视频广告位id
            // HuLuBanner: "F178",//葫芦的banner广告位id
            // HuluInterstitial: "B196",// 插屏广告
            // SubgameSplash: "A195",// 启动子游戏开屏广告

          };

          module.exports.getAdBanner = function () {
            if (Global.OPPOGameEnv) {
              return "F621";
            } else if (Global.VIVOGameEnv) {
              return "F609";
            } else if (Global.XIAOMIGameEnv) {
              return "F613";
            } else if (Global.YSDKGameEnv) {
              return "F355";
            } else if (Global.MomoyuGameEnv) {
              return "F616";
            } else {
              return "F560";
            }
          };

          module.exports.getAdBannerBig = function () {
            if (Global.OPPOGameEnv) {
              return "F621";
            } else if (Global.VIVOGameEnv) {
              return "F609";
            } else if (Global.XIAOMIGameEnv) {
              return "F613";
            } else if (Global.YSDKGameEnv) {
              return "";
            } else if (Global.MomoyuGameEnv) {
              return "F616";
            } else {
              return "F560";
            }
          };

          module.exports.getAdReward = function () {
            if (Global.OPPOGameEnv) {
              return "J622";
            } else if (Global.VIVOGameEnv) {
              return "J608";
            } else if (Global.XIAOMIGameEnv) {
              return "J612";
            } else if (Global.YSDKGameEnv) {
              return "J356";
            } else if (Global.MomoyuGameEnv) {
              console.log("momoyu reward-J617");
              return "J617";
            } else {
              return "J559";
            }
          };

          module.exports.getAdInterstitial = function () {
            if (Global.OPPOGameEnv) {
              return "F412";
            } else if (Global.VIVOGameEnv) {
              return "B429";
            } else if (Global.XIAOMIGameEnv) {
              return "B415";
            } else if (Global.YSDKGameEnv) {
              return "B354";
            } else {
              return "B562";
            }
          };

          module.exports.getAdInterstitialVideo = function () {
            if (Global.OPPOGameEnv) {
              return "B620";
            } else if (Global.VIVOGameEnv) {
              return "B611";
            } else if (Global.XIAOMIGameEnv) {
              return "B614";
            } else if (Global.YSDKGameEnv) {
              return "";
            } else if (Global.MomoyuGameEnv) {
              return "B615";
            } else {
              return "B562";
            }
          };

          module.exports.AdScene = {
            TaskGameRun: 'TaskGameRun',
            TaskGamePk: 'TaskGamePk',
            TaskWatering: 'TaskWatering',
            GameScene: 'minigame/筹码大师',
            GameRunPause: 'GameRunPause',
            GamePkBattle: 'GamePkBattle',
            GameHitMonster: 'GameHitMonster',
            LaunchSubgame: 'LaunchSubgame',
            // 启动子游戏显示开屏广告
            XiGuaInterstitial: 'XiGuaInterstitial' // 西瓜插屏广告

          };
          module.exports.WATER_DROP = {
            giftBagForNovice: {
              cate: 1,
              name: '新手礼包'
            },
            signInReward: {
              cate: 2,
              name: '每日签到'
            },
            cumulativeWater: {
              cate: 3,
              name: '累计浇水'
            },
            threeMealsWelfare: {
              cate: 4,
              name: '三餐福利'
            },
            shareToGroup: {
              cate: 5,
              name: '分享到群'
            },
            seeVideo: {
              cate: 6,
              name: '看视频'
            },
            signInRemind: {
              cate: 7,
              name: '签到提醒'
            },
            luckeyTurnable: {
              cate: 8,
              name: '幸运转盘'
            },
            friendsHelp: {
              cate: 9,
              name: '好友助力'
            },
            timingBlessingBag: {
              cate: 10,
              name: '定时福袋'
            },
            thunderStormCloud: {
              cate: 11,
              name: '雷雨云'
            },
            addFriend: {
              cate: 12,
              name: '好友赠与'
            },
            gameAward: {
              cate: 13,
              name: '游戏奖励'
            },
            offline: {
              cate: 14,
              name: ' '
            },
            stolenFromFriend: {
              cate: 15,
              name: '偷好友'
            }
          };

          module.exports.getWaterDropName = function (cate) {
            switch (cate) {
              case 1:
                return ConstValue.WATER_DROP.giftBagForNovice.name;

              case 2:
                return ConstValue.WATER_DROP.signInReward.name;

              case 3:
                return ConstValue.WATER_DROP.cumulativeWater.name;

              case 4:
                return ConstValue.WATER_DROP.threeMealsWelfare.name;

              case 5:
                return ConstValue.WATER_DROP.shareToGroup.name;

              case 6:
                return ConstValue.WATER_DROP.seeVideo.name;

              case 7:
                return ConstValue.WATER_DROP.signInRemind.name;

              case 8:
                return ConstValue.WATER_DROP.luckeyTurnable.name;

              case 9:
                return ConstValue.WATER_DROP.friendsHelp.name;

              case 10:
                return ConstValue.WATER_DROP.timingBlessingBag.name;

              case 11:
                return ConstValue.WATER_DROP.thunderStormCloud.name;

              case 12:
                return ConstValue.WATER_DROP.addFriend.name;

              case 13:
                return ConstValue.WATER_DROP.gameAward.name;

              case 14:
                return ConstValue.WATER_DROP.offline.name;

              case 15:
                return ConstValue.WATER_DROP.stolenFromFriend.name;

              default:
                return '水滴';
            }
          };
          /**
           * 红包放放场景
           */


          module.exports.RED_PACKET_CASE = {
            newUser: 1,
            //新人礼
            huluDone: [2, 6, 7, 8, 9, 10, 11],
            //1-7娃出世
            hulu2_7Done: 3,
            //2~7娃出世 (兼容客户端老版本)
            huluKing: 4,
            //金刚葫芦娃出世
            random: 5,
            //随机红包
            dailyRedpacket: 12,
            //天天红包
            huluGrowing: 13,
            //葫芦成长中
            InviteSuccess: 14 //设置邀请码

          };
          /**
           * 好友分享场景
           */

          module.exports.SHARE_TO_WX_SCENE = {
            addFriend: 0,
            friendHelp: 1,
            shareToWxGroup: 2,
            messageToFriend: 3,
            InviteToPlay: 4
          };
          module.exports.HULU_TALK = ["想看我变葫芦娃，多给我浇水吧!", "邀请好友助力，转盘抽奖都能获得水滴哦!", "今天的领水任务做了没有啊?", "哼! 没给我浇水别老戳我啊!", "我好想马上成熟哦!", "确认过眼神，你是能把我养大的人!", "把我养大就能领红包哦!", "集齐七兄弟，合成有惊喜!", "分红葫芦娃躺赚收益，去[玩法]里看看吧!"];
          module.exports.RED_MARKER_MESSAGE = ["再多浇点水就能领红包啦", "距离我又近了一点呢", "我就在这里静静地等着你", "浇水不断,红包不停"];
          const HULU_INIT_SCALE = 0.5;

          module.exports.cloneHulu = function (hulu) {
            return {
              id: hulu.id,
              name: hulu.name,
              normalIcon: hulu.normalIcon,
              smallIcon: hulu.smallIcon,
              image: hulu.image,
              totalWater: hulu.totalWater,
              usedWater: hulu.usedWater,
              initScale: hulu.initScale
            };
          };

          module.exports.HULU_PATAMS = [{
            id: 1,
            name: "大娃",
            normalIcon: {
              url: "maingame/main_gourd_1",
              urls: ["maingame/main_gourd_1", "maingame/main_gourd_1", "common/huluwa1"],
              ancherX: 0.5,
              ancherY: 1
            },
            smallIcon: {
              url: "maingame/main_flower_1",
              ancherX: 0.5,
              ancherY: 1
            },
            image: "common/huluwa1",
            totalWater: 150,
            usedWater: 0,
            //color: new cc.Color(167, 30, 16),
            initScale: HULU_INIT_SCALE
          }, {
            id: 2,
            name: "二娃",
            normalIcon: {
              url: "maingame/main_gourd_2",
              urls: ["maingame/main_gourd_2", "maingame/main_gourd_2_2", "maingame/main_gourd_2_3", "common/huluwa2"],
              ancherX: 0.5,
              ancherY: 1
            },
            smallIcon: {
              url: "maingame/main_flower_2",
              ancherX: 0.5,
              ancherY: 1
            },
            image: "common/huluwa2",
            totalWater: 150,
            usedWater: 0,
            //color: new cc.Color(231, 114, 32),
            initScale: HULU_INIT_SCALE
          }, {
            id: 3,
            name: "三娃",
            normalIcon: {
              url: "maingame/main_gourd_3",
              urls: ["maingame/main_gourd_3", "maingame/main_gourd_3_2", "maingame/main_gourd_3_3", "common/huluwa3"],
              ancherX: 0.5,
              ancherY: 1
            },
            smallIcon: {
              url: "maingame/main_flower_3",
              ancherX: 0.5,
              ancherY: 1
            },
            image: "common/huluwa3",
            totalWater: 150,
            usedWater: 0,
            //color: new cc.Color(240, 184, 31),
            initScale: HULU_INIT_SCALE
          }, {
            id: 4,
            name: "四娃",
            normalIcon: {
              url: "maingame/main_gourd_4",
              urls: ["maingame/main_gourd_4", "maingame/main_gourd_4_2", "maingame/main_gourd_4_3", "common/huluwa4"],
              ancherX: 0.5,
              ancherY: 1
            },
            smallIcon: {
              url: "maingame/main_flower_4",
              ancherX: 0.5,
              ancherY: 1
            },
            image: "common/huluwa4",
            totalWater: 150,
            usedWater: 0,
            //color: new cc.Color(5, 148, 3),
            initScale: HULU_INIT_SCALE
          }, {
            id: 5,
            name: "五娃",
            normalIcon: {
              url: "maingame/main_gourd_5",
              urls: ["maingame/main_gourd_5", "maingame/main_gourd_5_2", "maingame/main_gourd_5_3", "common/huluwa5"],
              ancherX: 0.5,
              ancherY: 1
            },
            smallIcon: {
              url: "maingame/main_flower_5",
              ancherX: 0.5,
              ancherY: 1
            },
            image: "common/huluwa5",
            totalWater: 150,
            usedWater: 0,
            //color: new cc.Color(11, 128, 161),
            initScale: HULU_INIT_SCALE
          }, {
            id: 6,
            name: "六娃",
            normalIcon: {
              url: "maingame/main_gourd_6",
              urls: ["maingame/main_gourd_6", "maingame/main_gourd_6_2", "maingame/main_gourd_6_3", "common/huluwa6"],
              ancherX: 0.5,
              ancherY: 1
            },
            smallIcon: {
              url: "maingame/main_flower_6",
              ancherX: 0.5,
              ancherY: 1
            },
            image: "common/huluwa6",
            totalWater: 150,
            usedWater: 0,
            //color: new cc.Color(10, 45, 161),
            initScale: HULU_INIT_SCALE
          }, {
            id: 7,
            name: "七娃",
            normalIcon: {
              url: "maingame/main_gourd_7",
              urls: ["maingame/main_gourd_7", "maingame/main_gourd_7_2", "maingame/main_gourd_7_3", "common/huluwa7"],
              ancherX: 0.5,
              ancherY: 1
            },
            smallIcon: {
              url: "maingame/main_flower_7",
              ancherX: 0.5,
              ancherY: 1
            },
            image: "common/huluwa7",
            totalWater: 150,
            usedWater: 0,
            //color: new cc.Color(147, 19, 170),
            initScale: HULU_INIT_SCALE
          }];
          /**
           * 统计
           */

          module.exports.EVENT_MAIN = {
            GLOBAL_WATERING: "global_watering",
            //使用水滴，浇水
            GLOBAL_GET_REDPACKET: "global_get_redpacket",
            //获得了红包
            TURNABLE: "turnable",
            //点击转盘按钮
            TURNABLE_VIDEO_GET_RESULT: "turnable_video_get_result",
            //转盘点击旋转
            TURNABLE_VIDEO_GET_POWER: "turnable_video_get_power",
            //转盘点击得体力
            TURNABLE_ALERT_VIDEO_DOUBLE: "turnable_alert_video_double",
            //转盘弹框
            TURNABLE_ALERT_MERGE: "turnable_alert_merge",
            //转盘弹框
            TURNABLE_ALERT_GET: "turnable_alert_get",
            //转盘弹框
            TURNABLE_ALERT_RESULT: "turnable_alert_result",
            //转盘结果
            FRIEND_HELP: "friend_help",
            //点击好友助力
            FRIEND_HELP_INVITE: "friend_help_invite",
            //点击邀请好友助力
            ACHIEVEMENT: "achievement",
            //点击背包
            FRIEND: "friend",
            //点击我的好友
            FRIEND_ADD: "friend_add",
            //点击我的好友-添加
            FRIEND_DEL: "friend_del",
            //点击我的好友-删除
            FRIEND_WATER: "friend_water",
            //点击我的好友-水滴
            BLESSINGBAG: "blessingbag",
            //点击福袋
            BLESSINGBAG_VIDEO_GET: "blessingbag_video_get",
            //点击福袋-看视频获取
            BLESSINGBAG_VIDEO_DOUBLE: "blessingbag_video_double",
            //点击福袋-看视频双倍
            BLESSINGBAG_GET: "blessingbag_get",
            //点击福袋-直接获取
            TOOGLESOUND: "tooglesound",
            //点击音效
            SETTING: "setting",
            //点击设置
            GAMERULES: "gamerules",
            //点击玩法
            WITHDRAW: "withdraw",
            //点击兑换
            TASKLIST: "tasklist",
            //点击任务
            TASKLIST_SIGNIN: "tasklist_signin",
            //点击任务-签到
            TASKLIST_SIGNIN_GET: "tasklist_signin_get",
            //点击任务-签到-获取
            TASKLIST_SIGNIN_REMIND: "tasklist_signin_remind",
            // 点击任务-签到提醒
            TASKLIST_SIGNIN_REMIND_DOUBLE: "tasklist_signin_remind_double",
            TASKLIST_SIGNIN_REMIND_GET: "tasklist_signin_remind_get",
            TASKLIST_WATERING: "tasklist_watering",
            //点击任务-浇水
            TASKLIST_WATERING_ALERT_GET: "tasklist_watering_alert_get",
            //点击任务-弹框-获取水滴
            TASKLIST_MEALS: "tasklist_meals",
            //点击任务-三餐福利
            TASKLIST_MEALS_GET: "tasklist_meals_get",
            //点击任务-三餐福利-获取
            TASKLIST_MEALS_DOUBLE: "tasklist_meals_double",
            //点击任务-三餐福利-翻倍
            TASKLIST_SHARING: "tasklist_sharing",
            //点击任务-分享到群
            TASKLIST_SHARING_ALERT_GET: "tasklist_sharing_alert_get",
            TASKLIST_SHARING_ALERT_DOUBLE: "tasklist_sharing_alert_double",
            TASKLIST_VIDEO: "tasklist_video",
            //点击任务-看视频
            TASKLIST_SEEVIDEO_ALERT_GET: "tasklist_seevideo_alert_get",
            //点击任务-弹框-获取水滴
            TASKLIST_GAMEPK_ALERT_GET: "tasklist_gamepk_alert_get",
            TASKLIST_GAMEPK_ALERT_DOUBLE: "tasklist_gamepk_alert_double",
            TASKLIST_GAMEPK: "tasklist_gamepk",
            TASKLIST_GAMERUN_ALERT_GET: "tasklist_gamerun_alert_get",
            TASKLIST_GAMERUN_ALERT_DOUBLE: "tasklist_gamerun_alert_double",
            SUBGAME: "subgame",
            //点击小游戏
            SUBGAME_YEYE: "subgame_yeye",
            //点击小游戏-爷爷快跑
            SUBGAME_DAYAOGUAI: "subgame_dayaoguai",
            //点击小游戏-打妖怪
            SUBGAME_EXCEPT: "subgame_except",
            //点击小游戏-敬请期待
            DAILY_REDPACKET: "daily_redpacket",
            //点击天天红包
            REDPACKET_GET_NEW_USER: "redpacket_get_new_user",
            //新手礼包
            REDPACKET_GET_RANDOM: "redpacket_get_random",
            //随机红包
            REDPACKET_GET_HULUDONE_: "redpacket_get_huludone_",
            //某娃出世_
            REDPACKET_GET_DAILY: "redpacket_get_daily",
            //天天红包
            REDPACKET_GET_HULUGROWING: "redpacket_get_hulugrowing",
            //葫芦成长中
            REDPACKET_GET_SIGNIN: "redpacket_get_signin",
            //任务列表签到
            WXLOGIN_WITH_DRAW: "wxlogin_with_draw",
            //微信登录-兑换
            WXLOGIN_PROFILE_PHOTO: "wxlogin_profile_photo",
            //微信登录-头像
            WXLOGIN_ADDFRIEND: "wxlogin_addfriend",
            //微信登录-添加好友
            WXLOGIN_FRIEND_HELP: "wxlogin_friend_help",
            //微信登录-好友助力
            WXLOGIN_CANCEL: "wxlogin_cancel",
            //微信登录-取消
            Activity_Click: "activity_click",
            //点击活动-（小游戏网页端操作统计）
            Activity_Click_Vine: "activity_click_vine",
            //点击活动-藤
            Activity_Click_Butterfly: "activity_click_butterfly",
            //点击活动-蝴蝶
            Apply_Prop: "apply_prop",
            //应用道具
            GO_DOWNLOAD_APP: "go_download_app",
            GO_DOWNLOAD_APP_CANCEL: "go_download_app_cancel",
            PROMPT_CLICK: "prompt_click",
            // 点击通用弹框“我知道了”
            PROFIT_DUIHUAN: "profit_exchange_click",
            PROFIT_WITHDRAW: "prpfit_withdraw_click",
            MY_CORN_CLICK: "my_corn_click",
            PUT_IN_WALLET: "put_in_wallet_click",
            MULTIPLE: "multiple_click",
            PLATFORM_CLICK: "platform_click",
            MY_PROFIT_EXPLAIN: "my_profit_explain",
            MULTIPLE_EXPLAIN: "multiple_explain_click",
            WatermelonThemeUnlock: "WatermelonThemeUnlock",
            Theme01Unlock: "Theme01Unlock",
            Theme02Unlock: "Theme02Unlock",
            Theme03Unlock: "Theme03Unlock",
            Theme04Unlock: "Theme04Unlock",
            WatermelonComposite: "WatermelonComposite",
            //累计合成西瓜数量
            WatermelonCompositeLabel: "WatermelonCompositeLabel",
            SmallLabel: "SmallLabel",
            WatermelonValue: "WatermelonValue",
            SmallValue: "SmallValue",
            WatermelonEndlessEnterPointCheck: "WatermelonEndlessEnterPointCheck",
            WatermelonEndlessNextPointCheck: "WatermelonEndlessNextPointCheck",
            WatermelonGameScore: "WatermelonGameScore",
            GameScoreWatermelon: "GameScoreWatermelon",
            GameScoreEndless: "GameScoreEndless",
            GameScoreSmall: "GameScoreSmall",
            WatermelonClick: "WatermelonClick",
            WatermelonClickPlaySmall: "WatermelonClickPlaySmall",
            WatermelonClickPlaySmallUnlock: "WatermelonClickPlaySmallUnlock",
            WatermelonClickPlayDefault: "WatermelonClickPlayDefault",
            WatermelonClickPlayEndless: "WatermelonClickPlayEndless",
            WatermelonClickTheme: "WatermelonClickTheme",
            WatermelonClickThemeBtnUse: "WatermelonClickThemeBtnUse",
            UseThemeSuccess: "UseThemeSuccess",
            UseThemeFail: "UseThemeFail",
            UseThemeNowWaring: "UseThemeNowWaring",
            ClearNumberHighNum: "ClearNumberHighNum",
            ClearNumberRestartHighNum: "ClearNumberRestartHighNum",
            ClearNumberDestroyHighNum: "ClearNumberDestroyHighNum",
            ClearNumberHomeHighNum: "ClearNumberHomeHighNum",
            ClearNumberGameOverHighNum: "ClearNumberGameOverHighNum",
            ClearNumberClick: "ClearNumberClick",
            ClearNumberClickBomb: "ClearNumberClickBomb",
            ClearNumberClickBombWidth: "ClearNumberClickBombWidth",
            ClearNumberClickBombHeight: "ClearNumberClickBombHeight",
            ClearNumberClickBombLight: "ClearNumberClickBombLight",
            ClearNumberClickRestart: "ClearNumberClickRestart",
            ClearNumberClickPause: "ClearNumberClickPause",
            ClearNumberClickExit: "ClearNumberClickExit",
            onClickBtnBombReward: "onClickBtnBombReward",
            onClickBtnBombRewardCancel: "onClickBtnBombRewardCancel"
          };
          module.exports.WX_AUTH_SCENE = {
            WITH_DRAW: "wx_auth_with_draw",
            First_Start: "wx_auth_first_start",
            CLICK_PROFILE_PHOTO: "wx_auth_profile_photo",
            TOKEN_EXPIRED: "wx_auth_token_expired",
            ADD_FRIEND: "wx_auth_add_friend",
            FRIEND_HELP: "wx_auth_friend_help"
          };
          /**
           * 微信订阅
           */

          module.exports.SCENE_FOR_WX = {
            SIGNIN_REMIND: 1 //签到提醒

          };
          module.exports.PropType = {
            butterfly: 1,
            fallingStar: 2
          };
          module.exports.LocalStorage = {
            Sound_Effects_Enable: 'Sound_Effects_Enable',
            Turnable_Cur_Power: "Turnable_Cur_Power",
            Turnable_Total_Power: "Turnable_Total_Power",
            Add_Friend_List: "Add_Friend_List",
            Achievement_List: "Achievement_List",
            Last_Income_Tips: 'Last_Income_Tips',
            Tasklist_Item_Watering: "Tasklist_Item_Watering",
            Tasklist_Item_Sharing: "Tasklist_Item_Sharing",
            Tasklist_Item_SeeVideo: "Tasklist_Item_SeeVideo",
            Tasklist_Item_Remind: "Tasklist_Item_Remind",
            Tasklist_Item_Sharing_Temp: "Tasklist_Item_Sharing_Temp",
            Tasklist_Item_SeeVideo_Temp: "Tasklist_Item_SeeVideo_Temp",
            TaskList_Item_GameRunSignIn: "TaskList_Item_GameRunSignIn",
            TaskList_Item_GameRunScore40: "TaskList_Item_GameRunScore40",
            TaskList_Item_GameRunScore80: "TaskList_Item_GameRunScore80",
            TaskList_Item_GameRunScore120: "TaskList_Item_GameRunScore120",
            TaskList_Item_GameRunScore160: "TaskList_Item_GameRunScore160",
            TaskList_Item_GamePKSignIn: "TaskList_Item_GamePKSignIn",
            TaskList_Item_GamePKVictory1: "TaskList_Item_GamePKVictory1",
            TaskList_Item_GamePKVictory3: "TaskList_Item_GamePKVictory3",
            TaskList_Item_GamePKVictory5: "TaskList_Item_GamePKVictory5",
            TaskList_Item_GamePKVictory10: "TaskList_Item_GamePKVictory10",
            TaskList_Item_GamePKVictoryCount: "TaskList_Item_GamePKVictoryCount"
          };
          module.exports.WealType = {
            DailyOnlineGoldCoin: 3
          };
          /**
           * 外部（Android、H5、iOS...）通过 Global.callCocosGameMethod 调用 Cocos 时定义好的 cmd 协议。
           */

          module.exports.CallCocosCmd = {
            Wx_Auth: 'wx_auth'
          };
          module.exports.loginMode = {
            Visitor: 1,
            WxApp: 2,
            WxMiniGame: 3,
            WxWeb: 4
          };
          /**
           * 系统好友id
           */

          module.exports.SysFriend = {
            '1201212121212000': {
              iconPath: 'maingame/friend_huhu',
              name: '葫葫'
            },
            '1201212121212001': {
              iconPath: 'maingame/friend_lulu',
              name: '芦芦'
            }
          };
          module.exports.HandSpeedBattleMode = {
            Endless: 1,
            Quick: 2
          };
          module.exports.GameId = {
            YeYeRun: 1,
            HitMonster: 2,
            HandSpeed: 3
          };
          module.exports.GameLevel = {
            1: '初级黑铁',
            2: '倔强青铜',
            3: '不屈白银',
            4: '荣耀黄金',
            5: '尊贵铂金',
            6: '永恒钻石',
            7: '至尊星耀',
            8: '最强王者'
          };
          module.exports.GameLevelSecond = {
            1: 'Ⅰ',
            2: 'Ⅱ',
            3: 'Ⅲ'
          };

          module.exports.getGameLevel = function (values) {
            let level = '';

            if (values) {
              let arr = values.split('&');
              level = ConstValue.GameLevel[arr[0]] + ConstValue.GameLevelSecond[arr[1]];
            }

            return level;
          };

          module.exports.Backpack = {
            Hulu1: {
              type: 0,
              name: "大娃"
            },
            Hulu2: {
              type: 1,
              name: "二娃"
            },
            Hulu3: {
              type: 2,
              name: "三娃"
            },
            Hulu4: {
              type: 3,
              name: "四娃"
            },
            Hulu5: {
              type: 4,
              name: "五娃"
            },
            Hulu6: {
              type: 5,
              name: "六娃"
            },
            Hulu7: {
              type: 6,
              name: "七娃"
            },
            JinGangHulu: {
              type: 7,
              name: "金刚葫芦娃"
            },
            BonusHulu: {
              type: 8,
              name: "分红葫芦娃"
            },
            Lotus1: {
              type: 9,
              name: "莲花"
            },
            Lotus2: {
              type: 10,
              name: "莲花"
            },
            Lotus3: {
              type: 11,
              name: "莲花"
            },
            Lotus4: {
              type: 12,
              name: "莲花"
            }
          };
          module.exports.PromptType = {
            Payment: 1,
            FriendHelp: 2,
            OfflineWater: 3,
            GongGao: 4
          };
        })();

        _cjsExports = exports('default', module.exports);
      });

      const __cjsMetaURL = exports('__cjsMetaURL', module.meta.url);
    }
  };
});

System.register("chunks:///_virtual/buttonEx.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './constants.ts', './audioManager.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Button, _applyDecoratedDescriptor, _initializerDefineProperty, constants, AudioManager;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Button = module.Button;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      AudioManager = module.AudioManager;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp;

      cclegacy._RF.push({}, "e122fG1ssFILIO3WiAvp7JK", "buttonEx", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let ButtonEx = exports('ButtonEx', (_dec = ccclass('ButtonEx'), _dec(_class = (_class2 = (_temp = class ButtonEx extends Button {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "isPreventSecondClick", _descriptor, this);

          _initializerDefineProperty(this, "preventTime", _descriptor2, this);

          _initializerDefineProperty(this, "isPlaySound", _descriptor3, this);
        }

        start() {
          let button = this.node.getComponent(Button);
          this.node.on('click', event => {
            if (this.isPreventSecondClick) {
              button.interactable = false;
              this.scheduleOnce(function () {
                if (button.node) button.interactable = true;
              }, this.preventTime);
            }

            if (this.isPlaySound) {
              AudioManager.instance.playSound(constants.AUDIO_SOUND.CLICK, false);
            }
          }, this);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "isPreventSecondClick", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return false;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "preventTime", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 2;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "isPlaySound", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return true;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/AdUtils.js", ['./cjs-loader.mjs', './PlatformBridge.js', './ConstValue.js'], function (exports, module) {
  'use strict';

  var loader, __cjsMetaURL$2, __cjsMetaURL$1;

  return {
    setters: [function (module) {
      loader = module.default;
    }, function (module) {
      __cjsMetaURL$2 = module.__cjsMetaURL;
    }, function (module) {
      __cjsMetaURL$1 = module.__cjsMetaURL;
    }],
    execute: function () {
      exports('default', void 0);

      let _cjsExports;

      loader.define(module.meta.url, function (exports$1, _require, module, __filename, __dirname) {
        let require = loader.createRequireWithReqMap({
          "./ConstValue": __cjsMetaURL$1,
          "./PlatformBridge": __cjsMetaURL$2
        }, _require);

        (function () {
          //const AdUtils = require("AdUtils");
          const ConstValue = require("./ConstValue");

          const PlatformBridge = require("./PlatformBridge");

          const AdUtils = {
            subgameExitLastTime: {
              /*'gameId': 0,*/
            },

            updateSubgameExitTime(gameId) {
              this.isExitFromSubgame = true;
              let curElapsedTime = window.performance.now();
              this.subgameExitLastTime[gameId] = curElapsedTime;
              console.log('AdUtils.updateSubgameExitTime gameId:' + gameId + ', curElapsedTime:' + curElapsedTime);
            },

            showSubgameSplashAd(gameId) {
              if (cc.sys.platform == cc.sys.ANDROID && Global.appVersionCode < 1040200) {
                console.log('AdUtils.showSubgameSplashAd showSplashAd support ver 1.4.2');
                return;
              }

              let curElapsedTime = window.performance.now();
              let subgameExitLastTime = this.subgameExitLastTime[gameId] ? this.subgameExitLastTime[gameId] : 0;
              console.log('AdUtils.showSubgameSplashAd curElapsedTime: ' + curElapsedTime + ', gameId: ' + gameId + ', subgameExitLastTime: ' + subgameExitLastTime + ', HuluDoneIndex: ' + DataModel.getHuluDoneIndex());

              if (DataModel.getHuluDoneIndex() >= 1 && Math.abs(curElapsedTime - subgameExitLastTime) > 30 * 1000) {
                console.log('AdUtils.showSubgameSplashAd showSplashAd');
                PlatformBridge.showSplashAd(ConstValue.AdScene.LaunchSubgame, ConstValue.AdId.SubgameSplash);
              }
            },

            // 上次显示插屏广告时间
            interstitialAdLastTime: 0,
            // 上次关闭插屏广告的时间
            interstitialAdCloseLastTime: 0,
            // 显示插屏广告的时间间隔，参数由服务端配置
            interstitialAdInterval: 360 * 1000,
            //6分钟
            // 插屏广告定时器
            interstitialAdTimer: undefined,
            // 首次进入游戏延时显示插屏广告，参数由服务端配置
            interstitialAdFirstDelayTime: 360 * 1000,
            //6分钟
            // 从小游戏退出之后延时显示查屏广告，参数由服务端配置
            interstitialAdExitSubGameDelayTime: 180 * 1000,
            //3分钟
            // 插屏广告正在显示
            interstitialAdIsShowing: false,
            isFirstStart: true,
            isExitFromSubgame: false,

            setinterstitialAdParams(firstDelayTime, exitSubGameDelayTime, interval) {
              console.log('AdUtils.setinterstitialAdParams firstDelayTime: ' + firstDelayTime + ', exitSubGameDelayTime: ' + exitSubGameDelayTime + ', interval:' + interval);

              if (typeof firstDelayTime == 'number') {
                this.interstitialAdFirstDelayTime = firstDelayTime;
              }

              if (typeof exitSubGameDelayTime == 'number') {
                this.interstitialAdExitSubGameDelayTime = exitSubGameDelayTime;
              }

              if (typeof interval == 'number') {
                this.interstitialAdInterval = interval;
              }
            },

            onInterstitialAdCallback(success, scene) {
              console.log('AdUtils.onInterstitialAdCallback success: ' + success + ', scene: ' + scene); // if (scene == ConstValue.AdScene.XiGuaInterstitial) {

              if (!success) {
                this.interstitialAdIsShowing = false;
                this.setInterstitialAdTimer(this.interstitialAdInterval);

                if (scene.indexOf("diamondShop1") >= 0) {
                  PlatformBridge.showRewardAd("onClickDiamondShopBtn1", "1", ConstValue.getAdReward());
                } else if (scene.indexOf("diamondShop2") >= 0) {
                  PlatformBridge.showRewardAd("onClickDiamondShopBtn2", "1", ConstValue.getAdReward());
                } else if (scene.indexOf("diamondShop3") >= 0) {
                  PlatformBridge.showRewardAd("onClickDiamondShopBtn3", "1", ConstValue.getAdReward());
                } else if (scene.indexOf("diamondShop4") >= 0) {
                  PlatformBridge.showRewardAd("onClickDiamondShopBtn4", "1", ConstValue.getAdReward());
                }
              } // }

            },

            onInterstitialAdDismissCallback(scene) {
              console.log('AdUtils.onInterstitialAdDismissCallback scene: ' + scene);

              if (scene == ConstValue.AdScene.XiGuaInterstitial) {
                this.interstitialAdCloseLastTime = window.performance.now() + 60 * 2 * 1000;
                this.interstitialAdIsShowing = false;
                this.setInterstitialAdTimer(this.interstitialAdInterval);
              }
            },

            tryShowInterstitialAdQuickly() {
              return;
            },

            /**
             * 在葫芦庄园主界面显示插屏广告
             */
            showInterstitialAd(scene) {
              // let temp = window.performance.now()+60 * 2 * 1000 - this.interstitialAdCloseLastTime;
              // if (temp < 60 * 2 * 1000) {
              //     console.log("插屏需要2分钟间隔:",temp);
              //     return;
              // }
              console.log('AdUtils.showInterstitialAd ad is showing: ' + this.interstitialAdIsShowing); // if (!this.interstitialAdIsShowing) {

              this.interstitialAdLastTime = window.performance.now();
              let adWidth = parseInt(0.7 * cc.view.getFrameSize().width);
              let adHeight = parseInt(adWidth * 3 / 2);
              console.log('zhaowei3 showInterstitialAd: adWidth:' + adWidth + ", adHeight:" + adHeight);

              if (scene) {
                PlatformBridge.showInterstitialAd(scene, ConstValue.getAdInterstitial(), adWidth, adHeight);
              } else {
                PlatformBridge.showInterstitialAd(ConstValue.AdScene.XiGuaInterstitial, ConstValue.getAdInterstitial(), adWidth, adHeight);
              }

              this.interstitialAdIsShowing = true; // }
            },

            prepareInterstitialAd(scene) {
              console.log('adUtils->prepareInterstitialAd:');
              let adWidth = parseInt(0.7 * cc.view.getFrameSize().width);
              let adHeight = parseInt(adWidth * 3 / 2);

              if (scene) {
                PlatformBridge.prepareInterstitialAd(scene, ConstValue.getAdInterstitial(), adWidth, adHeight, false);
              } else {
                PlatformBridge.prepareInterstitialAd(ConstValue.AdScene.XiGuaInterstitial, ConstValue.getAdInterstitial(), adWidth, adHeight, false);
              }
            },

            /**
             * 从子游戏退出要显示插屏广告
             */
            showInterstitialAdWhenExitSubgame() {
              console.log('AdUtils.showInterstitialAdWhenExitSubgame isExitFromSubgame: ' + this.isExitFromSubgame);

              if (this.isExitFromSubgame) {
                this.isExitFromSubgame = false;

                if (this.interstitialAdExitSubGameDelayTime == 0) {
                  //1、显示广告的时间间隔是0
                  AdUtils.showInterstitialAd();
                } else {
                  this.setInterstitialAdTimer(this.interstitialAdExitSubGameDelayTime);
                }
              }
            },

            /**
             * 
             * @param {Number} firstDelayTime 
             * @param {Number} interval 
             */
            showInterstitialAdIfNeeded() {
              return;
            },

            /**
             * 插屏广告定时显示任务
             * @param {*} timeout 
             */
            setInterstitialAdTimer(timeout) {
              return;
            },

            /**
             * 清除插屏广告定时器
             */
            clearInterstitialAdTimer() {
              console.log('AdUtils.clearInterstitialAdTimer interstitialAdTimer: ' + this.interstitialAdTimer);

              if (this.interstitialAdTimer) {
                if (Global.ScriptWatermelon) {
                  Global.ScriptWatermelon.unschedule(this.interstitialAdTimer);
                }

                this.interstitialAdTimer = undefined;
              }
            }

          };
          module.exports = AdUtils;
        })();

        _cjsExports = exports('default', module.exports);
      });

      const __cjsMetaURL = exports('__cjsMetaURL', module.meta.url);
    }
  };
});

System.register("chunks:///_virtual/Loading.js", ['./cjs-loader.mjs'], function (exports, module) {
  'use strict';

  var loader;
  return {
    setters: [function (module) {
      loader = module.default;
    }],
    execute: function () {
      exports('default', void 0);

      let _cjsExports;

      loader.define(module.meta.url, function (exports$1, _require, module, __filename, __dirname) {
        let require = loader.createRequireWithReqMap({}, _require);

        (function () {
          const Loading = {
            _MyPrefab: undefined,
            show: function (reason) {
              let self = this;
              let curScene = cc.director.getScene();
              let curNode = curScene && curScene.getChildByName('Canvas');

              if (curNode) {
                if (!curNode._LoadingReasons) {
                  curNode._LoadingReasons = new Set();
                }

                if (!curNode._LoadingReasons.has(reason)) {
                  curNode._LoadingReasons.add(reason);

                  console.log("Loading.js.show(" + reason + ") -> Reasons has not " + reason + ", _PrefabLoading:" + curNode._PrefabLoading + ", _LoadingNode:" + curNode._LoadingNode);

                  if (curNode._PrefabLoading || curNode._LoadingNode) {
                    return;
                  }

                  let instantiateprefab = function (prefab) {
                    let progressBarNode = cc.instantiate(prefab);
                    curNode._LoadingNode = progressBarNode;
                    curNode.addChild(progressBarNode);
                    progressBarNode.setPosition(cc.v2(0, 0));
                    let loading = progressBarNode.getChildByName('bg').getChildByName('progress');
                    loading.runAction(cc.repeatForever(cc.rotateBy(1.5, 360)));
                  };

                  console.log("Loading.js.show(" + reason + ") -> self._MyPrefab：" + self._MyPrefab);

                  if (self._MyPrefab) {
                    instantiateprefab(self._MyPrefab);
                  } else {
                    curNode._PrefabLoading = true;
                    console.log("Loading.js.show(" + reason + ") -> load(prefabs/loading) <start>");
                    cc.resources.load('prefabs/loading', cc.Prefab, function (err, prefab) {
                      console.log("Loading.js.show(" + reason + ") -> load(prefabs/loading) <end> err:" + err + ", prefab:" + prefab + ", _LoadingReasons size:" + curNode._LoadingReasons.size);
                      curNode._PrefabLoading = false;

                      if (!err) {
                        self._MyPrefab = prefab;

                        if (curNode._LoadingReasons.size > 0) {
                          instantiateprefab(prefab);
                        }
                      }
                    });
                  }
                } else {
                  console.log("Loading.js.show(" + reason + ") -> Reasons has " + reason + ", _PrefabLoading:" + curNode._PrefabLoading + ", _LoadingNode:" + curNode._LoadingNode);
                }
              } else {
                console.log("ProgressBar.js.show(" + reason + ") -> curNode is null");
              }
            },
            hide: function (reason) {
              let curScene = cc.director.getScene();
              let curNode = curScene && curScene.getChildByName('Canvas');

              if (curNode) {
                if (curNode._LoadingReasons) {
                  curNode._LoadingReasons.delete(reason);

                  console.log("Loading.js.hide(" + reason + ") -> Reasons.size " + curNode._LoadingReasons.size + ", _PrefabLoading:" + curNode._PrefabLoading + ", _LoadingNode:" + curNode._LoadingNode);

                  if (curNode._LoadingReasons.size == 0) {
                    if (curNode._LoadingNode) {
                      curNode._LoadingNode.removeFromParent(true);

                      curNode._LoadingNode = undefined;
                    }
                  }
                }
              } else {
                console.log("Loading.js.hide(" + reason + ") -> curNode is null");
              }
            }
          };
          window.Loading = Loading;
        })();

        _cjsExports = exports('default', module.exports);
      });

      const __cjsMetaURL = exports('__cjsMetaURL', module.meta.url);
    }
  };
});

System.register("chunks:///_virtual/balanceFailed.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './sceneManager.ts', './playerData.ts', './uiManager.ts', './gameLogic.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, _applyDecoratedDescriptor, _initializerDefineProperty, SceneManager, playerData, uiManager, GameLogic;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
    }, function (module) {
      SceneManager = module.SceneManager;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      GameLogic = module.GameLogic;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _temp;

      cclegacy._RF.push({}, "e4928/nKARPlqGf+IiCXcgK", "balanceFailed", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let BalanceFailed = exports('BalanceFailed', (_dec = ccclass('BalanceFailed'), _dec(_class = (_class2 = (_temp = class BalanceFailed extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "lbLevel", _descriptor, this);
        }

        show() {
          this.lbLevel.string = playerData.instance.level;
        }

        onBtnRetryClick() {
          uiManager.instance.hideDialog('fight/balanceFailed');
          GameLogic.instance.resetLevel();
        }

        onBtnCloseClick() {
          uiManager.instance.hideDialog('fight/balanceFailed');
          SceneManager.instance.loadScene('pve', [], (err, result) => {
            if (err) {
              console.error(err.message || err);
              return;
            }
          });
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "lbLevel", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/poolManager.ts", ['cc', './_rollupPluginModLoBabelHelpers.js'], function (exports) {
  'use strict';

  var cclegacy, _decorator, instantiate, NodePool, _defineProperty;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      instantiate = module.instantiate;
      NodePool = module.NodePool;
    }, function (module) {
      _defineProperty = module.defineProperty;
    }],
    execute: function () {
      var _dec, _class, _class2, _temp;

      cclegacy._RF.push({}, "e4ab6T5/1VCqK/Vn+UcADNM", "poolManager", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let poolManager = exports('poolManager', (_dec = ccclass("poolManager"), _dec(_class = (_temp = _class2 = class poolManager {
        constructor() {
          _defineProperty(this, "_dictPool", {});

          _defineProperty(this, "_dictPrefab", {});
        }
        /* class member could be defined like this */
        // dummy = '';

        /* use `property` decorator if your want the member to be serializable */
        // @property
        // serializableDummy = 0;


        static get instance() {
          if (this._instance) {
            return this._instance;
          }

          this._instance = new poolManager();
          return this._instance;
        }
        /**
         * 根据预设从对象池中获取对应节点
         */


        getNode(prefab, parent) {
          let name = prefab.name; //@ts-ignore

          if (!prefab.position) {
            //@ts-ignore
            name = prefab.data.name;
          }

          this._dictPrefab[name] = prefab;
          let node = null;

          if (this._dictPool.hasOwnProperty(name)) {
            //已有对应的对象池
            let pool = this._dictPool[name];

            if (pool.size() > 0) {
              node = pool.get();
            } else {
              node = instantiate(prefab);
            }
          } else {
            //没有对应对象池，创建他！
            let pool = new NodePool();
            this._dictPool[name] = pool;
            node = instantiate(prefab);
          }

          node.parent = parent;
          node.active = true;
          return node;
        }
        /**
         * 将对应节点放回对象池中
         */


        putNode(node) {
          if (!node) {
            return;
          }

          let name = node.name;
          let pool = null;

          if (this._dictPool.hasOwnProperty(name)) {
            //已有对应的对象池
            pool = this._dictPool[name];
          } else {
            //没有对应对象池，创建他！
            pool = new NodePool();
            this._dictPool[name] = pool;
          }

          pool.put(node);
        }
        /**
         * 根据名称，清除对应对象池
         */


        clearPool(name) {
          if (this._dictPool.hasOwnProperty(name)) {
            let pool = this._dictPool[name];
            pool.clear();
          }
        }
        /**
        * 预生成对象池
        * @param prefab 
        * @param nodeNum 
        * 使用——poolManager.instance.prePool(prefab, 40);
        */


        prePool(prefab, nodeNum) {
          const name = prefab.name;
          let pool = new NodePool();
          this._dictPool[name] = pool;

          for (let i = 0; i < nodeNum; i++) {
            const node = instantiate(prefab);
            pool.put(node);
          }
        }

      }, _defineProperty(_class2, "_instance", void 0), _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/clientEvent.ts", ['cc', './_rollupPluginModLoBabelHelpers.js'], function (exports) {
  'use strict';

  var cclegacy, _decorator, _defineProperty;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
    }, function (module) {
      _defineProperty = module.defineProperty;
    }],
    execute: function () {
      var _dec, _class, _class2, _temp;

      cclegacy._RF.push({}, "e55dbzBNn1NUrh8r5zusvCZ", "clientEvent", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let clientEvent = exports('clientEvent', (_dec = ccclass("clientEvent"), _dec(_class = (_temp = _class2 = class clientEvent {
        /**
         * 监听事件
         * @param {string} eventName 事件名称
         * @param {function} handler 监听函数
         * @param {object} target 监听目标
         */
        static on(eventName, handler, target) {
          var objHandler = {
            handler: handler,
            target: target
          };
          var handlerList = clientEvent._handlers[eventName];

          if (!handlerList) {
            handlerList = [];
            clientEvent._handlers[eventName] = handlerList;
          }

          for (var i = 0; i < handlerList.length; i++) {
            if (!handlerList[i]) {
              handlerList[i] = objHandler;
              return i;
            }
          }

          handlerList.push(objHandler);
          return handlerList.length;
        }
        /**
         * 取消监听
         * @param {string} eventName 监听事件
         * @param {function} handler 监听函数
         * @param {object} target 监听目标
         */


        static off(eventName, handler, target) {
          var handlerList = clientEvent._handlers[eventName];

          if (!handlerList) {
            return;
          }

          for (var i = 0; i < handlerList.length; i++) {
            var oldObj = handlerList[i];

            if (oldObj.handler === handler && (!target || target === oldObj.target)) {
              handlerList.splice(i, 1);
              break;
            }
          }
        }
        /**
         * 分发事件
         * @param {string} eventName 分发事件名
         * @param  {...any} params 分发事件参数
         */


        static dispatchEvent(eventName, ...args) {
          var handlerList = clientEvent._handlers[eventName];
          var args1 = [];
          var i;

          for (i = 1; i < arguments.length; i++) {
            args1.push(arguments[i]);
          }

          if (!handlerList) {
            return;
          }

          for (i = 0; i < handlerList.length; i++) {
            var objHandler = handlerList[i];

            if (objHandler.handler) {
              objHandler.handler.apply(objHandler.target, args1);
            }
          }
        }

      }, _defineProperty(_class2, "_handlers", {}), _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/playerData.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './constants.ts', './clientEvent.ts', './constant.ts', './storageManager.ts', './utils.ts', './localConfig.ts', './sceneManager.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, _defineProperty, constants, clientEvent, constant, StorageManager, utils, localConfig, SceneManager;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
    }, function (module) {
      _defineProperty = module.defineProperty;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      clientEvent = module.clientEvent;
    }, function (module) {
      constant = module.constant;
    }, function (module) {
      StorageManager = module.StorageManager;
    }, function (module) {
      utils = module.utils;
    }, function (module) {
      localConfig = module.localConfig;
    }, function (module) {
      SceneManager = module.SceneManager;
    }],
    execute: function () {
      var _dec, _class, _class2, _temp;

      cclegacy._RF.push({}, "e5927B2lO9C6o5eLg2NmcKB", "playerData", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let playerData = exports('playerData', (_dec = ccclass("playerData"), _dec(_class = (_temp = _class2 = class playerData extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "serverTime", 0);

          _defineProperty(this, "localTime", 0);

          _defineProperty(this, "spareStep", void 0);

          _defineProperty(this, "curLevelInfo", void 0);

          _defineProperty(this, "dictTargets", void 0);

          _defineProperty(this, "score", void 0);

          _defineProperty(this, "arrStars", void 0);

          _defineProperty(this, "level", 1);

          _defineProperty(this, "dataVersion", void 0);

          _defineProperty(this, "isFirst", void 0);

          _defineProperty(this, "balanceOverAdTimes", void 0);

          _defineProperty(this, "_bag", null);

          _defineProperty(this, "_userId", '');

          _defineProperty(this, "_playerInfo", null);

          _defineProperty(this, "_history", null);

          _defineProperty(this, "_settings", null);

          _defineProperty(this, "_isNewBee", false);

          _defineProperty(this, "_dataVersion", '');
        }

        static get instance() {
          if (this._instance) {
            return this._instance;
          }

          this._instance = new playerData();
          return this._instance;
        }

        get bag() {
          return this._bag;
        }

        get userId() {
          return this._userId;
        }

        set userId(v) {
          this._userId = v;
        }

        get settings() {
          return this._settings;
        }

        set settings(v) {
          this._settings = v;
        }

        get playerInfo() {
          return this._playerInfo;
        }

        get history() {
          return this._history;
        }

        get isNewBee() {
          return this._isNewBee;
        }

        set isNewBee(v) {
          this._isNewBee = v;
        }
        /**
         * 加上用户数据
         */


        loadGlobalCache() {
          let userId = StorageManager.instance.getUserId();

          if (userId) {
            this._userId = userId;
          }
        }
        /**
         * 加载本地存储数据
         */


        loadFromCache() {
          //读取玩家基础数据
          this._playerInfo = this._loadDataByKey(constant.LOCAL_CACHE.PLAYER);
          this._history = this._loadDataByKey(constant.LOCAL_CACHE.HISTORY);
          this._settings = this._loadDataByKey(constant.LOCAL_CACHE.SETTINGS);
          this._bag = this._loadDataByKey(constant.LOCAL_CACHE.BAG);
        }
        /**
         * 获取本地存储数据
         * @param {string}keyName 
         * @returns 
         */


        _loadDataByKey(keyName) {
          let ret = {};
          let str = StorageManager.instance.getConfigData(keyName);

          if (str) {
            try {
              ret = JSON.parse(str);
            } catch (e) {
              ret = {};
            }
          }

          return ret;
        }
        /**
         * 创建角色数据
         * @param loginData 
         */


        createPlayerInfo(loginData) {
          this._playerInfo = {
            diamond: 0,
            //钻石总数
            key: 0,
            //钥匙数量
            level: 1,
            //当前关卡
            createDate: new Date() //记录创建时间

          };
          this._isNewBee = true; //区分新老玩家

          if (loginData) {
            for (let key in loginData) {
              this._playerInfo[key] = loginData[key];
            }
          }

          this.savePlayerInfoToLocalCache();
        }
        /**
         * 生成随机账户
         * @returns
         */


        generateRandomAccount() {
          this.userId = `${Date.now()}${utils.getRandomInt(0, 1000)}`;
          StorageManager.instance.setUserId(this._userId);
        }
        /**
         * 存用户数据
         * @param userId 
         */


        saveAccount(userId) {
          this._userId = userId;
          StorageManager.instance.setUserId(userId);
        }
        /**
         * 保存玩家数据
         */


        savePlayerInfoToLocalCache() {
          StorageManager.instance.setConfigData(constant.LOCAL_CACHE.PLAYER, JSON.stringify(this._playerInfo));
        }
        /**
         * 保存玩家设置相关信息
         */


        saveSettingsToLocalCache() {
          StorageManager.instance.setConfigData(constant.LOCAL_CACHE.SETTINGS, JSON.stringify(this._settings));
        }
        /**
         * 当数据同步完毕，即被覆盖的情况下，需要将数据写入到本地缓存，以免数据丢失
         */


        saveAll() {
          StorageManager.instance.setConfigDataWithoutSave(constant.LOCAL_CACHE.PLAYER, JSON.stringify(this._playerInfo));
          StorageManager.instance.setConfigDataWithoutSave(constant.LOCAL_CACHE.HISTORY, JSON.stringify(this._history));
          StorageManager.instance.setConfigDataWithoutSave(constant.LOCAL_CACHE.SETTINGS, JSON.stringify(this._settings));
          StorageManager.instance.setConfigDataWithoutSave(constant.LOCAL_CACHE.BAG, JSON.stringify(this.bag));
          StorageManager.instance.setConfigData(constant.LOCAL_CACHE.DATA_VERSION, this._dataVersion);
        }
        /**
         * 更新用户信息
         * 例如钻石、金币、道具
         * @param {String} key
         * @param {Number} value
         */


        updatePlayerInfo(key, value) {
          let isChanged = false;

          if (this._playerInfo.hasOwnProperty(key)) {
            if (typeof value === 'number') {
              isChanged = true;
              this._playerInfo[key] += value;

              if (this._playerInfo[key] < 0) {
                this._playerInfo[key] = 0;
              } //return;

            } else if (typeof value === 'boolean' || typeof value === 'string') {
              isChanged = true;
              this._playerInfo[key] = value;
            }
          } else {
            this._playerInfo[key] = value;
          }

          if (isChanged) {
            //有修改就保存到localcache
            StorageManager.instance.setConfigData(constant.LOCAL_CACHE.PLAYER, JSON.stringify(this._playerInfo));
          }
        }
        /**
         * 获取玩家杂项值
         * @param {string} key 
         */


        getSetting(key) {
          if (!this._settings) {
            return null;
          }

          if (!this._settings.hasOwnProperty(key)) {
            return null;
          }

          return this._settings[key];
        }
        /**
         * 设置玩家杂项值
         * @param {string} key 
         * @param {*} value 
         */


        setSetting(key, value) {
          if (!this._settings) {
            this._settings = {};
          }

          this._settings[key] = value;
          this.saveSettingsToLocalCache();
        }
        /**
         * 清除用户信息
         */


        clear() {
          this._playerInfo = {};
          this._settings = {};
          this.saveAll();
        }
        /**
         * 与上次登录时间超过一定分钟，就可以再次领取离线奖励。
         * @param checkRewardTime 
         * @returns 
         */


        isOpenOffLineReward(checkRewardTime) {
          let now = Date.now();
          let isOpen = false;

          if (!this.playerInfo.loginDate) {
            this.playerInfo.loginDate = Date.now();
          } else {
            isOpen = now - this.playerInfo.loginDate >= checkRewardTime;

            if (isOpen) {
              this.playerInfo.loginDate = now;
            }
          }

          this.savePlayerInfoToLocalCache();
          return isOpen;
        }
        /**
        * 获取在线奖励信息 
        */


        getOnlineRewardInfo() {
          if (!this.playerInfo.hasOwnProperty('onlineRewardInfo')) {
            this.resetOnlineRewardInfo();
          } else {
            let isNeedRefreshReward = utils.getDeltaDays(this.playerInfo.onlineRewardInfo['loginTime'], Date.now()); //新的一天            

            if (isNeedRefreshReward > 0) {
              this.resetOnlineRewardInfo();
            }
          }

          return this.playerInfo.onlineRewardInfo;
        }
        /**
         * 重置在线奖励信息
         * value:{times: 当前已领取到了第几次奖励, receiveStatus: 领取状态(0不可领取1可领取)}
         * loginTime: 在线开始时间
         * used: 倒计时消耗时间
         */


        resetOnlineRewardInfo() {
          this.playerInfo.onlineRewardInfo = {};
          this.playerInfo.onlineRewardInfo['value'] = {
            times: 0,
            receiveStatus: constants.REWARD_STATUS.UNRECEIVABLE
          };
          this.playerInfo.onlineRewardInfo['loginTime'] = Date.now();
          this.playerInfo.onlineRewardInfo['usedTime'] = 0;
          this.savePlayerInfoToLocalCache();
        }
        /**
        * 刷新商城随机道具的信息
        */


        resetShopPropInfo() {
          this.playerInfo.shopPropInfo = {};
          let dictProp = localConfig.instance.getTable('prop');

          if (!dictProp) {
            return false;
          }

          let arrPropKey = Object.keys(dictProp);
          let arrRandom = arrPropKey.filter(element => {
            return Number(element) !== constants.PROP_ID.INFINITE;
          });
          let randomVal = arrRandom[Math.floor(Math.random() * arrRandom.length)];
          this.playerInfo.shopPropInfo['createDate'] = Date.now();
          this.playerInfo.shopPropInfo['prop'] = randomVal;
          this.playerInfo.shopPropInfo['receiveStatus'] = constants.REWARD_STATUS.UNRECEIVABLE; //可领取或不可领取，用来切换状态

          this.savePlayerInfoToLocalCache();
        }
        /**
        * 更新商城随机道具的状态
        */


        updateShopPropInfo(isReceived) {
          if (!this.playerInfo.shopPropInfo) {
            return;
          }

          if (isReceived) {
            this.resetShopPropInfo();
          } else {
            //时间到设置为可领取
            this.playerInfo.shopPropInfo['receiveStatus'] = constants.REWARD_STATUS.RECEIVABLE;
          }

          this.savePlayerInfoToLocalCache();
        }
        /**
        * 签到：更新签到领取日期，补签状态，如果超过7天则轮回
        */


        updateSignInCurrentDay() {
          if (!this.playerInfo['signInInfo'] || this.isNeedRecycleSignInInfo()) {
            this.createNewSignInInfo();
          } else {
            let offectDays = utils.getDeltaDays(this.playerInfo['signInInfo']['signInDate'], Date.now()); //比较两个时间，为0则今天更新过

            if (offectDays === 0) {
              return;
            } //将昨天“补签后”但是没领取奖励重置为“补签”状态


            this.updateSignInFillSignInDays(0, true); //更新领取今日签到信息

            this.playerInfo['signInInfo'].currentDay += offectDays; //当测试时间差异的时候将当前的时间设置为第一天

            if (this.playerInfo['signInInfo'].currentDay <= 0) {
              this.createNewSignInInfo();
            }

            this.playerInfo['signInInfo'].currentDay > constants.MAX_SIGN_IN_REWARDS_DAY ? constants.MAX_SIGN_IN_REWARDS_DAY : this.playerInfo['signInInfo'].currentDay;
            this.playerInfo['signInInfo'].signInDate = Date.now();
          }

          this.savePlayerInfoToLocalCache();
        }
        /**
        * 签到：是否需要重新开始一个新的签到周期
        */


        isNeedRecycleSignInInfo() {
          if (!this.playerInfo['signInInfo']) {
            this.createNewSignInInfo();
          }

          let isNeedRecycled = false;
          let diffTime = utils.getDeltaDays(this.playerInfo['signInInfo'].createDate, Date.now());

          if (diffTime >= constants.MAX_SIGN_IN_REWARDS_DAY) {
            //当前日期与创建日期超过七天，1号7号相差6天，第8天进行更新
            isNeedRecycled = true;
          }

          return isNeedRecycled;
        }
        /**
         * 签到：创建新的签到信息
         * signInInfo: {
         *  createDate： 签到创建时间, 
         *  signInDate: 记录当前打开签到界面是第几天，用于更新今日签到日期
         *  currentDay： 当前日期，
         *  receivedDays： 已经领取的日期数组,
         *  afterFillSignInDays： 补签完了之后可领取的日期数组
         * } 
         */


        createNewSignInInfo() {
          if (!this.playerInfo['signInInfo']) {
            this.playerInfo['signInInfo'] = {};
          }

          this.playerInfo['signInInfo'].createDate = Date.now();
          this.playerInfo['signInInfo'].signInDate = Date.now();
          this.playerInfo['signInInfo'].currentDay = 1;
          this.playerInfo['signInInfo'].receivedDays = [];
          this.playerInfo['signInInfo'].afterFillSignInDays = [];
          this.savePlayerInfoToLocalCache();
        }
        /**
         * 签到：更新补签后变为可领取的日期数组
         * @param {number} day 
         * @param {boolean} isClear 是否清空昨天补签完后还未领取的数组
         */


        updateSignInFillSignInDays(day, isClear) {
          let afterFillSignInDays = this.playerInfo['signInInfo']['afterFillSignInDays'];

          if (!isClear) {
            if (Array.isArray(afterFillSignInDays) && afterFillSignInDays.includes(day)) {
              return;
            } //记录领取天数


            afterFillSignInDays.push(Number(day));
          } else {
            afterFillSignInDays.length = 0;
          }

          this.savePlayerInfoToLocalCache();
        }
        /**
         * 签到：返回“当天”还有“全部”的签到奖励领取情况
         * 用来判断“领取按钮显示”，“登陆自动显示签到界面”和“红点提示”
         * @returns {boolean, boolean} isAllReceived是否全部领取， isTodayReceived是否当天已领取
         */


        getSignInReceivedInfo() {
          if (!this.playerInfo['signInInfo']) {
            this.createNewSignInInfo();
          }

          let signInInfo = this.playerInfo['signInInfo'];
          let isAllReceived = false;
          let isTodayReceived = false;

          if (signInInfo.receivedDays.length < signInInfo.currentDay) {
            isAllReceived = false;
          } else {
            isAllReceived = true;
          }

          if (signInInfo.receivedDays.includes(signInInfo.currentDay)) {
            isTodayReceived = true;
          } else {
            isTodayReceived = false;
          }

          return {
            isAllReceived,
            isTodayReceived
          };
        }
        /**
         * 获取当前在线奖励时间间隔
         */


        getCountdownTime() {
          let onlineCurrentTimes = this.playerInfo['onlineRewardInfo'].value.times;
          let arrInterval = constants.ONLINE_REWARD_INTERVAL;
          let maxInterval = arrInterval.length - 1;
          onlineCurrentTimes = onlineCurrentTimes > maxInterval ? maxInterval : onlineCurrentTimes; //限制最大时间间隔

          let curInterval = arrInterval[onlineCurrentTimes];
          return curInterval;
        }
        /**
         * 更新在线奖励次数,状态,时间信息
         * 时间到了和点击领取时候调用
         */


        updateOnlineRewardInfo(isReceive) {
          if (!this.playerInfo.onlineRewardInfo) {
            return;
          }

          let onlineRewardValue = this.playerInfo.onlineRewardInfo['value'];

          if (isReceive) {
            //如果是点击领取则更新新的在线奖励内容
            onlineRewardValue.times += 1;
            onlineRewardValue.receiveStatus = constants.REWARD_STATUS.UNRECEIVABLE;
          } else {
            //倒计时结束，设置为可领取，并将倒计时消耗置为0
            onlineRewardValue.receiveStatus = constants.REWARD_STATUS.RECEIVABLE;
            this.playerInfo.onlineRewardInfo['usedTime'] = 0;
          }

          this.savePlayerInfoToLocalCache();
        }
        /**
         * 设置已经消耗过的时间
         */


        addUsedTime() {
          if (!this.playerInfo.onlineRewardInfo || SceneManager.instance.isStop) {
            return;
          }

          this.playerInfo.onlineRewardInfo['usedTime'] += 1; //秒

          this.savePlayerInfoToLocalCache();
        }
        /**
         * 签到：转化签到数据格式,新版本数据结构不一样
         */


        convertSignInDataFormat(info) {
          let arrValue = info.value.split('#');
          let arrReceivedDays = arrValue[1].split('|');
          arrReceivedDays.splice(arrReceivedDays.length - 1, 1);
          this.playerInfo['signInInfo'].createDate = info.signInDate - 24 * 60 * 60 * 1000 * Number(arrValue[0] - 1);
          this.playerInfo['signInInfo'].signInDate = info.signInDate;
          this.playerInfo['signInInfo'].currentDay = Number(arrValue[0]);
          this.playerInfo['signInInfo'].receivedDays = arrReceivedDays.map(Number);
          this.playerInfo['signInInfo'].afterFillSignInDays = [];
          delete info.value;
          this.savePlayerInfoToLocalCache();
        }
        /**
         * 完成连接
         * @param {String} cake 
         * @param {Number} finishValue 
         */


        finishLink(cake, finishValue) {
          this.reduceStep();
          this.finishTarget(cake, finishValue);
        }

        reduceStep() {
          if (this.curLevelInfo.infinite) {
            return;
          }

          this.spareStep--;

          if (this.spareStep < 0) {
            this.spareStep = 0;
          }
        }

        finishTarget(cake, finishValue) {
          if (this.dictTargets.hasOwnProperty(cake)) {
            this.dictTargets[cake] -= finishValue;

            if (this.dictTargets[cake] < 0) {
              this.dictTargets[cake] = 0;
            }
          }
        }
        /**
         * 检查关卡是否已经完成
         */


        isLevelFinish() {
          let isFinish = true;

          for (let target in this.dictTargets) {
            if (this.dictTargets.hasOwnProperty(target)) {
              if (this.dictTargets[target] > 0) {
                isFinish = false;
                break;
              }
            }
          }

          return isFinish;
        }
        /**
         * 是否游戏结束
         */


        isGameOver() {
          return this.spareStep <= 0;
        }

        startNewLevel() {
          let levelInfo = this.getCurrentLevelInfo();
          this.score = 0;
          this.spareStep = 0;
          this.curLevelInfo = {};
          this.curLevelInfo.startTime = Date.now();
          this.curLevelInfo.infinite = false;

          if (levelInfo) {
            this.spareStep = levelInfo.limit;
          }

          this.dictTargets = {};
          let arrTargets = levelInfo.targets.split('|');

          for (let idx = 0; idx < arrTargets.length; idx++) {
            let arrTargetObj = arrTargets[idx].split('-');
            this.dictTargets[arrTargetObj[0]] = Number(arrTargetObj[1]);
          }

          this.arrStars = levelInfo.stars.split('|');
        }

        getCurrentLevelInfo() {
          let level = localConfig.instance.queryByID('level', this.level);

          if (level) {
            level.level = this.level;
          }

          return level;
        }
        /**
         * 增加钻石数量
         *
         * @param {Number} num
         */


        addDiamond(num) {
          this.updatePlayerInfo('diamond', num);
        }
        /**
         * 增加金币数量
         *
         * @param {Number} num
         */


        addGold(num) {
          this.updatePlayerInfo('gold', Number(num));
        }
        /**
         * 获得道具
         *
         * @param {number} propId
         * @param {number} num
         */


        addProp(propId, num) {
          if (this._bag.hasOwnProperty(propId)) {
            let prop = this._bag[propId];
            prop.amount += num;
          } else {
            let prop = {
              amount: num
            };
            this._bag[propId] = prop;
          }

          this.addDataVersion();
          StorageManager.instance.setConfigData(constant.LOCAL_CACHE.BAG, JSON.stringify(this._bag));
          return true;
        }
        /**
         * 新增数据版本
         */


        addDataVersion() {
          let today = new Date().toLocaleDateString();
          let isAdd = false;

          if (this.dataVersion && typeof this.dataVersion === 'string') {
            var arrVersion = this.dataVersion.split('@');

            if (arrVersion.length >= 2) {
              if (arrVersion[0] === today) {
                this.dataVersion = today + '@' + (Number(arrVersion[1]) + 1);
                isAdd = true;
              }
            }
          }

          if (!isAdd) {
            this.dataVersion = today + '@1';
          }

          StorageManager.instance.setConfigDataWithoutSave(constants.LOCAL_CACHE.DATA_VERSION, this.dataVersion);
        }
        /**
         * 是否第一次点击更多游戏按钮
         * @param {boolean} isFirstClick 
         */


        isFirstClickMoreGame(isFirstClick) {
          if (isFirstClick) {
            this.isFirst = isFirstClick;
          }

          return this.isFirst;
        }
        /**
         * 获得抽奖次数
         *
         * @param {Boolean} isMore
         */


        getLotterySpareTimes(isMore) {
          let maxTimes = constants.LOTTERY_MAX_TIMES;

          if (isMore) {
            maxTimes = constants.LOTTERY_AD_MAX_TIMES;
          }

          let now = utils.getDay();
          let lottery = this.getSetting(constants.SETTINGS_KEY.LOTTERY);

          if (!lottery) {
            lottery = {};
          }

          if (!lottery.today || lottery.today !== now) {
            lottery = {};
            lottery.today = {};
            this.setSetting(constants.SETTINGS_KEY.LOTTERY, lottery);
            return maxTimes;
          }

          let currentTimes = lottery.times;

          if (isMore) {
            currentTimes = lottery.moreTimes;
          }

          if (!currentTimes) {
            currentTimes = 0;
          }

          let spareTimes = maxTimes - currentTimes;
          return spareTimes > 0 ? spareTimes : 0;
        }
        /**
         * 是否有完成任务但是还未领取奖励，用于红点切换
         */


        isFinishTaskAndNoReceive() {
          if (!this.playerInfo || !this.playerInfo.dictTask) {
            return false;
          }

          for (let key in this.playerInfo.dictTask) {
            let task = this.playerInfo.dictTask[key];
            let taskInfo = localConfig.instance.queryByID('task', key);
            let taskStatus = this.getTaskStatusById(key);

            if (taskStatus.taskFinishCount >= taskInfo.count && taskStatus.taskState === constants.TASK_STATE.RECEIVABLE) {
              return true;
            }
          }

          return false;
        }
        /**
         * 获取当前每个任务的情况
         *
         * @param {String} id
         * @returns
         */


        getTaskStatusById(id) {
          if (!this.playerInfo || !this.playerInfo.hasOwnProperty('taskDate')) {
            return null;
          }

          let taskStatus = this.playerInfo.dictTask[id];
          return taskStatus = !taskStatus ? null : taskStatus;
        }

        getGold() {
          if (!this.playerInfo.hasOwnProperty('gold')) {
            return 0;
          }

          return this.playerInfo.gold;
        }
        /**
         * 解析礼包结构，返回礼包内容
         *
         * @param {number} 礼包奖励子类型id
         */


        parseGift(giftId) {
          let objGift = localConfig.instance.queryByID('gift', giftId);

          if (!objGift) {
            return null;
          }

          let arrType = objGift.type.split('|').map(Number); //奖励类型

          let arrSubType = objGift.subType.split('|').map(Number); //奖励子类型

          let arrAmount = objGift.amount.split('|').map(Number); //类型对应数量

          let arrGift = [];
          arrType.forEach((val, idx, arr) => {
            arrGift.push({
              type: val,
              subType: arrSubType[idx],
              amount: arrAmount[idx]
            });
          });
          return arrGift;
        }
        /**
         * 签到：更新领取奖励后已领取日期数组
         * @param {Number} day
         */


        updateSignInReceivedDays(day) {
          let receivedDays = this.playerInfo['signInInfo']['receivedDays'];

          if (Array.isArray(receivedDays) && receivedDays.includes(day)) {
            return;
          } //记录领取天数


          receivedDays.push(Number(day));
          this.savePlayerInfoToLocalCache();
        }
        /**
         * 增加抽奖次数
         *
         * @param {Boolean} isMore
         * @param {Number} Times
         */


        addLotteryTimes(isMore, times) {
          if (!times) {
            times = 1;
          }

          let now = utils.getDay();
          let lottery = this.getSetting(constants.SETTINGS_KEY.LOTTERY);

          if (!lottery) {
            lottery = {};
          }

          if (!lottery.today || lottery.today !== now) {
            lottery = {};
            lottery.today = now;
          }

          if (!isMore) {
            if (lottery.times) {
              lottery.times += times; //普通领奖次数累加
            } else {
              lottery.times = times;
            }
          } else {
            if (lottery.moreTimes) {
              lottery.moreTimes += times; //看广告领奖次数累加
            } else {
              lottery.moreTimes = times;
            }
          }

          this.setSetting(constants.SETTINGS_KEY.LOTTERY, lottery);
        } //获得无限道具的分享/广告次数


        getInfiniteTimes() {
          if (this.playerInfo.infiniteShareTimes) {
            return this.playerInfo.infiniteShareTimes;
          }

          return 0;
        }

        exchangeInfiniteProp() {
          if (this.playerInfo.infiniteShareTimes >= constants.MAX_INFINITE_TIMES) {
            this.playerInfo.infiniteShareTimes -= constants.MAX_INFINITE_TIMES;
          } else {
            this.playerInfo.infiniteShareTimes = 0;
          }

          clientEvent.dispatchEvent('updateInfiniteShareTimes');
          this.savePlayerInfoToLocalCache();
        }
        /**
         * 获取玩家当前玩到的关卡
         */


        getCurrentLevel() {
          var history = utils.objectToArray(this.history);
          var length = history.length;

          if (length === 0) {
            return localConfig.instance.queryOne('level', 'name', '1');
          }

          history.sort(function (a, b) {
            return Number(a.levelId) - Number(b.levelId);
          });
          var last = history[length - 1];
          var curLevel = localConfig.instance.queryByID('level', parseInt(last.levelId).toString());
          var nextLevel = localConfig.instance.queryOne('level', 'name', String(parseInt(curLevel.name) + 1));

          if (!nextLevel || last.star === 0) {
            // 关卡必须前一关获得至少1星才可以挑战下一关
            return curLevel;
          }

          return nextLevel;
        }
        /**
         * 获得关卡最高分
         *
         * @param {Number} level
         * @returns
         */


        getHighestScoreByLevel(level) {
          if (this.history.hasOwnProperty(level)) {
            return this.history[level].score;
          }

          return 0;
        }
        /**
         * 获取道具剩余数量
         * 
         * @param {Number} propId 道具id
         */


        getPropAmount(propId) {
          if (this.bag.hasOwnProperty(propId)) {
            return this.bag[propId].amount || 0; //考虑undefined所以加或0
          }

          return 0;
        }
        /**
         * 道具是否解锁 (控制道具的显示隐藏)
         * @param {number} propId 
         */


        isPropUnlock(propId) {
          let higestLevel = this.getCurrentLevel().ID;

          if (!this.playerInfo.hasOwnProperty('unLockInfo')) {
            this.getUnLockInfo();
          }

          return higestLevel > 1 && this.playerInfo.unLockInfo.includes(propId);
        } //获得解锁道具信息


        getUnLockInfo() {
          if (!this.playerInfo.hasOwnProperty('unLockInfo')) {
            let higestLevel = this.getCurrentLevel().ID;
            let arrUnlockProp = constants.UNLOCK_PROP_ID;
            let [start, end] = [0, higestLevel - 1];
            this.playerInfo.unLockInfo = arrUnlockProp.slice(start, end);
            this.savePlayerInfoToLocalCache();
          }

          return this.playerInfo.unLockInfo;
        }

        addStep(addValue) {
          this.spareStep += addValue;
        }
        /**
         * 是否需要打开解锁界面
         */


        isNeedOpenUnlockPanel() {
          //当前关卡的等级,不一定是最高的那一关
          let curLevel = this.getCurrentLevelInfo().ID;

          if (curLevel > 1 && curLevel <= constants.UNLOCK_HIGEST_LEVEl) {
            //关卡对应的道具
            let curProp = constants.UNLOCK_PROP_ID[curLevel - 2];

            if (!this.playerInfo.hasOwnProperty('unLockInfo')) {
              this.getUnLockInfo();
            }

            let isPropUnlock = this.isPropUnlock(curProp);

            if (!isPropUnlock) {
              return true;
            }
          }

          return false;
        }

        hasSeenGuide() {
          return this.playerInfo.hasSeenGuide;
        }

        finishSeenGuide() {
          this.playerInfo.hasSeenGuide = true;
          this.updatePlayerInfo('hasSeenGuide', true);
        }
        /**
         * 消耗道具
         *
         * @param {number} propId
         */


        costProp(propId) {
          if (!this.bag.hasOwnProperty(propId)) {
            return false;
          }

          let prop = this.bag[propId];

          if (prop <= 0) {
            return false; //数量不足
          }

          prop.amount--;
          this.addDataVersion();
          StorageManager.instance.setConfigData(constant.LOCAL_CACHE.BAG, JSON.stringify(this.bag));
          return true;
        }
        /**
         * 增加分数
         * @param {Number} score 
         */


        addScore(score) {
          this.score += score;
        }
        /**
         * 通过目标类型获得目标值
         * @param {String} cake 
         */


        getTargetValue(cake) {
          if (this.dictTargets.hasOwnProperty(cake)) {
            return this.dictTargets[cake];
          }

          return 0;
        }
        /**
         * 更新已解锁道具
         */


        updateUnLockInfo(propId) {
          let arrUnLockProp = this.playerInfo.unLockInfo;

          if (!arrUnLockProp.includes(propId)) {
            arrUnLockProp.push(propId);
            this.savePlayerInfoToLocalCache();
          } else {
            return;
          }
        }

        finishLevel(level, score) {
          let star = 0;
          let levelInfo = localConfig.instance.queryByID('level', level);
          let costTime = (Date.now() - this.curLevelInfo.startTime) / 1000;

          if (levelInfo) {
            let arrStars = levelInfo.stars.split('|');

            if (score >= arrStars[2]) {
              star = 3;
            } else if (score >= arrStars[1]) {
              star = 2;
            } else if (score >= arrStars[0]) {
              star = 1;
            }
          }

          let preStar = 0;

          if (this.history.hasOwnProperty(level)) {
            preStar = this.history[level].star;

            if (this.history[level].score < score) {
              this.history[level].score = score;
              this.history[level].star = star;
              this.history[level].costTime = costTime;
            }
          } else {
            this.history[level] = {
              levelId: level,
              score: score,
              star: star,
              costTime: costTime
            };
          }

          StorageManager.instance.setConfigData(constant.LOCAL_CACHE.HISTORY, JSON.stringify(this.history)); //加金币

          let arrGolds = levelInfo.golds.split('|');
          let gold = 0;

          for (let idxStar = preStar; idxStar < star; idxStar++) {
            gold += Number(arrGolds[idxStar]);
          }

          if (gold > 0) {
            this.addGold(gold);
            clientEvent.dispatchEvent('updateGold');
          }

          return {
            levelId: level,
            score: score,
            star: star,
            gold: gold,
            costTime: costTime,
            spareStep: this.spareStep
          };
        }

        nextLevel() {
          this.level++;
          this.startNewLevel();
        }

      }, _defineProperty(_class2, "_instance", void 0), _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/propItem.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './resourceUtil.ts', './constants.ts', './clientEvent.ts', './playerData.ts', './uiManager.ts', './buttonEx.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, resourceUtil, constants, clientEvent, playerData, uiManager, ButtonEx;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      clientEvent = module.clientEvent;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      ButtonEx = module.ButtonEx;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _temp;

      cclegacy._RF.push({}, "e7ad36HvgtJMJhvgKYrltrK", "propItem", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let PropItem = exports('PropItem', (_dec = ccclass('PropItem'), _dec(_class = (_class2 = (_temp = class PropItem extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "lbPropNum", _descriptor, this);

          _initializerDefineProperty(this, "spPropIcon", _descriptor2, this);

          _defineProperty(this, "propInfo", void 0);

          _defineProperty(this, "propPrice", void 0);
        }

        start() {
          this.updateUnlockProp();
        }

        onEnable() {
          clientEvent.on('updateProp', this.updateProp, this);
          clientEvent.on('updateUnlockProp', this.updateUnlockProp, this);
        }

        onDisable() {
          clientEvent.off('updateProp', this.updateProp, this);
          clientEvent.off('updateUnlockProp', this.updateUnlockProp, this);
        }

        setInfo(propInfo) {
          this.propInfo = propInfo;
          let propNum = playerData.instance.getPropAmount(propInfo.ID);

          if (propNum <= 0) {
            propNum = '+';
          }

          this.lbPropNum.string = propNum;
          resourceUtil.setPropIcon(propInfo.icon, this.spPropIcon, () => {});
          this.propPrice = propInfo.price;
        }

        onPropItemClick() {
          uiManager.instance.showDialog('props/buy', [this.propInfo.ID, constants.ANALYTICS_TYPE.CHECKPOINT_PROP_BUY_NUM]);
        }

        updateProp(propId) {
          if (propId === this.propInfo.ID) {
            this.setInfo(this.propInfo);
          }
        }

        updateUnlockProp() {
          let isPropUnlock = playerData.instance.isPropUnlock(this.propInfo.ID);
          this.node.getComponent(ButtonEx).interactable = isPropUnlock;
          resourceUtil.setGray(this.node, !isPropUnlock);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "lbPropNum", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "spPropIcon", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/shop.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './resourceUtil.ts', './constants.ts', './clientEvent.ts', './utils.ts', './localConfig.ts', './playerData.ts', './uiManager.ts', './buttonEx.ts', './PlatformBridge.js', './PlatformBridge.mjs_cjs=&original=.js', './ConstValue.js', './ConstValue.mjs_cjs=&original=.js', './shopPropsOperation.ts', './shopItem.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, view, instantiate, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, resourceUtil, constants, clientEvent, utils, localConfig, playerData, uiManager, ButtonEx, _cjsExports, _cjsExports$1, ShopPropsOperation, ShopItem;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      view = module.view;
      instantiate = module.instantiate;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      clientEvent = module.clientEvent;
    }, function (module) {
      utils = module.utils;
    }, function (module) {
      localConfig = module.localConfig;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      ButtonEx = module.ButtonEx;
    }, function (module) {
      _cjsExports = module.default;
    }, null, function (module) {
      _cjsExports$1 = module.default;
    }, null, function (module) {
      ShopPropsOperation = module.ShopPropsOperation;
    }, function (module) {
      ShopItem = module.ShopItem;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _descriptor9, _descriptor10, _descriptor11, _descriptor12, _temp;

      cclegacy._RF.push({}, "ece87xczkNChrPYtwiev9Te", "shop", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let Shop = exports('Shop', (_dec = ccclass('Shop'), _dec(_class = (_class2 = (_temp = class Shop extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "arrMenu", _descriptor, this);

          _initializerDefineProperty(this, "pbShopItem", _descriptor2, this);

          _initializerDefineProperty(this, "lbGold", _descriptor3, this);

          _initializerDefineProperty(this, "aniLight", _descriptor4, this);

          _initializerDefineProperty(this, "ndShopPropsOperation", _descriptor5, this);

          _initializerDefineProperty(this, "spRandPropIcon", _descriptor6, this);

          _initializerDefineProperty(this, "lbRandPropNumber", _descriptor7, this);

          _initializerDefineProperty(this, "ndBtnReceive", _descriptor8, this);

          _initializerDefineProperty(this, "spReceive", _descriptor9, this);

          _initializerDefineProperty(this, "sfReceive", _descriptor10, this);

          _initializerDefineProperty(this, "sfShare", _descriptor11, this);

          _initializerDefineProperty(this, "sfAd", _descriptor12, this);

          _defineProperty(this, "arrShopItemScript", void 0);

          _defineProperty(this, "animState", void 0);

          _defineProperty(this, "randomItem", void 0);

          _defineProperty(this, "shopPropsOperationScript", void 0);

          _defineProperty(this, "bottomBannerAd", void 0);
        }

        onLoad() {
          Global.shop = this;
          this.showBannerAd();
        }

        showBannerAd() {
          console.log("showbannerad--2");
          let adWidth = Math.round(720 * view.getFrameSize().width / view.getVisibleSize().width);
          let adHeight = Math.round(adWidth * 90 / 600);
          let adBottomMargin = 0;
          console.log("BannerAd->", adWidth, ",", adHeight, ",", adBottomMargin);

          this.bottomBannerAd = function () {
            _cjsExports.showBannerAd(_cjsExports$1.AdScene.GameScene, _cjsExports$1.getAdBannerBig(), adWidth, adHeight, true, adBottomMargin, false);
          };

          if (Global.VIVOQuickGameEnv) {
            _cjsExports.showBannerAd(_cjsExports$1.AdScene.GameScene, _cjsExports$1.getAdBannerBig(), adWidth, adHeight, true, adBottomMargin, false);
          }

          this.refreshBannerAdSchedule();
        }

        onDestroy() {
          _cjsExports.hideBannerAd();
        }

        refreshBannerAdSchedule() {
          if (Global.VIVOQuickGameEnv) {
            return;
          }

          let adWidth = Math.round(720 * view.getFrameSize().width / view.getVisibleSize().width);
          let adHeight = Math.round(adWidth * 90 / 600);
          let adBottomMargin = 0;
          console.log("BannerAd->", adWidth, ",", adHeight, ",", adBottomMargin);

          _cjsExports.showBannerAd(_cjsExports$1.AdScene.GameScene, _cjsExports$1.getAdBannerBig(), adWidth, adHeight, true, adBottomMargin, false);

          this.unschedule(this.bottomBannerAd);
          this.schedule(this.bottomBannerAd, 35);
        }

        ctor() {
          this.arrShopItemScript = [];
        }

        onEnable() {
          clientEvent.on('updateGold', this.updateGold, this);
          clientEvent.on('updateShopPropInfo', this.showShopProp, this);
        }

        onDisable() {
          clientEvent.off('updateGold', this.updateGold, this);
          clientEvent.off('updateShopPropInfo', this.showShopProp, this);
        }

        show() {
          this.updateGold();
          this.init();
          this.animState = 'shopPropertyIdle';
          this.aniLight.play(this.animState);
          this.showShopProp();
          this.spReceive.spriteFrame = this.sfReceive;
        }

        showShopProp() {
          let shopPropInfo = playerData.instance.playerInfo.shopPropInfo;
          let dictProp = localConfig.instance.getTable('prop');
          this.randomItem = dictProp[shopPropInfo.prop];
          resourceUtil.setPropIcon(this.randomItem.icon, this.spRandPropIcon, () => {});
          this.lbRandPropNumber.string = '1';

          switch (shopPropInfo.receiveStatus) {
            case constants.REWARD_STATUS.UNRECEIVABLE:
              this.ndBtnReceive.getComponent(ButtonEx).interactable = false;
              break;

            case constants.REWARD_STATUS.RECEIVABLE:
              this.ndBtnReceive.getComponent(ButtonEx).interactable = true;
              break;
          }
        }

        init() {
          this.shopPropsOperationScript = this.ndShopPropsOperation.getComponent(ShopPropsOperation);

          if (!this.arrShopItemScript) {
            this.arrShopItemScript = [];
          }

          let dictShop = localConfig.instance.getTable('prop');
          let arrShop = utils.objectToArray(dictShop);
          arrShop.forEach((item, idx, arr) => {
            let node = null;

            if (this.arrMenu[idx].getChildByName('shopItem')) {
              node = this.arrMenu[idx].getChildByName('shopItem');
            } else {
              node = instantiate(this.pbShopItem);
              node.parent = this.arrMenu[idx];
            }

            let shopItemScript = node.getComponent(ShopItem);
            shopItemScript.setInfo(item, this);

            if (idx === 0) {
              shopItemScript.showSelect();
            }

            if (!this.arrShopItemScript.includes(shopItemScript)) {
              this.arrShopItemScript.push(shopItemScript);
            }
          });
        }

        updateGold() {
          this.lbGold.string = utils.formatMoney(playerData.instance.getGold());
        }

        onBtnCloseClick() {
          uiManager.instance.hideDialog('shop/shop');
        }

        showAllItemUnSelect() {
          this.arrShopItemScript.forEach(element => {
            element.showUnSelect();
          });
        }

        onBtnReceiveClick() {
          _cjsExports.showRewardAd("onBtnShopReceiveClick", "1", _cjsExports$1.getAdReward());
        }

        onBtnReceiveClickCallback(s) {
          if (s) {
            this.showRandPropSecelt();
            this.shopPropsOperationScript.show(this.randomItem['ID']);
            this.showReward();
          }
        }

        onRandPropClick() {
          this.showRandPropSecelt();
          this.shopPropsOperationScript.show(this.randomItem['ID']);
        }

        showRandPropSecelt() {
          this.showAllItemUnSelect();
          this.animState = 'shopPropertySelect';
          this.aniLight.play(this.animState);
        }

        hideRandPropSelect() {
          if (this.animState === 'shopPropertyIdle') return;
          this.animState = 'shopPropertyIdle';
          this.aniLight.play(this.animState);
        }

        showReward() {
          let itemInfo = {};
          itemInfo['itemType'] = constants.REWARD_TYPE.PROP;
          itemInfo['itemSubType'] = this.randomItem.ID;
          itemInfo['itemAmount'] = 1;
          uiManager.instance.showDialog('lottery/reward', [itemInfo, false, constants.SHARE_FUNCTION.SHOP_PROP]);
          playerData.instance.updateShopPropInfo(true);
          this.showShopProp();
          clientEvent.dispatchEvent('updateShopPropInfo');
          this.showRandPropSecelt();
          this.shopPropsOperationScript.show(this.randomItem['ID']);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "arrMenu", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "pbShopItem", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "lbGold", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "aniLight", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "ndShopPropsOperation", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "spRandPropIcon", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "lbRandPropNumber", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "ndBtnReceive", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor9 = _applyDecoratedDescriptor(_class2.prototype, "spReceive", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor10 = _applyDecoratedDescriptor(_class2.prototype, "sfReceive", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor11 = _applyDecoratedDescriptor(_class2.prototype, "sfShare", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor12 = _applyDecoratedDescriptor(_class2.prototype, "sfAd", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/LocalizedLabel.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './LanguageData.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, _applyDecoratedDescriptor, _defineProperty, _initializerDefineProperty, ready, init, t;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _defineProperty = module.defineProperty;
      _initializerDefineProperty = module.initializerDefineProperty;
    }, function (module) {
      ready = module.ready;
      init = module.init;
      t = module.t;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _temp;

      cclegacy._RF.push({}, "edf98QH2D1AUoCrtQlbxFrU", "LocalizedLabel", undefined);

      const {
        ccclass,
        property,
        executeInEditMode
      } = _decorator;
      let LocalizedLabel = exports('LocalizedLabel', (_dec = ccclass('LocalizedLabel'), _dec(_class = executeInEditMode(_class = (_class2 = (_temp = class LocalizedLabel extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "label", null);

          _initializerDefineProperty(this, "key", _descriptor, this);
        }

        onLoad() {
          if (!ready) {
            init('zh');
          }

          this.fetchRender();
        }

        fetchRender() {
          let label = this.getComponent('cc.Label');

          if (label) {
            this.label = label;
            this.updateLabel();
            return;
          }
        }

        updateLabel() {
          this.label && (this.label.string = t(this.key));
        }

      }, _temp), _descriptor = _applyDecoratedDescriptor(_class2.prototype, "key", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return '';
        }
      }), _class2)) || _class) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/configuration.ts", ['cc', './_rollupPluginModLoBabelHelpers.js'], function (exports) {
  'use strict';

  var cclegacy, _decorator, sys, _defineProperty;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      sys = module.sys;
    }, function (module) {
      _defineProperty = module.defineProperty;
    }],
    execute: function () {
      var _dec, _class, _class2, _temp;

      cclegacy._RF.push({}, "eec23YA39dCLqNg6zDnqLhV", "configuration", undefined);

      const {
        ccclass
      } = _decorator;
      let KEY_CONFIG = "LinkConfig";
      let Configuration = exports('Configuration', (_dec = ccclass('Configuration'), _dec(_class = (_temp = _class2 = class Configuration {
        constructor() {
          _defineProperty(this, "jsonData", void 0);

          _defineProperty(this, "path", void 0);

          _defineProperty(this, "markSave", void 0);

          _defineProperty(this, "saveTimer", void 0);
        }

        static get instance() {
          if (this._instance) {
            return this._instance;
          }

          this._instance = new Configuration();

          this._instance.init();

          return this._instance;
        }

        init() {
          this.jsonData = {
            "userId": ""
          };
          this.path = this.getConfigPath();
          var content;

          if (sys.isNative) {
            var valueObject = jsb.fileUtils.getValueMapFromFile(this.path);
            content = valueObject[KEY_CONFIG];
          } else {
            content = sys.localStorage.getItem(KEY_CONFIG);
          }

          if (content && content.length) {
            if (content.startsWith('@')) {
              content = content.substring(1);
            }

            try {
              var jsonData = JSON.parse(content);
              this.jsonData = jsonData;
            } catch (excepaiton) {}
          }

          this.markSave = false;
          this.saveTimer = setInterval(() => {
            this.scheduleSave();
          }, 500);
        }

        setConfigDataWithoutSave(key, value) {
          var account = this.jsonData.userId;

          if (this.jsonData[account]) {
            this.jsonData[account][key] = value;
          } else {
            console.error("no account can not save");
          }
        }

        setConfigData(key, value) {
          this.setConfigDataWithoutSave(key, value);
          this.markSave = true; //标记为需要存储，避免一直在写入，而是每隔一段时间进行写入
        }

        getConfigData(key) {
          var account = this.jsonData.userId;

          if (this.jsonData[account]) {
            var value = this.jsonData[account][key];
            return value ? value : "";
          } else {
            console.log("no account can not load");
            return "";
          }
        }

        setGlobalData(key, value) {
          this.jsonData[key] = value;
          this.save();
        }

        getGlobalData(key) {
          return this.jsonData[key];
        }

        setUserId(userId) {
          this.jsonData.userId = userId;

          if (!this.jsonData[userId]) {
            this.jsonData[userId] = {};
          }

          this.save();
        }

        getUserId() {
          return this.jsonData.userId;
        }

        scheduleSave() {
          if (!this.markSave) {
            return;
          }

          this.save();
        }

        markModified() {
          this.markSave = true;
        }

        save() {
          var str = JSON.stringify(this.jsonData);
          let zipStr = str;
          this.markSave = false;

          if (!sys.isNative) {
            var ls = sys.localStorage;
            ls.setItem(KEY_CONFIG, zipStr);
            return;
          }

          var valueObj = {};
          valueObj[KEY_CONFIG] = zipStr;
          jsb.fileUtils.writeToFile(valueObj, configuration.path);
        }

        getConfigPath() {
          var platform = sys.platform;
          var path = "";

          if (platform === sys.Platform.WIN32) {
            path = "src/conf";
          } else if (platform === sys.Platform.IOS) {
            path = "./conf";
          } else {
            if (sys.isNative) {
              path = jsb.fileUtils.getWritablePath();
              path = path + "conf";
            } else {
              path = "src/conf";
            }
          }

          return path;
        }

        parseUrl(paramStr) {
          if (!paramStr || typeof paramStr === 'string' && paramStr.length <= 0) {
            return;
          }

          var dictParam = {};

          if (typeof paramStr === 'string') {
            paramStr = paramStr.split('?')[1]; // 去除掉 ？号

            var arrParam = paramStr.split("&");
            arrParam.forEach(function (paramValue) {
              var idxEqual = paramValue.indexOf("=");

              if (idxEqual !== -1) {
                var key = paramValue.substring(0, idxEqual);
                dictParam[key] = paramValue.substring(idxEqual + 1);
              }
            });
          } else {
            dictParam = paramStr;
          }

          if (dictParam.action) {
            this.setGlobalData('urlParams', dictParam);
          }

          if (dictParam.source) {
            this.setGlobalData('source', dictParam.source);
          }

          if (dictParam.adchannelid) {
            this.setGlobalData('adchannelid', dictParam.adchannelid);
          }
        }

        generateGuestAccount() {
          return `${Date.now()}${0 | 10}`;
        }

      }, _defineProperty(_class2, "_instance", void 0), _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/lotteryItem.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './resourceUtil.ts', './constants.ts', './utils.ts', './uiManager.ts'], function (exports) {
  'use strict';

  var cclegacy, Sprite, Label, SpriteFrame, Color, Node, _decorator, Component, UITransform, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, resourceUtil, constants, utils, uiManager;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Sprite = module.Sprite;
      Label = module.Label;
      SpriteFrame = module.SpriteFrame;
      Color = module.Color;
      Node = module.Node;
      _decorator = module._decorator;
      Component = module.Component;
      UITransform = module.UITransform;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      utils = module.utils;
    }, function (module) {
      uiManager = module.uiManager;
    }],
    execute: function () {
      var _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _dec9, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _descriptor8, _temp;

      cclegacy._RF.push({}, "f1db2PMDSdEoolhZOaw5gvA", "lotteryItem", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let LotteryItem = exports('LotteryItem', (_dec = ccclass('LotteryItem'), _dec2 = property(Sprite), _dec3 = property(Label), _dec4 = property(Sprite), _dec5 = property(SpriteFrame), _dec6 = property(SpriteFrame), _dec7 = property(Color), _dec8 = property(Color), _dec9 = property(Node), _dec(_class = (_class2 = (_temp = class LotteryItem extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spSelect", _descriptor, this);

          _initializerDefineProperty(this, "lbValue", _descriptor2, this);

          _initializerDefineProperty(this, "spIcon", _descriptor3, this);

          _initializerDefineProperty(this, "sfGold", _descriptor4, this);

          _initializerDefineProperty(this, "sfDiamond", _descriptor5, this);

          _initializerDefineProperty(this, "colorNormal", _descriptor6, this);

          _initializerDefineProperty(this, "colorSelect", _descriptor7, this);

          _initializerDefineProperty(this, "ndPropAddIcon", _descriptor8, this);

          _defineProperty(this, "info", void 0);

          _defineProperty(this, "rewardType", void 0);

          _defineProperty(this, "rewardValue", void 0);

          _defineProperty(this, "propId", void 0);
        }

        setInfo(info) {
          this.info = info;
          this.rewardType = info.type;
          const uiTraSpIcon = this.spIcon.getComponent(UITransform);

          switch (this.rewardType) {
            case constants.REWARD_TYPE.DIAMOND:
              this.rewardValue = info.amount;
              this.spIcon.spriteFrame = this.sfDiamond;
              this.ndPropAddIcon.active = false;
              this.lbValue.string = this.rewardValue;
              uiTraSpIcon.width = 88.8;
              uiTraSpIcon.height = 50.4;
              break;

            case constants.REWARD_TYPE.GOLD:
              this.rewardValue = info.amount;
              this.spIcon.spriteFrame = this.sfGold;
              this.lbValue.string = utils.formatMoney(this.rewardValue);
              this.ndPropAddIcon.active = false;
              uiTraSpIcon.width = 93;
              uiTraSpIcon.height = 92;
              break;

            case constants.REWARD_TYPE.PROP:
              this.rewardValue = info.amount;
              this.lbValue.string = this.rewardValue;
              this.propId = "00" + info.subType;
              resourceUtil.setPropIcon(this.propId, this.spIcon, () => {});
              this.ndPropAddIcon.active = true;
              uiTraSpIcon.width = 77;
              uiTraSpIcon.height = 77;
              break;
          }
        }

        setSelect(isSelect) {
          this.spSelect.enabled = isSelect;
          this.lbValue.getComponent(Label).color = isSelect ? this.colorSelect : this.colorNormal;

          if (isSelect) {
            this.setReceivedUI();
          }
        }

        setReceivedUI() {
          let itemInfo = {};
          itemInfo['itemType'] = this.info['type'];
          itemInfo['itemSubType'] = this.info['subType'];
          itemInfo['itemAmount'] = this.info['amount'];
          uiManager.instance.showDialog('lottery/reward', [itemInfo, true, constants.SHARE_FUNCTION.LOTTERY_REWARD]);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spSelect", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "lbValue", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "spIcon", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "sfGold", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "sfDiamond", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "colorNormal", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return new Color();
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "colorSelect", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return new Color();
        }
      }), _descriptor8 = _applyDecoratedDescriptor(_class2.prototype, "ndPropAddIcon", [_dec9], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/loadingUI.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './constants.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, Sprite, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, constants;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      Sprite = module.Sprite;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      constants = module.constants;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _temp;

      cclegacy._RF.push({}, "f33bfL32OJOUqxJ3VWLer3l", "loadingUI", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let LoadingUI = exports('LoadingUI', (_dec = ccclass('LoadingUI'), _dec(_class = (_class2 = (_temp = class LoadingUI extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "progressBar", _descriptor, this);

          _initializerDefineProperty(this, "percentLabel", _descriptor2, this);

          _initializerDefineProperty(this, "versionLabel", _descriptor3, this);

          _initializerDefineProperty(this, "tipsNode", _descriptor4, this);

          _initializerDefineProperty(this, "spriteArr", _descriptor5, this);

          _defineProperty(this, "updateTimer", null);

          _defineProperty(this, "updateInterval", null);

          _defineProperty(this, "totalLength", null);

          _defineProperty(this, "lengthInterval", null);

          _defineProperty(this, "type", null);

          _defineProperty(this, "callback", null);

          _defineProperty(this, "tasks", null);

          _defineProperty(this, "currentMaxLength", null);

          _defineProperty(this, "currentLength", null);

          _defineProperty(this, "taskIndex", null);

          _defineProperty(this, "running", null);
        }

        onLoad() {
          this.updateTimer = 0;
          this.updateInterval = 0.01;
          this.totalLength = this.progressBar.totalLength;
          this.lengthInterval = 30; // this.versionLabel.string = 'Ver:' + localConfig.getVersion();
        }

        onEnable() {
          let num = Math.floor(Math.random() * 3);
          num = num >= 3 ? 2 : num;
          this.tipsNode.getComponent(Sprite).spriteFrame = this.spriteArr[num];
        }

        startLoading(type, tasks, callback) {
          // game.addPersistRootNode(this.node);
          this.node.active = true;
          this.type = type;
          this.callback = callback;
          this.tasks = tasks;
          this.currentMaxLength = 0;
          this.currentLength = 0;
          this.progressBar.progress = 0;
          this.percentLabel.string = '0%';
          this.taskIndex = 0;
          this.running = true;
          this.nextTask([]);
        }

        nextTask(args) {
          if (!this.tasks) return;

          if (this.taskIndex === this.tasks.length) {
            this.currentMaxLength = this.totalLength;

            if (this.type === constants.SCENE_MANAGER_TYPE.LOAD) {
              this.currentLength = this.currentMaxLength;
              this.setProgress();
            }

            return;
          }

          if (this.type === constants.SCENE_MANAGER_TYPE.LOAD) {
            this.currentLength = this.currentMaxLength;
            this.setProgress();
          }

          var _this = this;

          var taskCallback = function (err, args) {
            if (err) {
              return _this.callback.apply(null, [err].concat(args));
            }

            _this.nextTask(Array.prototype.slice.call(arguments).slice(1));
          };

          args.push(taskCallback);
          var task = this.tasks[this.taskIndex++];
          this.currentMaxLength = this.totalLength / (this.tasks.length + 1) * this.taskIndex;
          task.apply(null, args);
        }

        update(dt) {
          this.updateTimer += dt;

          if (this.updateTimer < this.updateInterval) {
            return; // we don't need to do the math every frame
          }

          if (!this.running) return;
          this.updateTimer = 0;
          this.currentLength += this.lengthInterval;
          this.currentLength = this.currentLength > this.currentMaxLength ? this.currentMaxLength : this.currentLength;
          this.setProgress();
        }

        setProgress() {
          var radio = this.currentLength / this.totalLength;
          radio = radio > 1 ? 1 : radio;
          this.percentLabel.string = Math.floor(radio * 100) + '%';
          this.progressBar.progress = radio;

          if (radio === 1) {
            this.running = false;
            this.callback.apply(null, [null].concat(null));
          }
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "progressBar", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "percentLabel", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "versionLabel", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "tipsNode", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "spriteArr", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/constants.ts", ['cc'], function (exports) {
  'use strict';

  var cclegacy;
  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
    }],
    execute: function () {
      cclegacy._RF.push({}, "f4f59qgd1lA2aWdYY7JPEm/", "constants", undefined);

      const constants = exports('constants', {
        VERSION: '1.4.7',
        //本地缓存KEY值
        LOCAL_CACHE: {
          PLAYER: 'player',
          //玩家基础数据缓存，如金币砖石等信息，暂时由客户端存储，后续改由服务端管理
          SETTINGS: 'settings',
          //设置相关，所有杂项都丢里面进去
          DATA_VERSION: 'dataVersion',
          //数据版本
          ACCOUNT: 'account',
          //玩家账号
          PASSWORD: 'password',
          //玩家账号
          PRIVATE_KEY: 'privateKey',
          //privateKey
          // TMP_DATA: 'tmpData',             //临时数据，不会存储到云盘
          HISTORY: "history",
          //关卡通关数据
          BAG: "bag" //玩家背包，即道具列表，字典类型

        },
        //settings的本地缓存key
        SETTINGS_KEY: {
          LOTTERY: 'lottery',
          //抽奖
          MOREGAME_FIRSTCLICK: 'moreGameFirstClick' //更多游戏是否头一次点击

        },
        TMP_DATA_KEY: {
          AD_TIMES: 'adTimes' //已经观看广告的次数

        },
        //道具ID列表
        PROP_ID: {
          HAMMER: 1,
          //锤子
          MAGIC: 2,
          //魔法棒
          REFRESH: 3,
          //刷新
          INFINITE: 4 //无限

        },
        GUIDE_TYPE: {
          //新手引导类型
          SPACE: 0,
          //空，不做任何操作，用来判定触发
          GUIDE_ANI: 1,
          //引导动画
          TRIGGER_EVENT: 2,
          //触发事件
          WAIT_EVENT: 3,
          //等待事件触发
          GUIDE: 4 //界面性引导

        },
        //顺时针
        GUIDE_TIPS_DIRECTION: {
          //tips展示方向
          TOP: 0,
          RIGHT: 1,
          BOTTOM: 2,
          LEFT: 3
        },
        SHARE_TYPE: {
          //分享文案
          SHARE_GAME: 0,
          //游戏分享
          GROUP_RANK: 1 //群排行

        },
        SHARE_FUNCTION: {
          BALANCE: 'balance',
          //结算分享
          PVE: 'pve',
          //PVE界面分享
          START_REWARD: 'startReward',
          //开局奖励
          LACK_STEP: 'lackStep',
          //步数不足
          FILL_SIGN: 'fillSign',
          //补签分享
          OFFLINE: 'offline',
          //离线奖励
          RANK: 'rank',
          //排行榜
          BUY_INFINITE: 'buyInfinite',
          //购买无限道具需要分享
          LOTTERY: 'lottery',
          //抽奖
          LOTTERY_REWARD: 'lotteryReward',
          //抽奖奖励，用于双倍分享
          ONLINE: 'online',
          //在线奖励
          SHOP_PROP: 'shopprop',
          //商店随机道具
          FIGHT: 'fight',
          //战斗界面分享
          SIGN: 'sign' //签到分享

        },
        //观看广告的最大次数
        WATCH_AD_MAX_TIMES: {
          LOTTERY: 10 //抽奖
          // CHOICE: 5,          //三选一  
          // PICK_GAME: 5,       //捡蛋糕游戏

        },
        ZORDER: {
          LINK_ITEM_NORMAL: 0,
          LINK_ITEM_SKILL: 1,
          FIGHT_NUM: 20,
          //战斗数字特效
          DIALOG: 100,
          //弹窗的Z序
          REWARD: 900,
          //奖励的弹窗
          WAITING: 998,
          //等待界面弹窗
          TIPS: 999 //提示框

        },
        //统计事件类型
        STAT_EVENT_TYPE: {// BALANCE_SHOW: 'balanceShow',                            //结算界面展现
          // BALANCE_SHARE_SHOW: 'balanceShareShow',                 //结算界面分享按钮展现
          // BALANCE_SHARE_SUCCESS: 'balanceShareSuccess',           //结算界面分享成功
          // BALANCE_AD_SHOW: 'balanceAdShow',                       //结算界面分享按钮展现
          // BALANCE_AD_SUCCESS: 'balanceAdSuccess',                 //结算界面分享成功
          // CROSS_BTN_CLICK: 'crossBtnClick',                       //交叉营销组件点击
        },
        LINK_ROWS_COUNT: 8,
        //总共有多少行
        LINK_COLS_COUNT: 8,
        //总共有多少列
        SPECIAL_EFFECT: {
          HORIZONTAL: 1,
          VERTICAL: 2,
          PLUS: 3,
          CENTER: 4
        },
        //签到奖励状态
        SIGN_REWARD_STATUS: {
          RECEIVED: 0,
          //已领取的
          RECEIVABLE: 1,
          //可领取的
          UNRECEIVABLE: 2,
          //不可领取的
          FILLSIGNIN: 3,
          //补签的
          AFTER_FILLSIGNIN: 4 //补签后

        },
        MAX_SIGN_IN_REWARDS_DAY: 7,
        //最多签到获取奖励天数
        MAX_INFINITE_TIMES: 10,
        //获得无限道具所需分享次数
        AUDIO_MUSIC: {
          BACKGROUND: "bgm",
          //背景音乐
          FIGHT: "fight" //游戏音乐

        },
        AUDIO_SOUND: {
          CLICK: "click",
          //点击音效
          BONUS_TIME: "bonusTime",
          FINISH_LINK: "finishLink",
          //连接完后触发
          CLICK_CAKE: "clickCake",
          //点击蛋糕
          FINISH_STAR: "finishStar",
          //星星达成
          FLY_STAR: "flyStar",
          //特殊效果获得
          LINE_BOMB: "lineBomb",
          //横竖爆炸触发
          PLUS_BOMB: "plusBomb",
          //十字爆炸触发
          RANGE_BOMB: "rangeBomb",
          //范围爆炸触发
          SPARE_STEP: "spareStep",
          //剩余步数飞入
          GOOD: "good",
          GREAT: "great",
          EXCELLENT: "excellent",
          AMAZING: 'amazing',
          UNBELIEVABLE: 'unbelievable'
        },
        MAX_GRADE_OF_EACH_PVE_LEVEL: 3,
        // pve每个关卡最高等级
        PVE_LEVEL_STATUS: {
          DONE: 0,
          UNDONE: 1,
          DOING: 2
        },
        //加载场景类型
        SCENE_MANAGER_TYPE: {
          LOAD: 0,
          //加载
          LOAD_SCENE: 1 //加载场景

        },
        //奖励类型
        REWARD_TYPE: {
          DIAMOND: 1,
          //钻石
          GOLD: 2,
          //金币
          PROP: 3,
          //道具
          GIFT: 4 //礼包

        },
        LOTTERY_MAX_TIMES: 3,
        //最大抽奖次数
        LOTTERY_AD_MAX_TIMES: 10,
        //看广告获得奖券的总次数
        TASK_RESET_TIME: 4,
        //任务倒计时时间
        TASK_MAX_NUM: 4,
        //显示最大任务数量
        MOREGAME_MAIN: '1001',
        //任务完成状态
        TASK_STATE: {
          UNRECEIVABLE: 0,
          //不可领取的，任务未完成
          RECEIVABLE: 1,
          //可领取的，任务完成
          RECEIVED: 2 //已领取，任务完成

        },
        ANALYTICS_TYPE: {
          ON_LOGIN: 'onLogin',
          // 登录
          START_LEVEL: 'levelStart',
          //关卡开始
          END_LEVEL: 'levelOver',
          //关卡结束
          ASK_WATCH_ADS_GET_EFFECT: 'askWatchAdForEffect',
          //询问看广告的有几次
          WATCH_ADS_GET_EFFECT: 'watchAdForEffect',
          // 观看激励广告获得特效
          ASK_WATCH_ADS_ADD_STEP: 'askWatchAdForAddStep',
          //询问看广告的有几次
          WATCH_ADS_ADD_STEP: 'watchAdForAddStep',
          // 观看激励广告增加步数
          SCORE_OF_LEVEL: 'scoreOfLevel',
          // 每关的玩家得分
          ASK_LOTTERY: 'askWatchAdForLottery',
          LOTTERY: 'watchAdForLottery',
          SHARE: 'share',
          ASK_GET_INFINITE: 'askWatchAdForInfinite',
          GET_INFINITE: 'watchAdForInfinite',
          //1.新手进游戏后的正常路线，每个节点都要统计到；
          //七天登陆
          SIGNIN_RECEIVE: 'signinReceive',
          //签到按钮点击次数
          SIGNIN_FILL: 'signinFill',
          //签到按钮点击次数
          SIGNIN_CLOSE: 'signinClose',
          //签到关闭按钮点击次数
          //离线奖励
          OFFLINE_REWARD_SHARE: "offlineRewardShare",
          //分享按钮点击数
          OFFLINE_REWARD_SHARE_SUCCESS: 'offlineRewardShareSuccess',
          //成功分享数
          OFFLINE_REWARD_CLOSE: 'offlineRewardClose',
          //关闭按钮点击数
          //第一关
          OPEN_PANEL: 'openPanel',
          //点击打开关卡界面
          START_GAME: 'startGame',
          //开始游戏按钮
          START_GAME_SUCCESS: 'startGameSuccess',
          //成功进入游戏
          //游戏说明框
          PLAYER_STAY_TIME: 'playerStayTime',
          //玩家停留时间
          //结算界面
          BALANCE_USED_STEP: 'balanceUsedStep',
          //使用步数
          BALANCE_GAIN_SCORE: 'balanceGainScore',
          //获得分数
          //以上每一步的留存率，包括之后5关的留存
          //2.界面所有功能的统计；（统计单人平均数据）
          //签到
          SIGNIN_ENTRANCE: 'signinEntrance',
          //入口点击数
          //大转盘
          LOTTERY_ENTRANCE: 'lotteryEntrance',
          //入口点击数
          LOTTERY_TOTAL_TIMES: 'lotteryTotalTimes',
          //抽奖总次数
          LOTTERY_WATCH_AD: 'lotteryWatchAd',
          //广告观看次数
          LOTTERY_SHARE: 'lotteryShare',
          //分享次数
          LOTTERY_WATCH_AD_SUCCESS: 'lotteryWatchAdSuccess',
          //成功观看广告次数
          LOTTERY_SHARE_SUCCESS: 'lotteryShareSuccess',
          //成功分享次数
          //在线奖励
          ONLINE_REWARD_ENTRANCE: 'onlineRewardEntrance',
          //入口点击数
          ONLINE_REWARD_SUCCESS: 'onlineRewardSuccess',
          //成功领取次数
          //商店
          SHOP_ENTRANCE: 'shopEntrance',
          //入口点击数
          SHOP_PROP_PER_BUY: 'shopPropPerBuy',
          //每种道具购买次数
          SHOP_RAND_PROP_SHARE: 'shopRandPropShare',
          //随机道具分享次数
          SHOP_PLAYER_GOLD: 'shopPlayerGold',
          //玩家拥有金币数量  
          //设置
          SETTING_MUSIC_ON: 'settingMusicOn',
          //音乐开启        
          SETTING_MUSIC_OFF: 'settingMusicOff',
          //音乐开启  
          SETTING_SOUND_ON: 'settingSoundOn',
          //音乐开启  
          SETTING_SOUND_OFF: 'settingSoundOff',
          //音乐开启  
          //排行榜
          RANK_ENTRANCE: 'rankEntrance',
          //入口点击数
          RANK_SHARE: 'rankShare',
          //排行榜分享
          //分享
          SHARE_CLICK: 'shareClick',
          //点击数
          SHARE_SUCCESS: 'shareSuccess',
          //成功分享数
          //更多游戏
          MOREGAME_ENTRANCE: 'moregameEntrance',
          //入口点击数
          MOREGAME_SINGLE: '互推墙-卖量',
          //单个游戏点击数
          //主推游戏
          MAIN_PUSH_GAME: '主界面-卖量',
          //点击数
          //关卡说明界面
          CHECKPOINT_PROP_BUY_NUM: 'checkpointPropBuyNum',
          //每种道具购买数量
          //游戏中
          GAME_PROP_SUCCESS_NUM: 'gamePropSuccessNum',
          //每种道具成功使用数量
          GAME_PROP_BUY_NUM: 'gamePropSuccessNum',
          //游戏中购买的每种道具的数量
          //关卡结算
          BALANCE_NEXT: 'balanceNext',
          //下一关数
          BALANCE_PLAY_AGAIN: 'balancePlayAgain',
          //重玩次数
          BALANCE_SHARE: 'balanceShare',
          //分享次数
          BALANCE_CLOSE: 'balanceClose',
          //关闭界面次数
          GAME_BAR_CLICK: '导流条-卖量',
          //导流条点击
          CHANNEL: 'channel',
          WATCH_AD_BTN_SHOW_TIMES: '视频按钮展示次数',
          WATCH_AD_BTN_CLICK_TIMES: '视频按钮点击次数',
          WATCH_AD_BTN_SUCCESS_TIMES: '视频按钮成功点击次数'
        },
        //在线奖励时间间隔(分钟)
        ONLINE_REWARD_INTERVAL: [0, 3, 5, 10, 30],
        //奖励领取状态
        REWARD_STATUS: {
          UNRECEIVABLE: 0,
          //不可领取的
          RECEIVABLE: 1,
          //可领取的  
          RECEIVED: 2 //已领取的

        },
        //打开奖励的方法
        OPEN_REWARD_TYPE: {
          AD: 0,
          SHARE: 1,
          NULL: 2
        },
        //商场随机道具倒计时的小时数
        SHOP_COUNTDOWN_HOURS: 4,
        //解锁道具最高的得到第几关
        UNLOCK_HIGEST_LEVEl: 5,
        //2，3，4, 5级对应的解锁道具
        UNLOCK_PROP_ID: [1, 2, 3, 4],
        //离线奖励，与上次登录时间超过10分钟
        OFFLINE_REWARD: 10,
        // 微信banner广告
        WX_BANNER_ADS: {
          BALANCE: 0,
          PVE_PAGE: 1,
          GAME: 2
        },
        // 微信视频广告
        WX_REWARD_ADS: {
          VIDEO: 0
        },
        // 微信广告类型
        WX_ADS_TYPE: {
          BANNER: 0,
          VIDEO: 4
        },
        // 广告返回code
        WX_ADS_RESP_CODE: {
          kAdsReceived: 0,
          kAdsShown: 1,
          kAdsDismissed: 2,
          kUnknownError: 6
        },
        //次按钮在主界面显示后3秒再显示
        NORMAL_SHOW_TIME: 0.2
      });

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/onlineReward.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './constants.ts', './utils.ts', './localConfig.ts', './playerData.ts', './uiManager.ts', './LanguageData.ts'], function (exports) {
  'use strict';

  var cclegacy, Animation, _decorator, Component, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, constants, utils, localConfig, playerData, uiManager, t;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Animation = module.Animation;
      _decorator = module._decorator;
      Component = module.Component;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      utils = module.utils;
    }, function (module) {
      localConfig = module.localConfig;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      t = module.t;
    }],
    execute: function () {
      var _dec, _dec2, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _temp;

      cclegacy._RF.push({}, "f6263VSRTFBzIruWaj84Ky6", "onlineReward", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let OnlineReward = exports('OnlineReward', (_dec = ccclass('OnlineReward'), _dec2 = property(Animation), _dec(_class = (_class2 = (_temp = class OnlineReward extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "ndTimer", _descriptor, this);

          _initializerDefineProperty(this, "lbTime", _descriptor2, this);

          _initializerDefineProperty(this, "aniFreeReward", _descriptor3, this);

          _initializerDefineProperty(this, "btnReceive", _descriptor4, this);

          _defineProperty(this, "oldTime", void 0);

          _defineProperty(this, "Reward", '');
        }

        onLoad() {
          Global.onlineRewardSc = this;
        }

        start() {
          this.checkOnlineReward(); //检查在线奖励
        }

        checkOnlineReward() {
          let onlineRewardInfo = playerData.instance.getOnlineRewardInfo();

          switch (onlineRewardInfo['value'].receiveStatus) {
            case constants.REWARD_STATUS.UNRECEIVABLE:
              if (this.btnReceive.node) {
                this.btnReceive.node.active = false;
              }

              this.aniFreeReward.play('freeGiftIdle');
              this.schedule(this.countDownCallback, 0.5);
              break;

            case constants.REWARD_STATUS.RECEIVABLE:
              if (this.btnReceive.node) {
                this.btnReceive.node.active = true;
              }

              this.aniFreeReward.play('freeGiftActivation');
              this.lbTime.string = t('onlineReward.receive');
              this.unschedule(this.countDownCallback);
              break;
          }
        }

        onBtnReceiveClick() {
          let dictProp = localConfig.instance.getTable('prop');

          if (!dictProp) {
            return false;
          }

          let arrPropKey = Object.keys(dictProp);
          let arrRandom = arrPropKey.filter(element => {
            return Number(element) !== constants.PROP_ID.INFINITE;
          });
          let randomVal = arrRandom[Math.floor(Math.random() * arrRandom.length)] + '';
          this.Reward = randomVal;
          Global.onLineReward = true; // if (Global.onLineRewardCount == 0) {

          Global.onLineRewardCount++; // return;
          // }

          this.showReward(randomVal); // GameLogic.instance.getOpenRewardType(constants.SHARE_FUNCTION.ONLINE, (err: any, type: any) => {
          //     if (!err) {
          //         switch (type) {
          //             case constants.OPEN_REWARD_TYPE.AD:
          //                 PlatformBridge.showRewardAd("onBtnonLineReceiveClick", "1", ConstValue.getAdReward());
          //                 // GameLogic.instance.showRewardAd((err: any) => {
          //                 //     if (!err) {
          //                 //     }
          //                 // })
          //                 break;
          //             case constants.OPEN_REWARD_TYPE.SHARE:
          //                 GameLogic.instance.share(constants.SHARE_FUNCTION.ONLINE, {}, (err: any) => {
          //                     if (!err) {
          //                         this.showReward(randomVal);
          //                     }
          //                 })
          //                 break;
          //             case constants.OPEN_REWARD_TYPE.NULL:
          //                 this.showReward(randomVal);
          //                 break;
          //         }
          //     }
          // })
        }

        onBtnonLineReceiveClickCallback(s) {
          if (s) {
            this.showReward(this.Reward);
          }
        }

        countDownCallback() {
          let nowTime = Date.now();

          if (!this.oldTime) {
            this.oldTime = nowTime;
          }

          if (nowTime - this.oldTime > 1000) {
            let usedTime = playerData.instance.getOnlineRewardInfo()['usedTime'];
            let spareTime = playerData.instance.getCountdownTime() * 60 * 1000 - usedTime * 1000; // spareTime = 0;//todo

            if (spareTime <= 0) {
              this.unschedule(this.countDownCallback);
              playerData.instance.updateOnlineRewardInfo(false); //设置为可领取

              this.checkOnlineReward();
              this.lbTime.string = t('onlineReward.receive');
            } else {
              this.lbTime.string = utils.formatTimeForMillisecond(spareTime).toString();
              this.oldTime = nowTime;
            }
          }
        }

        showReward(randomVal) {
          let itemInfo = {};
          itemInfo['itemType'] = constants.REWARD_TYPE.PROP;
          itemInfo['itemSubType'] = randomVal;
          itemInfo['itemAmount'] = 1;
          uiManager.instance.showDialog('lottery/reward', [itemInfo, false, constants.SHARE_FUNCTION.ONLINE]);
          playerData.instance.updateOnlineRewardInfo(true);
          this.checkOnlineReward();
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "ndTimer", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "lbTime", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "aniFreeReward", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "btnReceive", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/uiManager.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './poolManager.ts', './resourceUtil.ts', './animationUI.ts', './tips.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, isValid, find, _defineProperty, poolManager, resourceUtil, AnimationUI, tips;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      isValid = module.isValid;
      find = module.find;
    }, function (module) {
      _defineProperty = module.defineProperty;
    }, function (module) {
      poolManager = module.poolManager;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }, function (module) {
      AnimationUI = module.AnimationUI;
    }, function (module) {
      tips = module.tips;
    }],
    execute: function () {
      var _dec, _class, _class2, _temp;

      cclegacy._RF.push({}, "f9384FYDp5GqoW+CtrCla3U", "uiManager", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      const SHOW_STR_INTERVAL_TIME = 800;
      let uiManager = exports('uiManager', (_dec = ccclass("uiManager"), _dec(_class = (_temp = _class2 = class uiManager {
        constructor() {
          _defineProperty(this, "_dictSharedPanel", {});

          _defineProperty(this, "_dictLoading", {});

          _defineProperty(this, "_arrPopupDialog", []);

          _defineProperty(this, "_showTipsTime", 0);
        }

        static get instance() {
          if (this._instance) {
            return this._instance;
          }

          this._instance = new uiManager();
          return this._instance;
        }
        /**
         * 检查当前界面是否正在展示
         * @param panelPath 
         */


        isDialogVisible(panelPath) {
          if (!this._dictSharedPanel.hasOwnProperty(panelPath)) {
            return false;
          }

          let panel = this._dictSharedPanel[panelPath];
          return isValid(panel) && panel.active && panel.parent;
        }
        /**
         * 显示单例界面
         * @param {String} panelPath 
         * @param {Array} args 
         * @param {Function} cb 回调函数，创建完毕后回调
         */


        showDialog(panelPath, args, cb) {
          if (this._dictLoading[panelPath]) {
            return;
          }

          let idxSplit = panelPath.lastIndexOf('/');
          let scriptName = panelPath.slice(idxSplit + 1);

          if (!args) {
            args = [];
          }

          if (this._dictSharedPanel.hasOwnProperty(panelPath)) {
            let panel = this._dictSharedPanel[panelPath];

            if (isValid(panel)) {
              panel.parent = find("Canvas");
              panel.active = true;
              let script = panel.getComponent(scriptName);
              let script2 = panel.getComponent(scriptName.charAt(0).toUpperCase() + scriptName.slice(1));

              if (script && script.show) {
                script.show.apply(script, args);
                cb && cb(script);
              } else if (script2 && script2.show) {
                script2.show.apply(script2, args);
                cb && cb(script2);
              } else {
                throw `查找不到脚本文件${scriptName}`;
              }

              return;
            }
          }

          this._dictLoading[panelPath] = true;
          resourceUtil.createUI(panelPath, (err, node) => {
            //判断是否有可能在显示前已经被关掉了？
            let isCloseBeforeShow = false;

            if (!this._dictLoading[panelPath]) {
              //已经被关掉
              isCloseBeforeShow = true;
            }

            this._dictLoading[panelPath] = false;

            if (err) {
              console.error(err);
              return;
            }

            this._dictSharedPanel[panelPath] = node;
            let script = node.getComponent(scriptName);
            let script2 = node.getComponent(scriptName.charAt(0).toUpperCase() + scriptName.slice(1));

            if (script && script.show) {
              script.show.apply(script, args);
              cb && cb(script);
            } else if (script2 && script2.show) {
              script2.show.apply(script2, args);
              cb && cb(script2);
            } else {
              throw `查找不到脚本文件${scriptName}`;
            }

            if (isCloseBeforeShow) {
              //如果在显示前又被关闭，则直接触发关闭掉
              this.hideDialog(panelPath);
            }
          });
        }
        /**
         * 隐藏单例界面
         * @param {String} panelPath 
         * @param {fn} callback
         */


        hideDialog(panelPath, callback) {
          if (this._dictSharedPanel.hasOwnProperty(panelPath)) {
            let panel = this._dictSharedPanel[panelPath];

            if (panel && isValid(panel)) {
              let ani = panel.getComponent(AnimationUI);

              if (ani) {
                ani.close(() => {
                  panel.parent = null;

                  if (callback && typeof callback === 'function') {
                    callback();
                  }
                });
              } else {
                panel.parent = null;

                if (callback && typeof callback === 'function') {
                  callback();
                }
              }
            } else if (callback && typeof callback === 'function') {
              callback();
            }
          }

          this._dictLoading[panelPath] = false;
        }
        /**
         * 将弹窗加入弹出窗队列
         * @param {string} panelPath 
         * @param {string} scriptName 
         * @param {*} param 
         */


        pushToPopupSeq(panelPath, scriptName, param) {
          let popupDialog = {
            panelPath: panelPath,
            scriptName: scriptName,
            param: param,
            isShow: false
          };

          this._arrPopupDialog.push(popupDialog);

          this._checkPopupSeq();
        }
        /**
         * 将弹窗加入弹出窗队列
         * @param {number} index 
         * @param {string} panelPath 
         * @param {string} scriptName 
         * @param {*} param 
         */


        insertToPopupSeq(index, panelPath, param) {
          let popupDialog = {
            panelPath: panelPath,
            param: param,
            isShow: false
          };

          this._arrPopupDialog.splice(index, 0, popupDialog); //this._checkPopupSeq();

        }
        /**
         * 将弹窗从弹出窗队列中移除
         * @param {string} panelPath 
         */


        shiftFromPopupSeq(panelPath) {
          this.hideDialog(panelPath, () => {
            if (this._arrPopupDialog[0] && this._arrPopupDialog[0].panelPath === panelPath) {
              this._arrPopupDialog.shift();

              this._checkPopupSeq();
            }
          });
        }
        /**
         * 检查当前是否需要弹窗
         */


        _checkPopupSeq() {
          if (this._arrPopupDialog.length > 0) {
            let first = this._arrPopupDialog[0];

            if (!first.isShow) {
              this.showDialog(first.panelPath, first.param);
              this._arrPopupDialog[0].isShow = true;
            }
          }
        }
        /**
         * 显示提示
         * @param {String} content 
         * @param {Function} cb 
         */


        showTips(content, callback) {
          let str = String(content);

          let next = () => {
            this._showTipsAni(str, callback);
          };

          var now = Date.now();

          if (now - this._showTipsTime < SHOW_STR_INTERVAL_TIME) {
            var spareTime = SHOW_STR_INTERVAL_TIME - (now - this._showTipsTime);
            setTimeout(() => {
              next();
            }, spareTime);
            this._showTipsTime = now + spareTime;
          } else {
            next();
            this._showTipsTime = now;
          }
        }
        /**
         * 内部函数
         * @param {String} content 
         * @param {Function} cb 
         */


        _showTipsAni(content, callback) {
          resourceUtil.getUIPrefabRes('common/tips', function (err, prefab) {
            if (err) {
              return;
            }

            let tipsNode = poolManager.instance.getNode(prefab, find("Canvas"));
            let tipScript = tipsNode.getComponent(tips);
            tipScript.show(content, callback);
          });
        }

      }, _defineProperty(_class2, "_instance", void 0), _temp)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/Toast.ts", ['cc', './_rollupPluginModLoBabelHelpers.js'], function (exports) {
  'use strict';

  var cclegacy, Node, Layers, BlockInputEvents, Sprite, Texture2D, ImageAsset, SpriteFrame, color, UITransform, Label, UIOpacity, tween, v3, Canvas, director, view, _defineProperty;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      Node = module.Node;
      Layers = module.Layers;
      BlockInputEvents = module.BlockInputEvents;
      Sprite = module.Sprite;
      Texture2D = module.Texture2D;
      ImageAsset = module.ImageAsset;
      SpriteFrame = module.SpriteFrame;
      color = module.color;
      UITransform = module.UITransform;
      Label = module.Label;
      UIOpacity = module.UIOpacity;
      tween = module.tween;
      v3 = module.v3;
      Canvas = module.Canvas;
      director = module.director;
      view = module.view;
    }, function (module) {
      _defineProperty = module.defineProperty;
    }],
    execute: function () {
      exports('Gravity', void 0);

      cclegacy._RF.push({}, "f9a5avllMxJdbKT8jqi/p+P", "Toast", undefined);
      /**
       * 位置
       */


      let Gravity;

      (function (Gravity) {
        Gravity[Gravity["BOTTOM"] = 0] = "BOTTOM";
      })(Gravity || (Gravity = exports('Gravity', {})));

      class Toast {
        // 短时间吐司
        // 长时间吐司
        constructor(node) {
          _defineProperty(this, "bgNode", void 0);

          _defineProperty(this, "textNode", void 0);

          _defineProperty(this, "node", void 0);

          _defineProperty(this, "text", '');

          _defineProperty(this, "time", 1);

          _defineProperty(this, "textSize", 20);

          _defineProperty(this, "gravity", Gravity.BOTTOM);

          if (null == node) {
            this.node = this.getPNode();
          } else {
            this.node = node;
          }

          this.bgNode = new Node();
          this.bgNode.layer = Layers.Enum.UI_2D;
          this.bgNode.addComponent(BlockInputEvents);
          let sprite = this.bgNode.addComponent(Sprite);
          sprite.type = Sprite.Type.SLICED;
          let imageObj = new Image();
          imageObj.src = "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAIAAAACAQMAAABIeJ9nAAAAA1BMVEX///+nxBvIAAAACklEQVQI12MAAgAABAABINItbwAAAABJRU5ErkJggg==";
          let textureObj = new Texture2D();
          textureObj.image = new ImageAsset(imageObj);
          let sf = new SpriteFrame();
          sf.texture = textureObj;
          sprite.spriteFrame = sf;
          sprite.color = color(0, 0, 0, 200);
          this.bgNode.active = false;
          this.textNode = new Node('Text');
          this.textNode.layer = Layers.Enum.UI_2D;
          let uiTransform = this.textNode.addComponent(UITransform);
          uiTransform.width = this.node.getComponent(UITransform).width;
          let label = this.textNode.addComponent(Label);
          label.horizontalAlign = Label.HorizontalAlign.CENTER;
          label.verticalAlign = Label.VerticalAlign.CENTER;
          this.textSize = 20;
          this.textNode.parent = this.bgNode;
          this.bgNode.parent = this.node;
        }
        /**
         * 生成吐司
         * @param node  
         * @param text 
         * @param time 
         * @returns 
         */


        static makeText(node, text, time) {
          let toast = new Toast(node);
          toast.text = text;
          toast.time = time;
          return toast;
        }
        /**
         * 显示吐司
         */


        show() {
          this.setText(this.text);
          this.setOverFlow();
          this.bgNode.active = true;
          let uiOpacity = this.bgNode.getComponent(UIOpacity);

          if (null == uiOpacity) {
            uiOpacity = this.bgNode.addComponent(UIOpacity);
          }

          tween(uiOpacity).delay(this.time).to(0.3, {
            opacity: 0
          }).call(() => {
            this.bgNode.destroy();
          }).start();
        }
        /**
         * 设置文字
         * @param text 文字
         * @returns 
         */


        setText(text) {
          this.text = text;
          let label = this.textNode.getComponent(Label);
          label.string = this.text;
          return this;
        }
        /**
         * 设置文字大小
         * @param textSize 文字大小
         * @returns 
         */


        setTextSize(textSize) {
          this.textSize = textSize;
          let label = this.textNode.getComponent(Label);
          label.fontSize = this.textSize;
          return this;
        }
        /**
         * 设置时间
         * @param time 时间 
         * @returns 
         */


        setTime(time) {
          this.time = time;
          return this;
        }
        /**
         * 设置位置
         * @param gravity 位置
         * @returns 
         */


        setGravity(gravity) {
          this.gravity = gravity;
          return this;
        }

        setPosition() {
          let uiTransform = this.node.getComponent(UITransform);
          let bgUITransform = this.bgNode.getComponent(UITransform);

          if (Gravity.BOTTOM === this.gravity) {
            let y = -uiTransform.height / 2 + bgUITransform.height / 2 + 64;
            this.bgNode.position = v3(0, y, 0);
          }
        }

        setOverFlow() {
          let maxLength = this.node.getComponent(UITransform).width / 2;
          let label = this.textNode.getComponent(Label);
          let fontLength = this.text.length * label.fontSize;
          let uiTransform = this.textNode.getComponent(UITransform);

          if (fontLength > maxLength) {
            uiTransform.width = maxLength;
            label.overflow = Label.Overflow.RESIZE_HEIGHT;
          } else {
            uiTransform.width = fontLength;
            label.overflow = Label.Overflow.NONE;
          }

          let bgUITransform = this.bgNode.getComponent(UITransform);
          bgUITransform.width = uiTransform.width + label.fontSize * 4;
          bgUITransform.height = uiTransform.height;
          this.setPosition();
        }

        getPNode() {
          if (null == Toast.pNode || !Toast.pNode.isValid) {
            var _director$getScene;

            Toast.pNode = new Node('Toast');
            let transform = Toast.pNode.addComponent(UITransform);
            Toast.pNode.layer = Layers.Enum.UI_2D;
            Toast.pNode.addComponent(Canvas);
            (_director$getScene = director.getScene()) === null || _director$getScene === void 0 ? void 0 : _director$getScene.addChild(Toast.pNode);
            let size = view.getVisibleSize();
            transform.contentSize = size;
            transform.width = size.width;
            transform.height = size.height;
            Toast.pNode.position = v3(size.width / 2, size.height / 2, 0);
          }

          return Toast.pNode;
        }

      }

      exports('Toast', Toast);

      _defineProperty(Toast, "LENGTH_SHORT", 2);

      _defineProperty(Toast, "LENGTH_LONG", 3.5);

      _defineProperty(Toast, "pNode", null);

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/fightProp.ts", ['cc', './_rollupPluginModLoBabelHelpers.js', './resourceUtil.ts', './constants.ts', './clientEvent.ts', './playerData.ts', './uiManager.ts', './buttonEx.ts'], function (exports) {
  'use strict';

  var cclegacy, _decorator, Component, UITransform, Vec3, _applyDecoratedDescriptor, _initializerDefineProperty, _defineProperty, resourceUtil, constants, clientEvent, playerData, uiManager, ButtonEx;

  return {
    setters: [function (module) {
      cclegacy = module.cclegacy;
      _decorator = module._decorator;
      Component = module.Component;
      UITransform = module.UITransform;
      Vec3 = module.Vec3;
    }, function (module) {
      _applyDecoratedDescriptor = module.applyDecoratedDescriptor;
      _initializerDefineProperty = module.initializerDefineProperty;
      _defineProperty = module.defineProperty;
    }, function (module) {
      resourceUtil = module.resourceUtil;
    }, function (module) {
      constants = module.constants;
    }, function (module) {
      clientEvent = module.clientEvent;
    }, function (module) {
      playerData = module.playerData;
    }, function (module) {
      uiManager = module.uiManager;
    }, function (module) {
      ButtonEx = module.ButtonEx;
    }],
    execute: function () {
      var _dec, _class, _class2, _descriptor, _descriptor2, _temp;

      cclegacy._RF.push({}, "fe8afmT+lpEBr/zkz0jwl9D", "fightProp", undefined);

      const {
        ccclass,
        property
      } = _decorator;
      let FightProp = exports('FightProp', (_dec = ccclass('FightProp'), _dec(_class = (_class2 = (_temp = class FightProp extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spProp", _descriptor, this);

          _initializerDefineProperty(this, "lbNum", _descriptor2, this);

          _defineProperty(this, "prop", void 0);

          _defineProperty(this, "clickCallback", void 0);
        }

        start() {
          this.updateUnlockProp();
        }

        onEnable() {
          clientEvent.on('updateProp', this.updateProp, this);
          clientEvent.on('updateUnlockProp', this.updateUnlockProp, this);
        }

        onDisable() {
          clientEvent.off('updateProp', this.updateProp, this);
          clientEvent.off('updateUnlockProp', this.updateUnlockProp, this);
        }

        show(prop) {
          this.prop = prop;
          resourceUtil.setPropIcon(prop.icon, this.spProp, () => {});
          let num = playerData.instance.getPropAmount(prop.ID);

          if (num <= 0) {
            num = '+';
          }

          this.lbNum.string = num;
        }

        updateProp(propId) {
          if (propId === this.prop.ID) {
            this.show(this.prop);
          }
        }

        setClickListener(callback) {
          this.clickCallback = callback;
        }

        onItemClick() {
          let num = playerData.instance.getPropAmount(this.prop.ID);

          if (num <= 0) {
            uiManager.instance.showDialog('props/buy', [this.prop.ID, constants.ANALYTICS_TYPE.GAME_PROP_BUY_NUM]);
            return;
          }

          if (this.clickCallback) {
            this.clickCallback(this.prop, this.node.getComponent(UITransform).convertToWorldSpaceAR(new Vec3(0, 0, 0)));
          }
        }

        updateUnlockProp() {
          let isPropUnlock = playerData.instance.isPropUnlock(this.prop.ID);
          this.node.getComponent(ButtonEx).interactable = isPropUnlock;
          resourceUtil.setGray(this.node, !isPropUnlock);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spProp", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "lbNum", [property], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      cclegacy._RF.pop();
    }
  };
});

System.register("chunks:///_virtual/Global.js", ['./cjs-loader.mjs', './PlatformBridge.js', './ConstValue.js', './AdUtils.js'], function (exports, module) {
  'use strict';

  var loader, __cjsMetaURL$2, __cjsMetaURL$1, __cjsMetaURL$3;

  return {
    setters: [function (module) {
      loader = module.default;
    }, function (module) {
      __cjsMetaURL$2 = module.__cjsMetaURL;
    }, function (module) {
      __cjsMetaURL$1 = module.__cjsMetaURL;
    }, function (module) {
      __cjsMetaURL$3 = module.__cjsMetaURL;
    }],
    execute: function () {
      exports('default', void 0);

      let _cjsExports;

      loader.define(module.meta.url, function (exports$1, _require, module, __filename, __dirname) {
        let require = loader.createRequireWithReqMap({
          "./ConstValue": __cjsMetaURL$1,
          "./PlatformBridge": __cjsMetaURL$2,
          "./AdUtils": __cjsMetaURL$3
        }, _require);

        (function () {
          var ConstValue = require("./ConstValue");

          const PlatformBridge = require("./PlatformBridge");

          const AdUtils = require("./AdUtils");

          const Global = {
            supportVersion: 1,
            Version: "1.1.12",
            appVersionCode: 0,
            ScriptHome: null,
            ScriptPause: null,
            ScriptStartProp: null,
            ScriptRelive: null,
            ScriptSettlement: null,
            UserAgent: null,
            QQGameEnv: false,
            OPPOGameEnv: false,
            OPPOQuickGameEnv: false,
            XIAOMIGameEnv: true,
            VIVOGameEnv: false,
            VIVOQuickGameEnv: false,
            YSDKGameEnv: false,
            MomoyuGameEnv: false,
            TestEnv: false,
            loginCallbacks: null,
            initCallbacks: null,
            userActionCallbacks: null,
            networkStateChangeCallbacks: null,
            soundEffectsEnabled: undefined,
            _GuideDoneWaterDrop: false,
            loginInfo: null,
            // { token: loginToken, userId: userId }
            userInfo: undefined,
            curSceneNode: null,
            networkState: undefined,
            initComplete: false,
            isWXappInstalled: true,
            dailyOnlineGoldCoinQuantity: 0,
            dailyOnlineGoldCoinUnCommit: 0,
            hasClickBtnFire: false,
            currentMode: 1,
            shopPanel: null,
            skillPanel: null,
            revivePanel: null,
            settlementPanel: null,
            reward: null,
            signIn: null,
            offLineReward: null,
            shop: null,
            lottery: null,
            adProp: null,
            adStep: null,
            balance: null,
            unLockProp: null,
            onlineRewardSc: null,
            buySc: null,
            onClickNextCount: 0,
            onLineRewardCount: 0,
            onLineReward: false,
            dailyOnlineGoldCoinEnable: function () {
              return Global.dailyOnlineGoldCoinQuantity > 0;
            },
            setAppVersionCode: function (versionCode) {
              console.log("Global.setAppVersionCode() -> versionCode:" + versionCode);
              Global.appVersionCode = parseInt(versionCode);
            },
            setAppVersionName: function (versionName) {
              console.log("Global.setAppVersionName() -> versionName:" + versionName);
            },

            /**
             * 
             * @param {*} success 
             * @param {*} scene
             * @param {*} code 
             */
            onAuthFromWXCallback: function (success, scene, code) {
              console.log("Global.onAuthFromWXCallback() -> success:" + success + ", code:" + code + ", scene:" + scene);
              let currentSuccess = false;

              if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
                if (success == 1) {
                  currentSuccess = true;
                } else {
                  currentSuccess = false;
                }
              } else {
                currentSuccess = success;
              }

              if (currentSuccess) {
                Loading.show("gourd/login.do");
                DataModel.post("gourd/login.do", {
                  "id": Global.loginInfo ? Global.loginInfo.userId : "",
                  "code": code,
                  "mode": "2"
                  /**游客登录1,  微信登录2*/

                }, (err, response) => {
                  if (!err) {
                    let obj = JSON.parse(response);

                    if (obj && obj.code == 0) {
                      Global.loginInfo = {
                        token: obj.token,
                        userId: obj.id,
                        tokenExpired: false
                      };
                      cc.sys.localStorage.setItem("LoginInfo", JSON.stringify(Global.loginInfo));
                      Global.updateGiftBagForNovice(Global.loginInfo.token, obj.new == 1);
                      Global.notifyLoginCallback();
                    }
                  } else {
                    AlertDialog.show({
                      id: 'network_error',
                      content: '哎呀，好像网络不太给力啊！',
                      positive: {
                        label: '点击重试',
                        clickEvent: function () {//Global.onAuthFromWXCallback(true, scene, code);
                        }
                      }
                    });
                  }

                  Loading.hide("gourd/login.do");
                });

                if (scene == ConstValue.WX_AUTH_SCENE.First_Start) {
                  if (DataModel.alertDialogWxAuthFristStart) {
                    AlertDialog.hide(DataModel.alertDialogWxAuthFristStart);
                    DataModel.alertDialogWxAuthFristStart = undefined;
                  }
                }
              }
            },
            transformOldData: function (loginToken, userId) {
              console.log("Global.transformOldData() -> loginToken:" + loginToken + ", userId:" + userId);
              let loginInfo = cc.sys.localStorage.getItem("LoginInfo");

              if (!loginInfo) {
                console.log("Global.transformOldData() -> localStorage is not exist [loginInfo]");

                if (loginToken && userId) {
                  cc.sys.localStorage.setItem("LoginInfo", JSON.stringify({
                    token: loginToken,
                    userId: userId
                  }));
                }
              } else {
                console.log("Global.transformOldData() -> localStorage exist [loginInfo]:" + JSON.stringify(loginInfo));
              }
            },

            /**
             * Android initSuccess 之后才可以联网请求
             */
            initSuccess: function () {
              console.log("Global.initSuccess() -> loginInfo:" + Global.loginInfo + ", initComplete:" + this.initComplete);

              if (!this.initComplete) {
                this.initComplete = true;
                this.notifyInitCallback();
              }
            },
            setUserAgent: function (userAgent) {
              // Mozilla/5.0 (Linux; U; Android 6.0; zh-cn;GIONEE-S9/S9 Build/IMM76D) AppleWebKit/534.30(KHTML,like Gecko)Version/4.0 Mobile Safari/534.30 Id/3A8BDF6877F92DAE11CDF78795D90FB0 RV/amigo3.5.5 AV/1.0.0.k GV/1.0.0
              console.log("Global.setUserAgent() -> UA:" + userAgent);

              if (userAgent) {
                this.UserAgent = userAgent + " GV/" + this.Version;
              }
            },
            refresh: function () {
              console.log("Global.refresh()");

              if (Global.ScriptHome && Global.loginInfo) {
                Global.ScriptHome.updateGoldCoinsWhenRefresh();
              }
            },

            /**
             * Android 游戏退出登录
             */
            logout: function () {
              console.log("Global.logout() -> 游戏退出登录");
              Global.loginInfo = null;
              cc.sys.localStorage.removeItem("LoginInfo");
              cc.audioEngine.stopAll();
              cc.game.restart();
            },
            reloginWhenAuthenticationFailed: function () {
              if (!Global.isWXappInstalled) {
                return;
              }

              console.log("Global.reloginWhenAuthenticationFailed()");

              if (Global.loginInfo && !Global.loginInfo.tokenExpired) {
                Global.loginInfo.tokenExpired = true;
                cc.sys.localStorage.setItem("LoginInfo", JSON.stringify(Global.loginInfo));
              }

              let curScene = cc.director.getScene();
              let curNode = curScene && curScene.getChildByName('Canvas');

              if (curNode) {
                if (curNode._alertWechatAuthorizedLogin) {
                  console.log("Global.reloginWhenAuthenticationFailed() 正在显示[Token过期,重新登录]弹框");
                  return;
                }

                curNode._alertWechatAuthorizedLogin = true;
                AlertDialog.show({
                  id: 'wx_auth',
                  content: '微信授权已经过期，需要您重新授权~',
                  positive: {
                    label: '微信登录',
                    clickEvent: function () {
                      curNode._alertWechatAuthorizedLogin = false;
                      PlatformBridge.authFromWeixin(ConstValue.WX_AUTH_SCENE.TOKEN_EXPIRED);
                    }
                  }
                });
              } else {
                console.log("Global.reloginWhenAuthenticationFailed() 当前场景节点获取失败 curScene:" + curScene + ", curNode:" + curNode);
              }
            },
            onNetworkStateChange: function (networkState) {
              return;
            },
            updateGiftBagForNovice: function (token, newUser) {
              let lastGiftBagForNovice = cc.sys.localStorage.getItem('giftBagForNovice');
              console.log("Global.loginSuccess() -> lastGiftBagForNovice:" + lastGiftBagForNovice);

              if (!lastGiftBagForNovice || JSON.parse(lastGiftBagForNovice).token != token) {
                cc.sys.localStorage.setItem('giftBagForNovice', JSON.stringify({
                  token: token,
                  received: !newUser
                }));
              }

              let lastWaterDropForNovice = cc.sys.localStorage.getItem('waterDropForNovice');
              console.log("Global.loginSuccess() -> lastWaterDropForNovice:" + lastWaterDropForNovice);

              if (!lastWaterDropForNovice || JSON.parse(lastWaterDropForNovice).token != token) {
                cc.sys.localStorage.setItem('waterDropForNovice', JSON.stringify({
                  token: token,
                  received: !newUser
                }));
              }
            },
            addUserActionCallback: function (key, callback) {
              if (!this.userActionCallbacks) {
                this.userActionCallbacks = {};
              }

              this.userActionCallbacks[key] = callback;
            },
            reportUserAction: function () {
              if (Global.dailyOnlineGoldCoinEnable()) {
                if (this.userActionCallbacks) {
                  for (var key in this.userActionCallbacks) {
                    let func = this.userActionCallbacks[key];

                    if (typeof func == "function") {
                      func.call(this.userActionCallbacks);
                    }
                  }
                }
              }
            },
            addLoginCallback: function (key, callback) {
              if (!this.loginCallbacks) {
                this.loginCallbacks = {};
              }

              this.loginCallbacks[key] = callback;

              if (typeof callback == "function") {
                if (Global.loginInfo) {
                  callback();
                }
              }
            },
            addInitCallback: function (key, callback) {
              if (!this.initCallbacks) {
                this.initCallbacks = {};
              }

              this.initCallbacks[key] = callback;
              console.log("Global.addInitCallback initComplete:" + this.initComplete);

              if (this.initComplete && typeof callback == "function") {
                callback();
              }
            },
            notifyInitCallback: function () {
              if (this.initCallbacks) {
                for (var key in this.initCallbacks) {
                  let func = this.initCallbacks[key];

                  if (typeof func == "function") {
                    func.call(this.initCallbacks);
                  }
                }
              }
            },
            notifyLoginCallback: function () {
              if (this.loginCallbacks) {
                for (var key in this.loginCallbacks) {
                  let func = this.loginCallbacks[key];

                  if (typeof func == "function") {
                    func.call(this.loginCallbacks);
                  }
                }
              }
            },
            addNetworkStateChangeCallback: function (key, callback) {
              if (!this.networkStateChangeCallbacks) {
                this.networkStateChangeCallbacks = {};
              }

              this.networkStateChangeCallbacks[key] = callback;
            },
            openScene: function (uri) {
              console.log("openScene:uri=" + uri); //let uri = "smartgame://hulumanor/friend?opensence=1&uid=1";

              let myIndex = uri.indexOf("?");
              let myUri = uri.substring(myIndex);
              const url = decodeURI(myUri); // 获取url中"?"符后的字串(不包括问号)

              let query = {};

              if (url.indexOf("?") != -1) {
                const str = url.substr(1);
                const pairs = str.split("&");

                for (let i = 0; i < pairs.length; i++) {
                  const pair = pairs[i].split("=");
                  query[pair[0]] = pair[1];
                }
              }

              this.ScriptHome.onOpenScene(query.opensence, query.uid);
            },

            onWateringEvent(type, value) {
              this.onEvent(ConstValue.EVENT_MAIN.GLOBAL_WATERING, ["type : " + type], value);
            },

            onRedpacketEvent(scene, amount) {
              this.onEvent(ConstValue.EVENT_MAIN.GLOBAL_GET_REDPACKET, ["scene : " + scene], amount);
            },

            onEvent(eventId, label, value) {
              cc.log("onEvent:" + eventId);

              if (value !== null && value != undefined) {
                PlatformBridge.onEventValue(eventId, label, value);
              } else {
                if (label == null || label == undefined) {
                  PlatformBridge.onEvent(eventId);
                } else {
                  switch (typeof label) {
                    case "string":
                      PlatformBridge.onEventLabel(eventId, label);
                      break;

                    case "object":
                      PlatformBridge.onEventMap(eventId, label);
                      break;
                  }
                }
              }

              if (cc.sys.isBrowser) {
                if (_czc) {
                  _czc.push(["_trackEvent", eventId, "ok", value, 1, "openBtn"]);

                  console.log("onEvent->:", eventId);
                } else {
                  console.log("onEvent-error->: [_CZC not define in CocosCreator]");
                }
              }
            },

            openTestMode: function () {
              this.TestEnv = true;
            },

            onShareToWXCallback(success, scene) {
              cc.log("onShareToWXCallback->");
              cc.log(success);
              let currentSuccess = false;

              if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
                if (success == 1) {
                  currentSuccess = true;
                } else {
                  currentSuccess = false;
                }
              } else {
                currentSuccess = success;
              }

              if (scene.indexOf('Tasklist') >= 0) {
                this.ScriptTasklist.onClickSharingCallback(currentSuccess);
              }
            },

            /**
             * Android 1.4.3(1040300)及以后版本支持
             * @param {*} success 
             * @param {*} scene 
             */
            onInterstitialAdCallback(success, scene) {
              AdUtils.onInterstitialAdCallback(success, scene);
            },

            /**
             * Android 1.4.3(1040300)及以后版本支持
             * @param {*} scene 
             */
            onInterstitialAdDismissCallback(scene) {
              AdUtils.onInterstitialAdDismissCallback(scene);
            },

            onBannerAdDismissCallback(scene) {
              PlatformBridge.dismissBannerAdCallback(scene);
            },

            onRewardAdCallback(success, scene) {
              console.log("onRewardAdCallback->", success, " scene:", scene);
              console.log(success);

              if (scene.indexOf('onBtnDoubleReceiveClick') >= 0) {
                this.reward.onBtnDoubleReceiveClickCallback(success);
              } else if (scene.indexOf('onBtnSignDoubleReceiveClick') >= 0) {
                this.signIn.showAdCallback(success);
              } else if (scene.indexOf('onBtnOffLineReceiveClick') >= 0) {
                this.offLineReward.onBtnOffLineReceiveClickCallback(success);
              } else if (scene.indexOf('onBtnNormalReceiveClick') >= 0) {
                this.reward.onBtnNormalReceiveClickCallback(success);
              } else if (scene.indexOf('onBtnShopReceiveClick') >= 0) {
                this.shop.onBtnReceiveClickCallback(success);
              } else if (scene.indexOf('onBtnAdClick') >= 0) {
                this.lottery.onBtnAdClickCallback(success);
              } else if (scene.indexOf('onBtnAdPropReceiveClick') >= 0) {
                this.adProp.onBtnPlayClickCallback(success);
              } else if (scene.indexOf('onBtnAdStepReceiveClick') >= 0) {
                this.adStep.onBtnPlayClickCallback(success);
              } else if (scene.indexOf('onBtnBalanceReceiveClick') >= 0) {
                this.balance.onBtnDoubleClickCallback(success);
              } else if (scene.indexOf('onBtnUnLockPropReceiveClick') >= 0) {
                this.unLockProp.onBtnReceiveClickCallback(success);
              } else if (scene.indexOf('onBtnonLineReceiveClick') >= 0) {
                this.onlineRewardSc.onBtnonLineReceiveClickCallback(success);
              } else if (scene.indexOf('onBtnBuyReceiveClick') >= 0) {
                this.buySc.onBtnReceiveClickCallback(success);
              }
            },

            onBackPressd() {
              console.log("global.onBackPressd");

              if (this.ScriptWatermelon) {
                this.ScriptWatermelon.onKeyDown();
              }
            },

            // 微信签到提醒
            onSubscribeMessageCallback(success, openId, scene) {
              cc.log("onSubscribeMessageCallback->");
              let currentSuccess = false;

              if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
                if (success == 1) {
                  currentSuccess = true;
                } else {
                  currentSuccess = false;
                }
              } else {
                currentSuccess = success;
              }

              if (scene == ConstValue.SCENE_FOR_WX.SIGNIN_REMIND) {
                this.ScriptTasklist.onClickSignInRemindCallback(currentSuccess, openId, scene);
              }
            },

            // Global.isAndroidOriOSPlatform();
            isAndroidOriOSPlatform: function () {
              return cc.sys.platform == cc.sys.ANDROID || cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE;
            },

            isWXAppInstalled(installed) {
              if (cc.sys.platform == cc.sys.IPAD || cc.sys.platform == cc.sys.IPHONE) {
                cc.log("isWXAppInstalled->" + installed);

                if (installed == 1) {
                  Global.isWXappInstalled = true;
                } else {
                  Global.isWXappInstalled = false;
                }
              } else {
                Global.isWXappInstalled = true;
              }

              cc.log("isWXAppInstalled->" + Global.isWXappInstalled);
            },

            /**
             * Android 1.2.0(1020000)及以后版本支持, 浏览器同步每日在线金币
             * @param {Number} currentJinbiNumber 
             * @param {Number} currentProgressTime 
             */
            onJinbiCallback(currentJinbiNumber, currentProgressTime) {
              console.log('Global.onJinbiCallback currentJinbiNumber:' + currentJinbiNumber + ", currentProgressTime:" + currentProgressTime);
              Global.dailyOnlineGoldCoinUnCommit += currentJinbiNumber;
            },

            /**
             * Android 1.2.0(1020000)及以后版本支持
             * @param {string} jsonStr 格式: {"cmd": "自定义cmd","args": {"自定义String类型字段": "value", ""自定义int类型字段": 1}}
             */
            callCocosGameMethod(jsonStr) {
              console.log('Global.callCocosGameMethod jsonStr:' + jsonStr);

              if (typeof jsonStr != 'string') {
                return;
              }

              let obj = JSON.parse(jsonStr);

              if (obj.cmd == ConstValue.CallCocosCmd.Wx_Auth) {
                setTimeout(() => {
                  // 延时2秒弹框，解决从BrowserActivity调用登录，游戏Activity尚未resume就执行显示Dialog，Dialog内容显示异常。
                  AlertDialog.show({
                    id: 'wx_auth_withdraw',
                    content: '用微信号登录，金币可以兑换，还可以邀请好友助力得水滴哦~',
                    negative: {
                      label: '再想想'
                    },
                    positive: {
                      label: '微信登录',
                      clickEvent: function () {
                        Global.onEvent(ConstValue.EVENT_MAIN.WXLOGIN_WITH_DRAW);
                        PlatformBridge.authFromWeixin(ConstValue.WX_AUTH_SCENE.WITH_DRAW);
                      }
                    }
                  });
                }, 2000);
              }
            },

            /**
            * ios 认证
            */
            callCocosGameAuthMethod(scene) {
              console.log('Global.callCocosGameAuthMethod jsonStr:' + scene);

              if (scene == ConstValue.CallCocosCmd.Wx_Auth) {
                setTimeout(() => {
                  // 延时2秒弹框，解决从BrowserActivity调用登录，游戏Activity尚未resume就执行显示Dialog，Dialog内容显示异常。
                  AlertDialog.show({
                    id: 'wx_auth_withdraw',
                    content: '用微信号登录，金币可以兑换，还可以邀请好友助力得水滴哦~',
                    negative: {
                      label: '再想想'
                    },
                    positive: {
                      label: '微信登录',
                      clickEvent: function () {
                        Global.onEvent(ConstValue.EVENT_MAIN.WXLOGIN_WITH_DRAW);
                        PlatformBridge.authFromWeixin(ConstValue.WX_AUTH_SCENE.WITH_DRAW);
                      }
                    }
                  });
                }, 2000);
              }
            }

          };
          window.Global = Global;
        })();

        _cjsExports = exports('default', module.exports);
      });

      const __cjsMetaURL = exports('__cjsMetaURL', module.meta.url);
    }
  };
});

System.register("chunks:///_virtual/main", ['./poolManager.ts', './resourceUtil.ts', './constants.ts', './linkItem.ts', './clientEvent.ts', './constant.ts', './util.ts', './storageManager.ts', './utils.ts', './csvManager.ts', './localConfig.ts', './loadingUI.ts', './sceneManager.ts', './playerData.ts', './loadsh.ts', './animationUI.ts', './tips.ts', './uiManager.ts', './audioManager.ts', './buttonEx.ts', './fightProp.ts', './LanguageData.ts', './fightPropsOperation.ts', './fightTarget.ts', './PlatformBridge.mjs_cjs=&original=.js', './NativeAdIcon.ts', './levelUI.ts', './fightGuide.ts', './fightNum.ts', './gameLogic.ts', './ConstValue.mjs_cjs=&original=.js', './buy.ts', './balance.ts', './linkLine.ts', './RotateAnim.ts', './showTargetCake.ts', './showTarget.ts', './signinReward.ts', './LocalizedMaterial.ts', './pveSlotUI.ts', './multiScrollView.ts', './unLockProp.ts', './shopPropsOperation.ts', './fightHandGuide.ts', './linkContent.ts', './reward.ts', './effectManager.ts', './shopItem.ts', './NativeAdBig.ts', './pveUI.ts', './stopPropagation.ts', './AdUtils.mjs_cjs=&original=.js', './loginScene.ts', './adStepItem.ts', './offLineReward.ts', './loading.ts', './adStep.ts', './propItem.ts', './targetCake.ts', './levelPanel.ts', './signInItem.ts', './signIn.ts', './MessageUISc.ts', './effectGroup.ts', './fightUI.ts', './fightScene.ts', './adProp.ts', './setting.ts', './PlatformPlugin.ts', './LocalizedSprite.ts', './gameSetting.ts', './elasticLimit.ts', './lotteryItem.ts', './lottery.ts', './balanceFailed.ts', './shop.ts', './LocalizedLabel.ts', './configuration.ts', './onlineReward.ts', './Toast.ts', './VIVOGameBridge.mjs_cjs=&original=.js', './OppoGameBridge.mjs_cjs=&original=.js', './Loading.mjs_cjs=&original=.js', './Global.mjs_cjs=&original=.js'], function () {
  'use strict';

  return {
    setters: [null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null],
    execute: function () {}
  };
});

(function(r) {
  r('virtual:///prerequisite-imports/main', 'chunks:///_virtual/main'); 
})(function(mid, cid) {
    System.register(mid, [cid], function (_export, _context) {
    return {
        setters: [function(_m) {
            var _exportObj = {};

            for (var _key in _m) {
              if (_key !== "default" && _key !== "__esModule") _exportObj[_key] = _m[_key];
            }
      
            _export(_exportObj);
        }],
        execute: function () { }
    };
    });
});